code_seg        segment
        assume  cs:code_seg
        org     100h
        jmp     start
;----------------------------------
;B/C Software                        ;Author
;520 North Stateline Rd
;Sharon, Pa 16146
;----------------------------------
tone1    dw     0
message1 db     'press Esc to Quit',0dh,0ah,'$'   ;Esc to end arcade
message2 db     'press any other key to play$'    ;or to go again
;------------------------------------------------------------------
start   proc    near
        mov     ah,9                 ;DOS function number to print string
        mov     dx,offset message1   ;the message
        int     21h                  ;DOS interrupt
        mov     dx,offset message2   ;the message
        int     21h                  ;DOS interrupt
begin:  mov     ah,0                 ;BIOS function wait for key press
        int     16h                  ;BIOS interrupt
        cmp     ah,1                 ;Esc scan code 
        jz      done                 ;do we stop ?
        call    arcade_a             ;no call arcade_a
        call    arcade_b             ;call arcade_b
        jmp     begin                ;go see if we do it again
done:   mov     ax,4c00h             ;no exit back to DOS
        int     21h                  ;DOS interrupt
start   endp
;-------------------------------------------
arcade_a        proc    near
        cli                          ;no interrupts
        mov     si,2                 ;do hole thing twice
agin1:  mov     bp,20                ;we want 20 cycles of sound
        mov     al,10110110xb        ;must address channel 2
        out     43h,al               ;mode 3 - send it
        mov     bx,100               ;start frequency very high
agin2:  mov     ax,bx                ;place in (ax)
        out     42h,al               ;send LSB
        mov     al,ah                ;move MSB into (al)
        out     42h,al               ;send it to port
        in      al,61h               ;get value from speaker port
        or      al,00000011xb        ;ORing turns speaker on
        out     61h,al               ;send it
        mov     cx,30000             ;our delay count 
looperq:loop    looperq              ;do nothing loop so we can hear sound
        add     bx,50                ;lower frequency a bit for next pass
        in      al,61h               ;get value from port
        and     al,11111100xb        ;ANDing turns speaker off 
        out     61h,al               ;send it
        dec     bp                   ;decrement cycle count
        jnz     agin2                ;if not = 0 do again
        dec     si                   ;else decrement repeat count
        jnz     agin1                ;if not = 0 do hole thing again
        sti                          ;else turn interrupts back on
        ret
arcade_a        endp
;-------------------------------------
arcade_b        proc    near
        cli                          ;no interrupts
        mov     di,4                 ;do hole thing four times
agin3:  mov     bp,20                ;do twenty cycles of sound
        mov     al,10110110xb        ;our magic number
        out     43h,al               ;send it to timer port
        mov     bx,1000              ;start frequency at 1000
agin4:  mov     ax,bx                ;put it in (ax)
        out     42h,al               ;send LSB
        mov     al,ah                ;put MSB in (al)
        out     42h,al               ;send it
        in      al,61h               ;get value from port
        or      al,00000011xb        ;ORing turns speaker on
        out     61h,al               ;send it
        mov     cx,15000             ;our delay count
looperx:loop    looperx              ;do nothing loop so we can hear sound
        sub     bx,50                ;subtract 50 from frequency number
        in      al,61h               ;get port value
        and     al,11111100xb        ;ANDing turns speaker on
        out     61h,al               ;send it
        dec     bp                   ;decrement cycle count
        jnz     agin4                ;if not = 0 do again
        dec     di                   ;else decrement repeat count
        jnz     agin3                ;if not = 0 do hole thing again
        sti                          ;else turn interrupts on
        ret
arcade_b        endp
;----------------------------------
code_seg        ends

