;created 11/28/91
;updated 11/30/91

;======================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;======================================================================
;RM82TS8,16,24,32,40,48

DOSSEG
.MODEL MEDIUM, BASIC

BIOSRAM SEGMENT AT 0            ;make ASSUMEs more readable
BIOSRAM ENDS

ROM SEGMENT AT 0FFFFh
ROM ENDS

	INCLUDE KEY.INC

.CODE
; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26


COMMENT         |*
;since nothing is sent using these routines they are commented out
;======================================================================
; Put value to send in BL. Sends it to Port 60h
; Returns:
;       AX = 0 if no error, AX = -1 if error
; Trashes AX & CX, returns with STI
;======================================================================

EVEN
SndByte60 LABEL NEAR
	Xor     CX,CX           ; start loop counter
SB_LBL1:
	In      AL,64h          ; is input buffer clear?
	Test    AL,10b          ; is bit 1 clear?
	Jz      SB_SndByte60    ; if yes then send byte
	Loop    SB_LBL1         ; else try again
	Jmp     Short SB_Error  ; if CX = 0 then error occurred
SB_SndByte60:
	CLI                     ; stop interrupts
	Mov     AL,BL           ; send byte from BL
	Out     60h,AL          ; through port 60h
	Xor     CX,CX           ; set delay counter again
SB_LBL2:
	In      AL,60h          ; see if got ACK from keyboard?
	Cmp     AL,0FAh         ; is this an ACK?
	JE      SB_OK           ; yep, quit w/ success
	Loop    SB_LBL2         ; try again
SB_Error:                       ; timeout error, then
	STI                     ; allow interrupts again
	Mov     AX,-1           ; return -1 to report error
	Ret                     ; return to QBASIC
SB_OK:
	STI                     ; allow interrupts again
	Xor     AX,AX           ; report all o.k.
	Retn                    ; return to QBASIC

;======================================================================
; Put value to send in BX.  Sends it to Port 60h
; Input:
;       Put first byte to send in BL, second in BH
; Returns:
;       AX = 0 if no error, AX = -1 if error
; Trashes AX & CX, returns with STI
;======================================================================

EVEN
SndWord60 LABEL NEAR
	Call    Near Ptr SndByte60   ; send first byte
	Or      AX,AX           ; did an error occur?
	JNZ     Error           ; yes, so quit
	Mov     BL,BH           ; else put byte in BL
	Call    Near Ptr SndByte60
Error:
	Retn
	*|

;======================================================================
; Put value to send in BL. Sends it to Port 64h
; Returns:
;       AX = 0 if no error, AX = -1 if error
; Trashes AX & CX, returns with STI
;======================================================================

EVEN
SndByte64 LABEL NEAR
	Xor     CX,CX           ; start loop counter
SB_Lbl1:
	In      AL,64h          ; is input buffer clear?
	Test    AL,10b          ; is bit 1 clear?
	Jz      SB_SndByte64    ; if yes then send byte
	Loop    SB_Lbl1         ; else try again
	Jmp     Short SB_Err  ; if CX = 0 then error occurred
SB_SndByte64:
	CLI                     ; stop interrupts
	Mov     AL,BL           ; send byte from BL
	Out     64h,AL          ; through port 60h
	Xor     CX,CX           ; set delay counter again
SB_Lbl2:
	In      AL,64h          ; got input buffer clear from keyboard?
	Test    AL,10b          ; is bit 1 clear?
	Jz      SB_ok           ; yep, quit w/ success
	Loop    SB_Lbl2         ; no try again
SB_Err:                         ; timeout error, then
	STI                     ; allow interrupts again
	Mov     AX,-1           ; return -1 to report error
	Ret                     ; return to QBASIC
SB_ok:
	STI                     ; allow interrupts again
	Xor     AX,AX           ; report all o.k.
	Retn                    ; return to QBASIC

;======================================================================
; DECLARE FUNCTION ATKEYON% ()
; Turn keyboard on, Resets AT KBD.  Tests to make sure have 101 keyboard
; Does not change typematic speed, use ATKEYDELAY to change speed.
;
;       Returns: -1 if error at kbd level
;                 0 if no error
;======================================================================

EVEN
ATKEYON PROC FAR
	Cmp     B$KBD_Inst,0    ; are we installed?
	JE      FindType        ; if 0, then install
Main:
	Mov     AX,-1           ; assume error
	Cmp     B$KBD_Type,010h ; do we have EXTENDED KBD?
	Jne     Finis           ; if <> 010h then no, so quit
	;Mov     BL,0F4h            ; send AT KBD reset & turn on
	;Call    Near Ptr SndByte60 ; send it to Port 60h
	;Mov     BX,00F3h           ; send F3h, then 0 bytes to reset
	;Call    Near Ptr SndWord60 ; typematic to fastest speed
	Mov     BL,0AEh            ; does same through Port 64h
	Call    Near Ptr SndByte64 ; w/o affecting typematic
Finis:
	Ret
FindType:
	Call    B$CHK_KB
	Jmp     Short Main
ATKEYON ENDP

;======================================================================
; DECLARE FUNCTION ATKEYOFF% ()
; Turns AT Keyboard OFF and clears keyboard buffer
; Tests to make sure have AT 101 keyboard.  Does not change typematic
;       Returns: -1 if error at kbd level
;                 0 if no error
; Warning!  When run, the keyboard is shut off and CTRL-ALT-DEL wont
; work to reset machine.
;======================================================================

EVEN
ATKEYOFF PROC FAR
	Cmp     B$KBD_Inst,0    ; are we installed?
	JE      FindType        ; if 0, then install
Main:
	Mov     AX,-1           ; assume error
	Cmp     B$KBD_Type,010h ; do we have EXTENDED KBD?
	Jne     Finis           ; if <> 010h then no, so quit
	Xor     AX,AX           ; very fast, no keys to read
	Mov     ES,AX
	ASSUME  ES:BIOSRAM
	CLI                     ; prevent interrupts temporarily
	Mov     AL,ES:[041Ch]   ; Refer to actual addresses
	Mov     ES:[041Ah],AL   ; using ES: form
	STI                     ; allow interrupts again
	;Mov     BL,0F5h            ; send AT KBD off command
	;Call    Near Ptr SndByte60 ; through port 60h
	Mov     BL,0ADh            ; merely disables interface
	Call    Near Ptr SndByte64 ; w/o affecting typematic
	ASSUME  ES:NOTHING
Finis:
	Ret
FindType:
	Call    B$CHK_KB
	Jmp     Short Main
ATKEYOFF ENDP

;============================================================================
; DECLARE FUNCTION EXTKBD% ()
; Returns:
;        0 if no extended keyboard with bios support
;       -1 if extended keyboard with bios support
; Note:
; Should not be affected by a full keyboard buffer or keyboard extenders
;============================================================================

EVEN
EXTKBD PROC FAR
	Cmp     B$KBD_Inst,0
	JE      FindType                ; if not installed, Findtype
Main:
	Xor     AX,AX                   ; assume not found
	Cmp     B$KBD_Type,010h         ; is it installed?
	Jne     Finis                   ; nope, so assumed correctly
	Mov     AX,-1                   ; report found
Finis:                                  ; quit
	Ret
FindType:                               ; run the install routine
	Call    B$CHK_KB
	Jmp     Short Main
EXTKBD ENDP

;============================================================================
; DECLARE SUB ATKEYDELAY (BYVAL Rate%)
; CALL ATKEYDELAY (Rate%)
; Input:
;        0 = none, fastest
;        1 = normal
;        any other = slowest
; Returns:
;        Nothing
;============================================================================

EVEN
ATKEYDELAY PROC FAR, RATE:WORD
	Mov     AX,0FFFFh       ; Read system byte
	Mov     ES,AX           ; Store segment in ES
	Assume  ES:ROM
	Mov     AL,ES:[0EH]     ; Get System ID.  FFFF:000Eh
	Cmp     AL,0FCh         ; Check if AT, PS/2 Model 50 & 60.
	; Most AT clones use same code too, including: COMPAQ 286 & 386
	; machines and PS/2 Model 30/286, AT&T 6300 PLUS, IBM XT-286,
	; and "7552 Gearbox"
	JZ      Do_Speed        ; If AT, change speed
	Cmp     AL,0F8h         ; if &HF8: Model 80, Model 70 or Model 55SX
	JZ      Do_Speed        ; OK, change speed
	Jmp     Short  AT_Exit  ; not an AT so quit
Do_Speed:
	Mov     BX,RATE         ; get Rate% (note BYVAL)
	Or      BX,BX
	JZ      Doit            ; if zero, speed to the max
	Cmp     BX,1            ; if one then jump forward
	JNE     @f              ; else, skip if not equal
	Mov     BX, 010Bh       ; select the PS/2 rate (a nice default)
	Jmp     Short   Doit    ; doit
@@:                             ; default
	Mov     BX,031Fh        ; select the S...L...O....W rate
Doit:
	Mov     AX,0305h        ; change typematic function
	Int     16h
AT_Exit:
	Ret
ATKEYDELAY      ENDP
END

