; created 11/10/90
; updated 12/10/91
;
;-----------------------------------------------------------------------
;   Copyright (C) Copr. 1990, 1991 by Sidney J. Kelly
;                   All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;-----------------------------------------------------------------------

;RM90TS8,16,24,32,40
DOSSEG
.MODEL MEDIUM, BASIC
.CODE


Delay_Factor   EQU     700h  ;heuristic guess

Wait_CRT_Retrace    Macro
	Local   WaitVert, WaitHor, FINIS
;;------------------------------------------------------------------
;; For use the BEEPER routines, we must check for horizontal as well
;; as vertical retrace because vertical retrace does not exist
;; on a MDA.  So we have to allow a poor person to have MDA.  This
;; routine couldn't be tested on a MDA since I don't have access to
;; one.  It does work on HERC, CGA, COMPAQ-CGA, EGA, VGA

;; Input:
;;  Call with STI.  Assumes:  CRT status register in DX
;; Modifies:
;;  DX and AL
;; Logic:
;;  if in the middle of vertical retrace, then end
;;  if in the middle of horizontal retrace, wait until a
;;     new horizontal retrace starts, then end
;;------------------------------------------------------------------

WaitVert:
	In	AL,DX	;;Read CRT status register
	Test	AL,8	;;Check if vertical retrace
	Jnz	FINIS	;;if yes, assume that can write at least 1 word
	Rcr	AL,1	;;see if bit 1, Horizontal retrace set
	Jc      WaitVert   ;;if it is set start loop again
WaitHor:
	In	AL,DX	;;Read CRT status again
	Rcr	AL,1	;;Wait for horizontal retrace so we can start
	Jnc     WaitHor   ;;not yet, keep trying
FINIS:			;;rest of routine can now write at least one word
	endm

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1990, 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

;======================================================================
; DECLARE SUB BEEPER10
;       makes a short 750 Hz tone
;
;    These routine makes a beep tone in a speed independent fashion
;======================================================================

EVEN
BEEPER10 PROC FAR USES AX CX DX ES
	Xor     AX,AX
	Mov	ES,AX
	Mov	DX,03DAh        ; assume color retrace port
	; look a port info stored in RAM bios at 0000:0463h
	Cmp     Byte Ptr ES:[0463h],0B4h    ; Mono reports 0B4h, color 0D4h
	JNE	@f
	Mov	DX,03BAh        ; else, retrace port for mono display
@@:
	; the following makes sure that speaker is connected to the timer.
	; It is not always necessary to do this.  QBASIC's sound routine
	; only does it once in a program.  We do here to be sure
	Mov     AL,0B6h         ; magic number 10110110b
	; select square wave sound  & initialize timer channel 2
	Out     43h,AL
	Mov     AX,0636h        ; send frequency, about 750 Hz
	Jmp     $+2             ; delay for AT's
	Out     42h,AL          ; send LSB of frequency
	Mov     AL,AH           ; get MSB into AL
	Jmp     $+2             ; delay for AT's
	Out     42h,AL          ; send MSB of frequency
	In      AL,61h          ; read port 61h
	Mov     AH,AL           ; store result in AH
	OR      AL,03           ; set the turn speak on bit
	Jmp     $+2             ; delay for AT's
	Out     61h,AL          ; send value to port
	Mov     CX,Delay_Factor ; loop Delay_Factor times

; video time killer
; The CRT retrace is the only "timer" that is machine speed independent.
; If we use the BIOS clock tick timer, we must initialize a variable
; of count per clock ticks, and worry whether the clock has rolled over
; because a midnight passed.  Better timers are available on the AT machine
; but not on the PC/XT machines.
EVEN
Start_Loop:
	Wait_CRT_Retrace        ; wait for retrace on CGA MACRO
	Loop    Start_Loop      ; loop CX times

	Mov     AL,AH           ; get back old port value from AH
	Out     61h,AL          ; send it back to speaker port
        Ret
BEEPER10 ENDP

;======================================================================
; DECLARE SUB BEEPER20
;       makes a short 950 Hz tone
;
;    These routine makes a beep tone in a speed independent fashion
;======================================================================

EVEN
BEEPER20 PROC FAR USES AX CX DX ES
	Xor     AX,AX
	Mov     ES,AX
	Mov     DX,03DAh        ; assume color retrace port
	; look a port info stored in RAM bios at 0000:0463h
	Cmp     Byte Ptr ES:[0463h],0B4h    ; Mono reports 0B4h, color 0D4h
	JNE     @f
	Mov     DX,03BAh        ; else, retrace port for mono display
@@:
	; the following makes sure that speaker is connected to the timer.
	; It is not always necessary to do this.  QBASIC's sound routine
	; only does it once in a program.  We do here to be sure
	Mov     AL,0B6h         ; magic number 10110110b
	; select square wave sound  & initialize timer channel 2

	Out     43h,AL
	Mov     AX,04E7h        ; send frequency, about 950 Hz
	Jmp     $+2             ; delay for AT's
	Out     42h,AL          ; send LSB of frequency
	Mov     AL,AH           ; get MSB into AL
	Jmp     $+2             ; delay for AT's
	Out     42h,AL          ; send MSB of frequency
	In      AL,61h          ; read port 61h
	Mov     AH,AL           ; store result in AH
	OR      AL,03           ; set the turn speak on bit
	Jmp     $+2             ; delay for AT's
	Out     61h,AL          ; send value to port
	Mov     CX,Delay_Factor ; loop Delay_Factor times

; video time killer
; The CRT retrace is the only "timer" that is machine speed independent.
; If we use the BIOS clock tick timer, we must initialize a variable
; of count per clock ticks, and worry whether the clock has rolled over
; because a midnight passed.  Better timers are available on the AT machine
; but not on the PC/XT machines.
EVEN
Start_Loop:
	Wait_CRT_Retrace        ; wait for retrace on CGA MACRO
	Loop    Start_Loop      ; loop CX times

	Mov     AL,AH           ; get back old port value from AH
	Out     61h,AL          ; send it back to speaker port
	Ret
BEEPER20 ENDP

;======================================================================
; DECLARE SUB KILLTIME (BYVAL Counter%)
; CALL KILLTIME (Counter%)
; relys on the CRT to give a machine independent delay.  May have
; a problem with a MDA display, but should work on CGA,EGA,HERC,VGA
; COMPAQ CGA, AT&T CGA.
;======================================================================

EVEN
KILLTIME PROC FAR COUNTER:WORD
	;get the CRT status port by determining if have MONO or
	;or COLOR adapter
	Xor     AX,AX
	Mov     ES,AX
	Mov     DX,03DAh        ; assume color retrace port
	; look a port info stored in RAM bios at 0000:0463h
	Cmp     Byte Ptr ES:[0463h],0B4h    ; Mono reports 0B4h, color 0D4h
	JNE     @f
	Mov     DX,03BAh        ; else, retrace port for mono display
@@:
	Mov     CX,COUNTER      ; get delay count
	JCXZ    Quit            ; if input were zero, give 'em zero & quit
	Mov     BX,CX           ; store a spare copy in CX

; The CRT retrace is the only "timer" that is machine speed independent.
; If we use the BIOS clock tick timer, we must initialize a variable
; of count per clock ticks, and worry whether the clock has rolled over
; because a midnight passed.  Better timers are available on the AT machine
; but not on the PC/XT machines.  We don't tinker with the CLI flag to
; make routine operate smoother and w/o jerks
	Mov     AH,6            ; double counter to slow down loop
EVEN
Start_Loop:
	Wait_CRT_Retrace        ; wait for retrace on CRT MACRO
	Loop    Start_Loop      ; loop CX times
	Mov     CX,BX           ; reload CX with delay count
	Dec     AH
	JNZ     Start_Loop      ; double count the input number
				; to keep an acceptable delay
Quit:
	Ret
KILLTIME ENDP
END

