'                               BigPrint 3.0
'                      (C)1989 By Michael J. Himowitz
'                           8134 Scotts Level Rd.
'                            Baltimore, MD 21208
'
' BigPrint is a programming utility and demo that provides you
' with a set of large block characters for screen display,
' printing and disk output. They're useful for title screens,
' games, educational programs and other applications requiring
' large, bold, displays. The routines should work on virtually any
' machine with any monitor. They were developed on a 10-mHz AT clone,
' and the timing on the banner and scrolling displays is set for
' a 286 computer operating at that speed. If you're using an XT, you
' can speed the display up by decreasing the value of the variable
' called WASTE in the BANNER and SCROLL subroutines. If you have
' a faster machine, you can slow down the display by increasing
' the value of WASTE in those subroutines.
'
' If you have a printer that cannot produce the IBM character set,
' you may get unexpected results if you set the BIGPRINT character
' to a value greater than 122. The actual characters produced by these
' high order ASCII codes can be found in your printer manual. Experiment
' a little and see what you get. If you have an IBM-compatible printer,
' values of 219-223 and 254 will give you the most interesting results.

' The actual bigprint characters are found in the DATA statments at
' the end of the program. Most of them were developed using the program
' BIGECHO by Barry Simon and Richard Wilson. Simon and Wilson figured
' out how to find the actual character matrix used by the IBM video
' display adapter and echo the characters in large format.
' I have changed a few of these for display purposes. In particular,
' I have changed the use of the ^ character. If you use it in a string,
' you'll get a mathematical division sign. This is useful if you're
' designing math programs for kids. You can use any of the following
' characters in a bigprint message (along with a space, of course):

' ABCDEFGHIJKLMNOPQRSTUVWXYZ
' abcdefghijklmnopqrstuvwxyz
' 0123456789,.:$&*@#!^-+=%?;()"'
'
' The character matrix itself is eight characters tall. The
' width varies, depending on the character (this allows for
' something close to proportional spacing. The 83 bigprint characters
' are stored in a two dimensional array called ALPHA$(83,8). By
' default, the character used to make up the BigPrint character set
' is , which has an ASCII value of 219. This makes the boldest
' screen display. However, you can change this character to give
' your display or printout a totally different look. I do this
' via the CHANGE subprogram.

' The main subprograms are BIGPRINT, BANNER, BANPRT, SCROLL, LP and DISKIT.
' They take your message, find the position of each character in the
' string called TEST$, and use that position to reference the
' proper elements in the ALPHA$() array. BANPRT is interesting
' because it rotates each character 90 degrees, multiplies the
' height by 8 and the width by 2. This makes the characters
' large enough to produce a good-looking printed banner.
'
' There are a few other routines here that I find useful in my
' programs. The MAINMENU subprogram sets up a bounce-bar menu
' with choices referenced in array M$(). The user's choice is
' returned in the variable ch. It can be used anywhere
' you need a menu. The BOX subprogram does just what it says.
' It draws a box between given coordinates. When set to 1,
' the variable men% in the BOX subroutine draws horizontal
' bars at the top and bottom of the box. This is useful for
' title and status lines.
'
'There are more comments in each subprogram

'
' Feel free to use any or all of these routines in your own program.
' This is not a finished work, but a demonstration. There's plenty of
' room for improvent, so hack away. If you have any questions
' my ID's on various services are CIS 71655,1327, Delphi MHIMOWITZ,
' and Dialcom 44:OWN001.
'
'
DECLARE SUB bigprint (msg$, wline%, wcol%, fg%, bg%)
DECLARE SUB change (code)
DECLARE SUB lp (msg$)
DECLARE SUB scroll (msg$, fg, bk)
DECLARE SUB banner (msg$, fg, bk, howmany)
DECLARE SUB box (r1%, c1%, R2%, c2%, men%)
DECLARE SUB mainmenu (the.foreground%, bkgd%, row%, col%)
DECLARE SUB center (wline%, msg$)
DECLARE SUB yesno ()
DECLARE SUB eraseline (wline%)
DECLARE SUB pause ()
DECLARE SUB toolong ()
DECLARE SUB gong ()
DECLARE SUB diskit (msg$)
DECLARE SUB banprt (msg$)

DIM SHARED alpha$(83, 8), bigstring$(8)
DIM SHARED test$, np, ch, M$(9), monitor, yn$, yes, bigprint.char



' This string contains the 83 allowable BIGPRINT characters
test$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz 0123456789,.:$&*@#!^-+=%?;()" + CHR$(34) + "'"

' This sets the default BIGPRINT building block as ""

bigprint.char = 219

' This reads the BigPrint character matrix into an array

FOR x = 1 TO 83
        FOR y = 1 TO 8
        READ alpha$(x, y)
        NEXT y
        NEXT x
' The Menu Choices are defined here

M$(1) = "Standard BigPrint Display"
M$(2) = "Scrolling BigPrint Display"
M$(3) = "Banner Bigprint Display"
M$(4) = "BigPrint to Printer"
M$(5) = "BigPrint Banner to Printer"
M$(6) = "BigPrint to Disk"
M$(7) = "Set Monitor Type"
M$(8) = "Change BigPrint Character"
M$(9) = "Quit"

' Variable np is used by MAINMENU to determine the number of menu choices.

np = 9



' The value of monitor determines whether we use a color or
' monochrome display. A value of zero means monochrome. Any other
' value means a color display.

COLOR 7, 0
CLS

bigprint "FHS", 8, 0, 7, 0
center 18, "Federal Hill Software Presents"

FOR waste = 1 TO 3000: NEXT
CLS

box 1, 1, 24, 79, 0


bigprint "BIGPRINT", 3, 0, 7, 0
bigprint "3.0", 13, 0, 7, 0

center 22, "(C)1989 by Michael J. Himowitz"
center 23, "Strike Any Key To Continue"
pause



monitor = 0



COLOR 7, 0

' This is the start of the main menu subroutine

start.here:

IF monitor THEN
        f% = 7
        b% = 1
        menb% = 4
        ELSE
        f% = 7
        b% = 0
        menb% = 0
        END IF
        

COLOR f%, b%

CLS


box 1, 1, 24, 79, 1
center 2, "BigPrint Version 3.0"
center 3, "(C)1989 by Michael J. Himowitz"
center 23, "Use Arrow Keys to Choose. Hit ENTER to Execute"




bigprint "ABC", 9, 45, f%, b%
LOCATE 17, 45
PRINT "Character is " + CHR$(bigprint.char) + " (" + MID$(STR$(bigprint.char), 2) + ")"

mainmenu f%, menb%, 8, 4

IF ch = 1 THEN GOTO standard
IF ch = 2 THEN GOTO scrollit
IF ch = 3 THEN GOTO dobanner
IF ch = 4 THEN GOTO doprinter
IF ch = 5 THEN GOTO dobannerprt
IF ch = 6 THEN GOTO dodisk
IF ch = 7 THEN GOTO pick.monitor
IF ch = 8 THEN GOTO char.change

CLS

center 12, "Do you want to quit? (Y/N)"
        yesno
        IF yes = 0 THEN GOTO start.here
COLOR 7, 0, 0
CLS
center 4, "Hope you enjoyed using"
bigprint "BIGPRINT", 8, 0, 7, 0
LOCATE 23, 1
END





pick.monitor:
        CLS
        center 12, "Do you have a color monitor? (Y/N)"
        yesno
        IF yes THEN monitor = -1 ELSE monitor = 0
        GOTO start.here

' This is the standard BigPrint Display
standard:
        
COLOR f%, b%
CLS
box 1, 1, 24, 79, 1
center 2, "BigPrint Version 3.0"
center 3, "Standard BigPrint Screen Display"

LOCATE 6, 7
PRINT "This will demonstrate the standard BigPrint Screen Display";
LOCATE 7, 7
PRINT "Enter two lines of text (9 characters maximum per line)."

get.standard1:
        eraseline 10
        LOCATE 10, 6
        LINE INPUT ; "Message No. 1: "; msg1$
                IF LEN(msg1$) = 0 THEN GOTO start.here
                IF LEN(msg1$) > 9 THEN
                     toolong
                     GOTO get.standard1
                     END IF
get.standard2:

        eraseline 12
        LOCATE 12, 6
        LINE INPUT ; "Message No. 2: "; msg2$
                IF LEN(msg2$) > 9 THEN
                     toolong
                     GOTO get.standard2
                     END IF

IF monitor THEN
        f1% = 14
        b1% = 0
        ELSE
        f1% = 7
        b1% = 0
        END IF
COLOR 7, 0
CLS
box 1, 1, 24, 79, 0
bigprint msg1$, 3, 0, f1%, b1%
bigprint msg2$, 12, 0, f1%, b1%

center 23, "Try this again? (Y/N)"
yesno
        IF yes THEN GOTO standard ELSE GOTO start.here

char.change:
        COLOR f%, b%
        CLS
        box 1, 1, 24, 79, 1
        center 2, "BigPrint Version 3.0"
        center 3, "Set BigPrint Character"
        bigprint "AaBbCc", 6, 0, f%, b%
        COLOR f%, b%

        center 15, "Current BigPrint Character is " + CHR$(bigprint.char)
        center 16, "Its ASCII value is" + STR$(bigprint.char) + "."
        center 17, "Do you want to change it? (Y/N)"
        yesno
        IF yes = 0 THEN GOTO start.here
bp.char:      
        eraseline 19
        LOCATE 19, 20
        LINE INPUT ; "Enter a value between 1 and 255: "; bigprint.char$
        testchar = VAL(bigprint.char$)
                IF testchar < 1 OR testchar > 255 THEN
                        eraseline 23
                        center 23, "Value Must be 1-255. Try again? (Y/N)"
                        yesno
                        IF yes THEN
                        eraseline 23
                        GOTO bp.char
                        ELSE
                        GOTO start.here
                        END IF
                        END IF
        bigprint.char = testchar
        change bigprint.char
        GOTO char.change

scrollit:

COLOR f%, b%
CLS
box 1, 1, 24, 79, 1
center 2, "BigPrint Version 3.0"
center 3, "Scrolling BigPrint Screen Display"

LOCATE 6, 7
PRINT "This will demonstrate a scrolling BigPrint Screen Display";
LOCATE 7, 7
PRINT "Enter four lines of text (9 characters maximum per line)."

get.scroll1:
        eraseline 10
        LOCATE 10, 6
        LINE INPUT ; "Message No. 1: "; msg1$
                IF LEN(msg1$) = 0 THEN GOTO start.here
                IF LEN(msg1$) > 9 THEN
                     toolong
                     GOTO get.scroll1
                     END IF
get.scroll2:

        eraseline 12
        LOCATE 12, 6
        LINE INPUT ; "Message No. 2: "; msg2$
                IF LEN(msg2$) > 9 THEN
                     toolong
                     GOTO get.scroll2
                     END IF

get.scroll3:
        eraseline 14
        LOCATE 14, 6
        LINE INPUT ; "Message No. 3: "; msg3$
                IF LEN(msg3$) > 9 THEN
                     toolong
                     GOTO get.scroll3
                     END IF
get.scroll4:

        eraseline 16
        LOCATE 16, 6
        LINE INPUT ; "Message No. 4: "; msg4$
                IF LEN(msg4$) > 9 THEN
                     toolong
                     GOTO get.scroll4
                     END IF

        eraseline 18
        LOCATE 18, 6
        LINE INPUT ; "How many repeats? (2-10): "; hmr$
                hmr = VAL(hmr$)
                IF hmr = 0 THEN hmr = 2
                IF hmr > 10 THEN hmr = 10


FOR iterations = 1 TO hmr

COLOR 7, 0


CLS

b1 = 0
f1 = 7

scroll msg1$, f1, b1
IF monitor THEN f1 = 4
scroll msg2$, f1, b1
IF monitor THEN f1 = 13
scroll msg3$, f1, b1
IF monitor THEN f1 = 6
scroll msg4$, f1, b1
COLOR 7, 0
scroll "      ", 7, 0
scroll "      ", 7, 0
scroll "      ", 7, 0

NEXT iterations
gong
center 21, "Strike any key to continue"
pause
GOTO start.here

dobanner:

COLOR f%, b%
CLS
box 1, 1, 24, 79, 1
center 2, "BigPrint Version 3.0"
center 3, "BigPrint Banner Display"

LOCATE 6, 7
PRINT "This will demonstrate a BigPrint Banner Screen Display";
LOCATE 7, 7
PRINT "Enter a line of text below:"

get.banner:
        eraseline 10
        LOCATE 10, 6
        LINE INPUT ; ">> "; msg1$
        IF LEN(msg1$) = 0 THEN GOTO start.here

eraseline 12
        LOCATE 12, 6
        LINE INPUT ; "How many repeats? (2-10): "; hmr$
                hmr = VAL(hmr$)
                IF hmr > 10 THEN hmr = 10
                IF hmr < 2 THEN hmr = 2

COLOR 7, 0
CLS
IF monitor THEN f1 = 13 ELSE f1 = 7

banner msg1$, f1, 0, hmr

gong
center 21, "Strike any key to continue"
pause
GOTO start.here

doprinter:

COLOR f%, b%
CLS
box 1, 1, 24, 79, 1
center 2, "BigPrint Version 3.0"
center 3, "BigPrint Printer Output"

LOCATE 6, 7
PRINT "This will demonstrate BigPrint Printer Output";
LOCATE 7, 7
PRINT "Enter two lines of text (9 characters maximum per line)."

get.printer1:
        eraseline 10
        LOCATE 10, 6
        LINE INPUT ; "Message No. 1: "; msg1$
                IF LEN(msg1$) = 0 THEN GOTO start.here
                IF LEN(msg1$) > 9 THEN
                     toolong
                     GOTO get.printer1
                     END IF
get.printer2:

        eraseline 12
        LOCATE 12, 6
        LINE INPUT ; "Message No. 2: "; msg2$
                IF LEN(msg2$) > 9 THEN
                     toolong
                     GOTO get.printer2
                     END IF

eraseline 17
center 17, "Do You Want To Continue With Printout? (Y/N)"
        yesno
        IF yes = 0 THEN GOTO start.here
center 19, "Position Print head at top of page and strike any key."
        pause
        FOR waste = 1 TO 14: LPRINT : NEXT
        lp msg1$
        LPRINT
        LPRINT
        lp msg2$
        LPRINT CHR$(12)

        gong
center 23, "Want to try another one? (Y/N)"
        yesno
        IF yes THEN GOTO doprinter
        GOTO start.here



dobannerprt:

COLOR f%, b%
CLS
box 1, 1, 24, 79, 1
center 2, "BigPrint Version 3.0"
center 3, "Print Banner"

LOCATE 6, 7
PRINT "This will print a Long Banner with characters rotated 90 degrees";
LOCATE 7, 7
PRINT "Enter a line of text below:"

get.banprt:
        eraseline 10
        LOCATE 10, 6
        LINE INPUT ; ">> "; msg1$
        IF LEN(msg1$) = 0 THEN GOTO start.here

eraseline 12
       
        gong
        center 12, "Continue with Printout? (Y/N)"

        yesno
        IF yes = 0 THEN GOTO start.here
        gong
        center 16, "Make sure Printer is Ready, then strike Any Key."
        pause
        center 18, "Printing Banner Now...."
        banprt msg1$



        GOTO start.here



dodisk:

COLOR f%, b%
CLS
box 1, 1, 24, 79, 1
center 2, "BigPrint Version 3.0"
center 3, "BigPrint Disk Output"

LOCATE 6, 7
PRINT "This will demonstrate BigPrint Disk Output";
LOCATE 7, 7
PRINT "It will create an ASCII text file that you can import into"
LOCATE 8, 7
PRINT "Any standard word processing program."
LOCATE 9, 7
PRINT "Enter two lines of text (9 characters maximum per line)."

get.disk1:
        eraseline 12
        LOCATE 12, 6
        LINE INPUT ; "Message No. 1: "; msg1$
                IF LEN(msg1$) = 0 THEN GOTO start.here
                IF LEN(msg1$) > 9 THEN
                     toolong
                     GOTO get.disk1
                     END IF
get.disk2:

        eraseline 14
        LOCATE 14, 6
        LINE INPUT ; "Message No. 2: "; msg2$
                IF LEN(msg2$) > 9 THEN
                     toolong
                     GOTO get.disk2
                     END IF

        eraseline 16
        LOCATE 16, 6
        LINE INPUT ; "Enter name of file to save: "; nf$

        eraseline 18
        center 18, "Saving Message as file " + UCASE$(nf$)

        OPEN nf$ FOR OUTPUT AS 1
        diskit msg1$
        diskit msg2$
        CLOSE #1
        gong
        eraseline 19
        center 19, "Now we'll read the file back and display it on the screen."
        eraseline 20
        center 20, "Hit any key to continue..."
        pause
        CLS

        OPEN nf$ FOR INPUT AS 1
        WHILE NOT EOF(1)
        LINE INPUT #1, a$
        PRINT a$
        WEND
        CLOSE #1
        gong
        center 24, "Hit any key to continue..."
        pause
        GOTO start.here

' Here are the data statements that make up the bigprint characters
' By removing the DATA and quotation marks from each line,
' You can save the data as an external disk file that can be read in
' by your program. This will make your program much smaller, although
' it will take a little longer to execute at the outset.
' You'll notice that each character is eight lines deep. The
' width varies, which makes for a better display than a single
' width for the entire character set.

DATA "   "
DATA "    "
DATA "    "
DATA " "
DATA "    "
DATA "    "
DATA "    "
DATA "        "
DATA "  "
DATA "    "
DATA "    "
DATA "   "
DATA "    "
DATA "    "
DATA "  "
DATA "        "
DATA "   "
DATA "    "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA "   "
DATA "        "
DATA "  "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "  "
DATA "        "
DATA " "
DATA "     "
DATA "     "
DATA "    "
DATA "     "
DATA "     "
DATA " "
DATA "        "
DATA " "
DATA "     "
DATA "     "
DATA "    "
DATA "     "
DATA "      "
DATA "    "
DATA "        "
DATA "   "
DATA "    "
DATA "    "
DATA "      "
DATA "  "
DATA "    "
DATA "   "
DATA "        "
DATA "    "
DATA "    "
DATA "    "
DATA " "
DATA "    "
DATA "    "
DATA "    "
DATA "        "
DATA "    "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA "        "
DATA "    "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA "    "
DATA "        "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "        "
DATA "    "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "     "
DATA " "
DATA "        "
DATA "    "
DATA "  "
DATA " "
DATA "   "
DATA "    "
DATA "    "
DATA "    "
DATA "        "
DATA "    "
DATA "   "
DATA "  "
DATA "  "
DATA "   "
DATA "    "
DATA "    "
DATA "        "
DATA "   "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "   "
DATA "        "
DATA "  "
DATA "    "
DATA "    "
DATA "   "
DATA "      "
DATA "      "
DATA "    "
DATA "        "
DATA "   "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "   "
DATA "      "
DATA "  "
DATA "    "
DATA "    "
DATA "   "
DATA "    "
DATA "    "
DATA "   "
DATA "        "
DATA "   "
DATA "    "
DATA "      "
DATA "   "
DATA "      "
DATA "    "
DATA "   "
DATA "        "
DATA "  "
DATA "    "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA "        "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "   "
DATA "        "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "     "
DATA "        "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "   "
DATA "  "
DATA "    "
DATA "        "
DATA "    "
DATA "    "
DATA "     "
DATA "     "
DATA "     "
DATA "    "
DATA "    "
DATA "        "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "      "
DATA "      "
DATA "    "
DATA "        "
DATA " "
DATA "    "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA " "
DATA "        "
DATA "        "
DATA "        "
DATA "   "
DATA "      "
DATA "  "
DATA "    "
DATA "  "
DATA "        "
DATA "      "
DATA "      "
DATA "  "
DATA "    "
DATA "    "
DATA "    "
DATA "  "
DATA "        "
DATA "        "
DATA "        "
DATA "   "
DATA "    "
DATA "      "
DATA "    "
DATA "   "
DATA "        "
DATA "      "
DATA "      "
DATA "  "
DATA "    "
DATA "    "
DATA "    "
DATA "  "
DATA "        "
DATA "        "
DATA "        "
DATA "   "
DATA "    "
DATA " "
DATA "      "
DATA "   "
DATA "        "
DATA "    "
DATA "    "
DATA "      "
DATA "    "
DATA "      "
DATA "      "
DATA "      "
DATA "        "
DATA "        "
DATA "        "
DATA "  "
DATA "    "
DATA "    "
DATA "  "
DATA "      "
DATA "   "
DATA "      "
DATA "      "
DATA "  "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "        "
DATA "      "
DATA "        "
DATA "     "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA "        "
DATA "        "
DATA "      "
DATA "        "
DATA "     "
DATA "      "
DATA "      "
DATA "    "
DATA "    "
DATA "      "
DATA "      "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "        "
DATA "     "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA "        "
DATA "        "
DATA "        "
DATA "  "
DATA " "
DATA "   "
DATA "    "
DATA "    "
DATA "        "
DATA "        "
DATA "        "
DATA "  "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "        "
DATA "        "
DATA "        "
DATA "   "
DATA "    "
DATA "    "
DATA "    "
DATA "   "
DATA "        "
DATA "        "
DATA "        "
DATA "  "
DATA "    "
DATA "    "
DATA "  "
DATA "      "
DATA "      "
DATA "        "
DATA "        "
DATA "  "
DATA "    "
DATA "    "
DATA "  "
DATA "      "
DATA "      "
DATA "        "
DATA "        "
DATA "  "
DATA "   "
DATA "      "
DATA "      "
DATA "      "
DATA "        "
DATA "        "
DATA "        "
DATA "   "
DATA "      "
DATA "   "
DATA "      "
DATA "   "
DATA "        "
DATA "      "
DATA "      "
DATA "  "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA "        "
DATA "        "
DATA "        "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "  "
DATA "        "
DATA "        "
DATA "        "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "     "
DATA "        "
DATA "        "
DATA "        "
DATA "    "
DATA "    "
DATA "   "
DATA " "
DATA "    "
DATA "        "
DATA "        "
DATA "        "
DATA "    "
DATA "    "
DATA "     "
DATA "    "
DATA "    "
DATA "        "
DATA "        "
DATA "        "
DATA "    "
DATA "    "
DATA "    "
DATA "  "
DATA "      "
DATA "   "
DATA "        "
DATA "        "
DATA " "
DATA "      "
DATA "      "
DATA "      "
DATA " "
DATA "        "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "   "
DATA "   "
DATA "  "
DATA "  "
DATA "   "
DATA "   "
DATA "   "
DATA "        "
DATA "      "
DATA "     "
DATA "    "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA "        "
DATA "   "
DATA "    "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA " "
DATA "        "
DATA "   "
DATA "    "
DATA "      "
DATA "    "
DATA "      "
DATA "    "
DATA "   "
DATA "        "
DATA "     "
DATA "    "
DATA "    "
DATA "    "
DATA " "
DATA "      "
DATA "      "
DATA "        "
DATA " "
DATA "      "
DATA "      "
DATA "  "
DATA "      "
DATA "      "
DATA "  "
DATA "        "
DATA "   "
DATA "    "
DATA "      "
DATA "  "
DATA "    "
DATA "    "
DATA "   "
DATA "        "
DATA " "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "        "
DATA "   "
DATA "    "
DATA "    "
DATA "   "
DATA "    "
DATA "    "
DATA "   "
DATA "        "
DATA "   "
DATA "    "
DATA "    "
DATA "  "
DATA "      "
DATA "    "
DATA "   "
DATA "        "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA "   "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "  "
DATA "    "
DATA "      "
DATA "      "
DATA "    "
DATA "      "
DATA "      "
DATA "    "
DATA "      "
DATA "      "
DATA "       "
DATA "   "
DATA "    "
DATA "   "
DATA "     "
DATA "   "
DATA "       "
DATA "        "
DATA "      "
DATA "      "
DATA "      "
DATA "    "
DATA "   "
DATA "    "
DATA "    "
DATA "        "
DATA "        "
DATA "     "
DATA "     "
DATA " "
DATA "     "
DATA "     "
DATA "        "
DATA "        "
DATA "   "
DATA "      "
DATA "    "
DATA "    "
DATA "    "
DATA "   "
DATA "   "
DATA "        "
DATA "    "
DATA "    "
DATA " "
DATA "    "
DATA " "
DATA "    "
DATA "    "
DATA "        "
DATA "     "
DATA "     "
DATA "     "
DATA "     "
DATA "     "
DATA "       "
DATA "     "
DATA "       "
DATA "         "
DATA "         "
DATA "        "
DATA "         "
DATA "   "
DATA "         "
DATA "        "
DATA "         "
DATA "         "
DATA "         "
DATA "         "
DATA "         "
DATA "   "
DATA "         "
DATA "         "
DATA "         "
DATA "         "
DATA "       "
DATA "       "
DATA "   "
DATA "       "
DATA "       "
DATA "         "
DATA "         "
DATA "         "
DATA "         "
DATA "   "
DATA "         "
DATA "   "
DATA "         "
DATA "         "
DATA "         "
DATA "    "
DATA "    "
DATA "  "
DATA "      "
DATA "   "
DATA "    "
DATA "  "
DATA "        "
DATA "    "
DATA "     "
DATA "       "
DATA "       "
DATA "       "
DATA "         "
DATA "       "
DATA "         "
DATA "      "
DATA "      "
DATA "    "
DATA "      "
DATA "      "
DATA "    "
DATA "     "
DATA "      "
DATA "     "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
DATA "     "
DATA "      "
DATA "      "
DATA "     "
DATA "     "
DATA "     "
DATA "     "
DATA "     "
DATA "      "
DATA "       "
DATA "     "
DATA "     "
DATA "         "
DATA "         "
DATA "         "
DATA "         "
DATA "         "
DATA "         "
DATA "       "
DATA "       "
DATA "       "
DATA "         "
DATA "         "
DATA "         "
DATA "         "
DATA "         "

SUB banner (msg$, fg, bk, howmany)
' This routine produces a horizontally scrolling banner.
' The contents of the banner are in variable MSG$.
' The banner repeats the number of times set in the variable howmany.
' The foreground color is fg; background is bk.
' I'm least satisfied with this routine because it can look choppy.
' This is a function of the speed of the video display. Maybe someone
' can figure out a way to make it faster. If you're using an XT,
' you might want to decrease the value of the WASTE variable to
' speed up the scroll.
'


FOR u = 1 TO howmany


FOR x = 1 TO 8: bigstring$(x) = "": NEXT

text$ = ""

l = LEN(msg$)

FOR q = 1 TO 8
       
        FOR K = 1 TO l

r = INSTR(test$, (MID$(msg$, K, 1)))
        text$ = text$ + alpha$(r, q)
       
        NEXT K
      
bigstring$(q) = STRING$(80, 32) + text$ + STRING$(80, 32)

        text$ = ""
NEXT q

substring = 1
columns = 80
start = 1
        COLOR fg, bk
        CLS
        l = LEN(bigstring$(1))
        FOR x = 1 TO l
                FOR y = 1 TO 8
                LOCATE y + 7, 1
                remainder = l - columns

                IF remainder > 80 THEN PRINT MID$(bigstring$(y), x, columns);
                IF remainder <= 80 THEN PRINT MID$(bigstring$(y), x);
               
                NEXT y
             FOR waste = 1 TO 150: NEXT
             NEXT x
NEXT u

COLOR 7, 0

END SUB

SUB banprt (msg$)
     
'This subroutine will print a long banner.
'It takes the BigPrint character matrix, rotates it 90 degrees,
'It makes each character eight times as high and twice as wide
'as the standard BigPrint character. This makes it more suitable
'for large banner-style printouts.

      
      
       l = LEN(msg$)
       FOR q = 1 TO l
        this.char$ = MID$(msg$, q, 1)
        index = INSTR(test$, this.char$)
                char.width = LEN(alpha$(index, 1))
                        FOR y = 1 TO char.width
                            FOR u = 1 TO 2
                            FOR x = 8 TO 1 STEP -1
                                b$ = MID$(alpha$(index, x), y, 1)
                                LPRINT STRING$(8, b$);
                                NEXT x
                                LPRINT
                                NEXT u
                                NEXT y
                                NEXT q




END SUB

SUB bigprint (msg$, wline%, wcol%, fg%, bg%)

' This prints the standard BIGPRINT screen display of the string MSG$.
' WLINE% and WCOL% are the coordinates of the upper left hand corner
' of the message. If you set WCOL% to zero, the message will be centered
' horizontally. The foreground and background color of the characters
' are in fg% and bg%, respectively. The maximum length of the standard
' display is 80 screen characters, which translates into 9-11 BigPrint
' characters, depending on which characters you use. I've put in a
' safety net here to keep characters from being printed below the
' 25th line, which would cause an FC error.



vert% = wline%
horiz% = wcol%



COLOR fg%, bg%

l = LEN(msg$)
FOR q = 1 TO 8
FOR K = 1 TO l
r = INSTR(test$, (MID$(msg$, K, 1)))
text$ = text$ + alpha$(r, q)
NEXT K

' If wcol% is set to zero, the following routine centers the message                     


        IF horiz% = 0 THEN
                tl% = LEN(text$)
                tl% = INT((80 - tl%) / 2)
                horiz% = tl%
                END IF


IF vert% < 25 THEN
        LOCATE vert%, horiz%

        PRINT text$;
        END IF
        text$ = ""
vert% = vert% + 1
NEXT q


END SUB

SUB box (r1%, c1%, R2%, c2%, men%)
' DRAW A BOX AT SPECIFIED COORDINATE
' This is a generic routine that can be used to draw a box anywhere.
' r1% is the starting row. c1% is the starting column.
' r2% is the ending row. c2% is the ending column.
' The paramater men%, set to 1, prints horizontal bars
' three rows down from the top of the box and two rows up from the bottom.
' If men% is set to 0, the routine will print a plain box.
' This can create a quick frame for a title screen.

'The first piece of code sets up the strings for box drawing

      gloop$ = CHR$(186)
      boxtop = (c2% - c1%) - 1
      boxtop$ = CHR$(201) + STRING$(boxtop, 205) + CHR$(187)
      BOXBOTTOM$ = CHR$(200) + STRING$(boxtop, 205) + CHR$(188)
      midbox$ = CHR$(204) + STRING$(boxtop, 205) + CHR$(185)
   
'This prints the top of the box

      LOCATE r1%, c1%: PRINT boxtop$;
   
'Print the sides of the box
   
      FOR E1% = r1% + 1 TO R2% - 1
        LOCATE E1%, c1%: PRINT gloop$;
        LOCATE E1%, c2%: PRINT gloop$;
      NEXT
  
'Print the bottom of the box
   
      LOCATE R2%, c1%: PRINT BOXBOTTOM$;
   
'Optionally prints horizontal lines at top and bottom of the box
'To set up title and menu screens.

      IF men% > 0 THEN
        
           LOCATE r1% + 3, c1%: PRINT midbox$;
           LOCATE R2% - 2, c1%: PRINT midbox$;
        
           END IF

END SUB

SUB center (wline%, msg$)

'This simple subroutine centers the string msg$ on line wline%

        tl = LEN(msg$)
        tl = INT((80 - tl) / 2)
        LOCATE wline%, 2
        PRINT STRING$(76, 32);
        LOCATE wline%, tl
        PRINT msg$;



END SUB

SUB change (code)
       
' This routine changes the screen character used to make up the
' BigPrint character matrix. The default is  (219). I merely
' searches for all non-spaces in the ALPHA$() array and changes
' those characters to the ASCII value passed in the variable code.

       
       
        CLS
        center 8, "Changing Bigprint Character to " + CHR$(code)
        FOR x = 1 TO 83
        LOCATE 10, 39
        PRINT x;

                FOR y = 1 TO 8
                FOR u = 1 TO LEN(alpha$(x, y))
                        IF MID$(alpha$(x, y), u, 1) <> CHR$(32) THEN
                                MID$(alpha$(x, y), u, 1) = CHR$(code)
                                END IF
                 NEXT u
                 NEXT y
                 NEXT x


END SUB

SUB diskit (msg$)

'This performs virtually the same function as the lp routine,
'but it prints to a disk file opened as #1 in the main body of
'the program. You can use the disk file with a word processing
'program, or to generate data statements for a specific screen
'display in another BASIC program.


text$ = ""


l = LEN(msg$)
FOR q = 1 TO 8
FOR K = 1 TO l
r = INSTR(test$, (MID$(msg$, K, 1)))
text$ = text$ + alpha$(r, q)
NEXT K

                tl% = LEN(text$)
                tl% = INT((80 - tl%) / 2)
                horiz% = tl%



        PRINT #1, TAB(horiz%); text$;
        text$ = ""
NEXT q
PRINT #1, " "

END SUB

SUB eraseline (wline%)
      
' Nothing tricky. This just erases the line specified in wline%
' Without forcing a scroll up.
       
        LOCATE wline%, 2: PRINT STRING$(76, 32);
END SUB

SUB gong
' This creates a short beep      

        SOUND 800, 2
END SUB

SUB lp (msg$)

'This sends the BigPrint string MSG$ to your printer.
'The message will be centered horizontally.
'There's lots of room for fancy stuff here. By default, your
'printer width is set to 80 characters. This means a maximum
'of 8 to 10 BigPrint characters per line. But you can change this.
'If You have a wide carriage printer, you can use the WIDTH command
'to produce a longer line with more characters, i.e, WIDTH 132.
' You can do the same thing by setting
'a standard printer to condensed print and setting a wider line
' width. On most IBM and EPSON-compatible printers, you can do
' set condensed by issuing an LPRINT CHR$(15) command. Likewise, you can
' produce interesting effects by issuing a command to your printer
' to vary the line spacing. These printer codes are in your printer
' manual. Remember that if you're using a printer that can't reproduce
' the IBM screen character set, you'll get different results than you
' see on the screen when you use a BigPrint character with an ASCII
' value of 123 or higher.


text$ = ""

' Enter your printer setup commands here, i.e.,
' WIDTH 132  to set a longer line
' LPRINT CHR$(15) to set condensed print on IBM-EPSON compatible printers.

l = LEN(msg$)
FOR q = 1 TO 8
FOR K = 1 TO l
r = INSTR(test$, (MID$(msg$, K, 1)))
text$ = text$ + alpha$(r, q)
NEXT K

                tl% = LEN(text$)
                tl% = INT((80 - tl%) / 2)
                horiz% = tl%



        LPRINT TAB(horiz%); text$;
        text$ = ""
NEXT q
LPRINT


END SUB

SUB mainmenu (the.foreground%, bkgd%, row%, col%)
' This creates  bounce-bar menu anywhere on the screen.
' The setup allows up to nine choices, saved string array M$().
' Variable np is the number of choices. Both M$() and np are shared
' variables DIMed in the main body of the program.
' Text colors of menu and border are the.foreground% and bkgd%.
' row% and col% are the coordinates of the top left-hand corner of the menu.

esc$ = CHR$(27)
left.arrow$ = CHR$(0) + CHR$(75)
right.arrow$ = CHR$(0) + CHR$(77)

COLOR the.foreground%, bkgd%, brdr
      REM
      REM


      


mstep1:
      c1f = the.foreground%: c1b = bkgd%
      c2f = bkgd%: c2b = the.foreground%
      '
mstep2:

GOSUB mstep3
      'cls
      GOTO mmenu.end
      GOTO mstep1
      GOTO mstep2
      '
      '
mstep3:
      COLOR c1f, c1b
      FOR j = 1 TO 16: x$ = INKEY$: NEXT: ch = 1
      LS = 2: FOR j = 1 TO np: IF LEN(M$(j)) > LS THEN LS = LEN(M$(j))
      NEXT: ML$ = "##  \" + SPACE$(LS - 1) + "\"

 longest = LEN(ML$)
 menbox.row% = row%
 menbox.col% = col%
 menbot.row% = menbox.row% + np + 1
 menbot.col% = menbox.col% + longest + 2
 men.fore = c1b: men.back = c1f
 old.fore = c2b: oldback = c2f
  
      COLOR c1f, c1b
      SL = col% + 1' + 18 - LEN(ML$) / 2
      FOR K = 1 TO np: LOCATE row% + K, SL: PRINT USING ML$; K; M$(K): NEXT

mstep4:
    
        LOCATE row% + ch, SL
        COLOR c2f, c2b: PRINT USING ML$; ch; M$(ch)
        COLOR c1f, c1b: TD = ch
mstep5:
 
'Look for ESC key, left or right arrows

      x$ = INKEY$: IF LEN(x$) THEN KP = ASC(RIGHT$(x$, 1)) ELSE GOTO mstep5
      IF x$ = CHR$(27) THEN
      ch = 27
      GOTO mmenu.end
      END IF
  
      IF KP = 72 THEN ch = ch - 1: IF ch < 1 THEN ch = np
      IF KP = 80 THEN ch = ch + 1: IF ch > np THEN ch = 1
      IF x$ >= "1" AND x$ <= "9" THEN
        IF VAL(x$) >= 1 AND VAL(x$) <= np THEN ch = VAL(x$): RETURN
        END IF
      IF KP = 13 THEN RETURN
      IF KP <> 72 AND KP <> 80 THEN
        KP = KP - 48
        IF KP < 1 OR KP > np THEN PRINT CHR$(7): GOTO mstep5 ELSE ch = KP
      END IF
  
  
      IF ch = TD THEN
      GOTO mstep5
      ELSE LOCATE row% + TD, SL: PRINT USING ML$; TD; M$(TD): GOTO mstep4
      END IF

mmenu.end:

END SUB

SUB pause
        WHILE INKEY$ = "": WEND
END SUB

SUB scroll (msg$, fg, bk)

'This produces a vertically scrolling centered message.
'You can increase the speed of the display by decreasing
'the value of the variable WASTE. This is good if you're
'using an XT compatible. If you're using a really fast
'computer, you might want to increase the value of WASTE.
'Fool around with it and see how you like the results.
'The foreground and background colors are fg and bk, by the way.


text$ = ""

l = LEN(msg$)
FOR q = 1 TO 8
FOR K = 1 TO l
r = INSTR(test$, (MID$(msg$, K, 1)))
text$ = text$ + alpha$(r, q)
NEXT K

                tl% = LEN(text$)
                tl% = INT((80 - tl%) / 2)
                horiz% = tl%


        LOCATE 24, 1
        COLOR fg, bk
        PRINT TAB(horiz%); text$
        text$ = ""
        FOR waste = 1 TO 300: NEXT
NEXT q

        PRINT

        FOR waste = 1 TO 1000: NEXT


END SUB

SUB toolong
        eraseline 23
        center 23, "Message greater than 9 characters. Hit any key to try again."
        pause
        eraseline 23

END SUB

SUB yesno

'This routine lets the user answer a question with "Y" or "N"
'If the answer is "Y", the value of variable YES has a value of -1.
'If the answer is "N," the value of YES is set to zero.



startyes:
        yn$ = INKEY$: IF yn$ = "" THEN GOTO startyes
        IF INSTR("YyNn", yn$) = 0 THEN GOTO startyes
        yn$ = UCASE$(yn$)
        IF yn$ = "Y" THEN yes = -1 ELSE yes = 0




END SUB

