/*

  file    : bitstr_f.c
  author  : Erik Mavrinac
  version : 1.20  11/25/90

  description: This is the source for the function set for the bitstring
    manipulation routines. Also see the bitstr_h.h file for the same functions 
    implemented as #defines instead of functions, and bitstr.doc for complete
    details.

*/

/* size of unsigned int in bits */
#define US  16

/* CPU-specific hexadecimal definition of rightmost bit set (only) */
#define HEX1  ((unsigned) 0x0001)


void clear_bit(unsigned *string, int bit)

/* sets the "bit" bit to 0 */

{
  *(string+bit/US) &= (~(HEX1 << (US-1-(bit % US))));
}



void set_bit(unsigned *string, int bit)

/* sets the "bit" bit to 1 */

{
  *(string+bit/US) |= (HEX1 << (US-1-(bit % US)));
}



int test_bit(unsigned *string, int bit)

/* returns non-zero if "bit" is set */

{
  return (*(string+bit/US) & (HEX1 << (US-1-(bit % US))));
}

