_text	segment
	.radix 10
	assume cs:_text,ds:_text,es:_text
	jmp begin

 comment + To use the BASIC window routine
	bload bw.bin into a non BASIC segment.

    The order of operation is:
	1) Open a window
	2) Write to window
	3) Close window.

    The format of the call to BW is call segment(p1...pn,segment,function).

    To open a window, call segment(upper,lower,color,segment,1).

    To write to a window, call segment(text$,segment,2) Write window
    honors 13d (cr), 10d (lf) and 12d (ff). An FF will cause
    the window to clear and the write operation to begin at the
    upper left corner of the window. Write_window treats the data
    string as an ASCIIZ string so it MUST be terminated by a 0h character.
    Line wrap and scrolling is handled by Write_Window.

    When you wish for the window to terminate call
	segment(segment,3).

    While there may be many windows open, Write_Window will only
    write to the latest open window. For Write_Window to function,
    there must be an open window. +

window_save dw 3000 dup (?)
window_ptr  dw window_save-2
window_old  dw 0
window_flg  db 1

BEGIN:	push bp
	mov  bp,sp
	add bp,2    ;compensate for pushed bp
	push ds     ;save ds
	mov si,6[bp]
	mov ax,[si]
	mov es,ax   ;set ES to segment value
	push es
	push ds
	pop es
	pop ds	    ;flip ds & es
	mov si,4[bp]
	mov ax,ES:[si]
	cmp ax,1
	je call_open
	cmp ax,2
	je call_write
	cmp ax,3
	je call_close

call_open:
	mov si,12[bp]
	push ES:[si]
	mov si,10[bp]
	push ES:[si]
	mov si,8[bp]
	push ES:[si]
	call open_window
	jmp retf5

call_write:
	mov si,8[bp]
	mov ax,ES:[si]+1
	mov si,ax
	call write_window
	jmp retf3

call_close:
	call close_window
	jmp retf2

retf5:	pop ds
	pop bp
	retf 10
retf3:	pop ds
	pop bp
	retf 6
retf2:	pop ds
	pop bp
	retf 4

open_window:
	mov bp,sp
	mov di,Window_ptr
	add di,2
	mov Window_old,di
	mov ah,0fh
	int 10h ; get mode
	mov ah,03h
	int 10h ; read cursor
	mov [di],dx ; save cursor pos
	add di,2
	mov dx,[bp+6]
ow10:	mov ah,02h
	int 10h ; set cursor
	mov ah,08h
	int 10h ; read char
	mov [di],ax
	add di,2
	inc dl
	cmp dl,[bp+4]
	jng ow10
	mov dl,[bp+6]
	inc dh
	cmp dh,[bp+5]
	jng ow10

	mov ax,Window_old
	mov [di],ax
	mov ax,[bp+6] ; upper left
	mov [di+2],ax
	mov ax,[bp+4] ; lower right
	mov [di+4],ax
	mov ax,[bp+2]	; attribute
	mov [di+6],ax
	mov ax,[bp+6] ; current cursor
	mov [di+8],ax
	add di,8
	mov Window_ptr,di

	mov al,0
	mov cx,[bp+6]
	mov dx,[bp+4]
	mov bh,[bp+2]
	mov ah,06h
	int 10h ; clear window
	mov sp,bp
	ret 6

close_window:
	mov bp,Window_ptr
	mov si,DS:[bp-8] ; data start
	add si,2 ; data
	mov ah,0fh
	int 10h ; get mode
	mov dx,DS:[bp-6] ; init cursor
cw10:	mov ah,02h
	int 10h ; set curor
	mov ah,09
	mov al,[si]
	mov bl,[si+1]
	add si,2
	mov cx,1
	int 10h ; write char
	inc dl
	cmp dl,DS:[bp-4]
	jng cw10
	mov dl,DS:[bp-6]
	inc dh
	cmp dh,DS:[bp-3]
	jng cw10
	mov si,DS:[bp-8]
	mov ah,02
	mov dx,[si]
	int 10h ; set cursor
	sub si,2
	mov Window_ptr,si
	ret

write_window: ; receives ascii z in si
	mov bp,Window_ptr ; adr of window
	mov ah,15d
	int 10h ; mode&page
	call cur_adj
ww10:	cmp byte ptr ES:[si],0
	je wwx
	cmp byte ptr ES:[si],13d
	jne $+5
	call zro_col
	cmp byte ptr ES:[si],10d
	jne $+5
	call inc_row
	cmp byte ptr ES:[si],12d
	jne $+5
	call ff_scn
	cmp byte ptr ES:[si]," "
	jl ww20
	mov ah,09h
	mov al,ES:[si]
	mov bl,DS:[bp-2]
	mov cx,1
	int 10h ; write char
	call inc_col
ww20:	inc si
	jmp ww10
wwx:	ret

ff_scn: mov Window_flg,0
	jmp ca20
zro_col:
	mov al,DS:[bp-6]
	mov DS:[bp],al
	jmp short cur_adj
inc_col:
	add byte ptr DS:[bp],1
	jmp short cur_adj
inc_row:
	add byte ptr DS:[bp+1],1

cur_adj:
	mov ax,DS:[bp]
	cmp al,DS:[bp-4]
	jng ca10
	add byte ptr DS:[bp+1],1
	mov cl,DS:[bp-6]
	mov DS:[bp],cl
ca10:	mov ax,DS:[bp]
	cmp ah,DS:[bp-3]
	jng cur_set
	; scroll window
ca20:	mov ah,06h
	mov al,Window_flg
	mov cx,DS:[bp-6]
	mov dx,DS:[bp-4]
	mov bh,DS:[bp-2]
	int 10h ; scroll
	cmp Window_flg,1
	je ca30
	mov ax,DS:[bp-6]
	mov DS:[bp],ax
	mov Window_flg,1
	jmp ca40
ca30:	mov al,DS:[bp-6]
	mov ah,DS:[bp-3]
	mov DS:[bp],ax ; scrolled pos
ca40:	mov ah,15d
	int 10h ; reset page

cur_set:
	mov ah,02
	mov dx,DS:[bp]
	int 10h ; set cur
	ret


_text	ends
	end
