/*** 
*conio.h - definitions and declarations for console and port I/O routines
*
*
*
*Purpose:
*   This include file contains the function declarations for the
*   MS C V2.03 compatible console and port I/O routines.
*
*******************************************************************************/

/* function declarations for those who want strong type checking
 * on arguments to library function calls
 */

#ifdef LINT_ARGS    /* argument checking enabled */

#ifndef NO_EXT_KEYS /* extended keywords are enabled */
char * cdecl cgets(char *);
int cdecl cprintf(char *, ...);
int cdecl cputs(char *);
int cdecl cscanf(char *, ...);
int cdecl getch(void);
int cdecl getche(void);
int cdecl inp(unsigned int);
int cdecl kbhit(void);
int cdecl outp(unsigned int, int);
int cdecl putch(int);
int cdecl ungetch(int);
#else           /* extended keywords not enabled */
char *cgets(char *);
int cprintf(char *, ...);
int cputs(char *);
int cscanf(char *, ...);
int getch(void);
int getche(void);
int inp(unsigned int);
int kbhit(void);
int outp(unsigned int, int);
int putch(int);
int ungetch(int);
#endif  /* NO_EXT_KEYS */

#else

#ifndef NO_EXT_KEYS /* extended keywords are enabled */
char * cdecl cgets();
int cdecl cprintf();
int cdecl cputs();
int cdecl cscanf();
int cdecl getch();
int cdecl getche();
int cdecl inp();
int cdecl kbhit();
int cdecl outp();
int cdecl putch();
int cdecl ungetch();
#else           /* extended keywords not enabled */
char *cgets();
int cputs();
int putch();
#endif  /* NO_EXT_KEYS */

#endif  /* LINT_ARGS */
