REM
REM +----------------------------------------------------------------------+
REM |             COPY.BAS distributed as a portion of Mr_OBJ              |
REM |             supplied as an example of usage of Mr_OBJ routines       |
REM |      Copyright (c) 1989 Scott M. Russell all rights reserved         |
REM +----------------------------------------------------------------------+
REM
REM
REM  This basic module is used from within Mr_OBJ to control the primitive,
REM  CopyFile.  Since the primitive CopyFile contains no code for param
REM  checking this module will do any needed parameter checking.
REM  This module uses the following routines:
REM                           ResolvePath
REM                           Extract
REM                           FindFirstNext
REM                           CopyFile


'              $INCLUDE: 'Mr_OBJ.BI'


FUNCTION Copy% (FromFile$, ToFile$) STATIC

'
'              DRIVE NOT SPECIFIED?, ADD ".\" FOR CURRENT DIRECTORY
'
   IF MID$(FromFile$,2,1) <> ":" THEN FromFile$ = ".\" + FromFile$
'
'              NULL SECOND?, ASSUME CURRENT DIRECTORY
'
   IF ToFile$ = "" THEN ToFile$ = "."
'
'              NOT CURRENT OR DRIVE SPECIFIED?, ADD ".\" FOR CURRENT DIRECTORY
'
   IF LEN(ToFile$) > 2 AND MID$(ToFile$,2,1) <> ":" THEN
     ToFile$   = ".\" + ToFile$
   END IF


'
'              RESOLVE "FROM" FILE PATH
'
   Temp$ = ResolvePath(FromFile$, RC%)
   FromFile$ = Temp$

'
'              MAKE SURE "TO" IS USED AS A DIRECTORY
'
   IF MID$(ToFile$,LEN(ToFile$),1) <> "\" THEN ToFile$ = ToFile$ + "\"

'
'              RESOLVE "TO" FILE PATH
'
   ToFile$ = ToFile$
   Temp$ = ResolvePath(ToFile$, RC%)
   ToFile$ = Temp$

'
'              MAKE SURE "\" IS STILL THERE
'
   IF MID$(ToFile$,LEN(ToFile$),1) <> "\" THEN ToFile$ = ToFile$ + "\"


'
'              DON'T ALLOW A COPY OVER ITSELF
'
   IF FromFile$ = ToFile$ THEN
     RC% = 13
     GOTO ExitOut
   END IF

'
'              GET READY FOR FIRST "FindFirstNext" AND PRIME LOOP
'
   RC% = TRUE                                  'use value start option of FFN
   Attrib$ = CHR$(NORMAL)                      'we only want normal files
   FromName$ = Extract(FromFile$)              'extract filename from path
   FromPath$ = FromFile$
   FromFile$ = FromPath$ + FromName$           'rebuild filespec
   DO
      NewFrom$ = FromPath$ + FindFirstNext(Attrib$, FromFile$, RC%) + CHR$(0)
      A$ = NewFrom$
      NewToName$ = Extract(A$)
      NewTo$ = ToFile$ + NewToName$ + CHR$(0)
      IF RC% = 0 THEN RC% = CopyFile(NewFrom$, NewTo$)
    LOOP WHILE RC% = 0

ExitOut:
   Copy% = RC%                               'pass return code back

END FUNCTION
