REM
REM +----------------------------------------------------------------------+
REM |             DELETE.BAS distributed as a portion of Mr_OBJ            |
REM |             supplied as an example of usage of Mr_OBJ routines       |
REM |      Copyright (c) 1989 Scott M. Russell all rights reserved         |
REM +----------------------------------------------------------------------+
REM
REM
REM  This basic module is used from within Mr_OBJ to control the primitive,
REM  DeleteFile.  Since the primitive DeleteFile contains no code for param
REM  checking this module will do any needed parameter checking.
REM  This module uses the following routines:
REM                           ResolvePath
REM                           Extract
REM                           FindFirstNext
REM                           DeleteFile


'              $INCLUDE: 'Mr_OBJ.BI'


FUNCTION Delete% (FileSpec$) STATIC
'
'              MAKE SURE WE HAVE SOMETHING!
'
   IF FileSpec$ = "" THEN
     RC% = 13
     GOTO ExitOut
   ENDIF

'
'              DRIVE NOT SPECIFIED?, ADD ".\" FOR CURRENT DIRECTORY
'
   IF MID$(FileSpec$,2,1) <> ":" THEN FileSpec$ = ".\" + FileSpec$

'
'              RESOLVE "TARGET" FILE PATH
'
   Temp$ = ResolvePath(FileSpec$, RC%)
   FileSpec$ = Temp$

'
'              GET READY FOR FIRST "FindFirstNext"
'
   RC% = TRUE                                'use value start option of FFN
   Attrib$ = CHR$(NORMAL)                    'we only want normal files
   TargetName$ = Extract(FileSpec$)          'extract filename from path
   TargetPath$ = FileSpec$
   FileSpec$ = TargetPath$ + TargetName$     'rebuild filespec
   DO
      NewTarget$ = FromPath$ + FindFirstNext(Attrib$, FileSpec$, RC%) + CHR$(0)
      IF RC% = 0 THEN RC% = DeleteFile(NewTarget$)
    LOOP WHILE RC% = 0

ExitOut:
   Delete% = RC%                             'pass return code back

END FUNCTION
