'===========================================================================
'Updated 12/7/90
'This Demo program is public domain.
'However the MASM routines used by this DEMO are
'Copr. Copyright (C) 1990, Sidney J. Kelly, All rights Reserved.
'===========================================================================

DEFINT A-Z
REM $INCLUDE: 'KMOUSE.BI'
DECLARE SUB BackGround ()
DECLARE SUB Box (ULR%, ULC%, LRR%, LRC%, TitleMen%)
DECLARE SUB Delayer (Factor!)

CONST Factor! = .2  'the delay factor so you can read messages

DIM SHARED Bgrnd%  'so we can keep track of display color

WIDTH 80, 25       'this prevents an error with VIEW PRINT if display
                   'is already in 80 x 43 or 80 x 50 mode
CALL BackGround
CLS                'clear display to background color

ULR = 1: ULC = 1: LRR = 25: LRC = 80: TitleMen = 1
CALL Box(ULR%, ULC%, LRR%, LRC%, TitleMen%)  'draw title screen box

LOCATE 2, 17
PRINT "Kelly Keyboard and Mouse Control Demo 12/8/90"
LOCATE , 20           'approximate centered location

COLOR Bgrnd%, 7
IF EXTKBD% THEN
     PRINT "You have a 101 key, extended keyboard."
ELSE
     PRINT "You have a 83/84 key, normal keyboard."
END IF
COLOR 7, Bgrnd%

CALL GETKBD(Insert%, Caps%, NumL%, Scrolk%)

PRINT

LOCATE , 3
PRINT "Insert key is ";
IF Insert THEN
     PRINT "on."
ELSE
     PRINT "off."
END IF

LOCATE , 3
PRINT "Capslock key is ";
IF Caps THEN
     PRINT "on."
ELSE
     PRINT "off."
END IF

LOCATE , 3
PRINT "Numlock key is ";
IF NumL THEN
     PRINT "on."
ELSE
     PRINT "off."
END IF

LOCATE , 3
PRINT "Scrollock key is ";
IF Scrolk THEN
     PRINT "on."
ELSE
     PRINT "off."
END IF
PRINT

LOCATE , 3
LINE INPUT "Press a couple of keys. "; A$
LOCATE , 3
PRINT "Notice the case of the letters."
LOCATE , 3
PRINT "I will toggle the Caps lock key."
CapsOriginal = Caps
Caps = NOT Caps
CALL SETKBD(Insert%, Caps, NumL%, Scrolk%)

PRINT
LOCATE , 3
LINE INPUT "Press a couple of keys. "; A$
LOCATE , 3
PRINT "Notice the case of the letters."
LOCATE , 3
PRINT "I will now restore the Caps lock key state."
Caps = CapsOriginal
CALL SETKBD(Insert%, Caps, NumL%, Scrolk%)

PRINT
LOCATE , 3
LINE INPUT "Press a couple of keys. "; A$
LOCATE , 3
PRINT "Notice the case of the letters is restored to original status."

PRINT
LOCATE , 3
PRINT "Do you want to end the program? (Y/N) ";
IF YESNO% THEN END

VIEW PRINT 1 TO 22     'clear all but bottom 2 rows
CLS 2
PRINT
PRINT "O.K., I will continue testing the keyboard."
VIEW PRINT  'allow access to last row on screen

LOCATE 24, 5
COLOR Bgrnd%, 7
PRINT "To quit this section, hit ESCAPE, CTRL-C, CTRL-BREAK or CTRL-2."
COLOR 7, Bgrnd%

VIEW PRINT 1 TO 22
LOCATE 3, 1

CLRKBD    'clear keyboard buffer of pending keys.

DO
     DO    'loop until a key is pressed
          Temp = WAITFORKEY%
          IF Temp = -256 THEN
               PRINT "No key pressed"
               PRINT
               CALL Delayer(Factor!)
          ELSE
               EXIT DO
          END IF
     LOOP
   
     CLRKBD    'this makes sure there is no buffer overflow.
   
     'WAITFORKEY returns <0 if extended key, >0 if normal key
     'WAITFORKEY returns -256 if no key pressed.
     'using integers for SELECT CASE makes program very fast

     SELECT CASE Temp
          CASE -3      'Ctrl-2 key a undocumented CTRL-BREAK key
               PRINT "Key pressed was", Temp
               PRINT "You pressed the Control-2 key"
               EXIT DO
          CASE 3       'Ctrl-C key
               PRINT "Key pressed was", Temp
               PRINT "You pressed the Control-C or ALT-3 keys"
               EXIT DO
          CASE 0       'Ctrl-Break key
               PRINT "Key pressed was", Temp
               PRINT "You pressed the Control-BREAK key"
               EXIT DO
          CASE 27      'ESC key
               PRINT "Key pressed was", Temp
               PRINT "You pressed the ESC key"
               EXIT DO
          CASE IS < 0
               PRINT "You pressed an extended key."
          CASE IS > 0
               PRINT "You pressed a normal key."
          CASE ELSE
     END SELECT
   
     PRINT "Key pressed was", Temp; " &H";
        
     IF Temp < 0 THEN
          PRINT HEX$(-Temp)
     ELSE
          PRINT HEX$(Temp)
     END IF
   
     CLRKBD  'clear buffer so no beeps on fast machines if user leans
             'on the keys with typeamatic set to the max.

     CALL Delayer(Factor!)
    
LOOP

CALL Delayer(.9)

VIEW PRINT
CLS
VIEW PRINT 1 TO 24
PRINT

M2 = MMBUFSIZE%    'save current state of Mouse
IF M2 = 0 THEN
     PRINT "Sorry, you do not have a mouse.  This program will end."
     END
END IF

'Warning LEN(MouseBuffer$) can be 600 to 1200 bytes.  This could
'affect string space inside DGROUP
MouseBuffer$ = STRING$(M2%, 0)
M1 = 22     'save state of mouse
M4 = SADD(MouseBuffer$)       'MOUSE subroutine sets ES = DS automatically
'This will work so long as use string$ that is in DGROUP
'Far Strings in QBX will cause problems (solution use ARRAY in COMMON)
CALL MOUSE(M1%, M2%, M3%, M4%)

PRINT "Now we will test your mouse driver."
Temp = MMEXIST%

IF Temp THEN
     PRINT "You have a"; Temp; "button mouse."
ELSE
     PRINT "Sorry, you do not have a mouse.  This program will end."
     END
END IF

PRINT "Speed difference of the routines for testing ";
PRINT "the existence of the mouse driver."
PRINT "Here is MMEXIST%": Temp = MMEXIST%
PRINT "Here is FASTMOUSE%": Temp = FASTMOUSE%
PRINT "You can see FASTMOUSE% is faster."
PRINT

PRINT "Let's turn the mouse cursor on.": MMCURSON
CALL Delayer(.5)

PRINT "Click left button, and I will turn off the mouse cursor."
'must print to display then move mouse so cursor is visible
CALL MMSETLOCATION(10, 8) 'move mouse to a distintive location
'reset normally sends Mouse to exact middle of screen

DO   'make sure button released so we can now test it
     IF NOT MMLEFTBUT% THEN EXIT DO
LOOP

Button = 0
CALL MMPRESSLOCATE(Button%, Times%, Row%, Coll%)  'clear counter

Fore = 7: BackColor = Bgrnd%
DO
     CALL MMPRESSLOCATE(Button%, Times%, x%, x%)   'x% mean I don't care
     IF Times% THEN
          COLOR 7, Bgrnd%
          CLS : PRINT
          PRINT "Mouse cursor is now off."
          MMCURSOFF
          Delayer (.9)
          EXIT DO
     ELSE
          LOCATE 25, 10
          'This makes the last line "flash"
          SWAP Fore, BackColor: COLOR Fore, BackColor
          'turn off cursor if stray to bottom of display over my message
          'this prevents streaking if move mouse while screen is printing
          CALL MMINVIZ(25, 1, 25, 80)   'protect only bottom line
          PRINT "Come on now, press the left mouse button.";
          MMCURSON   'turn cursor back on once display is updated
     END IF
     CALL Delayer(.25)
LOOP
CALL Delayer(.3)

PRINT "This is the MOUSE ZONE.  "
CALL Delayer(1.4)

'to prevent smearing when screen scrolls
IF MMVISIBLE THEN MMCURSOFF  'not necessary, just a protection

PRINT "I will now control your MOUSE until you hit the right button."
PRINT
PRINT "Help!  The walls are closing in on your MOUSE!!"
CALL Delayer(1.4)

ULR = 1: ULC = 1: LRR = 24: LRC = 78: TitleMen% = 0
MMCURSON
Button = 1  'Right button
CALL MMPRESSLOCATE(Button%, Times%, x%, x%)  'clear counter
DO
     CLS 2
     CALL MMLIMIT(ULR%, ULC%, LRR%, LRC%)
     CALL MMSETLOCATION(12, 40)

     CALL MMPRESSLOCATE(Button%, Times%, x%, x%)  'clear counter
     IF Times THEN EXIT DO  'as soon as we find a right button click exit

     CALL Box(ULR%, ULC%, LRR%, LRC%, TitleMen%)
    
     CALL MMPRESSLOCATE(Button%, Times%, x%, x%)  'clear counter
     IF Times THEN EXIT DO   'as soon as we find a right button click exit

     CALL Delayer(.4)
     LOCATE 25, 1
     CALL MMLOCATE(Row1%, Col1%) 'get current mouse location
    
     'Note cannot let screen scroll if mouse cursor on or mouse will
     'leave streak marks on the display. To test use line below
     'and comment this line
     PRINT "Mouse Row: "; : PRINT USING "## "; Row1;
     PRINT ". Mouse Col: "; : PRINT USING "##"; Col1;
    
     'To see streak marks on the display use this line
     'PRINT "Mouse Row:"; Row1; PRINT "Mouse Col:"; Col1
    
     PRINT ".   Press right button to move on.              ";

      'make the allowed area smaller each LOOP
     ULR = ULR + 1: ULC = ULC + 2: LRR = LRR - 1: LRC = LRC - 2
     IF ULR > 23 THEN ULR = 1
     IF ULC > 78 THEN ULC = 1
     IF LRR < 2 THEN LRR = 24
     IF LRC < 2 THEN LRC = 78
    
     IF LRR <= ULR THEN
          ULR = 1: LRR = 24
     END IF
     IF LRC <= ULC THEN
          ULC = 1: LRC = 78
     END IF
         
     CALL MMPRESSLOCATE(Button%, Times%, x%, x%)  'clear counter
     IF Times THEN EXIT DO

LOOP

ULR = 1: ULC = 1: LRR = 24: LRC = 80
CALL MMLIMIT(ULR%, ULC%, LRR%, LRC%)
MMCURSOFF   'turn off mouse cursor to prevent smears.

CLS 2
PRINT
PRINT "This was the MOUSE ZONE.  I will give up control of your MOUSE ";
PRINT "when you double click the right button."
CALL Delayer(1.2)

MMCURSON  'turn it back on again
Button = 1 'select right button

DO    'wait until double click of right button
LOOP UNTIL MMDOUBLECLICK%(Button%)

DO   'make sure button released so we can now test it
LOOP UNTIL NOT MMLEFTBUT%
DO   'make sure button released so we can now test it
LOOP UNTIL NOT MMRIGHTBUT%

'delay to prevent button bounce from double click above
CALL Delayer(.2)

DO   'make sure button released so we can now test it
LOOP UNTIL NOT MMLEFTBUT%
DO   'make sure button released so we can now test it
LOOP UNTIL NOT MMRIGHTBUT%


CLRKBD 'clear keybuffer of all pending keys

CLS
LOCATE 10, 1
PRINT "The MASM routines used by this DEMO are"
PRINT "Copr. Copyright (C) 1990, Sidney J. Kelly, All rights Reserved."
PRINT
PRINT "Press any key or MOUSE button to quit."
PRINT "The first to occur (Press of key or Mouse Button) will end the program."

MMCURSOFF                     'turn cursor off

DO
LOOP UNTIL MMORKEY%           'Wait for a key or mouse button to move on

M1 = 23                       'restore original mouse state
M4 = SADD(MouseBuffer$)       'subroutine sets ES = DS automatically
CALL MOUSE(M1%, M2%, M3%, M4%)

MouseBuffer$ = ""             'tell QBASIC we don't need string
END

'==============================Background===================================
'Selects a nice background and cursor size
'depending on the type of CRT
'QBASIC selects a cursor that is properly sized only for the CGA
'Updated 1/9/90
'===========================================================================
SUB BackGround STATIC
     'Check BIOS area of RAM
     DEF SEG = &H40
     'CRTMode = PEEK(&H63)    'Check CRT port
     IF PEEK(&H63) = &HB4 THEN
          'if CRTMode = &HB4  then CRTMode is a Mono display
          Bgrnd% = 0         'use a black background
          LOCATE , , , 12, 13 'Pleasant cursor size
     ELSE
          'else a Color display (correct for EGA/VGA only if cursor
                                'emulation is on).
          Bgrnd% = 1         'use a blue background.  However,
                              'on a COMPAQ portable or EGA/VGA monochrome
                              'this is NOT attractive.
          LOCATE , , , 6, 7   'Pleasant cursor size
     END IF
     COLOR 7, Bgrnd%
     'restore Def Seg
     DEF SEG

END SUB

'----------------------------------------------------------------------------
' DRAW A BOX AT SPECIFIED COORDINATES
' This is a generic routine that can be used to draw a box anywhere.
' ULR% is the starting row. ULC% is the starting column.
' LRR% is the ending row. LRC% is the ending column.
' If the paramater TitleMen% is > 0, then prints horizontal bars
' three rows down from the top of the box and two rows up from the bottom.
' If TitleMen% is set to 0, the routine will print a plain box.
' This can create a quick frame for a title screen.
'
' In my VIDBASIC library is a much faster MASM routine.  This routine is
' added because it is generic and needs no MASM support
'----------------------------------------------------------------------------
SUB Box (ULR%, ULC%, LRR%, LRC%, TitleMen%) STATIC

'to make the definitions local to routine
STATIC BoxTop, BoxTop$, BoxBottom$, BoxMiddle$

' same as BoxSide$ = CHR$(186), CONST is used for speed
CONST BoxSide$ = ""

'The first piece of code sets up the strings for box drawing
BoxTop = (LRC% - ULC%) - 1
IF BoxTop < 0 THEN BoxTop = 0        'keep variable within range

BoxTop$ = CHR$(201) + STRING$(BoxTop, 205) + CHR$(187)
BoxBottom$ = CHR$(200) + STRING$(BoxTop, 205) + CHR$(188)

'This prints the top of the box
LOCATE ULR%, ULC%: PRINT BoxTop$;
  
'Print the sides of the box
FOR E1% = ULR% + 1 TO LRR% - 1
     LOCATE E1%, ULC%: PRINT BoxSide$;
     LOCATE E1%, LRC%: PRINT BoxSide$;
NEXT

'Print the bottom of the box
LOCATE LRR%, ULC%: PRINT BoxBottom$;

'Optionally prints horizontal lines at top and bottom of the box
'To set up title and menu screens.
IF TitleMen% > 0 THEN
     BoxMiddle$ = CHR$(204) + STRING$(BoxTop, 205) + CHR$(185)
     LOCATE ULR% + 3, ULC%: PRINT BoxMiddle$;
     LOCATE LRR% - 2, ULC%: PRINT BoxMiddle$;
END IF
         
'speed up garbage collection and allow use of STATIC
 BoxTop$ = "": BoxBottom$ = "": BoxMiddle$ = ""

END SUB

' =============================== Delay ================================
'   Better Timer Delay Function
'   Delay based on time so that wait will be the same on any processor.
'   Notice the check for negative numbers so that the delay won't
'   freeze at midnight when the delay could become negative.
'
'   A much better routine is available in Programmers Journal that uses
'   Long integers for more precise delays. That routine is copyrighted
'   by ETHAN WINER of Cresent Software.
'
'   The TIMER uses floating point numbers which adds 10kb to the program.
'   For that matter SOUND and VAL both use floating point numbers.
'
'   I use this because it is generic and doesn't require MASM.
' ======================================================================
SUB Delayer (Factor!) STATIC
   STATIC Begin!
 
   Begin! = TIMER
   DO UNTIL (TIMER - Begin! > Factor!) OR (TIMER - Begin! < 0)
   LOOP

END SUB

