ECHO OFF
CLS
if [%1]==[] goto NODRIVE
set DR=%1
goto OK1
:NODRIVE
ECHO Usage:
ECHO   When running this, select the path containing the source code
ECHO   to be cross referenced by the demo.
ECHO   Example:      DEMO C:\SOURCE
ECHO     or          DEMO A:
goto NGexit
:OK1
ECHO ******************************************************************
ECHO              Demonstration of FileXref Version 1.3
ECHO         A New Type of Cross Reference Tool for Programmers
ECHO ******************************************************************
ECHO                            -
ECHO A utility named FileList will be used to create the list of your
ECHO source files to be read by the demo.
ECHO ******************************************************************
ECHO Then FileXref will scan those files producing:
ECHO                            -
ECHO    A file usage report file, in both extended and condensed format
ECHO    so you can see which format you would prefer  ... and...
ECHO                            -
ECHO    a word usage report file of symbols beginning with the letters
ECHO    "re", but excluding the words "read" and "real" to demonstrate
ECHO    symbol inclusion and exclusion capabilities.
ECHO ******************************************************************
PAUSE
CLS
ECHO ******************************************************************
ECHO FileList is now creating the list of files to be read ...
FILELIST  %DR% > FileXref.FSL
ECHO ******************************************************************
ECHO Press enter to begin scanning and cross referencing the list of
ECHO files. this will process data at about 3,500 characters/second on
ECHO a 286. This is about five minutes per megabyte of source
ECHO code.
ECHO ******************************************************************
PAUSE
CLS
FileXref  /RPTB
ECHO ******************************************************************
ECHO Press Enter to see the FileXref statistics:
ECHO ******************************************************************
PAUSE
CLS
TYPE FileXref.MSG | MORE
ECHO ******************************************************************
PAUSE
CLS
ECHO ******************************************************************
ECHO                            -
ECHO The following Report files were produced:
ECHO      1. List of unreferenced files
ECHO      2. Condensed file usage report
ECHO            (all files assumed to be in the same subdirectory,
ECHO             seven references printed per line)
ECHO      3. Condensed word usage report
ECHO            (all files assumed to be in the same subdirectory,
ECHO             five references printed per line)
ECHO      4. File usage report
ECHO            (files assumed to be on separate directories,
ECHO             one reference printed per line)
ECHO      5. Word usage report
ECHO            (files assumed to be on separate directories,
ECHO             one reference printed per line)
ECHO ******************************************************************
PAUSE
CLS
ECHO ******************************************************************
ECHO This concludes the FileXref demonstration.
ECHO                            -
ECHO See the README.DOC file for more information.
ECHO                            -
ECHO Thanks for supporting shareware!
ECHO ******************************************************************
ECHO If you have a printer and wish to print the output reports,
ECHO position your printer to top of page and turn it on now.
ECHO If not, you may view the report file (FILEXREF.RPT) at your
ECHO monitor.
ECHO                            -
ECHO The number of printed pages will depend on the number of source
ECHO files examined and the frequency of cross referencing
ECHO between them. A minimum of five pages will be generated.
ECHO                            -
ECHO [Ctrl+Break] at any time to stop the printing.
ECHO ******************************************************************
PAUSE
ECHO ******************************************************************
ECHO Printing the FileXref processing statistics ...
TYPE FILEXREF.MSG > PRN
ECHO Printing the FileXref cross-reference reports ...
TYPE FILEXREF.RPT > PRN
ECHO End of demonstration.
ECHO ******************************************************************
:NGexit
