page ,132
title ***** DIR6 *****
comment *

=========================================================================
DIR6
04-30-86  by  Thomas E. Link

        Requires DOS 2.0 or higher. (not DOS 1.0,1.1)
        Subroutine to be called from BASIC to get diskette directory.
        A greatly modified version of DIRECTRY by Howard Glosser
        as published in SOFTALK magazine.

        This program should be assembled using MASM.
        `LINK DIR4' will say `no stack segment' error (ignore this).
        Use `EXE2BIN DIR6.EXE DIR6.BIN' to make the load file.

To use first:
       DIM DIRLST$(111)        ' array where directory will be stored.
       DIM DIRLST%(223)        ' array to store file lengths.
       DIM DIRDAT%(111)        ' array to store file dates
       DIM DIRTIM%(111)        ' array to store file times

NOTE !!! ... the dimensions above are large enough for root directories
only(maximum 112 entries). If you are using large subdirectories,
increase the dimensions of the arrays accordingly.

       DIM A%(???)             ' size of .BIN file/2
       LOOK$=STRING$(40,32)    ' reserve 40 bytes for lookstring
       LSET LOOK$=`drive id:\path\filename.ext'+CHR$(0)
           ' name to search for, same as with DIR command
           ' path works only when used with DOS 2.x
           ' This string must terminate with a CHR$(0) !
       VOLUME$=STRING$(13,32)  ' space for volume name
       COUNT%=0                ' number of files found (init to 0).

Because compiled BASIC has a two byte string length you must let the
subroutine know which version you are using with the code below.

   10  DIM COMPILED%(1): COMPILED%(1)=COMPILER_VERSION: ERASE COMPILED%
   20  IF COMPILED%(1)>0 THEN 40
   30  DEF SEG: DIRECTRY=VARPTR(A%[0]):BLOAD `DIR6.BIN',DIRECTRY
   40  CALL DIRECTRY(compiled%[1],look$,dirlst$[0],
       dirlst% [0], dirdat%[0],dirtim%[0],volume$,count%)

       If you are compiling, ignore the error on line 10,
       and include DIR6 as an object file when linking.
=========================================================================
*
BLOAD   equ     1
page
stack   struc                           ; Define the stack area.
        pushed_bp       dw      (?)
        return          dw      (?)
        address         dw      (?)
        countnumber     dw      (?)
        volstring       dw      (?)
        dirtimenum      dw      (?)
        dirdatenum      dw      (?)
        dirlstnum       dw      (?)
        dirlststring    dw      (?)
        lookstring      dw      (?)
        compiledflag    dw      (?)
stack   ends

        poplen  equ     compiledflag - address

workstruc       struc                   ; This will be the internal
        compiled        dw      (?)     ;   structure of WORKSPACE
        list_desc       dw      (?)
        len_addr        dw      (?)
        date_addr       dw      (?)
        time_addr       dw      (?)
        dircount        dw      (?)
        dta             db      48 dup (?)
workstruc       ends

sperr   equ     ds:078Ch

DIREC   segment  'CODE'
        assume CS:DIREC, DS:DIREC, ES:DIREC
header:
;........................................................................
ifdef   BLOAD
        db      0FDH            ; indicate BLOAD file
        dw      0               ; segment - BASIC uses default
        dw      0               ; offset - spec in BLOAD
        dw      rtn_len         ; length of routine
endif
;........................................................................
page
        public  DIRECTRY
DIRECTRY        proc    far
        cld                     ; Clear direction flag.
        mov     cx,sp           ; Save stack pointer for later
        push    bp
        mov     bp,sp           ; Point to arguments on stack.
        call    push_ip         ; Dummy call pushes IP
push_ip:
        pop     si              ; Get IP into SI
        sub     si,offset push_ip       ; Subtract offset into program
        add     si,offset workspace     ; SI now points at workspace.
        mov     bx,[bp].compiledflag    ; get compiled flag into ax
        mov     ax,[bx]
        or      ax,ax                   ; Compiled ??
        jz      dir1                    ; No - skip
        mov     [si].compiled,1         ; Get compiled flag into var
        cmp     ax,1                    ; Is this compiled version 1?
        jne     dir1                    ; No - jump
        mov     sperr,cx                ; If compiled, adjust for int 24
dir1:
        mov     [si].dircount,0         ; Move zero to directory count.

;----------------- get addresses of the parms from BASIC
        mov     dx,si           ; Put address of workspace into DX
        add     dx,offset dta   ; Bump to DTA
        mov     ah,1AH          ; Set AH for *SET DTA* function call.
        int     21H             ; Use DOS interrupt.
        mov     bx,[bp].dirlststring ; Point BX at filename array
        mov     [si].list_desc,bx  ; Store DIRLST$() descriptor address
        mov     bx,[bp].dirlstnum  ; Point BX at length array.
        mov     [si].len_addr,bx   ; Store DIRLIST%() address .
        mov     bx,[bp].dirdatenum ; Point BX at date array
        mov     [si].date_addr,bx  ; Store DIRDATE%() address .
        mov     bx,[bp].dirtimenum ; Point BX at time array
        mov     [si].time_addr,bx  ; Store DIRTIM%() address .

;-----------------  search
        mov     bx,[bp].lookstring      ; Point BX at file specifier ptr
        add     bx,[si].compiled        ; Bump +1 if compiled
        mov     dx,[bx+1]       ; Put address of LOOKSTRING in DX.
        mov     ah,4EH          ; Set AH for directory search.
        mov     cx,10H          ; search for files and directories.
        int     21H             ; Use DOS interrupt.
        jc      findlabel       ; No matches - so look for a label
        inc     [si].dircount   ; found - count first entry.
        call    move2           ; Go move entry into DIRLST().
dir2loop:
        mov     cx,10H
        mov     ah,4FH          ; Set AH for continuation of search.
        int     21H             ; Use DOS interrupt.
        jc      findlabel       ; No matches - so look for a label
        inc     [si].dircount   ; match - count this entry.
        call    move2           ; Go move entry into DIRLST().
        jmp     dir2loop        ; Do again.
findlabel:
        call    get_label       ; look for a volume label
done:
        mov     ax,[si].dircount      ; Move entries count to AX.
        mov     di,[bp].countnumber   ; Get address of COUNT%
        mov     [di],ax         ; Put entry count in COUNT%.
        pop     bp              ; Restore BP.
        ret     poplen          ; Far return and throw away parms

;........................................................................
;----------------- procedure to store results of DOS 2.x search
move2   proc    near
;----------------- first get the file time into array
        mov     ax,si           ; Point AX at Workspace.
        add     ax,offset dta +22; Point AX at DTA + 22
        mov     bx,[si].time_addr     ; Move DIRTIM%() address to BX.
        mov     di,bx           ; Point DI at DIRTIM%().
        add     bx,2            ; Bump BX to next DIRTIM%().
        mov     [si].time_addr,bx  ; Save it in variable space.
        push    si              ; Push workspace on stack
        mov     si,ax           ; Get DTA into SI
                movsw           ; Move time into array.
;----------------- now get the file date into array
        mov     ax,si           ; Save present SI (DTA)
        pop     si              ; Get old value back (workspace)
        mov     bx,[si].date_addr     ; Move DIRDAT%() address to BX.
        mov     di,bx           ; Point DI at DIRDAT%().
        add     bx,2            ; Bump BX to next DIRDAT%().
        mov     [si].date_addr,bx  ; Save it in variable space.
        push    si              ; Push workspace on stack
        mov     si,ax           ; Get DTA back in SI
                movsw           ; Move size into array.
;----------------- get the file length into array
        mov     ax,si           ; Save present SI (DTA)
        pop     si              ; Get old value back (workspace)
        mov     bx,[si].len_addr     ; Move DIRLST%() address to BX.
        mov     di,bx           ; Point DI at DIRLST%().
        add     bx,4            ; Bump BX to next DIRLST%().
        mov     [si].len_addr   ,bx  ; Save it in variable space.
        push    si              ; Push workspace on stack
        mov     si,ax           ; Get DTA back in SI
        mov     cx,2            ; Length of size in words.
        rep     movsw           ; Move size into array.
;-----------------  move filename into string array
        mov     ax,si           ; Save present SI (DTA)
        pop     si              ; Get old value back (workspace)
        mov     bx,[si].list_desc    ; Move DIRLST$() address to BX.
        add     bx,[si].compiled
        mov     di,[bx+1]       ; Point DI at DIRLST$().
        add     bx,3            ; Bump BX to next DIRLST$().
        mov     [si].list_desc,bx ; Save it in variable space.
        push    si              ; Save SI on stack
        mov     si,ax           ; and put DTA address into SI
        mov     cx,8            ; Length of name in bytes
move201:
                lodsb           ; Move character into al
        cmp     al,'.'          ; If is it a period ... jump.
        je      move202
        cmp     al,0            ; If zero - dont jump.
        jne     move201A
        add     di,cx           ; Point DI at period location.
        mov     al,'.'          ; Store it there.
                stosb
        add     di,3            ; bump to end of string.
        jmp     move203         ; Skip to subdir check.
move201A:
                stosb           ; No - store it in output string
        loop    move201
        inc     si              ; We found 8 characters - bump SI past .
move202:
        add     di,cx
        mov     al,'.'          ; Put period in output filename.
                stosb
        mov     cx,3            ; Length of extension in bytes
move202A:
                lodsb           ; Move character into AL.
        cmp     al,0            ; Is it a zero ?
        je      move202B        ; Yes .. jump.
                stosb           ; No .. Store it and loop
        loop    move202A
move202B:
        add     di,cx
move203:
        pop     si
        cmp     byte ptr [si].dta+21,10H        ; is it a subdirectory ?
        jne     move23          ; no - jump
        std                     ; change direction to decrement SI and DI
        dec     di              ; Back up to last character of extension
        mov     cx,3            ; Store `...' as the extension name when
        mov     al,'.'          ; a subdirectory entry.
        rep     stosb
        cld                     ; clear direction flag (increment)
move23:
        ret
move2   endp

;........................................................................

get_label proc near             ;Display the label for the
                                ;disk in the selected drive
        push    si              ; Save SI on stack
        mov     si,dx
        cmp     byte ptr[si]+1,':'    ; Was there a drive ID ?
        jne     drset
        inc     si              ; Yes - skip past
        inc     si
drset:
        mov     byte ptr[si],  '*'      ; Put in *.* as file spec.
        mov     byte ptr[si]+1,'.'
        mov     byte ptr[si]+2,'*'
        mov     byte ptr[si]+3, 0
gl1:
        pop     si              ; Get back SI but leave on stack
        push    si
        mov     ah,4EH          ; Set AH for directory search.
        mov     cx,08H          ; search for volume label.
        int     21H             ; Use DOS interrupt.
        jc      get_label2      ; No matches
;----------------- store volume name in variable
        mov     bx,[bp].volstring    ; Point BX at VOLUME$ descriptor
        add     bx,[si].compiled     ; Bump pointer up 1 if compiled.
        mov     di,[bx+1]       ; Point DI at VOLUME$.
        mov     ax,si
        add     ax,offset dta +30; Point AX at File name in DTA
        mov     si,ax           ; and put DTA address into SI
        mov     cx,13           ; Zero out high byte
gl2:
                lodsb           ; Look at character
        or      al,al
        jz      gl3             ; If zero - end of name
        cmp     al,'.'          ; Dont put period in Volume Name
        jne     gl22
        cmp     cx,5
        je      gl2
gl22:
                stosb           ; Store in destination
        loop    gl2
        jmp     short get_label2
gl3:
        rep     stosb           ; Move zeros into end of string
get_label2:
        pop     si
        ret
get_label endp

;........................................................................
workspace       workstruc       <>      ; This will be data area.
                db      26              ; So we know end of procedure

;........................................................................

rtn_len equ     $ - DIRECTRY
directry        endp
DIREC           ends
                end     header
