	page 64,132
	title DirInfo - a replacement for QB/BC "FILES"
	subttl Copyright 1990 Editing Services Co.
	.model medium, basic
									page +
comment	~

Written by Jim Mack, CIS ID 76630,2012.  Copyright 1990, Editing Services Co.
Permission is granted for non-commercial use of this code by MSSYS members.

     It's important that you read the .DOC file for this function in order to
understand how to call it and what the returned values mean.  One warning bears
repeating here, though:

      THIS ROUTINE MAKES USE OF AN UNDOCUMENTED QB/BC INTERNAL STRUCTURE.
      UNDOCUMENTED INTERNALS MAY CHANGE WITH ANY NEW VERSION OF QB OR BC.

     No one at Microsoft participated in the development of this code, or in my
exploration of any internals.  This is the result of my own experiments and
surmises, and shouldn't be considered definitive or necessarily correct.

     This code is specific to BC7 and QBX, and fully supports the FAR string
model.  The DIRINFO files should be used for earlier versions of BC and QB.
I'll test this code with any new versions as they become available, but be
advised that if you use this with any version of QB or BC not listed above,
you do so at your own risk.

       -- Jim Mack
       January, 1990
~
									page +
;  The following structures make it easier to access the DOS directory
;  information and the contents of the passed array of DirInfoType.

DOSDTA		STRUC

	resvd	db	21 dup (?)
	fattr	db	?
	ftim	dw	?
	fdat	dw	?
	fsiz	dd	?
	fnam	db	13 dup (?)

DOSDTA		ENDS

AD		STRUC

	aryad	dd	?
	ax0	dd	?
	arydm	db	?
	arytp	db	?
	ax2	dw	?
	arysz	dw	?
	aryn1	dw	?

AD		ENDS

UsrType		STRUC

	uattr	dw	?
	utim	dw	?
	udat	dw	?
	usiz	dd	?
	unam	db	12 dup (?)

UsrType		ENDS
									page +
odg	equ	<offset dgroup>		; some useful text macros
wo	equ	<word ptr>
by	equ	<byte ptr>
jsh	equ	<jmp short>
bit	equ	<1 shl>

        .data

; This small amount of DGROUP is needed for us to store some temporary info.

OldDTA		LABEL	DWORD
OldDTAOfs	dw	0
OldDTASeg	dw	0
ArraySiz	dw	0
ArrayUsed	dw	0
OurDTA		db	44 dup (0)
OurSpec		db	66 dup (0)
									page +
; DECLARE FUNCTION DirInfo% (Spec$, Attr%, Array() AS ANY)
;
	.code

EXTRN	STRINGLENGTH:FAR, STRINGADDRESS:FAR

DirInfo		PROC uses di si ds, spec, attr, array

	cld
	mov	ah, 2fH			; get current Disk Transfer Area addr.
	INT	21H
	mov	OldDTASeg, es		; save it to restore later
	mov	OldDTAOfs, bx
	mov	dx, odg:OurDTA
	mov	ah, 1aH			; set DTA to our local area
	INT	21H
	mov	bx, array		; reference to array
	test    by [bx].arytp, bit 1	; is array huge?
	jnz	erary			; yes, exit with error
        cmp     [bx].arydm, 1           ; single dimension array?
	jne	erary			; no, exit w/error
	cmp	[bx].arysz, type UsrType ; array of our TYPE?
	jne	erary			; no, exit w/error
	mov	ax, [bx].aryn1		; number of array elements
	or	ax, ax			; any elements in array?
	jz	erary			; no, exit w/error
	mov	ArraySiz, ax		; save info about array for later
	mov	ArrayUsed, 0		; zero number of elements used
	mov	ax, spec		; point to spec string descriptor
	push	ax			; one push to save it,
	push	ax			; another to pass it.
	call	STRINGLENGTH		; get length the compatible way
	mov	cx, ax
	pop	ax			; recover string descriptor address
	or	cx, cx			; check for null string
	jz	erspc			; no spec passed: error
	cmp	cx, 65			; see if spec too long
	ja	erspc			; yes, limited to 65 bytes
	push	cx			; save length
	push	ax			; pass address of string descriptor
	call	STRINGADDRESS		; get far address of string
	mov	si, ax			; make that the source of a move
	mov	ds, dx
	assume	ds:nothing
	pop	cx			; recover count of bytes to move
	mov	di, odg:ourspec		; get move destination
	mov	ax, @data		; set target of move (ES:DI)
	mov	es, ax
	assume	es:@data
	rep	movsb			; move string to our temp
	mov	es:[di], cl		; NULL at end for DOS
	mov	ax, @data
	mov	ds, ax			; re-establish DS=DGROUP
	assume	ds:@data
	mov	bx, attr		; get attributes to match
	mov	cx, [bx]		; pass them to DOS
	mov	dx, odg:ourspec		; where to check for spec
	mov	ah, 4eH			; ask for first matching file name
	INT	21H
	jnc	@f
	jsh	diend			; C flag = error or no files
									page +
erary:	mov	ax, -512		; these are errors *we* defined
	jsh	di99                    ; see DOC or BAS files for meaning.
erful:	mov	ax, -256		; ...stuck in the middle here for
	jsh	di99			; easier access...
erspc:	mov	ax, -128
	jsh	di99
@@:
	mov	bx, array		; reference to array
	les	di, [bx]		; get address of array
	assume	es:nothing
di20:
	mov	ax, ArrayUsed		; see if room in array
	cmp	ax, ArraySiz		; compare used space with available
	je	erful			; array full: exit w/error
	mov	si, odg:OurDTA+fattr	; start of DTA info needed (attributes)
	lodsb				; pick up attribute as a byte...
	xor	ah, ah			; ...zero high part of the integer...
	stosw				; ...store attributes as a word
	mov	cx, 8			; move numeric data...
	rep	movsb			; ...into array
	mov	cx, 12			; max name bytes to move
@@:	lodsb				; get a name byte
	or	al, al			; see if it's The Terminator (shudder)
	jz	@f			; if so, drop out of this loop...
	stosb				; ...else store it into array...
	loop	@b			; ...and try the next byte
@@:	jcxz	@f			; if we're all done, no fill bytes...
	mov	al, ' '			; ...else fill to end of entry...
	rep	stosb			; ...with blanks
@@:	inc	ArrayUsed		; count this entry
	mov	ah, 4fH			; ask for next matching file
	INT	21H
	jnc	di20			; loop until done or full or error
diend:					; get here if INT 21 returns carry set
	cmp	ax, 2			; check for normal "not found"
	je	di90			; OK
	cmp	ax, 18			; check for normal "no more files"
	je	di90			; OK
	neg	ax			; otherwise, error: return the code
	jsh	di99
di90:					; normal exit, return count of files
	mov	ax, ArrayUsed		; as function value
di99:					; any exit, error or otherwise
	mov	bx, ax			; preserve return value
	lds	dx, OldDta
	mov	ah, 1aH			; reset DTA to entry state
	INT	21H
	mov	ax, bx			; get return code again
	ret				; and get back to BASICs

DirInfo		ENDP
	 END


