dirsub:

'***************************************************************
'*   Directory subroutine                                      *
'*   The Array DIR$ must be DIM'ed to the max amount of        *
'*   dir entrys expected                                       *
'*                                                             *
'*INPUT  dir.fl$.......Directory mask                          *
'*       dir.ext= -1...Provide extended dir info               *
'*       dir.attrib$...Set search for specific "type" files    *
'*                      0 = Normal Files                       *
'*                      1 = Read Only                          *
'*                      2 = Hidden                             *
'*                      4 = System                             *
'*                      8 = Volume Label                       *
'*                     16 = Sub-Directory                      *
'*                     32 = Archived                           *
'*                                                             *
'*                Combinations allowed (eg. 16+8 = 24)         *
'*                Default = 63 (ALL files)                     *
'*                                                             *
'*                                                             *
'*OUTPUT dir.count%....Number of entrys                        *
'*       dir$()........Directory entrys                        *
'*                                                             *
'*       if dir.ext= -1 then dir$() has extended information   *
'*                                                             *
'*       1...5....10...15...20...25...30...35...40             *
'*       filename.ext  mmddyy  hhmmss AAAAAA    bytes..        *
'*       name          date    time   attrib    size           *
'*                                                             *
'***************************************************************

      IF dir.flag <> 1 THEN GOSUB dirsub.load
      IF LTRIM$(RTRIM$(dir.attrib$)) = "" THEN
	 dir.attrib% = 63
      ELSE
	 dir.attrib% = VAL(dir.attrib$)
      END IF
      
      dir.a$ = SPACE$(51): dir.func% = 0: dir.count% = 0
      dir.fl$ = dir.fl$ + CHR$(0)


dirsub1:
      file.attr$ = ""
      DEF SEG : dir.asmsub% = SADD(dirsub.prog$)
      CALL absolute(dir.func%, dir.a$, dir.fl$, dir.attrib%, dir.asmsub%)
      IF dir.attrib% = 18 THEN dir.ext = 0: RETURN
      dir.q$ = MID$(dir.a$, 31): dir.q$ = LEFT$(dir.q$, INSTR(dir.q$, CHR$(0)) - 1)
      dir.count% = dir.count% + 1

      IF dir.ext <> 0 THEN
	 file.attr = ASC(MID$(dir.a$, 22, 1))
	 zz = file.attr
	 yy = zz - 32
	 IF yy > -1 THEN file.attr$ = file.attr$ + "A": zz = yy
	 yy = zz - 16
	 IF yy > -1 THEN file.attr$ = file.attr$ + "D": zz = yy
	 yy = zz - 8
	 IF yy > -1 THEN file.attr$ = file.attr$ + "V": zz = yy
	 yy = zz - 4
	 IF yy > -1 THEN file.attr$ = file.attr$ + "S": zz = yy
	 yy = zz - 2
	 IF yy > -1 THEN file.attr$ = file.attr$ + "H": zz = yy
	 yy = zz - 1
	 IF yy > -1 THEN file.attr$ = file.attr$ + "W": zz = yy
	 IF file.attr$ = "" THEN file.attr$ = "N"
	 ' "W"      'Write Protected
	 ' "H"      'Hidden
	 ' "S"      'System
	 ' "V"      'Volume Label
	 ' "D"      'Sub-Directory
	 ' "A"      'Archived

	 file.size = CVL(MID$(dir.a$, 27, 4))
	 file.size$ = LTRIM$(STR$(file.size))
	 dat& = CVI(MID$(dir.a$, 25, 2))
	 file.day = dat& AND &H1F
	 file.day$ = LTRIM$(STR$(file.day))
	 IF LEN(file.day$) = 1 THEN file.day$ = "0" + file.day$
	 file.mth = (dat& \ 32) AND &HF
	 file.mth$ = LTRIM$(STR$(file.mth))
	 IF LEN(file.mth$) = 1 THEN file.mth$ = "0" + file.mth$
	 file.yr = ((dat& \ 512) AND &H1F) + 80
	 file.yr$ = LTRIM$(STR$(file.yr))

	 tim& = CVI(MID$(dir.a$, 23, 2))
	 IF tim& < 0 THEN tim& = tim& + 65536
	 file.sec = tim& AND &H1F
	 file.min = (tim& \ 32) AND &H3F
	 file.hr = (tim& \ 2048) AND &H1F

	 file.sec$ = LTRIM$(STR$(file.sec))
	 file.min$ = LTRIM$(STR$(file.min))
	 file.hr$ = LTRIM$(STR$(file.hr))

	 IF LEN(file.sec$) < 2 THEN file.sec$ = "0" + file.sec$
	 IF LEN(file.min$) < 2 THEN file.min$ = "0" + file.min$
	 IF LEN(file.hr$) < 2 THEN file.hr$ = "0" + file.hr$
	 IF LEN(file.attr$) < 10 THEN file.attr$ = file.attr$ + STRING$(10 - LEN(file.attr$), " ")

	 filedate$ = file.mth$ + file.day$ + file.yr$
	 filetime$ = file.hr$ + file.min$ + file.sec$

	 dir$(dir.count%) = dir.q$ + SPACE$(14 - LEN(dir.q$)) + filedate$ + "  " + filetime$
	 dir$(dir.count%) = dir$(dir.count%) + " " + file.attr$
	 dir$(dir.count%) = dir$(dir.count%) + file.size$
      ELSE
	 dir$(dir.count%) = dir.q$
      END IF

      dir.func% = 1: GOTO dirsub1


dirsub.load:
      dir.flag = 1


dirsub.data:
      DATA -29867, 1772, 21075, 20561, 22358, 24203,-30196, 15367, 29697
      DATA -29934, 2142, 22411,-29950, 1630, 3979, 20148, 8653, 1515,-19312
      DATA -12977,-29919, 1630, 1929, 12212, 8653,-3189, 24203,-29942, 639
      DATA  11193, 1536, 1566, 1822,-3297, 8100,-5369,-28657, 1162, 1416
      DATA  17991,-31935, 11257, 628,-3349, 24159, 22872, 23386, 23815, 2250
      DATA  0, 0
      DATA "//"
      dir.c = 0: RESTORE dirsub.data
      dirsub.prog$ = ""


dirsub.load1:
      READ dir.a1$
      IF dir.a1$ = "//" THEN RETURN
      dirsub.prog$ = dirsub.prog$ + MKI$(VAL(dir.a1$))
      GOTO dirsub.load1

