code_seg        segment
        assume  cs:code_seg
        org     100h
        jmp     start
;-------------------------------------------
;B/C Software                        ;Author
;520 North Stateline Rd
;Sharon, Pa 16146
;----------------------------------
message1 db     'press Esc to Quit',0dh,0ah,'$'   ;Esc to end downup
message2 db     'press any other key to play$'    ;or to go again
;-----------------------------------------------------------------------------
start   proc    near
        mov     ah,9                 ;DOS function number to print string
        mov     dx,offset message1   ;the message
        int     21h                  ;DOS interrupt
        mov     dx,offset message2   ;the message
        int     21h                  ;DOS interrupt
begin:  mov     ah,0                 ;BIOS function wait for key press
        int     16h                  ;BIOS interrupt
        cmp     ah,1                 ;Esc scan code 
        jz      done                 ;do we stop ?
        call    slidedown            ;slide down
        call    slideup              ;slide up
        jmp     begin                ;go see if we do it again
done:   mov     ax,4c00h             ;no exit back to DOS
        int     21h                  ;DOS interrupt
start   endp
;-------------------------------------------
slidedown  proc    near  
        cli                          ;no interrupts
        mov     dx,5000              ;repeat count
        mov     bx,100               ;start frequency high
        mov     al,10110110xb        ;magic number
        out     43h,al               ;send it
backx:  mov     ax,bx                ;place frequency in (ax)
        out     42h,al               ;send LSB
        mov     al,ah                ;put MSB in (al)
        out     42h,al               ;send it
        in      al,61h               ;get value from port
        or      al,00000011xb        ;ORing will turn speaker on
        out     61h,al               ;send it
        inc     bx                   ;incrementing lowers frequency 
        mov     cx,400               ;delay count in (cx)
loopx:  loop    loopx                ;do nothing loop so we can hear sound
        dec     dx                   ;decrement our repeat count
        jnz     backx                ;if not = 0 go do again
        in      al,61h               ;get port value
        and     al,11111100xb        ;ANDing turns speaker off
        out     61h,al               ;send it
        sti                          ;turn interrupts back on
        ret
slidedown       endp
;-----------------------------------
slideup         proc    near
        cli                          ;no interrupts
        mov     dx,5000              ;repeat count
        mov     bx,5100              ;start frequency low
        mov     al,10110110xb        ;magic number
        out     43h,al               ;send it
backa:  mov     ax,bx                ;place frequency in (ax)
        out     42h,al               ;send LSB
        mov     al,ah                ;put MSB in (al)
        out     42h,al               ;send it
        in      al,61h               ;get value from port
        or      al,00000011xb        ;ORing will turn speaker on
        out     61h,al               ;send it
        dec     bx                   ;decrementing rises frequency 
        mov     cx,400               ;delay count in (cx)
loopa:  loop    loopa                ;do nothing loop so we can hear sound
        dec     dx                   ;decrement our repeat count
        jnz     backa                ;if not = 0 go do again
        in      al,61h               ;get port value
        and     al,11111100xb        ;ANDing turns speaker off
        out     61h,al               ;send it
        sti                          ;turn interrupts back on
        ret
slideup         endp
;----------------------------------
code_seg        ends

