{$A+,B-,D+,E-,F-,I+,L+,N-,O-,R-,S-,V+}
{$M 40000,32768,32768}
Program EgaFont(Input,Output);
{***************************************************************}
{**                                                           **}
{**                         EGA Font                          **}
{**                                                           **}
{**                       Version 2.31                        **}
{**                                                           **}
{**            Copyright 1989 by Aaron M. Williams            **}
{**                                                           **}
{**                  Completed on 09/30/1989                  **}
{**                                                           **}
{**  As being a shareware program,  I would like to ask that  **}
{**  if you find this program useful,  or you wish to use it  **}
{**  in whole or in part within your  own  programs,  send a  **}
{**  check of $10 to:                                         **}
{**                      Aaron  M.  Williams                  **}
{**                      35900   Turpin  Way                  **}
{**                      Fremont, California                  **}
{**                               94536.2666                  **}
{**                                                           **}
{**  Note: All corporations must call me except public domain **}
{**        companies if they  distribute this  program in the **}
{**        complete form.                                     **}
{***************************************************************}
{**                                                           **}
{**                       Requirements                        **}
{**                                                           **}
{**        IBM PC,XT,AT, or compatible (PS/2 not tested)      **}
{**                        256K of RAM                        **}
{**    Enhanced Graphics Adapter or VGA with at least 256k    **}
{**             EGA, VGA, PS/2, or multiscanning CRT          **}
{**  Microsoft compatible mouse (Mouse Systems, Logitec, Etc) **}
{**                Turbo Pascal 5.5  or later                 **}
{**  PC DOS versions 2.10, 3.00, 3.10, 3.20, 3.21, 3.30, 4.00 **}
{**            OS/2 1.10 trashes the help screen              **}
{**                      one disk drive                       **}
{**                                                           **}
{***************************************************************}


uses
  Crt,        {CRT driver}
  Dos,        {DOS functions}
  Fonts,      {Linked fonts unit}
  Drivers,    {Linked driver unit}
  Graph,      {Graphics procedures}
  Mouse;      {Mouse driver interface}

const
  EGA_CHAR_HEIGHT = 14;  {number of scan lines in 8x14 font}

  WIN_X1 = 120;  {Upper left coordinates of font box}
  WIN_Y1 = 92;
  WIN_X2 = 376;  {Right lower coordinates}
  WIN_Y2 = 348;

  CHR_X = 100; {XY coordinates for char being drawn (not in grid)}
  CHR_Y = 60;

  GRID_X_WIDTH = 10;
  GRID_Y_WIDTH = 10;

  NUMBER_OF_MENUS = 20;
  MENU_NAME : array[1..NUMBER_OF_MENUS] of string[14] =  {Menu list}
    ('Next Char',
     'Previous Char',
     'Set ASCII Code',
     'Clear Char',
     'Clear All',
     'Load Set',
     'Save Set',
     'Flip Horiz',
     'Flip Vert',
     'Invert Char',
     'Copy Char',
     '','','','','','',
     'Char Height',
     'Set Speed',
     'Quit');

  MENU_TITLE : array[1..NUMBER_OF_MENUS] of string[19] =  {Titles for help box}
    ('Next Character',
     'Previous Character',
     'Set ASCII Code',
     'Clear Character',
     'Clear Entire Set',
     'Load Character Set',
     'Save Character Set',
     'Flip Horizontally',
     'Flip Vertically',
     'Invert Char',
     'Copy Char',
     '','','','','','',
     'Set Character Height',
     'Set Mouse Speed',
     'Exit to DOS');

type
  YesNoType = (Yes,No);   {Used in yes/no mouse input}
  FileString = string[20];
  MenuProcType = procedure; {used for menu selections.  5.0 specific}

var
  MenuProc  : array[1..NUMBER_OF_MENUS] of MenuProcType; {Used for menu at right}
  MenuUsed  : array[1..NUMBER_OF_MENUS] of boolean;      {  "   "    "  "    "  }

  CharTable                     : array[0..255,0..31] of byte; {Buffer of character bit maps}

  OldX,OldY                     : integer;   {Used for blank and fill}
  FillX,FillY,BlankX,BlankY     : integer;

  AsciiCode                     : byte;  {Currently selected char to edit}
  AsciiChar,c                   : char;

  MaxY,OldMaxY                  : byte;  {maximum scanline for font}

  Q_Y_N                         : YesNoType;
  OKToQuit                      : boolean;  {Set false}

  GraphDriver,
  GraphMode                     : integer;  {Used for BGI}


procedure WaitButton;  {Wait until no mouse button is pressed}
begin
  repeat until MouseButton = 0;
end;

procedure EgaBox(X1,Y1,X2,Y2,color: word); {Draws a box With the EGA/VGA}
begin                                      {Used for update from *.P inline graphics code}
  SetFillStyle(SolidFill,color);
  Bar(X1,Y1,X2,Y2);
end;

procedure TextBox(X1,Y1,X2,Y2,color : integer); {Creates a box using text coordinates}
begin                       {Note: The height of a character is 14 scan lines in mode 10h}
  EgaBox(pred(X1)*8,pred(Y1) * EGA_CHAR_HEIGHT,pred(pred(X2)*8),pred(Y2) * EGA_CHAR_HEIGHT + (EGA_CHAR_HEIGHT-1),color);
end;

procedure EraseLine(x,y,Count,color : integer); {Erases a line in a certain color}
begin
  TextBox(x,y,x+Count,y,color);
end;

procedure TextColor(c : byte);  {New procedure TextColor (Replaces TP's)}
begin
  TextAttr := c;
  SetColor(c and 15);           {Sets current drawing color}
end;

procedure LoadPic(FileName : FileString);    {Loads PC Paintbrush PCX images}
                                             {to page 1 of the EGA/VGA}
{************************************************}
{**                                            **}
{**  The PCX format consist of the following:  **}
{**                                            **}
{**    if Buffer[i] and $C0 = $C0 then         **}
{**     begin                                  **}
{**       CountToRepeat := Buffer[i] and 63;   **}
{**       inc(i);                              **}
{**       DataToPlot := Buffer[i];             **}
{**       inc(i);                              **}
{**     end                                    **}
{**    else                                    **}
{**     begin                                  **}
{**       Count := 1;                          **}
{**       Data := Buffer[i];                   **}
{**       inc(i);                              **}
{**     end;                                   **}
{**                                            **}
{************************************************}

Const
  MaxX : integer = 79; {80 bytes per scan line [0..79]}

var
  i,j                                  : integer;  {junk variables}
  x,y                                  : word;
  n                                    : word;
  color, byt, count                    : byte;
  f                                    : file;
  planes                               : byte;
  mask                                 : byte;
  start                                : boolean;
  Y1,Y2                                : integer;

  Info                                 : array[0..63] of word;
  Offset                               : array[0..3] of word;

  procedure WriteError;
  begin
    CloseGraph;
    TextMode(3);
    writeln;
    writeln('Error reading ',FileName,'.PCX');
    writeln('File not found or something!');
    writeln('Halting EGA Font');
    Halt(1);
  end;

  procedure Plot(Offset : word;Mask,color : byte);  {Plots 8 bits to the CRT}
  begin
    PortW[$3CE] :=  $0310;
    Port[$3C4] := 2;
    Port[$3C5] := color;
    Port[$3CE] := 8;
    Port[$3CF] := Mask;
    Inline(                 {I use inline code to achieve greater speed}
      $B8/$00/$A8/          {mov   ax,0a800h    }
      $8E/$C0/              {mov   es,ax        }
      $8B/$5E/<Offset/      {mov   bx,[Offset]  }
      $26/$8A/$07/          {mov   al,es:[bx]   }
      $B0/$FF/              {mov   al,0ffh      }
      $26/$88/$07           {mov   es:[bx],al   }
    );
  end;

  procedure GetByte(var b : byte);  {is called by load pic for data.  Buffered input}
  var
    buffer          : array[0..32767] of byte;
    number, count   : integer;
    BufSize         : word;

  begin
    BufSize := SizeOf(buffer)-64;
    if start then
     begin
       {$I-}
       BlockRead(F,Buffer,BufSize,Number);
       {$I+}
       if IOresult <> 0 then
         WriteError;
       Count := 0;
       Number := 0;
       Start := false;
     end;
    b := buffer[count];
    inc(count);
    if (count >= bufSize) then
     begin
       count := 0;
       {$I-}
       BlockRead(F,buffer,BufSize,number);
       {$I+}
       if IOresult <> 0 then
         WriteError;
     end;
  end;

begin  {Main LoadPic}
  Count := 0;
  for i := 0 to 3 do
    Offset[i] := 0;
  Assign(F,FileName+'.PCX');
  {$I-}
  Reset(F,2);
  {$I+}
  if Ioresult <> 0 then
    WriteError;
  {$I-}
  BlockRead(F,Info,64);
  {$I+}
  if Ioresult <> 0 then
    WriteError;
  Y1 := Info[3];
  Y2 := Info[5];
  Planes := pred(Hi(Info[32]));
  Start := true;
  {$I-}
  Reset(F,1);
  Seek(F,128);  {Seek to start of data (end of header)}
  {$I+}
  if Ioresult <> 0 then
    WriteError;
  for i := 0 to 3 do
    Offset[i] := 0;
  y := 0;
  while y <= Y2-Y1 do
   begin
     for n := 0 to Planes do
      begin
        color := 1 shl n;
        if Planes = 0 then
          color := 15;
        x := 0;
        repeat
          GetByte(Byt);
          Count := 1;
          if Byt and $C0 = $C0 then
           begin
             Count := Byt and $3F;
             GetByte(Byt);
           end;
          inc(x,Count);
          for i := 1 to Count do
           begin
             Plot(Offset[n],Byt,color);
             inc(Offset[n]);
           end;
        until x > MaxX;
      end;
     inc(y);
   end;
  Close(F);
end;



procedure FillBox(x,y : byte);  {Sets a pixel to white (grid to red) }
begin
  With MouseReturn do
   begin
     if (CharTable[AsciiCode,pred(y)] and (256 shr x) = 0) then
      begin
        Hide;             { *** Hides the mouse cursor during screen IO}
        EgaBox(succ(pred(x)*GRID_X_WIDTH),y*GRID_Y_WIDTH+5,pred(x*GRID_X_WIDTH),y*GRID_Y_WIDTH+(EGA_CHAR_HEIGHT-1),LightRed);
        PutPixel(CHR_X + x, CHR_Y + y, White);
        PutPixel(((AsciiCode and 31) shl 3) + x + WIN_X1-1,AsciiCode and 224 + y + WIN_Y1-1,15); {Plots on main table}
        Show;             { *** Shows the mouse cursor again}
        CharTable[AsciiCode,pred(y)] := CharTable[AsciiCode,pred(y)] or (256 shr x);
        FillX := x;
        FillY := y;
        BlankX := -1;
        BlankY := -1;
      end;
   end;
end;

procedure BlankBox(x,y : byte);  {Blanks a pixel (sets grid to black) }
begin
  With MouseReturn do
   begin
     if CharTable[AsciiCode,pred(y)] and (256 shr x) <> 0 then
      begin
        Hide;
        EgaBox(succ(pred(x)*GRID_X_WIDTH),y*GRID_Y_WIDTH+5,pred(x*GRID_X_WIDTH),y*GRID_Y_WIDTH+(EGA_CHAR_HEIGHT-1),0);
        PutPixel(CHR_X + x,CHR_Y + y, Black);
        PutPixel(((AsciiCode and 31) shl 3) + x + WIN_X1-1,AsciiCode and 224 + y + WIN_Y1-1,1);
        Show;
        CharTable[AsciiCode,pred(y)] := CharTable[AsciiCode,pred(y)] and (255 xor (256 shr x));
        BlankX := x;
        BlankY := y;
        FillX := -1;
        FillY := -1;
      end;
   end;
end;


function YesNo : YesNoType;  {displays the nice YES / NO query }
Label
  END_OF_FUNCT;  {Used to exit loop}

begin
  Hide;
  Q_Y_N := No;
  YesNo := No;
  gotoxy(30,6);
  TextColor(LightRed);
  write(' Yes /');
  EraseLine(36,6,4,White);
  TextColor(White+Blink);
  write(' No ');
  Show;
  WaitButton;
  SetGraphCursor(HandCursor);

  repeat
    if MousePositionIn(232,54,272,98) then  {If mouse is in YES area...}
     begin
       gotoxy(30,6);
       Hide;
       EraseLine(30,6,5,White);
       TextColor(White+Blink);
       write(' Yes ');
       TextColor(LightRed);
       write('/ No ');
       Show;
       while MousePositionIn(232,54,272,98) do  {If pointer is clicked near 'Yes'}
        begin
          if MouseButton <> 0 then   {Yes?}
           begin
             WaitButton;
             Q_Y_N := Yes;
             YesNo := Yes;
             goto END_Of_FUNCT;
           end;
        end;
       Hide;    {Else NO}
       gotoxy(30,6);
       TextColor(LightRed);
       write(' Yes /');
       EraseLine(36,6,4,White);
       TextColor(White+Blink);
       write(' No  ');
       Show;
     end;
  until MouseButton <> 0;

  WaitButton;

END_OF_FUNCT:   {Jumps here}

  Hide;
  EraseLine(30,6,10,Black);
  Show;
  SetGraphCursor(ArrowCursor);
end;


function GetAsciiPosition : byte;   {Returns ASCII code from blue box}
var
  x, y                      : integer;
  AsciiPoint, OldAsciiPoint : byte;

begin
  AsciiPoint := 0;
  SetMouseXY(248,220);
  KeepMouseIn(120,92,375,347);

  repeat
    AsciiPoint := (((MouseX - WIN_X1) shr 3) + ((MouseY - WIN_Y1) and 224));

    if OldAsciiPoint <> AsciiPoint then
     begin
       Hide;
       TextColor(White);

       gotoxy(25,2);
       write(AsciiPoint,'  ');

       gotoxy(30,2);
       write(#0);

       gotoxy(30,2);
       write(Chr(AsciiPoint));
       Show;
     end;
    OldAsciiPoint := AsciiPoint;
  until MouseButton <> 0;

  GetAsciiPosition := AsciiPoint;

  WaitButton;
  KeepMouseIn(0,15,623,335);
  Show;
end;

procedure ShowChar(AsciiCode : byte);   {Updates the grid, blue box, etc.}
var
  x,y : integer;

begin
  Hide;
  TextColor(White);

  gotoxy(25,2);
  write(AsciiCode,'  ');

  gotoxy(30,2);
  write(#0);

  gotoxy(30,2);
  write(chr(AsciiCode));

  for y := 1 to MaxY do
    for x := 0 to 7 do
     begin

       if CharTable[AsciiCode,pred(y)] and ($80 shr x) = ($80 shr x) then
        begin

          EgaBox(((x*GRID_X_WIDTH)+1), (((y-1)*GRID_Y_WIDTH)+EGA_CHAR_HEIGHT+1),
                ((x*(GRID_X_WIDTH))+GRID_X_WIDTH-1), (((y-1)*GRID_Y_WIDTH)+(GRID_Y_WIDTH-1)+EGA_CHAR_HEIGHT),
                LightRed);
               {Show char on drawing grid}

              {Display to right of drawing grid}
          PutPixel(CHR_X+1+x, CHR_Y+y, White);

          {Display on blue grid}
          PutPixel(((AsciiCode and 31) shl 3) + x + WIN_X1, (AsciiCode and 224) + y + WIN_Y1-1, White);

        end
       Else
        begin

          EgaBox(((x*GRID_X_WIDTH)+1), (((y-1)*GRID_Y_WIDTH)+EGA_CHAR_HEIGHT+1),
                ((x*(GRID_X_WIDTH))+GRID_X_WIDTH-1), (((y-1)*GRID_Y_WIDTH)+(GRID_Y_WIDTH-1)+EGA_CHAR_HEIGHT),
                Black);
               {Erase char on drawing grid}

          PutPixel(CHR_X+1+x, CHR_Y+y, Black);

          PutPixel(((AsciiCode and 31) shl 3) + x + WIN_X1,AsciiCode and 224 + y + WIN_Y1-1, Blue);

        end;
     end;
  Show;
end;

{$F+}            {All menu items must be FAR}

procedure Nop;   {do nothing procedure}
begin
end;

procedure Quit;  {Ask to quit to DOS}
begin
  With MouseReturn do
   begin

     WaitButton;
     Hide;

     TextColor(LightRed);

     gotoxy(20,5);
     write('Are you sure you want to quit?');

     Show;

     if YesNo = Yes then
      begin
        CloseGraph;
        TextMode(3);
        Halt(0);
      end;

     Hide;
     EraseLine(20,5,30,Black);
     EraseLine(20,6,30,Black);
     Show;

   end;
end;

procedure MouseSpeed;   {Changes the mouse sensitivity}
var
  Mickeys : word;
  NumStr  : string[2];
  Code    : integer;

begin
  Hide;
  TextColor(LightRed);

  gotoxy(20,5);
  write('Enter mickeys per pixel [8..50] ');

  gotoxy(20,6);
  write('(Default = 8)  ');

  repeat

    Mickeys := 8;
    TextColor(White);

    gotoxy(38,6);
    write('__');

    gotoxy(38,6);
    readln(NumStr);

    Val(NumStr,Mickeys,Code);
    if Code <> 0 then
      Mickeys := 8;

  until (Mickeys in [8..50]);

  SetMickeys(Mickeys);  {Set mouse speed}

  EraseLine(20,5,32,Black);
  EraseLine(20,6,32,Black);
  Show;
end;

procedure SetChar;   {Select ASCII code from menu}
var
  x,y : integer;
begin
  Hide;
  TextColor(LightRed);

  gotoxy(20,5);
  write('Enter ASCII code [0..255] ');

  WaitButton;
  Show;

  AsciiCode := GetAsciiPosition;

  ShowChar(AsciiCode);

  Hide;
  EraseLine(20,5,32,Black);
  EraseLine(20,6,32,Black);
  Show;
end;

procedure CharHeight;  {Change the character height}
var
  NumStr       : string[3];
  Code         : integer;
  i, j, k, l   : integer;

begin
  Hide;
  TextColor(LightRed);

  gotoxy(20,5);
  write('Enter character height [1..32]');

  gotoxy(20,6);
  write('(Default = ',EGA_CHAR_HEIGHT,')  ');

  OldMaxY := MaxY;

  repeat
    TextColor(White);
    gotoxy(38,6);
    write('__');

    gotoxy(38,6);
    readln(NumStr);

    Val(NumStr,MaxY,Code);
    if Code <> 0 then
      MaxY := EGA_CHAR_HEIGHT;

  until MaxY in [1..32];


  if MaxY > OldMaxY then
    for i := OldMaxY to MaxY do
      for j := 0 to 7 do
       begin
         EgaBox(((j*GRID_X_WIDTH)+1), (((i-1)*GRID_Y_WIDTH)+EGA_CHAR_HEIGHT+1),
               ((j*(GRID_X_WIDTH))+GRID_X_WIDTH-1), (((i-1)*GRID_Y_WIDTH)+(GRID_Y_WIDTH-1)+EGA_CHAR_HEIGHT),
               Black);
               {Erase char on drawing grid}
         PutPixel(101+k,60+i,Black);
       end;
    OldMaxY := MaxY;

    if MaxY < 32 then
      for i := succ(MaxY) to 32 do    {Clear scan lines now unused}
       begin
         for l := 0 to 255 do
           CharTable[l,i] := 0;

         for k := 0 to 7 do
          begin
            PutPixel(CHR_X+1+k, CHR_Y+1+i, Black);
            EgaBox(((k*GRID_X_WIDTH)+1), (((i-1)*GRID_Y_WIDTH)+EGA_CHAR_HEIGHT+1),
                  ((k*(GRID_X_WIDTH))+GRID_X_WIDTH-1), (((i-1)*GRID_Y_WIDTH)+(GRID_Y_WIDTH-1)+EGA_CHAR_HEIGHT),
                  Yellow);
               {Erase char on drawing grid}
            SetColor(Blue);

            for j := 0 to 7 do
              Line(WIN_X1,i+WIN_Y1+(j shl 5),WIN_X2,i+WIN_Y1+(j shl 5));
          end;

       end;

  EraseLine(20,5,40,Black);
  EraseLine(20,6,40,Black);
  Show;
end;

procedure NextChar;  {Go to the next character, same as + key}

begin
  inc(AsciiCode);
  ShowChar(AsciiCode);
end;

procedure PreviousChar; {Go to the previous char., same as - key}

begin
  dec(AsciiCode);
  ShowChar(AsciiCode);
end;

procedure ClearChar;  {Clears the current character}
var
  i : integer;

begin
  for i := 0 to 31 do
    CharTable[AsciiCode,i] := 0;
  ShowChar(AsciiCode);
end;

procedure ClearAll;  {Clears the entire set}
var
  i : integer;
begin
  Hide;
  TextColor(LightRed);

  gotoxy(20,4);
  write('Are you sure you wish to erase');

  gotoxy(20,5);
  write('the entire set?');

  Show;
  if YesNo = Yes then
   begin
     FillChar(CharTable[0,0],SizeOf(CharTable),0);
     AsciiCode := 0;
     ShowChar(AsciiCode);

     Hide;
     EgaBox(WIN_X1, WIN_Y1, WIN_X2, WIN_Y2, Blue);
     Show;

   end;

  Hide;
  EraseLine(20,4,39,0);
  EraseLine(20,5,39,0);
  Show;
end;

procedure LoadSet;  {Load a set from a disk}
var
  FileName      : string[40];
  F             : File;
  OldMaxY       : byte;
  color         : word;
  i,j,k,l,x,y   : integer;

begin
  Hide;
  TextColor(LightRed);

  gotoxy(20,3);
  write('Enter the filename under which');

  gotoxy(20,4);
  write('you wish to load the set.');

  gotoxy(20,5);
  write('[Drive:] [Directory] [Filename]');

  EraseLine(20,6,40,Black);
  TextColor(White);
  gotoxy(20,6);
  readln(FileName);

  Show;
  if FileName <> '' then
   begin
     SetGraphCursor(WatchCursor);

     Assign(F,FileName);

     {$I-}        {Turn off I/O checking}
     Reset(F,1);
     {$I+}

     if IOResult <> 0 then
      begin                     {Error found}
        Hide;
        EraseLine(20,6,22,White);
        TextColor(LightCyan+Blink);

        gotoxy(20,6);
        write('Error: File not found!',#7);
        Show;

        Delay(1000);
        SetGraphCursor(ArrowCursor);
      end
     Else
      begin                     {No error}
        Hide;
        EgaBox(120,92,376,348,Blue);
        Show;

        FillChar(CharTable,SizeOf(CharTable),0);
        OldMaxY := MaxY;
        MaxY := FileSize(F) shr 8;

        for AsciiCode := 0 to 255 do
          BlockRead(F,CharTable[AsciiCode,0],MaxY);

        Close(F);
        Hide;

        for AsciiCode := 0 to 255 do
          for y := 0 to pred(MaxY) do
            for x := 1 to 8 do
             begin

               if CharTable[AsciiCode,y] and (256 shr x) = (256 shr x) then
                 color := White
               Else
                 color := Blue;

               PutPixel(((AsciiCode and 31) shl 3) + x + WIN_X1-1,AsciiCode and 224 + y + WIN_Y1, color);
             end;
        AsciiCode := 0;

        if MaxY > OldMaxY then
          for i := succ(OldMaxY) to MaxY do
            for j := 0 to 7 do
             begin
               EgaBox(((x*GRID_X_WIDTH)+1), (((y-1)*GRID_Y_WIDTH)+EGA_CHAR_HEIGHT+1),
                     ((x*(GRID_X_WIDTH))+GRID_X_WIDTH-1), (((y-1)*GRID_Y_WIDTH)+(GRID_Y_WIDTH-1)+EGA_CHAR_HEIGHT),
                     Black);
                     {Erase char on drawing grid}
               PutPixel(CHR_X+1+k,CHR_Y+i,Black);
             end;

        OldMaxY := MaxY;

        if MaxY < 32 then
          for i := succ(MaxY) to 32 do
           begin
             for l := 0 to 255 do
               CharTable[l,pred(i)] := 0;
             for k := 0 to 7 do
              begin
                PutPixel(CHR_X+1+k,CHR_Y+i,Black);
                 EgaBox(((x*GRID_X_WIDTH)+1), (((y-1)*GRID_Y_WIDTH)+EGA_CHAR_HEIGHT+1),
                       ((x*(GRID_X_WIDTH))+GRID_X_WIDTH-1), (((y-1)*GRID_Y_WIDTH)+(GRID_Y_WIDTH-1)+EGA_CHAR_HEIGHT),
                       Black);
                       {Erase char on drawing grid}

              end;
           end;

        ShowChar(0);
        Show;

        SetGraphCursor(ArrowCursor);

      end;     {No Error}
   end;   {if FileName <> ''}

  Hide;
  EraseLine(20,3,39,Black);
  EraseLine(20,4,39,Black);
  EraseLine(20,5,39,Black);
  EraseLine(20,6,39,Black);
  Show;
end;


procedure SaveSet; {Save a set to a disk file}
var
  FileName     : string[40];
  F            : File;
  y,AsciiCode  : integer;

begin
  Hide;
  TextColor(LightRed);

  gotoxy(20,3);
  write('Enter the filename under which');

  gotoxy(20,4);
  write('you wish to save the set.');

  gotoxy(20,5);
  write('[Drive:] [Directory] [Filename]');

  EraseLine(20,6,40,Black);
  TextColor(White);

  gotoxy(20,6);
  readln(FileName);

  Show;
  if FileName <> '' then
   begin
     Assign(F,FileName);
     {$I-}
     ReWrite(F,1);
     {$I+}
     if IOresult <> 0 then
      begin
        Hide;
        EraseLine(20,5,28,White);
        TextColor(Red+Blink);

        gotoxy(20,5);
        writeln(' Error: Illegal filename ',#7);

        EraseLine(20,6,28,White);
        Show;

        Delay(1000);

        SetGraphCursor(ArrowCursor);
        Hide;
        EraseLine(20,5,28,Black);
        EraseLine(20,6,28,Black);
        Show;

      end   {error}
     Else
      begin {no error}
        Show;
        SetGraphCursor(WatchCursor);
        for AsciiCode := 0 to 255 do
         begin

           {$I-}
           BlockWrite(F,CharTable[AsciiCode,0],MaxY);  {Write one entire char at a time to disk}
           {$I+}

           if IOresult <> 0 then
            begin
              Hide;
              EraseLine(20,5,28,White);
              TextColor(Lightcyan+Blink);

              gotoxy(20,5);
              writeln('Error: Disk full or something',#7);

              EraseLine(20,6,28,White);
              Show;

              Delay(1000);
              SetGraphCursor(ArrowCursor);

              Hide;
              EraseLine(20,3,40,Black);
              EraseLine(20,4,40,Black);
              EraseLine(20,5,40,Black);
              EraseLine(20,6,40,Black);
              Show;

              {$I-}
              Close(F);
              {$I+}

              exit;  {Exit procedure on error}

            end;
         end;
        Close(F);
        SetGraphCursor(ArrowCursor);
      end;
   end;
  Hide;
  EraseLine(20,3,39,Black);
  EraseLine(20,4,39,Black);
  EraseLine(20,5,39,Black);
  EraseLine(20,6,39,Black);
  Show;
end;


procedure FlipHoriz;  {Flips the current character horizontally}
var
  i,j,k : byte;

begin
  for i := 0 to 31 do
   begin
     k := CharTable[AsciiCode,i];
     j := 0;

     if (k and 128) = 128 then
       j := j or 1;
     if (k and 64)  = 64  then
       j := j or 2;
     if (k and 32)  = 32  then
       j := j or 4;
     if (k and 16)  = 16  then
       j := j or 8;
     if (k and 8)   = 8   then
       j := j or 16;
     if (k and 4)   = 4   then
       j := j or 32;
     if (k and 2)   = 2   then
       j := j or 64;
     if (k and 1)   = 1   then
       j := j or 128;

     CharTable[AsciiCode,i] := j;
   end;

  ShowChar(AsciiCode);
end;


procedure FlipVert; {Flips the current character vertically}
var
  i,j : byte;
  AsciiStore : array[0..31] of byte;

begin
  for i := 0 to pred(MaxY) do
    AsciiStore[i] := CharTable[AsciiCode,i];

  j := pred(MaxY);

  for i := 0 to j do
   begin
     CharTable[AsciiCode,i] := AsciiStore[j];
     j := pred(j);
   end;

  ShowChar(AsciiCode);
end;


procedure InvertChar;  {Inverts black and white on the current char.}
var
  i : integer;
begin
  for i := 0 to pred(MaxY) do
    CharTable[AsciiCode,i] := CharTable[AsciiCode,i] xor 255;

  ShowChar(AsciiCode);
end;


procedure CopyChar;  {Copies a character from a menu to the current place}
var
  i           : integer;
  AsciiSelect : byte;
begin
  Hide;
  TextColor(LightRed);

  gotoxy(20,5);
  write('Select Character from set');
  Show;
  WaitButton;
  SetMouseXY(248,220);

  AsciiSelect := GetAsciiPosition;

  for i := 0 to 31 do
    CharTable[AsciiCode,i] := CharTable[AsciiSelect,i];

  ShowChar(AsciiCode);

  Hide;
  EraseLine(20,5,32,Black);
  Show;
end;

{$F-} {end of menu items}


procedure Abort(Status : string); {Abourt routine}
begin
  TextMode(C80);  {Set back to text mode}
  writeln;
  TextColor(LightRed+Blink);
  writeln(Status);
  Halt(1);
end;

procedure LoadHelpScreen; {Loads the help screen into page 1}
var
  HelpFile : file of char;
  y, i     : integer;

begin
  SetActivePage(1);
  Assign(HelpFile,'EGAFONT.HLP');
  {$I-}
  Reset(HelpFile);
  {$I+}

  if IOResult <> 0 then
    Abort('Help file not found!');

  SetVisualPage(0);
  EgaBox(0, 0, GetMaxX, GetMaxY, Blue);
  SetColor(Yellow);
  SetWriteMode(OrPut);

  y := 0;
  MoveTo(0,y);

  for i := 1 to FileSize(HelpFile) do
   begin

     read(HelpFile,c);
     if c = #10 then  {if cr}
      begin
        y := y + 8;
        MoveTo(0,y);
      end;
     if c in [#24..#255] then
       OutText(c);

   end;

  SetWriteMode(NormalPut);
  Close(HelpFile);
  SetActivePage(0);
end;

procedure InitGraphicsAndFonts;  {Initialize linked in BGI driver and fonts}
begin                            {Also sets to graph mode}
  GraphDriver := EGA;
  GraphMode := EGAHi;  {640x350 16 colors 2 pages}

  if RegisterBGIdriver(@EGAVGADriverProc) < 0 then
    Abort('EGA or VGA not found!  Terminating to DOS');

  { Register all the fonts }
  if RegisterBGIfont(@GothicFontProc) < 0 then
    Abort('Gothic font not linked!  Terminating to DOS');

  InitGraph(GraphDriver, GraphMode, '');  { activate graphics }

  if GraphResult <> grOk then             { any errors? }
    Abort('Graphics init error: '+GraphErrorMsg(GraphDriver));

  CheckBreak := false;  {No <Ctrl> Break checking}
  DirectVideo := false; {Use BIOS for screen writes in graphics mode}

end;

procedure OpeningScreens; {Draw or load the opening screens}
var
  st         : string;
  BitMapSize : word;
  ImagePtr   : Pointer;
  x, y, i    : integer;

begin
  LoadPic('EGAFont');  {Load EGAFONT.PCX}
  SetVisualPage(1);
  SetActivePage(0);

  SetTextStyle(GothicFont,0,3);
  st := 'EGA Font';

  x := (GetMaxX - TextWidth(St)) div 2;  {Center EGA Font}

  SetWriteMode(OrPut);

  EgaBox(x-6, 114, x+TextWidth(St)+6, 114+TextHeight(St)+6, Blue);
  TextColor(Yellow);

  OutTextXY(x,114,St);

  SetWriteMode(CopyPut);

  BitMapSize := ImageSize(x-7,113,x+TextWidth(St)+7,114+TextHeight(St)+7);

  GetMem(ImagePtr,BitMapSize);

  GetImage(x-7,113,x+TextWidth(St)+7,114+TextHeight(St)+7,ImagePtr^);

  SetTextStyle(DefaultFont,0,1);
  TextColor(White);

  OutTextXY(272,156,  'Version 2.31'  );
  OutTextXY(280,170,  '09/29/1989'    );

  TextColor(Yellow);
  OutTextXY(0,198,    'If you find this program useful, please send '  );

  TextColor(White);
  OutTextXY(360,198,  '$10'  );  {Highlight $10}

  TextColor(Yellow);
  OutTextXY(384,198,  ' so that I may continue to'  );
  OutTextXY(0,212,    'write good software.  If you belong to a corporation that wishes to use my');
  OutTextXY(0,226,    'product or any part of it, call or write me.  Please send checks to:');

  TextColor(White);
  OutTextXY(0,258,    '     Aaron M. Williams');
  OutTextXY(0,272,    '     35900 Turpin Way');
  OutTextXY(0,286,    '     Fremont, California 94536.2666');

  TextColor(Yellow);
  OutTextXY(0,310,    'If you have any questions, please call me between 7:00pm and 9:00pm');
  OutTextXY(0,324,    'at (415) 792-0340');

  EraseLine(1,25,80,Blue);   {Set blue line at bottom (It's been in every version, why remove it?)}

  c := ReadKey;  {Wait for key to display this screen}
  SetVisualPage(0);

  for i := 113 downto 0 do
    PutImage(x-6,i,ImagePtr^,NormalPut);  {scroll EGA Font up to the top of the screen}

  Dispose(ImagePtr);

  Delay(5000);     {5 second delay}
end;


procedure InitWorkScreen;  {Draws the editing screen}
var
  x, y, i  : integer;

begin
  FillX := -1;  {No filling}  {Used in grid}
  FillY := -1;
  BlankX := -1; {No blanking}
  BlankY := -1;

  FillChar(CharTable[0,0],SizeOf(CharTable),0);  {Initialize CharTable}

  AsciiCode := 0;
  AsciiChar := chr(0);

  ClearDevice;
  TextColor(Green);

  Rectangle(471,27,632,43);  {Message box}

  TextBackground(Black);
  EgaBox(0,0,GetMaxX,(EGA_CHAR_HEIGHT-1),Blue); {Draw top border}
  TextColor(Yellow+Blink);
  gotoxy(14,1);
  write('EGA Font Editor');

  TextColor(White+Blink);
  write(' Copyright 1989 by Aaron M. Williams');

  TextColor(White);
  gotoxy(12,3);
  write('X,Y');

  gotoxy(12,2);
  write('ASCII Code = 0  ');

  gotoxy(12,4);
  write('1,1');

  TextColor(LightGreen);
  gotoxy(55,24);
  write(' Help ');

  SetColor(LightRed);
  Rectangle(431,321,480,337);  {Draw help box border}

  SetColor(Yellow);
  Line(0,(EGA_CHAR_HEIGHT-1),GetMaxX,(EGA_CHAR_HEIGHT-1));
  Line(0,EGA_CHAR_HEIGHT,0,GetMaxY);
  Line(GetMaxX,EGA_CHAR_HEIGHT,GetMaxX,GetMaxY);
  Line(0,GetMaxY,GetMAxX,GetMaxY);  {Draw peremeter}

         {  ___   change to constant later}
  EgaBox(0, 154, GRID_X_WIDTH*8, GetMaxY-1, Yellow);

  SetColor(Yellow);
  x := 0;
  MaxY := 32;

  for i := 1 to 8 do  {Draw grid v-lines}
   begin
     inc(x,GRID_X_WIDTH);
     Line(x,EGA_CHAR_HEIGHT,x,GetMaxY);
   end;
  y := EGA_CHAR_HEIGHT;

  for i := 1 to EGA_CHAR_HEIGHT do  {Draw grid h-lines}
   begin
     inc(y,GRID_Y_WIDTH);
     Line(0,y,GRID_Y_WIDTH*8,y);
   end;

  LoadHelpScreen;    {read in the help file}

  InitMouse;         {Initialize the mouse driver}

  if not MouseReturn.Installed then
    Abort('Mouse driver not found!');

  EgaBox(WIN_X1, WIN_Y1, WIN_X2, WIN_Y2, Blue);  {Draw blue background for character table}

  Show;
  SetGraphCursor(ArrowCursor);

  KeepMouseIn(0,15,623,335);  {Set limits for mouse movement}

  MaxY := EGA_CHAR_HEIGHT;
  OldMaxY := EGA_CHAR_HEIGHT;
end;

procedure ProcessKeyForBox;
var
  c : char;
  i : integer;
begin
  if KeyPressed then
   begin
     c := ReadKey;

     if (c=#0) and KeyPressed then
      begin
        c := ReadKey;

        case c of

          #75 : begin  {Left}
                  for i := 0 to pred(MaxY) do
                  CharTable[AsciiCode,i] := CharTable[AsciiCode,i] shl 1;
                  ShowChar(AsciiCode);
                end;

          #77 : begin  {Right}
                  for i := 0 to pred(MaxY) do
                    CharTable[AsciiCode,i] := CharTable[AsciiCode,i] shr 1;

                  ShowChar(AsciiCode);
                end;

          #72 : begin  {Up}
                  for i := 1 to pred(MaxY) do
                    CharTable[AsciiCode,pred(i)] := CharTable[AsciiCode,i];

                  CharTable[AsciiCode,pred(MaxY)] := 0;
                  ShowChar(AsciiCode);
                end;

          #80 : begin  {Down}
                  for i := MaxY DownTo 1 do
                    CharTable[AsciiCode,i] := CharTable[AsciiCode,pred(i)];

                  CharTable[AsciiCode,0] := 0;
                  ShowChar(AsciiCode);
                end;

          #45 : begin  {Alt X}
                  CloseGraph;
                  TextMode(3);
                  Halt(0);
                end;
        end;
      end
     Else   {if not keypressed (not extended char.)}
        case c of

         '+' : begin  {inc}
                 inc(AsciiCode);
                 ShowChar(AsciiCode);
               end;

         '-' : begin  {dec}
                 dec(AsciiCode);
                 ShowChar(AsciiCode);
               end;
       end;
   end;
end;


procedure MenuInit; {Sets up MenuProc for the menu routine.  5.0 specific code}
var
  i : integer;
begin
  for i := 1 to NUMBER_OF_MENUS do
    MenuUsed[i] := true;

  MenuProc[1] := NextChar;
  MenuProc[2] := PreviousChar;
  MenuProc[3] := SetChar;
  MenuProc[4] := ClearChar;
  MenuProc[5] := ClearAll;
  MenuProc[6] := LoadSet;
  MenuProc[7] := SaveSet;
  MenuProc[8] := FlipHoriz;
  MenuProc[9] := FlipVert;
  MenuProc[10] := InvertChar;
  MenuProc[11] := CopyChar;

  for i := 12 to 17 do
   begin
     MenuProc[i] := Nop;  { Fill with blank menus }
     MenuUsed[i] := false;
   end;

  MenuProc[18] := CharHeight;
  MenuProc[19] := MouseSpeed;
  MenuProc[20] := Quit;

  TextColor(LightRed);

  for i := 1 to NUMBER_OF_MENUS do {Display menu list on screen}
   begin
     gotoxy(65,i+4);
     write(MENU_NAME[i]);
   end;

end;

procedure CheckMenu;  {Checks the mouse and calls menu routines accordingly}
var
  MX, MY : word;

begin
  while MousePositionIn(512,56,639,336) and not KeyPressed do
   begin

     MouseXY(MX,MY);
     MX := succ(MX shr 3);  {Convert to text coordinates}
     MY := succ(MY div EGA_CHAR_HEIGHT);
     dec(MY,4);

     if (MX >= 65) and (MY >= 1) and (MY <= NUMBER_OF_MENUS) and MenuUsed[MY] then
      begin
        Hide;
        TextColor(White);

        gotoxy(60,3);
        write(MENU_TITLE[MY]);

        EraseLine(65,MY+4,14,White);

        TextColor(White+Blink);
        gotoxy(65,MY+4);
        write(MENU_NAME[MY]);
        Show;

        repeat
          if MouseButton <> 0 then
           begin

             MenuProc[MY];  {Use of new procedural type} {5.0 feature}

             WaitButton;
           end;
        until not XYPos(65,MY+4,79) or KeyPressed;

        Hide;
        EraseLine(65,MY+4,14,Black);
        TextColor(LightRed);

        gotoxy(65,MY+4);
        write(MENU_NAME[MY]);

        EraseLine(60,3,19,Black);
        Show;
      end;
   end;
end;

procedure ProcessBox; {Processes stuff within the grid}
var
  x, y : integer;

begin
  OldX := succ(MouseX div 10);
  OldY := succ((MouseY - EGA_CHAR_HEIGHT) div 10);

  if OldX > 8 then
    OldX := 8;

  if OldY > MaxY then
    OldY := MaxY;

  With MouseReturn do
    repeat

      x := succ(MouseX div GRID_X_WIDTH);
      y := succ((MouseY - EGA_CHAR_HEIGHT) div GRID_Y_WIDTH);

      if x > 8 then
        x := 8;

      if y > MaxY then
        y := MaxY;

      if (OldX <> x) or (OldY <> y) then
       begin
         Hide;
         gotoxy(12,4);
         TextColor(White);
         write(x,',',y,' ');
         Show;
       end;
      if ButtonMask = 1 then  {Left button}
        FillBox(x,y);
      if ButtonMask = 2 then  {Right Button}
        BlankBox(x,y);

      ProcessKeyForBox;  {Process cursor keys and <ALT X>}

      OldX := x;
      OldY := y;

    until not MousePositionIn(0,15,79,MaxY*GRID_Y_WIDTH+(EGA_CHAR_HEIGHT-1));
end;

procedure ProcessHelp; {Process a button click in the help box}
begin

  if XyPos(55,24,61) then  {If in help box then}
   begin
     Hide;
     gotoxy(60,3);

     TextColor(LightRed);
     write('Help');        {display 'Help' in help box'}

     gotoxy(56,24);
     EraseLine(55,24,6,White);  {clear help box to white}
     TextColor(Blink+White);    {blink is xor}
     write('Help');             {xor to reverse video}
     Show;

     repeat
       if MouseButton <> 0 then
        begin
          Hide;
          SetVisualPage(1);     {page where help screen resides for instant access}
          Show;

          WaitButton;
          repeat until MouseButton <> 0;
          WaitButton;

          Hide;
          SetVisualPage(0);
          Show;
        end;
     until not XyPos(55,24,61);

     Hide;
     gotoxy(56,24);
     EraseLine(55,24,6,Black);
     TextColor(LightGreen);
     write('Help');
     EraseLine(60,3,19,Black);
     Show;
   end;
end;

procedure ProcessAltX;
var
  c : char;
begin
  if KeyPressed then
   begin
     c := ReadKey;
     if (c=#0) and KeyPressed then
      begin
        c := ReadKey;
        if c = #45 then {if <ALT X>}
         begin
           CloseGraph;
           TextMode(3);  {CO80}
           Halt(0);      {Exit to DOS}
         end;
      end;
   end;
end;

{Main code}

begin

  InitGraphicsAndFonts;     {Go into graphics mode}

  OpeningScreens;           {Draw introduction screens}

  ClearDevice;              {Clear the screen}

  InitWorkScreen;           {Draws grid and main screen}

  MenuInit;                 {Install menu procedures}

  OKToQuit := false;        {Not currently set, just there to keep a continuous loop}

  repeat

    while MousePositionIn(0,15,79,MaxY * 10 + (EGA_CHAR_HEIGHT-1)) do  {if mouse is in box area}
      ProcessBox;   {Check and update grid and characters}

    ProcessAltX;    {Check if <ALT> X pressed to exit}

    ProcessHelp;    {Check if help selected}

    CheckMenu;      {See if we are in the menu area}

  until OKToQuit;   {end of main loop}

end.

