/**************************************
 ** EMAILNME.H   - by John Adkins    **
 **                06/05/92          **
 **                                  **
 ** Email Name Class                 **
 **************************************/

#ifndef __EMAILNME__
#define __EMAILNME__

/**************************************
 ******  INCLUDES  ********************
 **************************************/

#include <sortable.h>
#include <string.h>
#include <stdlib.h>

/**************************************
 ******  CLASSES  *********************
 **************************************/

class TTempStr
{
  public:
    TTempStr(char *initstr) { str=strdup(initstr); }
    ~TTempStr() { free(str); }
    operator char*() { return(str); }
  private:
    char        *str;
};

class TEmailName : public Sortable
{
  public:
    TEmailName(const char *);
    TEmailName(TEmailName &);
    virtual ~TEmailName();
    virtual classType isA() const { return(__firstUserClass); }
    virtual char *nameOf() const { return("TEmailName"); }
    virtual hashValueType hashValue() const { return(0); }
    virtual int isEqual(const Object&) const;
    virtual int isLessThan(const Object &) const;
    virtual int isSortable() const { return(1); }
    virtual void printOn(ostream &) const;
    virtual TTempStr getFirstName() const { return(firstname); }
    virtual TTempStr getLastName() const { return(lastname); }
    virtual TTempStr getUserID() const { return(userid); }
    virtual TTempStr getServerName() const { return(servername); }
  private:
    char        *firstname;
    char        *lastname;
    char        *userid;
    char        *servername;
};

/**************************************
 ******  END OF EMAILNME.H  ***********
 **************************************/

#endif

