/*
	event.H

	Keyboard, Mouse, and Timer Event Handler Header File

	Copyright (C) 1993, Geoff Friesen B.Sc.
	All rights reserved.

	Borland C++ 3.1
*/

#define	OK	0
#define	ERROR	-1

#define	KEY	0
#define	MOUSE	1
#define	TIMER	2

#define	NTIMER	32

#define	ME_MCM	1	/* mouse cursor movement  */
#define	ME_LBP	2	/* left button pressed    */
#define	ME_LBR	4	/* left button released   */
#define	ME_RBP	8	/* right button pressed   */
#define	ME_RBR	16	/* right button released  */
#define	ME_MBP	32	/* middle button pressed  */
#define	ME_MBR	64	/* middle button released */

typedef struct
	{
	   int type;
	   int parm1;
	   int parm2;
	   int parm3;
	   int parm4;
	}
	event;

#ifdef __cplusplus
extern "C"
{
#endif

int	e_close		(void);
int	e_fetch		(event *e);
int	e_flush		(void);
int	e_hide		(void);
int	e_hook		(int (*_hook) (int ax, int bx, int cx, int dx),
			 void (*_mshow) (void), void (*_mhide) (void));
int	e_init		(int maxevents);
int	e_mstatus	(int *exist, int *nbuttons);
int	e_resume	(void);
int	e_settimer	(int id, int value);
int	e_show		(void);
int	e_srstatus	(int *sflag);
int	e_stoptimer	(int id);
int	e_suspend	(void);
int	e_tstatus	(int id, int *eflag, int *value);

#ifdef __cplusplus
}
#endif