.MODEL tiny
.code
	org	0100h

	jmp	init_code

TRUE		equ	1
FALSE		equ	0

old_int_9	dd	?		; old keyboard int ptr
old_int_8	dd	?		; old timer int ptr
old_int_10	dd	?		; old video int ptr
fade_type	db	0		; fade out = 0, fade in = 1
fade_in		db	FALSE		; true if fading in
counter		dw	3276		; tick var (decrements)
count_down	dw	3276		; reset counter to this value
buffer		db	768 dup(0)	; used for fading
temp_buf	db	768 dup(0)	; stores all palettes while faded
faded		db	FALSE		; true if fading started
all_done	db	TRUE		; true if not fading



new_keyboard_int	proc far
;
; ties into keyboard interrupt to reset counter or stop fade
;
; Entry: none
; Exit:  none
;
	call	stop_fade
	jmp	dword ptr cs:[old_int_9] ; jump to old int9
new_keyboard_int	endp


new_video_int	proc	far
	cmp	ah,0			; are we changing modes?
	je	new_video_int_5		; yes, stop everything in fade
	jmp	new_video_int_10
new_video_int_5:
	mov	cs:[fade_in],FALSE
	mov	cs:[faded],FALSE
	mov	cs:[fade_type],0
	mov	cs:[all_done],TRUE
	push	ax
	mov	ax,cs:[count_down]
	mov	cs:[counter],ax
	pop	ax
new_video_int_10:
	cmp	ah,9			; write char and attr?
	je	new_video_int_20	; yes, jump
	cmp	ah,0ah			; write char at cursor pos?
	je	new_video_int_20	; yes, jump
	cmp	ah,0ch			; write dot?
	je	new_video_int_20	; yes, jump
	cmp	ah,0eh			; write tty?
	je	new_video_int_20	; yes, jump
	cmp	ah,6			; scroll up?
	je	new_video_int_20	; yes, jump
	cmp	ah,7			; scroll down?
	je	new_video_int_20	; yes, jump

	cmp	ah,0bh			; set color palette?
	je	new_video_int_40	; yes, jump
	cmp	ah,10h			; palette stuff?
	je	new_video_int_40	; yes, jump
	cmp	ah,6fh			; Video 7 extended function?
	je	new_video_int_40	; yes, jump

	jmp	new_video_int_60

new_video_int_20:
	call	stop_fade		; reverse fade if faded or fading
	jmp	new_video_int_60	; jump to old int 10

new_video_int_40: ; this stops everything and immediately sets the palettes back
	cmp	cs:[all_done],TRUE
	jne	new_video_int_45
	jmp	new_video_int_60
new_video_int_45:
	push	ax
	push	cx
	push	dx
	push	ds
	push	si

	mov	dx,3c8h
	mov	al,0
	out	dx,al
	inc	dx
	mov	cx,768
	mov	ax,cs
	mov	ds,ax
	mov	si,offset temp_buf
new_video_int_50:			; loop to reset all palettes
	lodsb
	out	dx,al
	loop	new_video_int_50

	call	stop_fade
	mov	cs:[all_done],TRUE
	mov	cs:[faded],FALSE
	mov	ax,cs:[count_down]
	mov	cs:[counter],ax
	pop	si
	pop	ds
	pop	dx
	pop	cx
	pop	ax

new_video_int_60:
	jmp	dword ptr cs:[old_int_10]	; jump to old int 10h
new_video_int	endp

;
; stop_fade
;
; sets all vars to reverse or reset fade so screen returns
; to normal
;
stop_fade	proc	near
	cmp	cs:[fade_type],0
	jne	stop_fade_10
	cmp	cs:[faded],TRUE
	jne	stop_fade_10
	mov	cs:[fade_in],TRUE
	mov	cs:[fade_type],1
stop_fade_10:
	cmp	cs:[counter],0
	jz	stop_fade_20
	push	ax
	mov	ax,cs:[count_down]
	mov	cs:[counter],ax
	pop	ax
stop_fade_20:
	ret
stop_fade	endp

;This is the actual fader.
new_int_8 proc	far
	cli
	pushf
	call	dword ptr cs:[old_int_8]	; call old timer interrupt
	sti

	cld

	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	es
	push	ds

	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	cmp	[counter],2	; about ready to fade?
	jne	new_int_8_20	; no, continue
	cmp	[fade_type],0	; fade out?
	jne	new_int_8_20	; no, continue
	cmp	[all_done],TRUE ; done?
	jne	new_int_8_20	; yes, continue
	mov	dx,3c7h
	mov	al,0
	out	dx,al
	mov	[all_done],FALSE	; not done
	mov	cx,768
	mov	di,offset temp_buf	; copy the pals to temp_buf
	mov	dx,3c9h
new_int_8_10:
	in	al,dx
	stosb
	loop	new_int_8_10
new_int_8_20:
	cmp	[counter],0		; timer run out?
	je	new_int_8_30		; yes, don't decrement it
	dec	[counter]
new_int_8_30:
	cmp	[fade_type],0		; fading out?
	jne	new_int_8_40		; no, continue
	cmp	[counter],0		; time run out?
	jne	new_int_8_40
	jmp	short new_int_8_50
new_int_8_40:
	jmp	short new_int_8_90	; no, continue
new_int_8_50:
	mov	[fade_in],FALSE		; no fading in
	mov	[faded],TRUE		; is faded
	mov	dx,3c7h
	mov	al,0
	out	dx,al
	mov	di,offset buffer
	mov	dx,3c9h
	mov	cx,768

new_int_8_60:
	in	al,dx			; copy pals to buffer
	stosb
	loop	new_int_8_60


	mov	dx,3c8h
	mov	al,0
	out	dx,al

	mov	[all_done],TRUE		; all done
	inc	dx
	mov	cx,768
	mov	si,offset buffer
new_int_8_70:

	cmp	byte ptr [si],0		; is it black?
	je	new_int_8_80		; yes, continue
	mov	[all_done],FALSE	; no, change to not all done
	dec	byte ptr [si]		; dec the color (fade part)
new_int_8_80:
	lodsb
	out	dx,al
	loop	new_int_8_70		; write out pals

	jmp	new_int_8_130		; jmp to end
new_int_8_90:
	mov	dx,3dah
	cmp	[fade_type],1		; fade in?
	jne	new_int_8_95		; no, continue
	cmp	[fade_in],TRUE		; fading in?
	jne	new_int_8_95		; no, continue
	cmp	[counter],0		; counter 0?
	jne	new_int_8_95		; no, continue
	jmp	new_int_8_100		; go to fade in
new_int_8_95:
	jmp	new_int_8_130		; go to end of proc
new_int_8_100:
	in	al,dx			; wait vert retrace
	test	al,8
	jz	new_int_8_100

	mov	dx,3c8h
	mov	al,0
	out	dx,al
	inc	dx
	mov	[all_done],TRUE		; assume finished
	mov	cx,768
	mov	si,offset buffer
	mov	di,offset temp_buf
new_int_8_110:
	mov	al,[si]
	cmp	al,[di]			; compare the buffers to check if finished
	jae	new_int_8_120		; all done, jump
	inc	byte ptr [si]		; fade in (actual fade part)
	mov	[all_done],FALSE	; not all done

new_int_8_120:
	lodsb				; write out all palettes
	out	dx,al
	inc	di
	loop	new_int_8_110

	cmp	[all_done],TRUE		; are we done yet?
	jne	new_int_8_130		; no, exit
	mov	[fade_in],FALSE		; yes, turn off fade in
	mov	[faded],FALSE		; we're not faded
	mov	[fade_type],0
	mov	ax,[count_down]
	mov	[counter],ax		; reset the counter
new_int_8_130:

	pop	ds
	pop	es
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	iret
new_int_8	endp

end_of_tsr	label	byte

copyright	db	'FADE.COM copyright 1989 by Aaron M. Williams',13,10
		db	'completed on 10/13/1989.  TIMEOUT = about 3 minutes',13,10
		db	'$'

main	proc	near
init_code:
	mov	al,20h
	out	20h,al
	mov	ax,3508h
	int	21h
	mov	word ptr [old_int_8],bx
	mov	word ptr [old_int_8+2],es

	mov	ax,3509h
	int	21h
	mov	word ptr [old_int_9],bx
	mov	word ptr [old_int_9+2],es

	mov	ax,3510h
	int	21h
	mov	word ptr [old_int_10],bx
	mov	word ptr [old_int_10+2],es

	mov	ax,2509h
	mov	dx,offset new_keyboard_int
	int	21h

	mov	ax,2508h
	mov	dx,offset new_int_8
	int	21h
	mov	ax,2510h
	mov	dx,offset new_video_int
	int	21h
	mov	ah,9
	mov	dx,offset copyright
	int	21h
	mov	dx,offset end_of_tsr
	int	27h
main	endp

end

