
  % converse/0
  converse():-
	temp(S),
	S = quit,
	!,
	purge.
  converse():-
	retract(temp(S)),
	doctor(S),
	write(": "),
	readln(P),
	patient(P),
	!,
	converse.

  converse():-
	doctor(""),
	write(": "),
	readln(P),
	patient(P),
	!,
	converse.

  % doctor/1
  doctor(""):-
	retract(topics(R)),
	not R = "",
	write("You just said ",`"),
	write(R,`"),
	nl,
	write("Tell me more..."),
	nl.
  doctor(""):-
	retract(responses(R)),
	assertz(responses(R)),
	write(R),
	nl.
  doctor(S):-
	respond(S),
	assert(topics(S)),
	nl.
  doctor(_):-
	retract(topics(R)),
	not R = "",
	write("You just said ",`"),
	write(R,`"),
	nl,
	write("Tell me more..."),
	nl.

  % patient/1
  patient(S):-
	patresponses(S),
	not(member(S,["","why","yes","no","maybe"])),
	write("You are repeating yourself."),
	nl,
	write(": "),
	readln(S2),
	!,
 	patient(S2).

  patient(S):-
	assert(patresponses(S)),
	assert(temp(S)).

  % purge/0
  purge():-
	retract(translate(_,_)),
	fail.
  purge():-
	retract(temp(_)),
	fail.
  purge():-
	retract(responses(_)),
	fail.
  purge():-
	retract(topics(_)),
	fail.
  purge():-
	retract(patresponses(_)),
	fail.
  purge().

  % respond/1
  respond(""):-
	fail.
  respond(S):-
	fronttoken(S,T,_),
	translate(T,T2),
	write(T2," ").
  respond(S):-
	fronttoken(S,_,S2),
	!,
	respond(S2).

  % responses/1
  responses("How are you this beautiful day?").
  responses("Did you have a happy childhood?").
  responses("Do you hate your father?").
  responses("I'm not sure I understand").
  responses("Go on ").
  responses("Do you have friends?").
  responses("Why don't you talk about something else?").
  responses("Do you like your Computer Methods teacher?").

  % temp/1
  temp("").

  % translate/2
  translate("unhappy","Why are you unhappy?").
  translate("think","Why do you think that?").
  translate("you","Let's not talk about me.").
  translate("hate","So you hate to tell me more.").
  translate("what","Why do you ask?").
  translate("want","What would you do with it?").
  translate("need","We all need many things.").
  translate("why","Remember, therapy is good for you.").
  translate("know","How do you know that?").
  translate("murder","I don't like killing.").
  translate("kill","It is wrong to kill").
  translate("jerk","Don't you ever call me a jerk!").
  translate("never","Don't be negative; think positive!").
  translate("failure","Make it a success").
  translate("stupid","Stupid is not a nice word").
  translate("sure","It is good to be confident").

member(X,[X|_]).
member(X,[_|Rest]):-
	!,
	member(X,Rest).