/****************************************************************************/
/*																																					*/
/* INSTALL.C                                                                */
/*																																					*/
/*																																					*/
/****************************************************************************/
/*----------------------------- include files ------------------------------*/
#include <stdio.h>
#include <alloc.h>
#include <ctype.h>
#include <dir.h>
#include "t.h"																/* include the TUI header			*/
#include "install.def"												/* include dialog definitions	*/


/*--------------------------------- globals --------------------------------*/
WINDOW	*Out_wnp;

TUI			Install_tui, *Tuip = &Install_tui;

char 		Src_install;
char 		Hdr_install;
char 		Lib_install;
char 		Help_install;
char 		Example_install;
char 		Src = 'a', Dest = 'c';
char 		*Compiler = "borlandc";
int  		X_off, Y_off, Width, Uwin_flag, Tui_flag;

int 		EnCom, UltraWin, InTUItion;
char		Compiler_path[33];

/*------------------- slider/image/palette globals -------------------------*/
uchar Palette_install[16] =
  { 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x14, 0x07,
		0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F };

/*------------------------------- prototypes -------------------------------*/
void main( int argc, char *argv[] );
void interact1( TUI *tuip, int dlg_inx, char *path, char *title );
int  interact0( TUI *tuip, int dlg_inx );
void change_dest( TUI *tuip );
void change_compiler( TUI *tuip );
void install( char *path );
void mymkdir( char *p );
int  check_for_file( char *path, char *s );
void install_help( void );
void whereto_help( void );
int  register_install_tui( TUI *tuip );
void register_install_dlg0( TUI *tuip );
void register_install_dlg1( TUI *tuip );


/*********/
/* ~main */
/*       ********************************************************************/
/****************************************************************************/
void main( int argc, char *argv[] )
{
	int  i, scan_lines;
	char *p, *ps, fname[81], *path, buff[81], *title;

	if( argc && (argv[0][1] == ':') )					/* run from a different drive?	*/
		Src = argv[0][0];

	/* load_tui(Tuip,"install.tui"); */
	register_install_tui(Tuip);

	init_tui(Tuip);
	if( interact0(Tuip,INSTALL_DLG3) )
	{
		select(Tuip, DEST_C);
		select(Tuip, BORLAND);
		select(Tuip, SRC_INSTALL);
		select(Tuip, HDR_INSTALL);
		select(Tuip, LIB_INSTALL);
		select(Tuip, HELP_INSTALL);
		select(Tuip, EXAMPLE_INSTALL);
		Src_install = Hdr_install = Lib_install = Help_install = Example_install = 1;
		X_off = get_item_x(Tuip, VIEW_BOX);
		Y_off = get_item_y(Tuip, VIEW_BOX);
		Width = get_item_w(Tuip, VIEW_BOX) - 1;

		sprintf( get_inp_text(Tuip,HDR_PATH),    "%c:\\%s\\include", Dest, Compiler );
		sprintf( get_inp_text(Tuip,LIB_PATH),    "%c:\\%s\\lib", Dest, Compiler     );
		sprintf( get_inp_text(Tuip,HELP_PATH),   "%c:\\%s\\enqhelp", Dest, Compiler );

		for( i = 0; i < 3; i++ )
		{
			switch(i)
			{
				case 0:
					path = "uw250";
					sprintf(fname, "%c:\\uw250\\uw250.ver",Src);
					title = "UltraWin Installation";
					sprintf( get_inp_text(Tuip,SRC_PATH),    "%c:\\%s\\uw250", Dest, Compiler );
					break;
				case 1:
					path = "tui150";
					sprintf(fname, "%c:\\tui150\\tui150.ver",Src);
					title = "InTUItion Installation";
					sprintf( get_inp_text(Tuip,SRC_PATH),    "%c:\\%s\\tui150", Dest, Compiler  );
					break;
				case 2:
					path = "encom110";
					sprintf(fname, "%c:\\encom110\\encom110.ver",Src);
					title = "EnCom Installation";
					sprintf( get_inp_text(Tuip,SRC_PATH),    "%c:\\%s\\encom110", Dest, Compiler );
					break;
			}
			sprintf( get_inp_text(Tuip,EXAMPLE_PATH),    "%s\\examples", get_inp_text(Tuip,SRC_PATH) );
			if( file_exists(fname) )
				interact1(Tuip, INSTALL_DLG, path, title);
		}
		whereto_help();
	}
	end_tui(Tuip);
	free_tui(Tuip);
	exit(0);
}
/*** end of main ***/

/**************/
/* ~interact1 */
/*            ***************************************************************/
/* Shell code for typical dialog interaction.  A pointer to the TUI and the */
/* define for the dialog are passed.                                        */
/*                                                                          */
/* Pass the DO_NORMAL define to do_dialog if you do not want to have every  */
/* event the do_dialog function does not understand returned to you!        */
/****************************************************************************/
void interact1( TUI *tuip, int dlg_inx, char *path, char *title )
{
	int inx, end_flag = OFF;
	int old_dest = Dest;

	draw_dialog(tuip, dlg_inx);
	Out_wnp = get_dlg_wnp(Tuip, INSTALL_DLG);
	wn_plst(CENTERED, 0, title, Out_wnp);
	while (!end_flag)
	{
		Event.key = 0;
		inx = do_dialog(tuip, dlg_inx, DO_RETURN_EVENT);
		if( (Event.m_button == RB) ||
			 ((Event.key == KEY_ALT_H) && (inx == EVENT_RETURNED)) )
			install_help();
		else switch( inx )
		{
			/*---------------- ESC pressed or clicked off dialog -----------------*/
			case NO_SELECTION:
				end_flag = ON;
				break;

			case HELP:
				deselect(tuip, inx);
				detab(tuip, inx);
				draw_item(tuip, inx);
				install_help();
				break;

			case CANCEL:
				deselect(tuip, inx);
				detab(tuip, inx);
				draw_item(tuip, inx);
				end_flag = 2;
				break;

			case OK:
				deselect(tuip, inx);
				detab(tuip, inx);
				draw_item(tuip, inx);
				end_flag = 1;
				break;

			case SRC_INSTALL:
				Src_install = is_selected(Tuip,inx);
				break;
			case HDR_INSTALL:
				Hdr_install = is_selected(Tuip,inx);
				break;
			case LIB_INSTALL:
				Lib_install = is_selected(Tuip,inx);
				break;
			case HELP_INSTALL:
				Help_install = is_selected(Tuip,inx);
				break;
			case EXAMPLE_INSTALL:
				Example_install = is_selected(Tuip,inx);
				break;

			case MICROSOFT:
				Compiler = "msc";
				change_compiler(tuip);
				break;
			case BORLAND:
				Compiler = "borlandc";
				change_compiler(tuip);
				break;
			case TURBO:
				Compiler = "tc";
				change_compiler(tuip);
				break;
			case ZORTECH:
				Compiler = "zortech";
				change_compiler(tuip);
				break;
			case MIX:
				Compiler = "powerc";
				change_compiler(tuip);
				break;
			case OTHER:
				strcpy( Compiler_path, get_inp_text(Tuip,OTHER));
				Compiler = Compiler_path;
				change_compiler(tuip);
				break;

			case DEST_C: Dest = 'c';	break;
			case DEST_D: Dest = 'd';	break;
			case DEST_E: Dest = 'e';	break;
			case DEST_F: Dest = 'f';	break;
		}
		if( Dest != old_dest )													/* change path names	*/
		{
			old_dest = Dest;
			change_dest(tuip);
		}
	}
	if( end_flag == 1 )
		install(path);
	erase_dialog(tuip, dlg_inx);
}
/*** end of interact ***/

/**************/
/* ~interact0 */
/*            ***************************************************************/
/* Shell code for typical dialog interaction.  A pointer to the TUI and the */
/* define for the dialog are passed.                                        */
/*                                                                          */
/* Pass the DO_NORMAL define to do_dialog if you do not want to have every  */
/* event the do_dialog function does not understand returned to you!        */
/****************************************************************************/
int interact0( TUI *tuip, int dlg_inx )
{
	int ret_inx, stat = 0, end_flag = OFF;

	center_dialog(tuip,dlg_inx);
	draw_dialog(tuip, dlg_inx);
	while (!end_flag)
	{
		ret_inx = do_dialog(tuip, dlg_inx, DO_RETURN_EVENT);
		switch( ret_inx )
		{
			case INSTALL_GO:
				stat = 1, end_flag = 1;
				break;
			case ABORT:
				end_flag = 1;
				break;
		}
	}
	erase_dialog(tuip, dlg_inx);
	return(stat);
}
/*** end of interact0 ***/

/****************/
/* ~change_dest */
/*              *************************************************************/
/****************************************************************************/
void change_dest( TUI *tuip )
{
	int i, inxs[] = { SRC_PATH, HDR_PATH, LIB_PATH, HELP_PATH, EXAMPLE_PATH };
	char *p;

	for( i = 0; i < 5; i++ )
	{
		p = get_inp_text(Tuip,inxs[i]);
		*p = Dest;
		draw_item( tuip, inxs[i] );
	}
}
/*** end of change_dest ***/

/********************/
/* ~change_compiler */
/*                  *********************************************************/
/****************************************************************************/
void change_compiler( TUI *tuip )
{
	int i, x, inxs[] = { SRC_PATH, HDR_PATH, LIB_PATH, HELP_PATH, EXAMPLE_PATH };
	char buff[133], *p, *p1;

	for( i = 0; i < 5; i++ )
	{
		setmem(buff, 132, 0);
		p = get_inp_text(Tuip,inxs[i]);

		if( p[1] == ':' && p[2] == '\\' )
			strncpy( buff, p, 3 );
		else if( p[1] == ':' )
			strncpy( buff, p, 2 );
		strcat( buff, Compiler );

		if( strchr(p,'\\') != NULL )
			strcat( buff, strchr(strchr(p,'\\') + 1, '\\') );

		strcpy( p, buff );
		draw_item( tuip, inxs[i] );
	}
}
/*** end of change_compiler ***/

/************/
/* ~install */
/*          *****************************************************************/
/****************************************************************************/
void install( char *path )
{
	int r = -1;
	char buff[133], buff1[133];
	Out_wnp->att = get_box_att(Tuip, VIEW_BOX);

	sprintf(buff, "%c:\\enqhelp.zip", Src);
	if ( file_exists(buff) )
	{
		mymkdir( get_inp_text(Tuip,SRC_PATH) );
		sprintf(buff, "%c:pkunzip -o %c:\\enqhelp.zip %s > nul",
						Src, Src, get_inp_text(Tuip,SRC_PATH) );
		strcpy(buff1,buff),	buff1[strlen(buff)-6] = '\0',	buff1[Width] = '\0';
		wn_plst( X_off, Y_off + r++, buff1, Out_wnp );
		system(buff);
	}
	sprintf(buff, "%c:\\enqrbld.zip", Src);
	if ( file_exists(buff) )
	{
		mymkdir( get_inp_text(Tuip,SRC_PATH) );
		sprintf(buff, "%c:pkunzip -o %c:\\enqrbld.zip %s > nul",
						Src, Src, get_inp_text(Tuip,SRC_PATH) );
		strcpy(buff1,buff),	buff1[strlen(buff)-6] = '\0',	buff1[Width] = '\0';
		wn_plst( X_off, Y_off + r++, buff1, Out_wnp );
		system(buff);
	}
	if( Src_install )
	{
		if( check_for_file(path,"source.zip") )
		{
			mymkdir( get_inp_text(Tuip,SRC_PATH) );
			sprintf(buff, "%c:pkunzip -o %c:\\%s\\source.zip %s > nul",
							Src, Src, path, get_inp_text(Tuip,SRC_PATH) );
			strcpy(buff1,buff),	buff1[strlen(buff)-6] = '\0',	buff1[Width] = '\0';
			wn_plst( X_off, Y_off + r++, buff1, Out_wnp );
			system(buff);
		}
	}
	if( Hdr_install )
	{
		if( check_for_file(path,"hdr.zip") )
		{
			mymkdir( get_inp_text(Tuip,HDR_PATH) );
			sprintf(buff, "%c:pkunzip -o %c:\\%s\\hdr.zip %s > nul",
							Src, Src, path, get_inp_text(Tuip,HDR_PATH) );
			strcpy(buff1,buff),	buff1[strlen(buff)-6] = '\0',	buff1[Width] = '\0';
			wn_plst( X_off, Y_off + r++, buff1, Out_wnp );
			system(buff);
		}
	}
	if( Lib_install )
	{
		if( check_for_file(path,"lib.zip") )
		{
			mymkdir( get_inp_text(Tuip,LIB_PATH) );
			sprintf(buff, "%c:pkunzip -o %c:\\%s\\lib.zip %s > nul",
							Src, Src, path, get_inp_text(Tuip,LIB_PATH) );
			strcpy(buff1,buff),	buff1[strlen(buff)-6] = '\0',	buff1[Width] = '\0';
			wn_plst( X_off, Y_off + r++, buff1, Out_wnp );
			system(buff);
		}
	}
	if( Help_install )
	{
		if( check_for_file(path,"help.zip") )
		{
			mymkdir( get_inp_text(Tuip,HELP_PATH) );
			sprintf(buff, "%c:pkunzip -o %c:\\%s\\help.zip %s > nul",
							Src, Src, path, get_inp_text(Tuip,HELP_PATH) );
			strcpy(buff1,buff),	buff1[strlen(buff)-6] = '\0',	buff1[Width] = '\0';
			wn_plst( X_off, Y_off + r++, buff1, Out_wnp );
			system(buff);
		}
	}
	if( Example_install )
	{
		if( check_for_file(path,"examples.zip") )
		{
			mymkdir( get_inp_text(Tuip,EXAMPLE_PATH) );
			sprintf(buff, "%c:pkunzip -o %c:\\%s\\examples.zip %s > nul",
							Src, Src, path, get_inp_text(Tuip,EXAMPLE_PATH) );
			strcpy(buff1,buff),	buff1[strlen(buff)-6] = '\0',	buff1[Width] = '\0';
			wn_plst( X_off, Y_off + r++, buff1, Out_wnp );
			system(buff);
		}
	}
}
/*** end of install ***/

/************/
/* ~mymkdir */
/*          *****************************************************************/
/****************************************************************************/
void mymkdir( char *p )
{
	int i;
	char tmp[81], tmp1[81];

	i = 0;
	tmp[i++] = *p++;
	tmp[i++] = *p++;
	tmp[i++] = *p++;
	while( *p )
	{
		while( *p && (*p != '\\') )
			tmp[i++] = *p++;
		tmp[i] = '\0';
		mkdir(tmp);
		if( *p == '\\' )
			tmp[i++] = *p++;
	}
}
/*** end of mymkdir ***/

/*******************/
/* ~check_for_file */
/*                 **********************************************************/
/****************************************************************************/
int check_for_file( char *path, char *s )
{
	char fname[81];

	sprintf(fname, "%c:\\%s\\%s", Src, path, s);
	return( file_exists(fname) );
}
/*** end of check_for_file ***/

/*****************/
/* ~install_help */
/*               ************************************************************/
/****************************************************************************/
char *Helps[] = {
"/// Setting install check boxes",
"  There is a check box next to each path.  Click on the check box or",
"  press the indicated key to turn the check box on/off.  Only those",
"  boxes with an X will be installed.",
"",
"/// Setting up directory paths",
"  There are four directory paths that need to be created. Default paths",
"  are created for Borland C.  You can change each path individually by",
"  clicking on the path string or pressing 1-5.  If you elect to use the",
"  standard directories, borlandc, tc, or msc, simply click or select the",
"  desired compiler.",
"",
"/// Setting the destination drive",
"  Clicking or selecting (Alt C-E) a destination drive will automatically",
"  change the paths for you.  You can also change them individually.",
"END"
};
void install_help( void )
{
	int i;
	WINDOW wn;

	m_hide();
	wn_create( 2, 2, V_cols-4, V_rows-4, SGL_BDR, WN_POPUP, &wn );
	wn_color( LIGHTGRAY, RED, &wn );
	wn_name("Help", &wn);
	wn_set(&wn);
	for( i = 0; i < 20 && strcmp(Helps[i],"END") ; i++ )
		wn_plst( 1, i + 1, Helps[i], &wn );
	wait_event();
	wn_destroy(&wn);
	m_show();
}
/*** end of install_help ***/

/*****************/
/* ~whereto_help */
/*               ************************************************************/
/****************************************************************************/
char *Whelps[] = {
"",
"   It is recommended that you first read the help files for the products",
"that you have installed. First, set the environment variable as follows,",
"\"set ENQHELP=c:\\borlandc\\enqhelp\" or whatever path you chose for the",
"help files, then run the help as follows: (it is recommended that you put",
"the set command in your autoexec.bat file)",
"   for EnCom     \"enqhelp encom.hlp\"",
"   for UltraWin  \"enqhelp uw_help0.hlp\"",
"   for InTUItion \"enqhelp tui0.hlp\"",
"",
"ENCOM: If you installed EnCom, go into the EnCom directory and run the",
"   EnCom demo, \"com_demo\".  You can also run \"td\", the terminal demo",
"   which can be used to dial the EnQue BBS.",
"",
"ULTRAWIN: If you installed UltraWin, go into the UltraWin directory and",
"   run the demo, \"uw_demo\".",
"",
"INTUITION: If you installed InTUItion, be sure that UltraWin in also",
"   installed, then go into the directory and run the tutorials as follows,",
"   \"tuicp -pentry.tut\". There are four tutorials; button.tut, entry.tut,",
"   help.tut, and menu.tut.",
"   Keep in mind that you are running an InTUItion demo right now!"
};
void whereto_help( void )
{
	int i, end_flag = OFF;
	WINDOW wn;

	m_hide();
	wn_create( 0, 0, V_cols-1, V_rows-1, SGL_BDR, WN_POPUP, &wn );
	wn_color( LIGHTGRAY, RED, &wn );
	wn_name("Where To Go From Here", &wn);
	wn_set(&wn);
	for( i = 0; i < 22 && strcmp(Whelps[i],"END") ; i++ )
		wn_plst( 0, i, Whelps[i], &wn );
	while (!end_flag)
	{
		wait_event();
		if ( !Event.is_mouse && (Event.key == KEY_ESC) )
			end_flag = ON;
	}
	wn_destroy(&wn);
	m_show();
}
/*** end of whereto_help ***/

/*************************/
/* ~register_install_tui */
/*                       ****************************************************/
/* Call this function to register the TUI.  This replaces load_tui!         */
/****************************************************************************/
int register_install_tui( TUI *tuip )
{
  Tui_error = OFF;
  setmem(tuip, sizeof(TUI), 0);
  tuip->version_num = 100L;
  tuip->blink_set = ON;
  tuip->rows = 25;
	tuip->back_att = 0x03;
  tuip->back_bdr_att = 0x03;
  movmem(Palette_install, tuip->palette, 16);

  register_install_dlg0(tuip);
  register_install_dlg1(tuip);
  set_tui_parenting(tuip);
  if (Tui_error)
  {
    free_tui(tuip);
    return(0);
  } else return(1);
}
/*** end of register_install_tui ***/

/**************************/
/* ~register_install_dlg0 */
/*                        ***************************************************/
/* Internally called function to register one dialog.                       */
/****************************************************************************/
void register_install_dlg0( TUI *tuip )
{
  add_dialog(tuip, 0x0000, 0, 0, 80, 25, 0x1F, 0x1F, 1);
  add_box(tuip, 0, 0x0011, 0, 3, 14, 53, 7, 0x70, 1);
  add_box(tuip, 0, 0x0000, 0, 59, 9, 18, 14, 0x3F, 1);
  add_box(tuip, 0, 0x0000, 0, 59, 2, 18, 5, 0x3F, 1);
  add_box(tuip, 0, 0x0000, 0, 3, 2, 53, 11, 0x30, 1);
  add_button(tuip, 0, 0x0000, 0, 5, 2, 14, 1, 0,
    0x3E, 0x3e, 0x3e, 0x3e, 0x3e, 0, "Install ON/OFF");
  add_button(tuip, 0, 0x0000, 0, 30, 2, 13, 1, 0,
    0x3E, 0x3e, 0x3e, 0x3e, 0x3e, 0, "Install Paths");
  add_check(tuip, 83, 0x1013, 0, 6, 3, 10, 1, 0,
    0x30, 0x3E, 0x3f, 1, 0x58, 4, "[ ] Source");
  add_check(tuip, 72, 0x1013, 0, 6, 5, 11, 1, 0,
    0x30, 0x3E, 0x3f, 1, 0x58, 4, "[ ] Headers");
	add_check(tuip, 76, 0x1013, 0, 6, 7, 13, 1, 0,
    0x30, 0x3E, 0x3f, 1, 0x58, 4, "[ ] Libraries");
  add_check(tuip, 69, 0x1013, 0, 6, 9, 8, 1, 0,
    0x30, 0x3E, 0x3f, 1, 0x58, 5, "[ ] Help");
  add_check(tuip, 65, 0x1013, 0, 6, 11, 11, 1, 0,
    0x30, 0x3E, 0x3f, 1, 0x58, 6, "[ ] Example");
  add_button(tuip, 0, 0x0000, 0, 22, 3, 2, 1, 1,
    0x1E, 0x1e, 0x1e, 0x1e, 0x1e, 0, "1)");
  add_input(tuip, 49, 0x000B, 0, 24, 3, 29, 1, 1, 0x17, 0x0f, 0x02,
    "",
    "________________________________________________________________________________",
    "********************************************************************************");
  add_button(tuip, 0, 0x0000, 0, 22, 5, 2, 1, 1,
    0x1E, 0x1e, 0x1e, 0x1e, 0x1e, 0, "2)");
  add_input(tuip, 50, 0x000B, 0, 24, 5, 29, 1, 1, 0x17, 0x0f, 0x02,
    "",
    "________________________________________________________________________________",
    "********************************************************************************");
  add_button(tuip, 0, 0x0000, 0, 22, 7, 2, 1, 1,
    0x1E, 0x1e, 0x1e, 0x1e, 0x1e, 0, "3)");
  add_input(tuip, 51, 0x000B, 0, 24, 7, 29, 1, 1, 0x17, 0x0f, 0x02,
    "",
    "________________________________________________________________________________",
    "********************************************************************************");
  add_button(tuip, 0, 0x0000, 0, 22, 9, 2, 1, 1,
    0x1E, 0x1e, 0x1e, 0x1e, 0x1e, 0, "4)");
  add_input(tuip, 52, 0x000B, 0, 24, 9, 29, 1, 1, 0x17, 0x0f, 0x02,
    "",
    "________________________________________________________________________________",
    "********************************************************************************");
  add_button(tuip, 0, 0x0000, 0, 22, 11, 2, 1, 1,
    0x1E, 0x1e, 0x1e, 0x1e, 0x1e, 0, "5)");
  add_input(tuip, 53, 0x000B, 0, 24, 11, 29, 1, 1, 0x17, 0x0f, 0x02,
    "",
    "________________________________________________________________________________",
		"********************************************************************************");
  add_button(tuip, 0, 0x0000, 0, 59, 2, 18, 1, 0,
    0x71, 0x71, 0x71, 0x71, 0x71, 0, "Dest (Alt C-F)");
  add_button(tuip, 302, 0x0017, 0, 61, 3, 5, 1, 1,
    0x1B, 0x1e, 0x03, 0x0e, 0x0f, 0, "C");
  add_button(tuip, 274, 0x0017, 0, 69, 3, 5, 1, 1,
    0x1B, 0x1e, 0x03, 0x0e, 0x0f, 0, "E");
  add_button(tuip, 288, 0x0017, 0, 61, 5, 5, 1, 1,
    0x1B, 0x1e, 0x03, 0x0e, 0x0f, 0, "D");
  add_button(tuip, 289, 0x0017, 0, 69, 5, 5, 1, 1,
    0x1B, 0x1e, 0x03, 0x0e, 0x0f, 0, "F");
  add_button(tuip, 0, 0x0000, 0, 59, 9, 18, 1, 0,
    0x71, 0x71, 0x71, 0x71, 0x71, 0, "Compiler");
  add_button(tuip, 66, 0x0017, 0, 62, 10, 11, 1, 1,
    0x17, 0x1e, 0x03, 0x0e, 0x0f, 0, "Borland");
  add_button(tuip, 84, 0x0017, 0, 62, 12, 11, 1, 1,
    0x17, 0x1e, 0x03, 0x0e, 0x0f, 0, "Turbo");
  add_button(tuip, 77, 0x0017, 0, 62, 14, 11, 1, 1,
    0x17, 0x1e, 0x03, 0x0e, 0x0f, 0, "Microsoft");
  add_button(tuip, 90, 0x0017, 0, 62, 16, 11, 1, 1,
    0x17, 0x1e, 0x03, 0x0e, 0x0f, 0, "Zortech");
  add_button(tuip, 88, 0x0017, 0, 62, 18, 11, 1, 1,
    0x17, 0x1e, 0x03, 0x0e, 0x0f, 2, "Mix");
  add_button(tuip, 0, 0x0000, 0, 65, 20, 5, 1, 0,
    0x31, 0x3e, 0x31, 0x3e, 0x31, 0, "Other");
  add_input(tuip, 79, 0x000B, 0, 62, 21, 11, 1, 1, 0x17, 0x0f, 0x02,
    "",
    "________________________________________________________________________________",
    "********************************************************************************");
  add_button(tuip, 67, 0x0013, 0, 3, 22, 10, 1, 1,
    0x71, 0x74, 0x03, 0x0e, 0x0f, 0, "Cancel");
  add_button(tuip, 291, 0x0013, 0, 19, 22, 21, 1, 1,
    0x71, 0x74, 0x03, 0x0e, 0x0f, 4, "Alt-H for help");
  add_button(tuip, 75, 0x0013, 0, 46, 22, 10, 1, 1,
    0x71, 0x74, 0x03, 0x0e, 0x0f, 1, "Ok");
}
/*** end of register_install_dlg0 ***/

/**************************/
/* ~register_install_dlg1 */
/*                        ***************************************************/
/* Internally called function to register one dialog.                       */
/****************************************************************************/
void register_install_dlg1( TUI *tuip )
{
  add_dialog(tuip, 0x0000, 20, 2, 40, 21, 0x1E, 0x1E, 2);
  add_button(tuip, 0, 0x0000, 0, 2, 1, 36, 1, 0,
    0x1F, 0x1f, 0x1f, 0x1f, 0x1f, 0, "This program will install all three");
  add_button(tuip, 0, 0x0000, 0, 2, 3, 36, 1, 0,
    0x1F, 0x1f, 0x1f, 0x1f, 0x1f, 0, "EnQue products, EnCom, UltraWin, and");
  add_button(tuip, 0, 0x0000, 0, 2, 5, 36, 1, 0,
    0x1F, 0x1f, 0x1f, 0x1f, 0x1f, 0, "InTUItion, if desired. Simply press");
  add_button(tuip, 0, 0x0000, 0, 2, 7, 36, 1, 0,
    0x1F, 0x1f, 0x1f, 0x1f, 0x1f, 0, "Ok after making any desired changes");
  add_button(tuip, 0, 0x0000, 0, 2, 9, 36, 1, 0,
    0x1F, 0x1f, 0x1f, 0x1f, 0x1f, 0, "to the destination drive or paths.");
  add_button(tuip, 0, 0x0000, 0, 2, 12, 36, 1, 0,
    0x9B, 0x9b, 0x9b, 0x9b, 0x9b, 0, "This installation program was");
  add_button(tuip, 0, 0x0000, 0, 1, 14, 36, 1, 0,
    0x9B, 0x9b, 0x9b, 0x9b, 0x9b, 0, "written with InTUItion!");
  add_button(tuip, 0, 0x0000, 0, 0, 0, 40, 1, 0,
    0x71, 0x71, 0x71, 0x71, 0x71, 0, "EnQue Installation");
  add_button(tuip, 67, 0x0013, 0, 22, 16, 14, 3, 1,
    0x4E, 0x4f, 0x03, 0x0f, 0x0f, 0, "Continue");
  add_button(tuip, 65, 0x0013, 0, 3, 16, 15, 3, 1,
    0x4E, 0x4f, 0x03, 0x0f, 0x0f, 0, "Abort");
}
/*** end of register_install_dlg1 ***/

/**** END OF FILE ****/
