/* ---------------- interp.h -------------------- */
#define TOKBUFSIZE 4096     /* token buffer size           */
#define MAXSYMBOLS  100     /* maximum symbols in table    */
#define MAXSTRINGS   50     /* maximum strings in arrays   */
#define MAXPARAMS    10     /* maximum parameters in calls */
/* ----------- error codes ----------------- */
enum errs {EARLYEOF,UNRECOGNIZED,DUPL_DECLARE,TABLEOVERFLOW,
           OMERR,UNDECLARED,SYNTAX,BRACERR,PARENERR,MISSING,
           NOTFUNC,BREAKERR,OUTOFPLACE,TOOMANYSTRINGS,BUFFULL,
           DIVIDEERR};
/* ------- intrinsic function table -------- */
typedef struct {
    char *fname;
    int (*fn)(int *);
} INTRINSIC;
/* -------- symbol table ------------ */
typedef struct {
    char *symbol;   /* points to symbol name                 */
    char *location; /* points to function code (NULL if int) */
    char **tblloc;  /* points to table array (NULL if func)  */
    int ival;       /* value of integer                      */
} SYMBOL;
/* ------- function prototypes -------- */
void loadsource(void);
int function(char *, SYMBOL *);
#define interpret() function("main\0();", symtop);
/* ------ functions provided by the shell -------- */
int getsource(void);
void ungetsource(int);
void sierror(enum errs, char *, int);
/* -------- the compiled (interpretable) S source -------- */
extern SYMBOL globals[];
extern char *tokenbf;
extern char *strings[];
extern SYMBOL *symtop;
