;RM82TS8,16,24,32,40,48
; updated 12/13/90

;============================================================================
;   Copyright (C) Copr. 1990 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;============================================================================

DOSSEG
.MODEL MEDIUM
.CODE

PUBLIC GETKBD, SETKBD, CLRKBD,  EXTKBD, ATKEYDELAY, YESNO

;===========================================================================
;DECLARE SUB GETKBD (Insert%, Caps%, NumL%, Scrolk%)
;Tests keyboard state of shift and special keys
;       False (0)    = keyboard element off
;       True (<>0)   = keyboard element On
;===========================================================================

EVEN
GETKBD  PROC           FAR
	Push           BP
	Mov            BP,SP
	Xor	       AX,AX	     ;set ES to BIOS RAM
	Mov            ES,AX
	Mov            AL,ES:[417h]
	Xor            CX,CX         ;clear CX
	Test           AL,80h        ;Test left most bit of 0040:0017h
	JZ             @F
				     ;return a -1
	Dec            CX            ;make CX = -1
 @@:
	;store Insert parameter
	Mov            BX,[BP+12]
	Mov            [BX],CX       ;store in Insert%
	Xor            CX,CX         ;clear CX
	Test           AL,40h        ;Test 2d left bit of 0040:0017h
	JZ             @F
	Dec            CX            ;make CX = -1
 @@:
	;store Capslock parameter
	Mov            BX,[BP+10]
	Mov            [BX],CX       ;
	Xor            CX,CX
	Test           AL,20h        ;Test 3d left bit of 0040:0017h
	JZ             @F
	Dec            CX
 @@:
	;store Numlock parameter
	Mov            BX,[BP+8]
	Mov            [BX],CX
	Xor            CX,CX         ;clear CX
	Test           AL,10h        ;Test 4th left bit of 0040:0017h
	JZ             @F
	Dec            CX            ;make CX = -1
 @@:
	;store Scrollock parameter
	Mov            BX,[BP+6]
	Mov            [BX],CX       ;store result in ScrollLock%
	Pop            BP
	Ret            8             ;eliminate 4*2 variables from stack
GETKBD  ENDP

;===========================================================================
;DECLARE SUB SETKBD (Insert%,Caps%,NumL%,Scrolk%)
;Sets keyboard state of shift keys.
;       False (0)   = keyboard element off
;       Not False   = keyboard element On
;===========================================================================

EVEN
SETKBD  PROC   FAR
	Push           BP
	Mov            BP,SP
	Xor	       AX,AX
	Mov            ES,AX		    ;set ES to BIOS RAM
;Set ES to the BIOS area of ram
	Mov            AL,ES:[417h]         ;get KeyBoard Bios status byte
	And            AL,1111b             ;clear upper 4 bits
	Mov            BX,[BP+12]
;Test Insert for clear
	Cmp  word ptr  [BX],0               ;is word 0
	JZ             @f                   ;if yes, jmp already cleared
	OR             AL,80h               ;else set bit
@@:
;Test Capslock for clear
	Mov            BX,[BP+10]           ;is word 0
	Cmp  word ptr  [BX],0               ;if yes, jmp, already cleared
	JZ             @f
	OR             AL,40h               ;else set bit
@@:
;Test Numlock for clear
	Mov            BX,[BP+8]
	Cmp  word  ptr [BX],0
	JZ             @f
	OR             AL,20h
@@:
;Test Scrollock for clear
	Mov            BX,[BP+6]
	Cmp  word ptr  [BX],0
	JZ             @f
	OR             AL,10h
@@:
;reset BIOS ram area with the change
	Mov           ES:[417h],AL
	Pop           BP
	Ret           8
SETKBD  ENDP

;===========================================================================
;DECLARE SUB CLRKBD ()
;Returns nothing
;Clears the Keyboard w/o using BIOS calls. Will probably crash with
;keyboard macro programs that change the buffer location. Not tested!!
;===========================================================================

EVEN
CLRKBD  PROC    FAR

	;Mov     AX,0c00h               ; DOS substitue language is shown
	;Int     21h                    ; but is 3 times slower
	Xor     AX, AX                  ; very fast, no keys to read
	Mov     ES, AX			; set ES to BIOS RAM
	Mov     AL, ES:[41Ch]           ; Refer to actual addresses
	Mov     ES:[41Ah], AL           ; using ES: form
	Ret
CLRKBD ENDP

;============================================================================
; DECLARE FUNCTION EXTKBD% ()
; Returns:
;        0 if no extended keyboard with bios support
;       -1 if extended keyboard with bios support
; Note:
; Should not be affected by a full keyboard buffer or keyboard extenders
;============================================================================

EVEN
EXTKBD PROC    FAR
	Push	BP
        Xor     AX,AX
	Mov     ES,AX
	TEST    Byte Ptr ES:[0496h],10h  ; check BIOS Ram For 101 Key KB bit
	JZ      No_Ext2

	; Function &HC0 of Int 15h might crash an AT&T 6300
	; so it is placed after keyboard detect routine in the hope that
	; this will prevent a crash.  Neither crash nor correction
	; has been tested.  Feedback PLEASE!.  This will not crash a 6300 Plus

	CLC
	Mov     AH,0C0h         ; only new AT and XT bios support function
	Int     15h
	STI                     ; I think this will prevent AT&T 6300 crash
				; I think AT&T bios error is the failure to
				; reset interrupts after calling Int 15h

	JC      No_Ext2         ; if carry set then error, so no bios support
	OR      AH,AH           ; can't have 101 Key KB w/ old bios
	Jnz     No_Ext2

Have_Ext_Kbd:
	Mov     AX,-1                    ; report that it works
	Jmp     Short Ext_Exit2

No_Ext2:
	Xor     AX,AX                    ; report error

Ext_Exit2:
	Xor     DX,DX                    ; clear DX in case called long
	Pop     BP
	Ret
EXTKBD ENDP

;============================================================================
; DECLARE SUB ATKEYDELAY (BYVAL Rate%)
; CALL ATKEYDELAY (Rate%)
; Purpose: allows user to change AT keyboard key repeat rate from fast, normal
; and very slow.  This routine can not keep current state, because there is
; no known method to determine current keyboard rate.
; Input:
;        0 = none, fastest
;        1 = normal
;        any other = slowest
; Returns:
;        Nothing
;============================================================================

EVEN
ATKEYDELAY     PROC     FAR
	Push    BP
	Mov     BP,SP
	Mov     AX,0FFFFh               ; Read system byte
	Mov     ES,AX                   ; Store segment in ES
	Mov     AL,ES:[0EH]             ; Get System ID.
	Cmp     AL,0FCh                 ; Check if AT, PS/2 Model 50 & 60
					; most AT clones use same code too
					; including COMPAQ 286 & 386 machines
					; and PS/2 Model 30/286. AT&T 6300 PLUS
	JZ      Do_Speed                ; If AT, change speed
	Cmp     AL,0F8h                 ; Check if &HF8 : Model 80 & Model 70
					; or Model 55SX
	JZ      Do_Speed                ; OK, change speed
	Jmp     Short  AT_Exit          ; not an AT so quit

Do_Speed:
	Mov     BX,[BP+6]               ; get address of Rate%
        Or      BX,BX                   ;
	JZ      Doit                    ; if zero, speed to the max
	Cmp     BX,1                    ; if one then jump forward
	JNE     @f                      ; else, skip if not equal
	Mov     BX, 010Bh               ; select the PS/2 rate
	Jmp     Short   Doit            ; doit
@@:                                     ; default
	Mov     BX,031Fh                ; select the S...L...O....W rate
Doit:
	Mov     AX,0305h
	Int     16h
AT_Exit:
	Pop     BP
	Ret     2
ATKEYDELAY      ENDP

;===========================================================================
; DECLARE FUNCTION YESNO% ()
; Returns:
;	-1 if Y key pressed
;	 0 if N key pressed
; Clears keyboard of keys, then waits for a key, if wrong key pressed
; program beeps
;===========================================================================

EVEN
YESNO	PROC	FAR
	Push	BP			; prevent errors with video bios

Wait4key:
	Mov     AX,0C00h                ; clears the keyboard buffer
	Int     21h                     ; using DOS, prevents wrong keys
					; from backing up in buffer

	Xor	AH,AH                   ; if no key waiting
	Int	16h                     ; program is in an infinite loop

	Or	AL,AL                   ; test for extended key
	JZ	BadKey			; report got bad key
	Xor	BX,BX			; assume will get "N" key
	CMP	AH,31h			; test for "N" scan code
	JE      Goodkey                 ; found, so end
        Cmp	AH,15h                  ; test for "Y" scan code
	JE	Ykey                    ; if yes then exit

BadKey:                                 ; else report error
	Mov	AX, 0E07h  	    	; Write ASCII 7 character
	Int     10h			; (bell) to console (BEEP)
	Jmp     Short	Wait4key        ; got the wrong key so beep

Ykey:
	Mov	BX,-1                   ; put -1 in BX

Goodkey:
	Mov	AX,BX			; get value back from BX
	Xor	DX,DX                   ; clear DX in case called long
	Pop	BP                      ; restore BP
	Ret                             ; back to basic
YESNO	ENDP
END
