;RM82TS8,16,24,32,40,48
;updated 11/20/90

;============================================================================
;   Copyright (C) Copr. 1990 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;============================================================================

DOSSEG
.MODEL MEDIUM
	Public  WAITFORKEY
.CODE

;===========================================================================
;DECLARE FUNCTION WAITFORKEY%()
; Looks for key press,
; Returns: -256 if none pending
;           a positive number, [e.g. CHR$(number)] if a normal key found.
;           a negative scan code if an extended key key pressed.
; Only initializes itself one time.
;===========================================================================

EVEN
Extended_Kbd    db      0 ; keep track of prior runs of routine

EVEN
WAITFORKEY PROC FAR
	Push    BP
	Cmp     Extended_Kbd,2  ; Regular keyboard?  2 = yes
	JE      REG_KB2         ; jump to regular keyboard routine
	Cmp     Extended_Kbd,1  ; Extended keyboard? 1 = yes
	JE      Have_Ext_Kbd    ; jumpt to extended keyboard routine

	Xor     AX,AX           ; else, set ES to BIOS Ram
	Mov     ES,AX
	Mov     BL,ES:[0496h]   ; check BIOS Ram For 101 Key KB bit
	And     BX,10h          ; Early Wyse keyboard will falsely
	JZ      REG_KB1         ; report have 101 keyboard
				; according to QBASIC bugs list

	; Function &HC0 of Int 15h might crash an AT&T 6300
	; so it is placed after keyboard detect routine in the hopes that
	; this will prevent a crash.  Neither crash nor correction
	; has been tested.  Feedback PLEASE!.  This will not crash a 6300 Plus

	CLC
	Mov     AH,0C0h         ; only new AT and XT bios support function
	Int     15h
	STI                     ; I think this will prevent AT&T 6300 crash
				; I think AT&T bios error is the failure to
				; reset interrupts after calling Int 15h

	JC      REG_KB1         ; if carry set then error, so no bios support
	OR      AH,AH           ; can't have 101 Key KB w/ old bios
	Jnz     REG_KB1
	Mov     Extended_Kbd,1  ; report have extended Keyboard
				; with bios support
Have_Ext_Kbd:
	;sets Zero flag if no character is pending
	Mov     AH,11h
	Int     16h
	JZ      No_Key_There

	;key there, so get it
	Mov     AH,10h
	Int     16h
	OR      AL,AL
	JZ      WaitForKey1
	Cmp     AL,0E0h         ; to eliminate extended keycode byte of 0xEOh
				; assumes AT kbd not in SCANMODE 3
	JE      WaitForKey1     ; (that is a very legit assumption)
	Xor     AH,AH           ; got normal key, clear Scan code
	Jmp     SHORT   WaitKeyEnd

REG_KB1:
	Mov     Extended_Kbd,2  ; report have normal keyboard

REG_KB2:
	Mov     AH,1            ; sets Zero flag if no character is
	Int     16h             ; pending
	JZ      No_Key_There

	Xor     AH,AH           ; Waits until a key is pressed
	Int     16h             ; as soon as press detected
				; gets it from buffer
	Or      AL,AL
	JZ      WaitForKey1     ; got extended key
	Xor     AH,AH           ; got normal key, clear Scan code
	Jmp     Short WaitKeyEnd

WaitForKey1:
	Xchg    AH,AL           ; put scan in AL
	Xor     AH,AH           ; clear AH
	NOT     AX              ; convert to negative
	Inc     AX              ; NOT then add 1
	Jmp     Short WaitKeyEnd

No_Key_There:
	Mov     AX,-256         ; assume never will get an extended
				; keycode of that number normally
WaitKeyEnd:
	Xor     DX,DX           ; answer returned in AX
	Pop     BP
	Ret
WAITFORKEY endp
END
