.MODEL SMALL
.STACK  200h

.DATA
                Notice          db      'Copyright 1989 by Aaron M. Williams ',10,13,'$'
                NoFile          db      'File not Found!',10,13,7,'$'
                KeepNote        db      'Installed into memory',10,13,'$'
                AllInst         db      'Already installed. Re-loading font.',10,13,'$'
                FileSize        dw      0 ; size of font file
                Error           db      0 ; Error used with file
                FHandle         dw      0 ; File Handle

.CODE

Start:          jmp     initialize  ; Goto beginning
                                db      ?
                IntVec10        dd      ?  ; Old video interrupt vector
                Buffer          db      8192 dup (?) ; Buffer for Fonts
                CharHeight      db      16 ; height of character
                CursStart       db      6  ; Cursor start scan line
                CursEnd         db      7  ; Cursor end scan line
                DisplayType     db      2 ; Default of EGA
                Info            db      ? ; Info register
                VideoMode       db      ? ; Video Mode
                SetCursor       db      0 ; True


NewInt10:       cmp     ah,0
                jne     go3
                push    ax
                push    es
                mov     ax,0040h
                mov     es,ax
                mov     al,es:[0049h]
                and     al,7Fh
                mov     cs:VideoMode,al
                pop     es
                pop     ax
                cmp     ax,0003h        ; set mode?
                jbe     j1              ; reset font
                cmp     ax,0007h
                je      j1
                cmp     ax,0087h
                je      j1
                cmp     ax,0080h
                jb      go3
                cmp     ax,0083h
                ja      go3
                jmp     j1

go3:            cmp     ax,01110h       ; font change?
                jz      j1              ; prevent
                cmp     ax,01114h
                jz      j1
                cmp     ax,0ffffh       ; Request info?
                jnz     j0
                jmp     j2              ; yes, return info

j0:             pushf                   ; do old interrupt
                call    dword ptr cs:IntVec10
                iret


j1:             push    ax
                push    es
                cmp     cs:VideoMode,7
                ja      NoCurs
                cmp     cs:VideoMode,3
                ja      NoCurs
                mov     ax,0040h
                mov     es,ax
                mov     al,es:[0060h]
                mov     cs:CursStart,al
                mov     al,es:[0061h]
                mov     cs:CursEnd,al
                mov     al,es:[0087h]   ; Get info for Cursor Emulation
                mov     cs:Info,al
                and     al,0feh         ; Disable cursor emulation
                mov     es:[0087h],al
NoCurs:         pop     es
                pop     ax

                pushf
                call    dword ptr cs:IntVec10 ; do old interrupt
                push    ax
                push    bx
                push    cx
                push    dx
                push    si
                push    di
                push    ds
                push    es
                push    bp
                mov     ax,cs
                mov     ds,ax
                mov     es,ax
                mov     bp,Offset Buffer
                mov     bh,cs:CharHeight
                mov     cx,256
                sub     dx,dx
                mov     bl,0
                mov     ax,01110h
                pushf
                call    dword ptr cs:IntVec10 ; load our font
                cmp     cs:VideoMode,7
                ja      NoCurs2
                cmp     cs:VideoMode,3
                ja      NoCurs2
                mov     ah,1
                mov     ch,cs:CursEnd
                mov     cl,cs:CursStart         ; Restore cursor
                pushf
                call    dword ptr cs:IntVec10   ; Set Cursor type

                mov     ax,0040h
                mov     es,ax
                mov     al,cs:Info
                mov     es:[0087h],al   ; Return Info as before

NoCurs2:        pop     bp
                pop     es
                pop     ds
                pop     di
                pop     si
                pop     dx
                pop     cx
                pop     bx
                pop     ax
                iret

j2:             mov     ax,cs
                mov     es,ax  ; es=segment of font buffer
                mov     bx,Offset Buffer ; bx=ofset of font buffer
                mov     dx,Offset CharHeight ; dx = offset of charheight variable
                mov     ax,01234h ; return installed state
                iret


SetFont:        push    ds ; loads the font in
                push    es
                mov     ax,cs
                mov     ds,ax
                mov     es,ax
                mov     bp,Offset Buffer
                mov     bh,cs:CharHeight
                mov     cx,256
                sub     dx,dx
                mov     bl,0
                mov     ax,01110h
                int     10h
                pop     es
                pop     ds
                ret

Initialize:
                mov     ax,@DATA
                mov     ds,ax
                mov     ah,51h
                int     21h
                mov     es,bx
                mov     ah,49h
                int     21h
                mov     dx,Offset Notice
                mov     ah,9          ; display copyright
                int     21h
                mov     ax,01a00h
                int     10h
                cmp     al,1Ah
                jne     NotVGA
                mov     al,6
                mov     cs:DisplayType,al
NotVGA:         mov     di,80h
                xor     bh,bh
                mov     bl,es:[di]   ; get parameters

next_byte:      mov     byte ptr es:[bx+di+1],0
                inc     di
                cmp     byte ptr es:[di],32
                jz      next_byte     ; find start of parameters-remove leading spaces
                push    ds
                push    es
                pop     ds
                mov     dx,di
                mov     ax,3d00h  ; Open File for reading
                int     21h ; open file
                pop     ds
                jnc     go ; if no error continue
                jmp     ProcError ; if error process it
go:             mov     bx,ax ; bx=handle
                mov     ds:FHandle,ax
                cld
                mov     ax,cs
                mov     ds,ax
                mov     dx,Offset Buffer
                mov     cx,8192
                mov     ah,3fh
                int     21h     ; BlockRead font
                jc      ProcError
                jmp     go2
ProcError:      mov     ax,@DATA
                mov     ds,ax
                mov     al,1
                mov     ds:Error,al
                mov     dx,Offset NoFile
                mov     ah,9
                int     21h ; display file not found
                mov     ax,01130h
                mov     bh,cs:DisplayType
                int     10h ; get font info and copy it to the buffer
                mov     cs:CharHeight,cl ; 14=EGA 16=VGA
                push    ds
                push    es
                mov     ax,es
                mov     ds,ax
                mov     ax,cs
                mov     es,ax
                mov     di,Offset buffer
                mov     si,bp
                mov     ch,cl
                mov     cl,0
                shr     cx,1
                rep     movsw ; copy font to buffer
                pop     es
                pop     ds
                mov     al,Error
                or      al,al
                jnz     ji3
                jmp     exit
ji3:            jmp     close_file
go2:            mov     ds:FileSize,ax
                mov     cs:CharHeight,ah
                mov     ax,0ffffh
                int     10h
                cmp     ax,01234h   ;returns es=segment
                jne     ji1
                mov     di,bx
                mov     ax,cs
                mov     ds,ax
                mov     si,Offset Buffer
                mov     cx,4096
                rep     movsw
                mov     al,cs:CharHeight
                mov     bx,dx
                mov     es:[bx],al
                mov     ax,01b00h
                xor     bx,bx
ji1:            push    es
                mov     ax,0040h
                mov     es,ax
                mov     al,es:[0060h]
                mov     cs:CursEnd,al
                mov     al,es:[0061h]
                mov     cs:CursStart,al
                pop     es
                call    SetFont
                mov     ch,cs:CursStart
                mov     cl,cs:CursEnd
                mov     ah,1
                int     10h
                mov     ax,@DATA
                mov     ds,ax
                mov     es,ax
                mov     ah,0fh
                int     10h
                mov     ah,00h
                int     10h

close_file:     mov     ax,@DATA ; Close the file
                mov     ds,ax
                mov     bx,DS:FHandle
                mov     ah,3eh
                int     21h

                mov     ax,0ffffh ; Installed already?
                int     10h
                cmp     ax,01234h
                jne     SetVec    ; no, install it
                jmp     Exit      ; yes, exit
SetVec:         cli
                push    es
                xor     ax,ax
                mov     es,ax
                mov     cx,es:[0040h]
                mov     dx,es:[0042h]
                mov     bx,Offset IntVec10   ; Looks funny?  way to doo it with TASM
                mov     cs:[bx],cx
                mov     cs:[bx+2],dx
                mov     cx,Offset NewInt10
                mov     dx,cs
                mov     es:[0040h],cx
                mov     es:[0042h],dx
                pop     es
                sti
                mov     ax,@Data
                mov     ds,ax
                mov     ah,0fh
                int     10h
                mov     ah,00h
                int     10h
                mov     ah,9
                mov     dx,offset KeepNote
                int     21h

                mov     ax,01200h ; Enable cursor emulation
                mov     bl,34h
                int     10h

                mov     dx,300h ; 12K

                mov     ax,03100h
                int     21h

Exit:           mov     ax,@Data
                mov     ds,ax
                mov     ah,9
                mov     dx,Offset AllInst
                int     21h
                mov     ax,04c00h
                int     21h           ; Terminate

                END
