DEFINT A-Z
'=======================================================================
' Kelly Include
' Updated as of 12/29/92
'=======================================================================
'Routines already available
 ' Makes a box of a specified dimension
DECLARE SUB MAKEBOXES (BYVAL ULR%, BYVAL ULC%, BYVAL LRR%, BYVAL LRC%, BYVAL HASNO%, BYVAL BORDER%, BYVAL ATTRIB%)
 ' Very fast screen printer, NO snow on CGA
DECLARE SUB QPRINT (BYVAL Row%, BYVAL Col%, Text$, BYVAL ATTR%)
 ' Reads memory information pointed to into an existing near string
 ' in DGROUP.  Number of bytes read is fixed by LEN(Text$).
DECLARE SUB MEM2STRING (Text$, BYVAL SegAddress%, BYVAL OffAddress%)
 ' Reads in a whole word from specified memory location
 ' and is faster than DEF SEG=: PEEK(C): etc.
DECLARE FUNCTION MEM2INT% (BYVAL SegAddress%, BYVAL OffAddress%)
 ' Makes input string an uppercase string
DECLARE SUB UPPER (A$)
 ' destroys original string and clears out control characters
DECLARE SUB CLEANSTRING (Text$)
 ' Makes input string a proper string
DECLARE SUB PROPER (A$)
' Sets blink mode if BMode% <> 0
 ' Sets intensity mode if BMode% = 0
DECLARE SUB SETBLINK (BYVAL BMode%)

'----------------------- VGA routines---------------

 ' Returns:
 ' -1 = IBM 8514/A
 '  0 = if not found
DECLARE FUNCTION TEST8514A% ()

  ' Returns:
  '  0 = no VESA, or no VGA
  ' -1 = VESA VGA
DECLARE FUNCTION TESTVESA% ()

 ' Returns:
 '  0 = no hirez VGA adapter found
 '  3 = ATI VGA WONDER
 '  4 = EVEREX / TSENG VGA
 '  5 = VIDEO7 /HEADLAND VGA
 '  6 = CHIPS & TECHNOLOGY SUPER VGA
 '  7 = CIRRUS VGA
 '  8 = PARADISE VGA
 '  9 = OAKTECH VGA
 ' 10 = ZYMOS VGA
 ' 11 = ABOVE A B VGA
 ' 12 = TRIDENT VGA
 ' 13 = GENOA SUPER VGA
 ' 14 = COMPAQ
 ' 15 = PHOENIX
 ' 16 = TSENG 4000
 ' 17 = AHEAD
DECLARE FUNCTION HIREZCRT% ()

' Test if have a TANDY/PC Jr. CGA installled
DECLARE FUNCTION TEST4TANDY%

'-------------------EQUIPMENT Routines-------------------------

 ' Returns size of installed extended memory on AT and above.
 ' Returns 0 on an AT if no memory or -1 if CMOS battery is bad
DECLARE FUNCTION ACTUALEXTND% ()

 ' Returns:    0 if no NDP, or if POST switch cleared
 '           -87 if 8087 being emulated by software on 80286 or 80386
 '            87 if 8087
 '           287 if 80287
 '           387 if 80387 or 80487
 ' Does rely on Equipment word as does QBX, because of clone errors.
DECLARE FUNCTION CHECK87% ()
 
 ' Returns CMOS drive type (Drive Num 1 or 2)
 ' Error reported as -1.  AT+ machines
DECLARE FUNCTION CMOSDRIVE% (BYVAL DriveNum%)

 ' Returns: 0 if nonexistent UART (Comm port) at PortNumber (1-4)
 '          1 if 8250 (PC/XT)
 '          2 if 16450 (most AT's)
 '          3 if 16550 (most early PS/2's)
 '          4 if 16550A (FIFO buffer now works)
 '          5 if IBM type 3 DMA
 '          6 if UART not functioning
DECLARE FUNCTION COMMPORT% (BYVAL PortNumber%)

 ' Returns 0 if no UART, 1 if error
DECLARE FUNCTION COMMINFO% (BYVAL PortNum%, SPEED&, PARITY%, WORDL%, StopB%)

 ' Given number or harddrive (1 or 2) returns BIOS information about
 ' such drive, or 0 if drive does not exist
DECLARE SUB DRIVESTAT (BYVAL DiskNum%, Head%, Cylinder%, Sector%)

 ' Returns info about boot sector on hard disk
DECLARE FUNCTION DOSSYSVER% (BYVAL DiskNum%)

 ' Returns information about the installation environment
DECLARE SUB EQUIPMENT (ConvMeminKB%, NumPrinterPorts%, NumComPorts%)

' Returns number of physical floppy drives in system
DECLARE SUB FLOPPYDRIVES (NoDrives%)

 ' Returns floppy drive type
DECLARE FUNCTION FLOPPYTYPE% (BYVAL DriveNum%)

' This returns CPU version as an integer
 ' Fast public domain routine
 ' 8088        =   88
 ' 8086        =   86
 ' 80188/86    =  186
 ' 80286       =  286
 ' 80386SX     =  386
 ' 80386DX     =  386
 ' 80486SX     =  486
 ' 80486       =  486
 ' NEC V20     =   20
 ' NEC V30     =   30
DECLARE FUNCTION GETCPU% ()

 ' Returns drive media type, adjusts MIMIC
DECLARE FUNCTION GETMEDIA% (Drive$)

 ' Returns number of hard drives in system
DECLARE SUB HARDRIVES (HARD%)

 ' Returns HERC type 0 = none, 1 = Basic, 2 = Plus, 3 = Incolor
DECLARE FUNCTION HERCTYPE% ()

 ' Returns -1 if MSLAN is installed, else 0 if not
DECLARE FUNCTION FINDLAN% ()

 ' Returns -1 if NETBIOS is installed, else 0 if not
DECLARE FUNCTION NETBIOS% ()

 ' Returns -1 if network is installed, 0 of not
DECLARE SUB NETWORK (BANYAN%, NOVELL%, MSNET%, LANTASTIC%)

 ' Returns number of logical or block devices in system
DECLARE FUNCTION NUMBLOCKS% ()

 ' Returns size of free extended, free expanded memory, free XMS
DECLARE SUB OTHERMEMORY (Extended%, Expanded%, XMS%, UMB%)

 ' Returns machine operating environment see if DVPI, MS Windows,
 ' DoubleDos, DESQVIEW or VCPI is active.
DECLARE SUB OTHEROPER (DPMI%, WINDOWS%, DESQVIEW%, DDOS%, VCPI%)

 ' Returns -1 if a TASKSWITCHER is active, else 0
DECLARE FUNCTION TASKSWITCH% ()

 ' Return True if Printer is ready (LPT 1 to 3)
DECLARE FUNCTION PRINTRDY% (BYVAL Lpt%)

 ' Mono         =   0
 ' CGA          =   2
 ' PGA          =   2   (Untested, assume PGA would be treated as CGA)
 ' COMPAQ - CGA =  -2   to tell that user may have a single color display
 ' HERC         =   3   if have HERC and MSHERC.COM
 ' HERC         =  -3   if have HERC but w/o MSHERC.COM
 ' AT&T         =   4   but only if have just CGA display, not EGA or VGA
 ' EGA64        =   8   Because resolution limited for 64k EGA
 ' EGA64 w/CGA  =  -8   Because resolution limited to CGA modes
 ' EGA          =   9   Have minimum of 128kb of video ram
 ' EGA w/CGA    =  -9   Since resolution limited to CGA modes
 ' EGA Mono     =  10   If have EGA with mono display
 ' MCGA w/EGA   = -12   If have an EGA ECD digital color display, since
 '                      resolution of this display is limited to EGA modes
 ' MCGA Mono    = -11   If have MCGA with a mono display
 ' MCGA         =  11   If have an analog color display
 ' VGA Mono     = -10   To distinguish between EGA mono
 ' VGA          =  13   Normal VGA color display
 ' VGA          = -13   Monochrome monitor really appears to be color
DECLARE FUNCTION VIDEOSTAT% ()


'--------------------Pure DOS routines--------------------------

'determines if block device driver supports DOS 4 big partitions
DECLARE FUNCTION TESTFOR4% (Drive$)
'determines if drive is fixed or removable (requires DOS Ver 3.00+)
DECLARE FUNCTION REMOVABLE% (Drive$)
'determines if drive is local or networked drive (requires DOS Ver 3.1+)
DECLARE FUNCTION REMOTE% (Drive$)


'-----------------Microsoft Mouse Routines------------------
 ' Returns number of buttons if Mouse Exists, 0 if Mouse does not Exist
 ' You MUST call it before calling any other mouse function!!!!!!!
DECLARE FUNCTION MMEXIST% ()

 ' A faster routine.  Assumes have 2 button mouse if returns TRUE
 ' Does not reset hardware.
DECLARE FUNCTION FASTMOUSE% ()

 ' Test if either a normal key or mouse press has occured
DECLARE FUNCTION MMORKEY% ()
 '  Merely does a software reset
DECLARE FUNCTION MMRESET% ()
 ' Returns version number of mouse driver
DECLARE FUNCTION MMVER% ()

'Mouse information routines:
 'LANGV = -1 if have internation version of driver
 'MTYPE returns type of mouse installed (P/S 2, HP, etc.)
 'MINTER returns interrupt number in use
DECLARE SUB MOUSEINFO (LANGV%, MTYPE%, MINTER%)
 ' Returns Mouse version as a string
DECLARE FUNCTION MMVERS$ ()
 ' Returns Mouse EGA driver version
DECLARE FUNCTION MMEGAVER$ ()

 ' Resets Keyboard & mouse motion counters
DECLARE SUB CLRMOUSEKEY ()


'----------------------KEYBOARD ROUTINES-------------------------------
 
  ' Returns -1 if 101 keyboard w/ BIOS support exits
  '          0 for 83/84 keyboard
DECLARE FUNCTION EXTKBD% ()


'-------------------------Other Routines----------------------------
 ' Make psuedo machine independent fast beep
DECLARE SUB BEEPER ()

 ' makes a short 750 Hz tone
DECLARE SUB BEEPER10
' makes a short 950 Hz tone
DECLARE SUB BEEPER20




