/* PC Keyboard defines and routines */

/* getkey(&x)  places the key value in x and returns 1 if x is a special
	       character, or 0 if it isn't
   getkeye(&x) is the same as getkey(), except that the character is
	       echoed to stdout if it is an ASCII character          */


/* Note that KEYS.H defines the control keys as special so they */
/* can be tested for, even though technically they are part of */
/* the regular character set */

#define F1    59
#define F2    60
#define F3    61
#define F4    62
#define F5    63
#define F6    64
#define F7    65
#define F8    66
#define F9    67
#define F10   68

#define SHIFTF1  84
#define SHIFTF2  85
#define SHIFTF3  86
#define SHIFTF4  87
#define SHIFTF5  88
#define SHIFTF6  89
#define SHIFTF7  90
#define SHIFTF8  91
#define SHIFTF9  92
#define SHIFTF10 93

#define CTRLA   1
#define CTRLB   2
#define CTRLC   3
#define CTRLD   4
#define CTRLE   5
#define CTRLF   6
#define CTRLG   7
#define CTRLH   8
#define CTRLI   9
#define CTRLJ  10
#define CTRLK  11
#define CTRLL  12
#define CTRLM  13
#define CTRLN  14
#define CTRLO  15
#define CTRLP  16
#define CTRLQ  17
#define CTRLR  18
#define CTRLS  19
#define CTRLT  20
#define CTRLU  21
#define CTRLV  22
#define CTRLW  23
#define CTRLX  24
#define CTRLY  25

#define CTRLF1   94
#define CTRLF2   95
#define CTRLF3   96
#define CTRLF4   97
#define CTRLF5   98
#define CTRLF6   99
#define CTRLF7  100
#define CTRLF8  101
#define CTRLF9  102
#define CTRLF10 103

#define ALTF1  104
#define ALTF2  105
#define ALTF3  106
#define ALTF4  107
#define ALTF5  108
#define ALTF6  109
#define ALTF7  110
#define ALTF8  111
#define ALTF9  112
#define ALTF10 113

#define ALT1  120
#define ALT2  121
#define ALT3  122
#define ALT4  123
#define ALT5  124
#define ALT6  125
#define ALT7  126
#define ALT8  127
#define ALT9  129
#define ALT10 130

#define ALTQ  16
#define ALTW  17
#define ALTE  18
#define ALTR  19
#define ALTT  20
#define ALTY  21
#define ALTU  22
#define ALTI  23
#define ALTO  24
#define ALTP  25
#define ALTA  30
#define ALTS  31
#define ALTD  32
#define ALTF  33
#define ALTG  34
#define ALTH  35
#define ALTJ  36
#define ALTK  37
#define ALTL  38
#define ALTZ  44
#define ALTX  45
#define ALTC  46
#define ALTV  47
#define ALTB  48
#define ALTN  49
#define ALTM  50

#define UPARROW    72
#define DOWNARROW  80
#define LEFTARROW  75
#define RIGHTARROW 77

#define TAB         9
#define SHIFTTAB   15
#define ENTER      '\n'

#define PGUP   73
#define PGDN   81
#define INSERT 82
#define DELETE 83
#define HOME   71
#define END    79

int _get_key(char *x,int echo);

int _get_key(char *x,int echo) { /* Only echoes if ASCII */
  *x=getch();
  if (*x=='\0') {
    *x=getch();
    return(1);
  }
  if (*x<27)
    return(1);
  if (echo) {
    putch(*x);
    return(0);
  }
}

#define getkey(x) _get_key(x,0)
#define getkeye(x) _get_key(x,1)
