;first updated 06/07/91
;updated 12/10/91

;=======================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
; RM82TS8,16,24,32,40,48

HAVETANDY   EQU    0    ; 0 = don't configure for TANDY 1000 series

DOSSEG
.MODEL MEDIUM

BIOSRAM SEGMENT AT 0            ;make ASSUMEs more readable
BIOSRAM ENDS

	Public  WAITFORKEY, CLRKBD
	INCLUDE KEY.INC
.CODE

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

;===========================================================================
; DECLARE FUNCTION WAITFORKEY%()
; Looks for key press,
; Returns: -256 if none pending
;           a positive number, [e.g. CHR$(number)] if a normal key found.
;           a negative scan code if an extended key key pressed.
;
; Only initializes itself one time.
;===========================================================================


EVEN
WAITFORKEY PROC FAR
	Cmp     B$KBD_Inst,0    ; have we installed before
	JE      Do_Install      ; if no, then do it
Main:                           ; else find keystroke
				; sets Zero flag if no character is pending
	Mov     AH,1            ; any keycode waiting?
	Or      AH,Byte Ptr B$KBD_Type ; use extended kbd function if avail
	Int     16h             ; use BIOS
	JZ      No_Key_There    ; if ZF then no key
				; else, key there, so get it
	Xor     AH,AH           ; read keycode word
	Or      AH,Byte Ptr B$KBD_Type ; use extended kbd function if avail
	Int     16h             ; use BIOS
	OR      AL,AL           ; if AL = 0 then have extended keycode
	JZ      GotExtCode      ; jump to that routine
	Cmp     AL,0E0h         ; to eliminate extended keycode byte of 0E0h
				; assumes AT kbd not in SCANMODE 3
	JE      GotExtCode      ; (that is a very legit assumption)
	Xor     AH,AH           ; got normal key, clear Scan code
	Ret                     ; return and quit
EVEN
GotExtCode:                     ; make extended keycode return a neg number
	Mov     AL,AH           ; put scan in AL
	Xor     AH,AH           ; clear AH
	Neg     AX              ; does fast 2's complement
	Ret                     ; return and quit
EVEN
No_Key_There:
	Mov     AX,-256         ; assume never will get an extended
	Ret                     ; keycode of that number normally
EVEN
Do_Install:
	Call    B$CHK_KB        ; determine KBD type
	Jmp     Short  Main     ; return to main loop
	Assume  ES:NOTHING
WAITFORKEY endp

;===========================================================================
; DECLARE SUB CLRKBD ()
; Returns nothing
;
; Clears the Keyboard using BIOS calls.  Have to use BIOS because Tandy
; 1000 did not look at keyboard buffer pointers
;===========================================================================

EVEN
CLRKBD  PROC    FAR
					; most compatible & slowest
	;Mov     AX,0C00h               ; DOS substitue language is shown
	;Int     21h                    ; It is 3 times slower but 100%
					; compatible.
IF      HAVETANDY
 KStart:            ; compatible & fairly fast works w/ TANDY 1000
	Mov     AH,01                   ; see if buffer empty
	Int     16h
	JZ      KQuit                   ; buffer empty if ZF set
	Xor     AH,AH                   ; if buffer not empty read keystroke
	Int     16h
	Jmp     Short KStart            ;and reloop
 KQuit:
	Ret
ELSE
	; very fast but non-compatible with TANDY 1000 series
	Xor     AX,AX                  ; very fast, no keys to read
	Mov     ES,AX
	ASSUME  ES:BIOSRAM
	CLI                            ; prevent interrupts temporarily
	Mov     AL,ES:[041Ch]          ; Refer to actual addresses
	Mov     ES:[041Ah],AL          ; using ES: form
	STI                            ; allow interrupts again
	Ret
ENDIF
	Assume  ES:NOTHING
CLRKBD ENDP
END

