/**
*** LTEST.C - Sample demo program for list manager.
***
***  This program is a simple demo of the linked list manager in
***  in L.C.  This program will create two linked lists, one of ints,
***  and one of strings.  It will insert the value 0 to 25 and "000" to "025"
***  first in odd numbers, then even numbers.  Then it will locate a
***  a value in the integer list, and delete it.  Finally it will display the
***  contents of both lists.  This program is purely academic.
***
***  To Compile:  TCC or QCL LTEST.C L.OBJ    (See L.C for info to make L.OBJ)
***  Mario Giannini
**/

#include "l.h"

main()
{
	int i;
	char Buffer[128];
	List ListOfInts, ListOfStrings;
	Node *Tmp;

	ListOfInts=MakeList(INT);
	ListOfStrings=MakeList(CHARSTR);

	for(i=0;i<25;i+=2) /* Add Odd values */
	{
		AddNode(ListOfInts, &i);
		sprintf(Buffer, "%03d - Text", i);
		AddNode(ListOfStrings, Buffer);
	}
	for(i=1;i<25;i+=2) /* Add Odd values */
	{
		AddNode(ListOfInts, &i);
		sprintf(Buffer, "%03d - Text", i);
		AddNode(ListOfStrings, Buffer);
	}

	i=11;
	Tmp=FindNode(ListOfInts, &i);
	if(Tmp)
		printf("found: %d\n", Tmp->Data.Int);
	else
		printf("Could not find 11\n");
	DeleteNode(Tmp);
	Tmp=FindNode(ListOfInts, &i);
	if(Tmp)
		printf("found: %d\n", Tmp->Data.Int);
	else
		printf("Could not find 11\n");
	i=110;
	Tmp=FindNode(ListOfInts, &i);		
	if(Tmp)
		printf("found: %d\n", Tmp->Data.Int);
	else
		printf("Could not find 110\n");
	ListNodes(ListOfInts, ASCEND);
	printf("Press any key to see the strings: ");
	getch();
	ListNodes(ListOfStrings, DESCEND);
	DestroyList(ListOfInts);
	DestroyList(ListOfStrings);
}

