/*** 
*malloc.h - function declarations for memory allocation functions
*
*
*Purpose:
*   This file contains the definitions and declarations for the
*   memory allocation functions.
*   [System V]
*
*******************************************************************************/

#ifndef _SIZE_T_DEFINED
typedef unsigned int size_t;
#define _SIZE_T_DEFINED
#endif

/* function declarations for those who want strong type checking
 * on arguments to library function calls
 */

#ifdef LINT_ARGS    /* argument checking enabled */

#ifndef NO_EXT_KEYS /* extended keywords are enabled */
extern unsigned int cdecl _amblksiz;
char * cdecl alloca(unsigned int);
void * cdecl calloc(size_t, size_t);
char * cdecl _expand(char *, unsigned int);
void cdecl _ffree(char far *);
void far * cdecl _fmalloc(unsigned int);
unsigned int cdecl _fmsize(char far *);
unsigned int cdecl _freect(unsigned int);
void cdecl free(void *);
char huge * cdecl halloc(long, unsigned int);
void cdecl hfree(char huge *);
void * cdecl malloc(size_t);
unsigned int cdecl _memavl(void);
unsigned int cdecl _msize(char *);
void cdecl _nfree(char near *);
void near * cdecl _nmalloc(unsigned int);
unsigned int cdecl _nmsize(char near *);
void * cdecl realloc(void *, size_t);
char * cdecl sbrk(int);
unsigned int cdecl stackavail(void);
#else           /* extended keywords not enabled */
extern unsigned int _amblksiz;
char *alloca(unsigned int);
void *calloc(size_t, size_t);
char * _expand(char *, unsigned int);
unsigned int _freect(unsigned int);
void free(void *);
void * malloc(size_t);
unsigned int _memavl(void);
unsigned int _msize(char *);
void *realloc(void *, size_t);
char *sbrk(int);
unsigned int stackavail(void);
#endif  /* NO_EXT_KEYS */

#else           /* argument checking not enabled */

#ifndef NO_EXT_KEYS /* extended keywords are enabled */
extern unsigned int cdecl _amblksiz;
char * cdecl alloca();
void * cdecl calloc();
char * cdecl _expand();
void cdecl _ffree();
void far * cdecl _fmalloc();
unsigned int cdecl _fmsize();
unsigned int cdecl _freect();
void cdecl free();
char huge * cdecl halloc();
void cdecl hfree();
void * cdecl malloc();
unsigned int cdecl _memavl();
unsigned int cdecl _msize();
void cdecl _nfree();
void near * cdecl _nmalloc();
unsigned int cdecl _nmsize();
void * cdecl realloc();
char * cdecl sbrk();
unsigned int cdecl stackavail();
#else           /* extended keywords not enabled */
extern unsigned int _amblksiz;
char *alloca();
void *calloc();
char *_expand();
void free();
unsigned int _freect();
void *malloc();
unsigned int _memavl();
unsigned int _msize();
void *realloc();
char *sbrk();
unsigned int stackavail();
#endif  /* NO_EXT_KEYS */

#endif  /* LINT_ARGS */
