/*** 
*memory.h - definitions/declarations for buffer (memory) manipulation routines
*
*
*Purpose:
*   This include file contains the function declarations for the
*   buffer (memory) manipulation routines.
*   [System V]
*
*******************************************************************************/


#ifndef _SIZE_T_DEFINED
typedef unsigned int size_t;
#define _SIZE_T_DEFINED
#endif

/* function declarations for those who want strong type checking
 * on arguments to library function calls
 */

#ifdef LINT_ARGS    /* argument checking enabled */

#ifndef NO_EXT_KEYS /* extended keywords are enabled */
char * cdecl memccpy(char *, char *, int, unsigned int);
void * cdecl memchr(const void *, int, size_t);
int cdecl memcmp(const void *, const void *, size_t);
void * cdecl memcpy(void *, const void *, size_t);
int cdecl memicmp(char *, char *, unsigned int);
void * cdecl memset(void *, int, size_t);
void cdecl movedata(unsigned int, unsigned int, unsigned int, unsigned int, unsigned int);
#else           /* extended keywords not enabled */
char *memccpy(char *, char *, int, unsigned int);
void *memchr(const void *, int, size_t);
int memcmp(const void *, const void *, size_t);
void *memcpy(void *, const void *, size_t);
int memicmp(char *, char *, unsigned int);
void *memset(void *, int, size_t);
void movedata(unsigned int, unsigned int, unsigned int, unsigned int, unsigned int);
#endif  /* NO_EXT_KEYS */

#else           /* argument checking not enabled */

#ifndef NO_EXT_KEYS /* extended keywords are enabled */
char * cdecl memccpy();
void * cdecl memchr();
int cdecl memcmp();
void * cdecl memcpy();
int cdecl memicmp();
void * cdecl memset();
void cdecl movedata();
#else           /* extended keywords not enabled */
char *memccpy();
void *memchr();
void *memcpy();
void *memset();
void movedata();
#endif  /* NO_EXT_KEYS */

#endif  /* LINT_ARGS */
