{ MPI - Multiple Precision Positive Integer Arithmetic Package   }
{ Copyright 1989, KSU Research Foundation, Manhattan KS  66506   }
{ License granted to copy, but not for sale or profit   }
 {test program in Turbo Pascal to interface to multiple precision positive}
 {integer arithmetic package and implement the verification of a few Mersenne}
 {numbers primality or compositeness}
 {$L mpiface}
 program mersenne;
    const regmax = 31;
    type
      c4 = packed array[1..4] of char;
      register = array[0..regmax] of word;
      ctrlptr = ^ctrl;
      regptrtyp = ^register;
      ctrl = record
        operation: c4;                          {character routine abbrev.}
        ptr1,ptr2: regptrtyp;                   {argument locations}
        ln1,ln2: word;                          {argument lengths}
      end;
    var
      argsdescr,holddescr: ctrl;
      argsptr,holdptr: ctrlptr;
      powertwo : array[0..15] of word;
      store,mersnum : register;
      output : packed array[1..150] of char;
      porc,result : char;
      mptr,tptr : regptrtyp;
 {by interspersing these next variables with zeroes}
 {we easily achieve the leading zero-valued guard word requirement}
      z0,one,z1,pcan,pby16,pmod16,j : word;
      i : byte;
procedure makecont(cptr:ctrlptr; a1,a2:regptrtyp; l1,l2:word; op:c4);
   begin
     cptr^.ptr1 := a1;
     cptr^.ptr2 := a2;
     cptr^.ln1  := l1;
     cptr^.ln2  := l2;
     cptr^.operation := op;
   end;
 procedure moveit(into,from:regptrtyp; l:word);
   var i:byte;
   begin
     for i := 0 to l do
     into^[regmax-l+i] := from^[i];
   end;
    function mpiface(a: ctrlptr): ctrlptr;  external;
    function pptface(a: ctrlptr): char; external;
    begin
      z0 := 0;  z1 := 0;  one := 1;
      argsptr := addr(argsdescr);
      holdptr := addr(holddescr);
      j := 1;
        for i := 0 to 15 do begin
          powertwo[i] := j;
          if i < 15 then j := j+j;
        end;
      pcan := 3;
        while true do
          begin
          result := 'P';
            for i:=1 to 3 do begin
              makecont(argsptr,addr(z1),addr(z1),1,1,'PROB');
              porc := pptface(argsptr);
                if porc = 'C' then result := 'C';
            end;
            if result = 'P' then begin
              pby16 := pcan div 16;
              pmod16 := pcan mod 16;
                if pby16 >= regmax then
                  begin
                  writeln(pcan,' will give too large a Mersenne number. Terminating.');
                  halt
                  end;
                for i := 0 to pby16+1 do
                mersnum[regmax - i] := 0;
              mersnum[regmax-pby16] := powertwo[pmod16];
              makecont(argsptr,addr(mersnum[regmax-pby16-1]),addr(z0),1+pby16,1,'SUBT');
              argsptr := mpiface(argsptr);
              holddescr := argsdescr;
              makecont(argsptr,argsptr^.ptr1,addr(z0),argsptr^.ln1,1,'PROB');
              porc := pptface(argsptr);
              for i:= 1 to 150 do output[i] := ' ';
              makecont(argsptr,addr(output[150]),holdptr^.ptr1,1,holdptr^.ln1,'CONB');
              argsptr := mpiface(argsptr);
                if porc = 'P' then
                  writeln(pcan,'''s Mersenne number, ',copy(output,150-argsptr^.ln1,argsptr^.ln1),' is prime.')
                else
                  writeln(pcan,'''s Mersenne number, ',copy(output,150-argsptr^.ln1,argsptr^.ln1),' is composite.');
            end
            else writeln(pcan,' is composite -- Mersenne number not calculated.');
          pcan := pcan + 2;
          end;
    end.
