; 7/1/91

;=======================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
;RM82TS8,16,24,32,40,48

;-----------------------------------------------------------------------
; DECLARE FUNCTION FASTMOUSE%()
; Description:  Tests for Mouse existence.
;               If Microsoft Mouse Exists, then
;               Returns the number of buttons & resets driver.
;               Else returns 0.
; Some of the complexity of the program is due to the need to test
; for &H33 vector in old versions of DOS, pre 3.xx, which did not
; initialize a vector for &H33 mouse interrupt.  Assumes that if a
; mouse driver exists, then it is installed properly.  It takes about
; .004 seconds to run this routine w/ a MM Mouse on a 10mhz 286 machine
; using version 7.xx of the MM mouse software.
; Does not perform a hardware reset, because that is slow.
;-----------------------------------------------------------------------
DOSSEG
.MODEL MEDIUM, BASIC

.DATA
	EXTRN  B$HAVEMOUSE:BYTE
	EXTRN  B$MOUSEON:BYTE

.CODE
; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1990, 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

EVEN
FASTMOUSE PROC FAR BASIC
	Mov     AX,3533h                ; Get Int 33H vector by calling
	Int     21h                     ; Int 21H. Reply in ES:BX
	Mov     AX,ES                   ; Check segment and offset of
	OR      AX,BX                   ; Int 33H.  If both 0 then driver
	JZ      Not_Installed           ; is not installed (AX & ES =  0).
; (Really this is a hidden DOS Version  check. DOS version 2.xx did
; not automatically initialize a vector to INT 33h.  Microsoft sample
; routines then check to see if INT 33h points to an IRET (DOS Versions
; 3.xx and above if no mouse is installed).  That is  unneccessary
; because call to INT 33h will not give us the correct information if
; MOUSE is not installed.)

Check_Mouse:
	Mov     AX,33                   ; perform software reset, very fast
	Int     33h
	Cmp     AX,-1                   ; if AX <> -1 then no mouse
	JNE     Not_Installed
	Mov     AX,14                   ; turn off light pen emulation
	Int     33h                     ; for speed (since function is
					; is useless on a VGA, and only
					; useful inside GWBASIC with the PEN)
	Mov     AX,BX                   ; recall num buttons from BX
	Mov     B$HAVEMOUSE,1           ; report have a mouse
	Mov     B$MOUSEON,0             ; report cursor is off
	Ret
Not_Installed:
	Xor     AX,AX                   ; zero AX for function return
	Mov     B$HAVEMOUSE,AL          ; report back have no mouse
	Mov     B$MOUSEON,AL            ; report cursor is off
	Ret
FASTMOUSE ENDP
END

