;RM82TS8,16,24,32,40,48
; 12/10/90

;============================================================================
;   Copyright (C) Copr. 1990 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;============================================================================

;---------------------------------------------------------------------------------
; DECLARE FUNCTION FASTMOUSE%()
; Description:  Tests for Mouse existence.
;               If Microsoft Mouse Exists, then
;               Returns the number of buttons & resets driver.
;               Else returns 0.
; Some of the complexity of the program is due to the need to test
; for &H33 vector in old versions of DOS, pre 3.xx, which did not
; initialize a vector for &H33 mouse interrupt.  Assumes that if a
; mouse driver exists, then it is installed properly.  It takes about
; .004 seconds to run this routine w/ a MM Mouse on a 10mhz 286 machine
; using version 7.xx of the MM mouse software.
; Does not perform a hardware reset.
;---------------------------------------------------------------------------------
DOSSEG
.MODEL MEDIUM
	PUBLIC FASTMOUSE
.CODE

EVEN
FASTMOUSE       PROC    FAR
	Mov     AX, 3533h               ; Get Int 33H vector by calling
	Int     21h                     ; Int 21H. Reply in ES:BX
	Mov     AX, ES                  ; Check segment and offset of
	OR      AX, BX                  ; Int 33H.  If both 0 then driver
	JZ      Quit                    ; is not installed (AX is 0).
	; (Really this is a hidden DOS Version  check. DOS version 2.xx did
	; not automatically initialize a vector to INT 33h.  Microsoft sample
	; routines then check to see if INT 33h points to an IRET (DOS Versions
	; 3.xx and above if no mouse is installed).  That is  unneccessary 
	; because call to INT 33h will not give us the correct information if
	; MOUSE is not installed.)

Check_Mouse:
	Mov     AX,33                   ; perform software reset, very fast
	Int     33h
	Cmp     AX,-1                   ; if AX <> -1 then no mouse
	JNE     Not_Installed
	Mov     AX,14                   ; turn off light pen emulation
	Int     33h                     ; for speed (since function is
					; is useless on a VGA, and only
					; useful inside GWBASIC with the PEN)
	Mov     AX,BX                   ; recall from BX
	JMP     Short Quit

Not_Installed:
	Xor     AX,AX			; put a zero in AX for function return

Quit:
	Ret
FASTMOUSE ENDP
END
