Extrn StringAddress:far,StringLength:far

code2	segment para public 'code'

	assume cs:code2,ds:code2

comment |

	Copyright 1990 MicroHelp, Inc.
	Release into the public domain.
	
	MicroHelp, Inc. is a publisher of add-on tools for Microsoft 
	Professional Development System and Microsoft QuickBASIC.
	
	For Btrieve 5.x, change InterFaceId at the end of this file
	and reassemble this source code:
	
	    MASM MHBTRV;
	    
	For information on MicroHelp products, call 1-800-922-3383 or
	(404) 552-0565.
	
	Modifications:
	
	Version 1.01
	  01/22/90 If Operation 25 is called, then this routine will
	           return status 20 on subsequent calls.
		   
		   Now checks the length of the PosBlock$ string to
		   make sure it's at least 128 bytes long.
		   
		   Now returns the length of the buffer in DataLength%
		   in case you are using variable-length records.
        Version 1.02
	  01/25/90 Now includes changes for Btrieve 5.0. See MHBTRV.ASM.
 	Version 1.03
          03/01/90 If you are using a version of Btrieve that makes use
	           of expanded memory, and you use this routine inside
		   the QBX environment, be sure to start QBX with the
		   /ES switch.

	|

	; These equates are relative to BP on the stack

	Bkey equ 6
	Bkey$ equ Bkey + 2
	Blen equ Bkey$ + 2
	Boffset equ Blen + 2
	Bseg equ Boffset + 2
	BBlock$ equ Bseg + 2
	BStatus equ BBlock$ + 2
	Bop equ Bstatus + 2
	
Public MhBtrv
MhBtrv Proc Far
;call MhBtrv(Operation%,Status%,PosBlock$,DataSegment%,DataOffset%,_
;            DataLength%,BtKey$,BtKey%)
	push bp
	mov bp,sp
	push si
	push di
	push ds
	push es

	cmp cs:BtrieveOffset,0			; already initialized?
	jnz AlreadyHaveBtrieveAddress		; yes
	mov ax,357bh				; Get interrupt address
	int 21h
	cmp bx,33h				; make sure offset is OK
	jz  SetBtrieveAddress			; no problem
	mov ax,20
ReturnError:
	mov si,[bp+Bstatus]			; point to status
	mov word ptr [si],ax			; return Status
	jmp MhBtrvExit
SetBtrieveAddress:
	mov cs:BtrieveOffset,bx
AlreadyHaveBtrieveAddress:
	mov si,[bp+Bkey]
	lodsb
	mov byte ptr cs:KeyNumber,al
	push [bp+Bkey$]
	call StringAddress
	mov cs:KeyBuffSegment,dx
	mov cs:keyBuffOffset,ax
	push [bp+Bkey$]
	call StringLength
	mov byte ptr cs:KeyLength,al
	mov si,[bp+Blen]
	lodsw
	mov cs:BufferLength,ax
	mov si,[bp+Boffset]
	lodsw
	mov cs:BufferOffset,ax
	mov si,[bp+Bseg]
	lodsw
	mov cs:BufferSegment,ax
	push [bp+BBlock$]
	call StringLength
	cmp ax,128			; at least 128 long?
	jae BlockOk			; yes
	mov ax,23
	jmp ReturnError			; get out with status 23
BlockOk:	
	push [bp+BBlock$]
	call StringAddress
	mov cs:PosBlockOffset,ax
	mov cs:PosBlockSegment,dx
	mov cs:FcbSegment,dx
	add ax,90
	mov cs:FcbOffset,ax
	mov si,[bp+BStatus]
	mov cs:StatusOffset,si
	mov cs:StatusSegment,ds
	mov si,[bp+Bop]
	lodsw
	mov cs:Operation,ax
	mov bx,cs
	mov ds,bx			; set ds:dx pointing to block
	cmp ax,25			; turning off Btrieve?
	jnz NotTurningOff		; nope
	mov BtrieveOffset,0		; yes - clear for next call
NotTurningOff:	
	mov dx,offset BufferOffset
	int 7bh				; call Btrieve
	mov si,[bp+Blen]
	mov ax,BufferLength		; return buffer length
	mov ss:[si],ax
MhBtrvExit:
	pop es
	pop ds	
	pop di
	pop si
	pop bp
	cld
	ret 16

MhBtrv Endp

BufferOffset	dw 0
BufferSegment	dw 0
BufferLength	dw 0
PosBlockOffset	dw 0
PosBlockSegment	dw 0
FcbOffset	dw 0
FcbSegment	dw 0
Operation	dw 0
KeyBuffOffset	dw 0
KeyBuffSegment	dw 0
KeyLength	db 0
KeyNumber	db 0
StatusOffset	dw 0
StatusSegment	dw 0
InterfaceId	dw 6173h		; 6176h for Btrieve 5

BtrieveOffset	dw 0			; non-zero indicates Btrieve loaded

code2	ends
	end
