;RM82TS8,16,24,32,40,48,56,64
; 11/20/90

;============================================================================
;   Copyright (C) Copr. 1990 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;============================================================================


DOSSEG
.MODEL MEDIUM
	PUBLIC MMHERC
.CODE
	EXTRN   B$CSCN:FAR      ; QBASIC SCREEN routine
;============================================================================
; DECLARE SUB MMHERC ()
; CALL MMHERC
; Purpose:
;  If have a HERC display with MSHERC.COM installed, routine will
;  adjust bios ram VIDEO mode data area so a mouse will work in graphics mode.
;  This routine calls SCREEN 3 automatically.
;  Assumes that you have a mouse installed, does not test for it.
;  Routine kills all user Mouse interrupt routines.
;============================================================================

EVEN
Have_Herc       db      0       ; keep track of prior calls

EVEN
MMHERC PROC FAR
	Cmp	Have_Herc,0	; have we done this before?
	JNE	Begin		; yep, so skip ahead
	Xor     AX,AX           ; Assume a Mono Display
	Mov     ES,AX           ; set ES to Ram BIOS area
	Mov     BX,ES:[0463h]   ; look at port info stored in RAM bios
				; at 0000:0463h
	Mov	AL,1		; assume a mono display
	Cmp     BL,0B4h         ; Mono reports 0B4h, color 0D4h
	Je      @f              ; test port address, if Mono then skip ahead
	Mov	AL,2		; say display is not a mono display
@@:
	Mov	Have_Herc,AL	; store display type in Have_Herc
	Cmp	AL,2		; is it a color display?
	JE	Finis		; yep, so quit
	
	;***** To make doubly sure have MSHERC.COM installed
	;***** you could drop this section if you wanted to.
	Mov     AX,0EF00h       ; test for MSHERC.COM
	Int     10h
     	Mov     AL,1            ; Assume MSHERC.COM installed
	Cmp     DX,0100h        ; **this is an undocumented call and may
                                ; change ******!!!!!
     	JE      @f              ; if equal then MSHERC.COM is installed
    	Mov     AL,2            ; else report MSHERC.COM is not installed
@@:
	Mov	Have_Herc,AL    ; store result
	;*****
Begin:
	Cmp	Have_Herc,1	; is a Herc display active?
	JNE	Finis		; no, so quit
	Xor	AX,AX
	Mov	ES,AX		; set ES to BIOS ram area
	Mov     BL,6            ; assume page 0 MS Mouse Programmers
				; Guide, Appendix F, page 305
	Cmp     Byte Ptr ES:[0462h],0  ; is CURPAGE from BIOS ram = 0?
	JE      @f
	Mov     BL,5            ; if using CRT page 1
@@:
	Mov     Byte Ptr ES:[0449h],BL  ; store value in Bios Video Mode
	Mov	AX,33           ; reset mouse to proper coordinates
	Int     33h		; do a software reset because its faster
	Mov     AX,14           ; turn off light pen emulation
	Int     33h             ; for speed (since function is
				; is useless on a VGA, and only
				; useful inside GWBASIC with PEN)
	Mov     AX,1            ; select SCREEN 3 (page 0?)
	Push    AX
	Mov     AX,3            ; this is the SCREEN Mode
	Push    AX
	Mov     AX,2		; (number of parameters on stack??)
	Push    AX
	Call    B$CSCN          ; call QBASIC to do it
Finis:	
	Ret
MMHERC	ENDP
END
