;RM82TS8,16,24,32,40,48
;Updated 11/20/90

;============================================================================
;   Copyright (C) Copr. 1990 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;============================================================================

;-----------------------------------------------------------------------------
; DECLARE FUNCTION MMEXIST%()
; Description:  Tests for Mouse existence.
;               If Microsoft Mouse Exists, then
;               Returns the number of buttons & resets driver.
;               Else returns 0.
; Some of the complexity of the program is due to the need to test
; for Int 33h vector in old versions of DOS, pre 3.xx, which did not
; initialize a vector for &H33 mouse interrupt.  It takes about
; 1.45 seconds to initialize a MM Mouse on a 10mhz 286 machine
; using version 7.xx of the MM mouse software.  It appears that every
; upgrade makes a complete reset take longer and longer.
;-----------------------------------------------------------------------------

DOSSEG
.model medium
	public MMEXIST
.code

EVEN                                    ; speed up access on 286/386
MMEXIST PROC    FAR
	Mov     AX, 3533h               ; Get Int 33H vector
	Int     21h                     ; by calling Int 21H.
					; get address in ES:BX
	Mov     AX, ES                  ; Check segment and offset of
	OR      AX, BX                  ; Int 33H.  If 0 then driver
	JZ      Not_Installed           ; is not installed.

check_mouse:
	Xor     AX,AX                   ; Initialize mouse
	Int     33h
	Cmp     AX,-1                   ; Is mouse installed?
	JNE     Not_Installed           ; nope, if AX <> -1
	Mov     AX,32                   ; enables driver if disabled
	Int     33h
	Mov     AX,14                   ; disable light pen emulation
	Int     33h                     ; for speed (light pen emulation
					; is only useful in GWBASIC 
					; and will not work with a VGA)
	Mov     AX,BX                   ; get number of buttons from BX
	JMP     Short Quit

Not_Installed:
	Xor     AX,AX

Quit:
	Ret
MMEXIST endp
END
