code_seg        segment
        assume  cs:code_seg
        org     100h
        jmp     start
;----------------------------------
;B/C Software
;520 North Statline Rd.
;Sharon, Penn. 16146
;----------------------------------
delay           dw      0                           ;Storage for delay count
message1        db      'Esc to Quit',0dh,0ah,'$'   ;Press to Quit
message2        db      'F1 = Fast',0dh,0ah,'$'     ;Press to go fast
message3        db      'F2 = Slow$'                ;Press to go slow
;----------------------------------
start   proc    near
        mov     ah,9                    ;display string
        lea     dx,message1             ;1st message
        int     21h                     ;DOS interrupt
        lea     dx,message2             ;2nd message
        int     21h                     ;DOS interrupt
        lea     dx,message3             ;3rd message
        int     21h                     ;DOS interrupt
        mov     si,30000                ;high number makes a low pitched sound
        mov     di,35000                ;very the sound by 5000
        mov     delay,20000             ;so the sound can be heard
        mov     al,10110110xb           ;we will use channel 2
        out     43h,al                  ;operation mode 3 - send it
do_it:  mov     ah,0                    ;wait for a key press to start
        int     16h                     ;BIOS interrupt
        cmp     ah,1                    ;if scan code of 1 
        jz      done                    ;then we exit
        cmp     ah,3bh                  ;maybe upspeed
        jz      upspeed                 ;if key F1 was pressed 
        cmp     ah,3ch                  ;maybe downspeed
        jz      downspeed               ;if key F2 was pressed 
back:   call    motor                   ;call motor sound
        jmp     do_it                   ;see if user wish to do again
upspeed:                                ;we want to up the speed
        mov     delay,3000              ;shorter delay ups the speed 
        jmp     back                    ;call motor sound
downspeed:                              ;we want to lower the speed
        mov     delay,20000             ;longer delay slows the speed
        jmp     back                    ;call motor sound
done:   int     20h                     ;user pressed the Esc key to quit
start   endp
;-------------------------------------------
motor   proc    near
        cli                             ;interrupts off
        mov     bp,100                  ;motor runs for 100 cycles
agin:   mov     ax,bx                   ;put sound number in (ax)
        out     42h,al                  ;send LSB to port
        mov     al,ah                   ;place MSB in al
        out     42h,al                  ;send it to port
        in      al,61h                  ;get value from port
        or      al,00000011xb           ;ORing value turns on speaker
        out     61h,al                  ;send it
        mov     cx,15000                ;our first delay count number
looperx:loop    looperx                 ;do nothing loop
        xchg    di,bx                   ;exchange 1st sound number for 2nd 
        in      al,61h                  ;get value from speaker port
        and     al,11111100xb           ;ANDing turns speaker off
        out     61h,al                  ;turn speaker off
        mov     cx,delay                ;user choosen delay
looperg:loop    looperg                 ;do nothing loop
        dec     bp                      ;decrement our cycle count
        jnz     agin                    ;if count not =0 do again
        sti                             ;if all done enable interrupts
        ret
motor   endp
;----------------------------------
code_seg        ends
