/*
	mouse.H

	Mouse Driver Interface Header File

	Copyright (C) 1992, Geoff Friesen B.Sc.
	All rights reserved.

	Borland C++ 3.1
*/

typedef struct
	{
	   int exists;
	   int nbuttons;
	}
	MRESET;

typedef struct
	{
	   int buttonstat;
	   int col;
	   int opcount;
	   int row;
	}
	MLOCATE;

typedef struct
	{
	   int hcount;
	   int vcount;
	}
	MMOVE;

typedef struct
	{
	   int hhot;
	   int vhot;
	   unsigned *image;
	}
	MGCURSOR;

#ifdef __cplusplus
extern "C"
{
#endif

void		mreset		(MRESET *resetdata);
void		mshow		(void);
void		mhide		(void);
void		mpos		(MLOCATE *locatedata);
void		mmoveto		(int col, int row);
void		mpressed	(int button, MLOCATE *locatedata);
void		mreleased	(int button, MLOCATE *locatedata);
void		mcolrange	(int hmin, int hmax);
void		mrowrange	(int vmin, int vmax);
void		mgraphcursor	(MGCURSOR *gcursordata);
void		mtextcursor	(int cursortype, unsigned arg1,
				 unsigned arg2);
void		mmotion		(MMOVE *movedata);
void		minsttask	(unsigned mask, unsigned taskseg,
				 unsigned taskofs);
void		mlpenon		(void);
void		mlpenoff	(void);
void		mratio		(int horiz, int vert);
unsigned	mbufsize	(void);
void		msave		(char *buffer);
void		mrest		(char *buffer);

#ifdef __cplusplus
}
#endif