/* NOPAUSE2.CPP - Disable Pause
   (C) Copyright 1991
   By Thomas Astin  CIS: 73407,3427  Prodigy: RNVN08A
   All rights reserved. */

/* Disable pause by intercepting interrupt $1C (clock tick) and
   clearing the pause/lock bit within the $1C ISR. */

/* NOTE: This program worked fine on the machine upon which it was
		 developed and tested.  Use at your own risk. The author is
		 not responsible for any damage, system failure, or the like
		 as a result of executing this code.

		 Compiles under Borland C++.  Code may require modifications for
		 use with other compilers.
*/

#include <dos.h>
#include <stdio.h>
#include <conio.h>

/* Protos */
void interrupt NewInt1C(...);
void ExitFunc(void);

/* exit func in case ^C */
#pragma exit ExitFunc

/* Globals */
void interrupt (*OldInt1C)(...)=NULL;

main(void)
{
	int num=0;

	OldInt1C=getvect(0x1C);				// grab clock tick
	setvect(0x1C,NewInt1C);				// point to ours

	while (kbhit() == 0 || getch() != 27) // show off
		printf("Try to pause me %d\r",num++);

	return(0);
}

void interrupt NewInt1C(...)
{
	unsigned char temp=peekb(0x40,0x18);			// get kbd flags
	if ((temp & 0x08)!=0)                           // chk pause/lock
		pokeb(0x40,0x18,temp & 0xF7);				// clear it
	OldInt1C();										// call orig int 9
}

void ExitFunc(void)
{
	if (OldInt1C!=NULL)
		setvect(0x1C,OldInt1C);				// restore as before
}