/* novm7.h - maps applicable VM7 macros to system memory usage.
   note the following are not supported:
	DEBUG
	COMPRESS
	ATTACH/DETACH
	VLASORT or VLABSORT
 */

#ifndef VMEM_H
#define VMEM_H

#include "stypes.h"
#include "smem.h"

#define DEFAULT_BANK	1

typedef VOIDPV VM7HDL;
#define VM7NULLHDL	  NULL

struct VLArray {
   CHAR *array;
   SHORT size;
   ULONG nitems;
   SHORT bump_size;
   };

typedef struct VLArray * VLARRAYPV;

VM7HDL AddVm7Literal(CHAR *);
VM7HDL AllocVlarray(ULONG, SHORT);
VOIDPV IndexVm7(VLARRAYPV, ULONG);

#define VM7_Set_SwapPath(a)
#define VM7_Get_SwapPath  

#define VM7_Begin_Bank_Def
#define VM7_Init_System(a)
#define VM7_Close_System
#define VM7_Attach_System(a)
#define VM7_Detach_System
#define VM7_Reset_Bank
#define VM7_Set_Current(a)
#define VM7_Get_Current     NULL
#define VM7_Init_Bank
#define VM7_Free_Bank
#define VM7_Flush_Bank
#define VM7_Attach_Bank(a,b)
#define VM7_Detach_Bank
#define VM7_Set_Page_Size(a)
#define VM7_Get_Page_Size
#define VM7_Set_NPages(a)
#define VM7_Get_NPages
#define VM7_Set_SwapFile(a)
#define VM7_Get_SwapFile
#define VM7_Set_NFilePages(a)
#define VM7_Get_NFilePages
#define VM7_Set_Debug
#define VM7_Add_Literal(a)  AddVm7Literal(a)
#define VM7_Lock(a)		a
#define VM7_Ref(a)		a
#define VM7_Unlock(a)
#define VM7_Make_Handle(a,b,c)
#define VM7_Get_Handle_Address(a)
#define VM7_Get_Handle_ID(a)
#define VM7_Check_Handle(a)   TRUE
#define VM7_Get_Chunk(a)	 (VM7HDL)Qalloc(a)
#define VM7_Resize_Chunk(a,b,c) (VM7HDL)Qrealloc(a,c)
#define VM7_Free(a)    	 (BOOL)Qfree(a)
#define VM7_Get_Array(a,b)   AllocVlarray(a,b)
#define VM7_Alloc_Array(a,b) AllocVlarray(a,b)
#define VM7_Free_Array(a)
#define VM7_Index_Ref(a,b)   IndexVm7(a,b)
#define VM7_Index_Lock(a,b)  IndexVm7(a,b)
#define VM7_Index_Unlock(a,b)
#define VM7_Sort_Array(a,b)
#define VM7_DumpHandles
#endif
