	page 60, 132
	.model medium, basic
	.code

; Modified for Far Strings 1/28/90

; THIS IS THE BC7 /QBX VERSION OF THE NUVAL FUNCTION: WILL NOT WORK PRE-BC7

; Please see the non-BC7 version for all disclaimers and explanations

EXTRN	StringAddress:FAR
EXTRN	StringLength:FAR

bit	equ	<1 shl >
wo	equ	<word ptr>
by	equ	<byte ptr>

;==============================================================================

NuVal	PROC USES ds si di, string 	; QB function... v& = NuVal&( num$)
	LOCAL sign, sos, acc

	cld
	xor	ax, ax
	mov	dx, ax			; clear running total to 0
	mov	sos, ax			; non-zero if inside body of number
	mov	acc, ax			; clear temp accumulator
	mov	sign, ax		; initially, no +/- sign
	push	string
	call	StringLength
	or	ax, ax
	jz	nvexit			; no string, return 0
	push	ax
	push	string
	call	StringAddress
	mov	ds, dx
	assume	ds:nothing
	mov	si, ax			; far pointer to body of string
	pop	cx			; length of string
	xor	ax, ax
@@:
	lodsb				; get byte from string
	cmp	al, '9'			; is it a digit?
	ja	nv90			; nothing above 9 is ever legitimate
	cmp	al, '0'
	jb	@f			; not digit, but could still be OK
	mov	sos, ax			; indicate that number has started
	and	al, not '0'		; isolate true digit value
	cbw				; clear ah
	mov	bx, dx
	mov	di, acc			; running total x10, quickly
	shl	di, 1
	rcl	dx, 1			; x2
;;	or	dx, dx
;;	js	nvof
;;
;;	Uncomment all lines containing "or dx,dx" and "js nvof" if you want
;;	NuVal to generate an overflow error when its value would exceed long
;;	integer range.  Also uncomment the last line in the PROC which has
;;	the label "nvof:".  For simplicity, this excludes one legal long
;;	integer, namely -2,147,483,648.  See me if this matters to you.
;;
	shl	di, 1
	rcl	dx, 1			; x4
;;	or	dx, dx
;;	js	nvof
	add	di, acc
	adc	dx, bx			; x5
;;	js	nvof
	shl	di, 1
	rcl	dx, 1			; x10
;;	or	dx, dx
;;	js	nvof
	add	di, ax			; add current digit to running total
	adc	dx, 0
;;	js	nvof
	mov	acc, di			; save temp
nv60:
	loop	@b
nv90:
	mov	ax, acc			; temp accumulator to low result
	cmp	sign, -1		; is sign exactly -1?
	jne	nvexit
	xor	bx, bx			; if negative, subtract from zero.
	mov	cx, bx			; Because this avoids one jmp, it's a
	sub	bx, ax			;  bit faster on average than NEG/NOT
	sbb	cx, dx			;  for a long integer negate
	mov	dx, cx
	mov	ax, bx
	jmp	short nvexit
;;
;;	Uncomment the following to allow embedded commas.  Note that the
;;	checking is very simplistic, so "9,000,,,,0" is allowed, = "9000"
;;	Change the comma below to a period for European notation.
;;
;;@@:
;;	cmp	al, ','			; not space, is it comma?
;;	jne	@f
;;	test	sos, -1			; yes, is it embedded?
;;	jz	nv90			; no, stop now
;;	jnz	nv60			; yes, ignore it
;;

@@:	test	sos, -1			; have we started number yet?
	jnz	nv90			; yes, only digits allowed now
	cmp	al, ' '			; still in lead in... got a space?
	jz	nv60			; yes, ignore it
	cmp	al, '+'			; is character a + or - sign?
	je	@f
	cmp	al, '-'
	jne	nv90			; not any legal character... exit
@@:
	test	sign, -1		; do we already have a sign?
	jnz	nv90			; done if so, only one allowed
	sub	al, '-' + 1		; this makes sign exactly -1 if "-"
	cbw				; extend into ah
	mov	sign, ax		; now sign is non-zero for testing
	jmp	nv60

nvof:
;;;;;;;	INT	4	;uncomment this line if you're trapping overflow

nvexit:
	ret

	assume	ds:@data

NuVal	ENDP

Empty	PROC string

;  Provides a benchmark for testing NuVal.  Does nothing, returns zero.

	xor	ax, ax
	ret

Empty	ENDP

;==============================================================================
;
; NuAsc and NuLen are included for completeness only: they are not as useful
; in Far String or FS-compatible modes
;
;;;==============================================================================
;;
;;NuAsc	PROC strng		; QB Function... AsciiValue% = NuAsc%(a$)
;;
;;	push	strng
;;	call	StringAddress
;;	mov	es, dx
;;	mov	bx, ax
;;	xor	ax, ax
;;	mov	al, es:[bx]
;;	ret
;;
;;NuAsc	ENDP
;;
;;;==============================================================================
;;
;;NuLen	PROC strng		; QB Function... StringLen% = NuLen%( a$)
;;
;;	push	strng
;;	call	StringLength
;;	ret
;;
;;NuLen	ENDP

	END
