        Page    60,132
;
;  Copyright (c) 1989 by Geoff Allan
;
;  MASM 5.10 or above required.
;
		SubTTl	Copyright (c) 1989 by Geoff Allan
        Title   AceWin

	name  AceWin

;   ;%	     .model  MemModel,Lang     ; If you want other language support,
;                                        you can change this easily

        .Model Medium, BASIC

LogicalTrue     equ     0ffffh
LogicalFalse    equ     0
mono            equ     0b000h
color           equ     0b800h
parmf           equ     16
parme           equ     14
parmd           equ     12
parmc           equ     10
parmb           equ     8
parma           equ     6

MaxFrames       equ     20
FrameSize       equ     6       ;words


WinData         segment word public 'AceData'
Copyright       db	'Text Windowing System'
                db      0dh,0ah
		db	'Copyright (c) 1989 by Geoff Allan'
                db      0dh,0ah
                db      'All Rights Reserved.'
                db      0dh,0ah,00
; This message is never printed, but becomes embedded in the
; object and executable files.

VideoSegment    dw      color    ;assume color
VideoPort       dw      3d4h     ;assume color
BoxType0        equ     This Word
Singles         db      'ڿĳ'
BoxType1        equ     This Word
Doubles         db      'ɻȼͺ'
BoxType2        equ     This Word
SingVDoubH      db      'ոԾͳ'
BoxType3        equ     This Word
DoubVSingH      db      'ַӽĺ'
BoxType4        equ     This Word
Solids1         db      ''
BoxType5        equ     This Word
Solids2         db      ''
BoxType6        equ     This Word
Solids3         db      ''
BoxType7        equ     This Word
Solids4         db      ''

MousePresent    db      0
BTYPE           dw      0
Attribute       db      7
BotScroll       db      0       ;1=Bottom Scroll Bar
SideScroll      db      0       ;1=Side Scroll Bar
Shadow          db      0       ;1=Shadows
Exploding       db      0       ;1=Exploding Window
Accessories     db      0       ;1=Arrows and Sys Pulldown

ScrollCurH      db      0       ;Current Horizontal
ScrollCurV      db      0       ;Current Vertical

ULC             equ     This Word
urow            db      0
ucol            db      0
LRC             equ     This Word
lrow            db      0
lcol            db      0
ULC1            dw      0
LRC1            dw      0
WinWidth        dw      0
Temp            dw      0
BasStringSeg    dw      DGroup
BasStringOff    dw      0
BoxStyle        db      0
BoxClear        db      0

wsp             dw      offset WStackEnd

Panels          dw      8192 dup(?)     ;16k of window data
;		can be expanded to 60k if required.
EndPanels       equ     This word

WStack          dw      MaxFrames*FrameSize dup(?)
WStackEnd       equ     This word
                dw      FrameSize dup(0)

WinData         ends

;
; Macros
;

MouseOn         macro
local           nomouse1
                mov     al,MousePresent
                cmp     al,1
                jne     nomouse1
                mov     ax,1
                int     33h
NoMouse1:
                endm

MouseOff        macro
local           NoMouse2
                mov     al,MousePresent
                cmp     al,1
                jne     NoMouse2
                mov     ax,2
                int     33h
NoMouse2:
                endm

MouseRead       macro
local           NoMouse3
                mov     al,MousePresent
                cmp     al,1
                jne     NoMouse3
                mov     ax,3
                int     33h
NoMouse3:
                endm

Pushem          macro
                push    ax
                push    bx
                push    cx
                push    dx
                endm

Popem           macro
                pop     dx
                pop     cx
                pop     bx
                pop     ax
                endm

StartProc       macro
                push    ds
                push    es
                endm

NewSeg          macro
                mov     ax,WinData
                mov     ds,ax
                assume  ds:WinData
                endm

OldSeg          macro
                mov     ax,DGroup
                mov     ds,ax
                assume  ds:DGroup
                endm

EndProc         macro args
                pop     es
                pop     ds
		ret
                endm

; The next two macros are bigger than they need to be,
; but they do run fast.

CalcOffset      macro   line,col
                push    ax
                push    bx
                mov     al,col
                cbw
                mov     di,ax
                mov     al,line
                cbw
                mov     bx,80
                push    dx
                mul     bx
                pop     dx
                add     di,ax
                shl     di,1
                pop     bx
                pop     ax
                endm

CalcOffset1     macro   line,col
                push    ax
                push    bx
                mov     al,col
                cbw
                mov     si,ax
                mov     al,line
                cbw
                mov     bx,80
                push    dx
                mul     bx
                pop     dx
                add     si,ax
                shl     si,1
                pop     bx
                pop     ax
                endm

; RevAL is used to find the reverse color to a given attribute.

RevAL           macro
                mov     ah,al
                and     ah,01110000b  ;fg only
                and     al,00000111b  ;bg only
                shr     ah,1
                shr     ah,1
                shr     ah,1
                shr     ah,1
                shl     al,1
                shl     al,1
                shl     al,1
                shl     al,1
                add     al,ah
                endm

.Code

;--------------------------------------------------------------------
;Initializing the System:
;
;  WindowInit reads the mouse status, sets flags, clears memory.
;  There are no parameters.
;
;--------------------------------------------------------------------
WindowInit  	Proc
    		StartProc
    		NewSeg
                mov     es,ax   ;ax still contains WinData seg addr
                assume  es:WinData
                cld

                ;Clear Panels
                mov     cx,8192
                mov     Panels,0
                mov     si,offset Panels
                mov     di,offset Panels+2
                rep     movsw

                ;Clear WStack
                mov     cx,MaxFrames * FrameSize
                mov     WStack,0
                mov     si,offset WStack
                mov     di,offset WStack+2
                rep     movsw

                mov     wsp,offset WStackEnd

                ;Initialize Mouse
                mov     MousePresent,0  ;assume none until
                mov     ax,0            ;tested for.
                int     33h             ;Mouse Interrupt
                cmp     ax,0            ;No Mouse?
                je      nomouse5
                mov     MousePresent,1  ;yes, mouse.
                MouseOn
nomouse5:
                ;Establish Video Segment
                mov     bx,40h
                mov     es,bx
                mov     dx,es:63h
                add     dx,6
                mov     VideoPort,dx
                mov     VideoSegment,Color      ;Assume Color...
                mov     ah,0fh
                int     10h
                cmp     al,7                    ;Mono?
                jne     ColDisplay
                mov     VideoSegment,Mono       ;Yes, Mono.
ColDisplay:
                mov     al,0
                mov     Shadow,al
                mov     BotScroll,al
                mov     SideScroll,al
                mov     Exploding,al
                mov     Accessories,al

    		EndProc
WindowInit      endp

;--------------------------------------------------------------------
;Terminating the System:
;
;  WindowTerm turns off the mouse, resets flags, releases memory,
;  and generally cleans up. There are no parameters.
;
;--------------------------------------------------------------------

WindowTerm  	Proc
    		StartProc
                NewSeg
    		MouseOff
    		EndProc
WindowTerm  	endp

;
; Local Procedures:
;
DrawBoxC        proc    near            ;Draw box with clear
                ; AL=BoxType
                ; BH=Attribute
                ; CX=ulc
                ; DX=lrc
                push    ax
                mov     ax,0600h        ;clear first
                int     10h
                pop     ax
                call    DrawBox
                ret
DrawBoxC        endp

DrawBox         proc    near            ;Draw box without clear
                push    ax
                mov     ax,es:VideoSegment
                mov     es,ax
                assume  es:nothing
                NewSeg
                pop     ax
                cmp     al,0
                jne     dbx1
                mov     si,offset BoxType0
                jmp     short db2
dbx1:           cmp     al,1
                jne     dbx2
                mov     si,offset BoxType1
                jmp     short db2
dbx2:           cmp     al,2
                jne     dbx3
                mov     si,offset BoxType2
                jmp     short db2
dbx3:           cmp     al,3
                jne     dbx4
                mov     si,offset BoxType3
                jmp     short db2
dbx4:           cmp     al,4
                jne     dbx5
                mov     si,offset BoxType4
                jmp     short db2
dbx5:           cmp     al,5
                jne     dbx6
                mov     si,offset BoxType5
                jmp     short db2
dbx6:           cmp     al,6
                jne     dbx7
                mov     si,offset BoxType6
                jmp     short db2
dbx7:           mov     si,offset BoxType7
db2:            mov     BTYPE,si
                mov     ah,bh
                CalcOffset ch,cl        ;ulc
                mov     al,[si]
                Stosw
                CalcOffset dh,dl        ;lrc
                mov     al,[si+3]
                Stosw
                CalcOffset ch,dl        ;urc
                mov     al,[si+1]
                Stosw
                CalcOffset dh,cl        ;llc
                mov     al,[si+2]
                Stosw
                ;Corners successfully attached.
                push    cx
                push    dx
                inc     cl
                dec     dl   ;define boundarys
                CalcOffset ch,cl
                sub     dl,cl
                inc     dl
                push    ax
                mov     al,dl
                cbw
                mov     cx,ax
                pop     ax
                mov     al,[si+4]       ;hor
db5:            Stosw
                loop    db5
                pop     dx
                pop     cx
                push    cx
                push    dx
                inc     cl
                dec     dl   ;define boundarys
                CalcOffset dh,cl
                sub     dl,cl
                inc     dl
                push    ax
                mov     al,dl
                cbw
                mov     cx,ax
                pop     ax
                mov     al,[si+4]       ;hor
db6:            Stosw
                loop    db6
                pop     dx
                pop     cx
                push    cx
                push    dx
                inc     ch
                dec     dh   ;define boundarys
                CalcOffset ch,cl
                sub     dh,ch
                inc     dh
                push    ax
                mov     al,dh
                cbw
                mov     cx,ax
                pop     ax
                mov     al,[si+5]       ;vert
db7:            Stosw
                add     di,158
                loop    db7
                pop     dx
                pop     cx
                inc     ch
                dec     dh   ;define boundarys
                CalcOffset ch,dl
                sub     dh,ch
                inc     dh
                push    ax
                mov     al,dh
                cbw
                mov     cx,ax
                pop     ax
                mov     al,[si+5]       ;vert
db8:            Stosw
                add     di,158
                loop    db8
                ret
DrawBox         endp

;--------------------------------------------------------------------
;Popping up Windows:
;
; PopUp row1%,col1%,row2%,col2%,parameters%,Att%
;
; Where: o Row1-Col2 are the coordinates of the corners
;        o Att is the color attribute byte to be assigned as
;          the default color for this window
;        o Parameters is: a bit mask built from constants.
;
;          CONST values are assigned as follows:
;          WSINGLE   = 0
;          WDOUBLE   = 1
;          WSINGV    = 2
;          WDOUBV    = 3
;          WSOLID1   = 4
;          WSOLID2   = 5
;          WSOLID3   = 6
;          WSOLID4   = 7
;          WSHADOW   = 8
;          WEXPLODE  = 16
;          WACCESS   = 32    (display accessories)
;          WSCROLLH  = 64
;          WSCROLLV  = 128
;          WSCROLLB  = 192  (both)
;
;          example:
;
; 		PopUp 2,1,22,80,WSINGLE + WSCROLLB,7
;
;--------------------------------------------------------------------
PopUp   	Proc  arg1:ptr word, arg2:ptr word, arg3:ptr word, arg4:ptr word, arg5:ptr word, arg6:ptr word
    		StartProc
    		mov ax,WinData
                mov     es,ax
                assume  es:WinData

    		mov bx,arg6        ;attribute
                mov     ax,[bx]
                mov     es:Attribute,al
    		mov bx,arg5        ;Type
                mov     ax,[bx]
                mov     es:BoxStyle,al
    		mov bx,arg4        ;lrr
                mov     ax,[bx]
                dec     al
                mov     dl,al
    		mov bx,arg3        ;lrc
                mov     ax,[bx]
                dec     al
                mov     dh,al
    		mov bx,arg2        ;ulr
                mov     ax,[bx]
                dec     al
                mov     cl,al
    		mov bx,arg1        ;ulc
                mov     ax,[bx]
                dec     al
                mov     ch,al
                mov     es:ULC,cx
                mov     es:LRC,dx

                NewSeg

;--------------------------------------------------------------------
;Window Stack Data:
;
;Word [Byte]    Value
;-------------  --------------
; 0   [0]       Ulc    [Msb=Line, Lsb=Column]
; 1   [2]       Lrc    [Msb=Line, Lsb=Column]
; 2   [4]       Attribute
; 3   [6]       Parameters:
;               Bit     Meaning
;               ------- --------------------------------
;               0 (lsb) ] bits 0,1 and 2 are the
;               1       ] frame type
;               2       ]
;               3       Shadow
;               4       Exploding                           'future
;               5       Put accessories on window
;               6       Put Scroll Bar on Bottom
;               7 (msb) Put Scroll Bar on Side
; 4   [8]
; 5   [A]       Stored Data Start Position within table
;
;--------------------------------------------------------------------
                ;adjust the stack pointer down a frame
                sub     wsp,FrameSize*2    ;words.
                mov     bx,wsp
                mov     al,0
                mov     Shadow,al
                mov     BotScroll,al
                mov     SideScroll,al
                mov     Exploding,al
                mov     Accessories,al
                mov     [bx],cx
                mov     2[bx],dx
                mov     al,Attribute
                cbw
                mov     4[bx],ax
                mov     al,BoxStyle
                cbw
                mov     6[bx],ax

                mov     ax,01000b       ;shadow
                and     al,BoxStyle
                cmp     al,01000b
                jne     noshad1
                add     dx,102h         ;+1 line, +2 columns
                mov     al,1
                mov     Shadow,al
noshad1:        mov     ax,01000000b    ;Bottom Scroll Bar
                and     al,BoxStyle
                cmp     al,01000000b
                jne     nobots1
                add     dx,100h         ;+1 line
                mov     al,1
                mov     BotScroll,al
nobots1:        mov     ax,10000000b    ;Side Scroll Bar
                and     al,BoxStyle
                cmp     al,10000000b
                jne     nosides1
                mov     al,1
                mov     SideScroll,al
nosides1:       mov     ax,010000b      ;Exploding
                and     al,BoxStyle
                cmp     al,010000b
                jne     NoExplode1
                mov     al,1
                mov     Exploding,al
NoExplode1:
                mov     ax,0100000b     ;Accessories
                and     al,BoxStyle
                cmp     al,0100000b
                jne     NoAccess2
                mov     al,1
                mov     Accessories,al
NoAccess2:      mov     ULC1,cx
                mov     LRC1,dx
                mov     ax,cx           ;Calculate Size Req.
                mov     bx,dx
                sub     bx,ax
                add     bx,101h
                mov     ax,0
                mov     al,bh
                mov     bh,0
                mov     WinWidth,bx
                mul     bx
                shl     ax,1
                mov     cx,ax           ;cx=#Bytes req.
; Extra characters are always added to the right or bottom
; ULC is never modified

                ;Save Screen Data
                mov     si,offset Panels
ff_loop:        mov     bx,4[si]
                cmp     bx,0
                je      foundfree
                mov     si,bx
                jmp     ff_loop
foundfree:      mov     ax,si
                add     ax,12
                add     ax,cx
                mov     dx,offset EndPanels
                cmp     ax,dx
                jge     IgnoreSave
                push    si
                pop     di
                push    di
                push    di
                add     di,6            ;save room for dataset
                MouseOff
                mov     ax,VideoSegment
                mov     ds,ax
                assume  ds:nothing
                mov     ax,WinData
                mov     es,ax
                assume  es:nothing
                mov     ax,es:ULC1
                mov     es:temp,ax
                ; DS:SI = screen location for first row
                ; ES:DI = data pointer location for first row
                ;    CX = Number of WORDS to move
SavLoop:        mov     bx,es:temp
                CalcOffset1 bh,bl
                mov     cx,es:WinWidth
                rep     MOVSW           ;transfer a row
                add     es:temp,0100h   ;next row
                mov     ax,es:temp
                mov     bx,es:LRC1
                cmp     ah,bh
                jle     SavLoop
                mov     bx,di
                NewSeg
                pop     di              ;old target
                mov     ax,ULC1
                stosw
                mov     ax,LRC1
                stosw
                mov     ax,bx
                stosw
                pop     di
IgnoreSave:
                ;clear window and Draw Border
                mov     bx,wsp
                mov     10[bx],di       ;where the old data is...
                mov     cx,[bx]
                mov     dx,2[bx]
                cmp     BotScroll,1
                jne     nobots2
                inc     dh              ;one line down

nobots2:        mov     ax,4[bx]
                push    ax              ;att
                mov     ax,6[bx]
                and     al,0111b        ;frame type
                pop     bx
                mov     bh,bl           ;att
                Pushem
                call    DrawBoxC        ;clear and draw
                Popem
                cmp     Shadow,1
                jne     noShad2
                mov     ax,VideoSegment
                mov     es,ax
                assume  es:nothing
                add     dx,101h
                add     cx,102h
                push    cx
                push    dx
                CalcOffset ch,dl      ;vert shad
                sub     dh,ch
                inc     dh
                mov     al,dh
                cbw
                mov     cx,ax         ;Num lines
                mov     al,8          ;shadow color
ShadLoop1:      inc     di
                Stosb
                inc     di
                Stosb
                add     di,156
                loop    ShadLoop1
                pop     dx
                pop     cx
                CalcOffset dh,cl
                sub     dl,cl
                inc     dl
                mov     al,dl
                cbw
                mov     cx,ax
                mov     al,8
ShadLoop2:      inc     di
                Stosb
                loop    ShadLoop2
NoShad2:
                NewSeg
                mov     ax,VideoSegment
                mov     es,ax
                assume  es:nothing
                mov     al,Accessories
                cmp     al,1
                je      Access1
                jmp     NoAccess1
Access1:
                mov     cx,ULC
                mov     dx,LRC
                sub     dl,6
                CalcOffset ch,dl
                mov     si,BTYPE
                mov     al,[si+6]
                stosb
                add     di,5
                stosb
                sub     di,3
                mov     al,[si+7]
                stosb
                add     di,5
                stosb
                mov     al,Attribute
                RevAL     ;reverse attribute color
                mov     ah,al
                mov     al,24   ;up arrow
                sub     di,3
                stosw
                sub     di,8
                mov     al,25   ;down arrow
                stosw
                add     cl,1
                CalcOffset ch,cl
                mov     al,[si+6]
                stosb
                add     di,3
                mov     al,[si+7]
                stosb
                mov     al,Attribute
                ;RevAL
                mov     ah,al
                mov     al,240    ;3 horiz stripes
                sub     di,3
                stosw
NoAccess1:
                mov     al,BotScroll
                cmp     al,1
                je      BotScroll1
                jmp     NoBots6
BotScroll1:
                mov     cx,ULC
                mov     dx,LRC
                inc     cl
                dec     dl
                CalcOffset dh,dl
                mov     temp,di
                CalcOffset dh,cl
                mov     al,Attribute
                RevAL                   ;reverse attribute color
                mov     ah,al
                mov     al,177          ;scroll bar guts
BotScrollLoop:  stosw
                cmp     di,temp
                jne     BotScrollLoop
                CalcOffset dh,cl
                mov     al,27           ;left arrow
                stosw
                CalcOffset dh,dl
                mov     al,26           ;right arrow
                stosw
NoBots6:
                mov     al,SideScroll
                cmp     al,1
                je      SideScroll1
                jmp     NoSides2
SideScroll1:
                mov     cx,ULC
                mov     dx,LRC
                inc     ch
                dec     dh
                CalcOffset dh,dl
                mov     temp,di
                CalcOffset ch,dl
                mov     al,Attribute
                RevAL                   ;reverse attribute color
                mov     ah,al
                mov     al,177          ;scroll bar guts
SideScrollLoop: stosw
                add     di,158
                cmp     di,temp
                jne     SideScrollLoop
                CalcOffset ch,dl
                mov     al,24           ;up arrow
                stosw
                CalcOffset dh,dl
                mov     al,25           ;down arrow
                stosw
NoSides2:
                MouseOn
    		EndProc
PopUp           endp

;--------------------------------------------------------------------
;Removing Windows:
;
;  PopDown removes the last current window, or does nothing
;  if no windows are active. There are no parameters.
;
;--------------------------------------------------------------------
PopDown   	Proc
    		StartProc
                NewSeg
                mov     si,offset Panels
                push    si
fl_loop:        mov     bx,[si+4]
                cmp     bx,0
                je      foundlast
                pop     ax
                push    si
                mov     si,bx
                jmp     fl_loop
foundlast:      pop     si
                cmp     si,0
                jne     okvalid
                jmp     noPopdown
okvalid:        push    si
                Lodsw           ;ulc
                mov     ULC,ax
                mov     temp,ax
                Lodsw           ;lrc
                mov     LRC,ax
                Lodsw
                push    ax
                mov     ax,ULC
                mov     bx,LRC
                sub     bx,ax
                add     bx,101h
                mov     ax,0
                mov     al,bh
                mov     bh,0
                mov     WinWidth,bx
                mov     ax,VideoSegment
                mov     es,ax
                assume  es:nothing
                MouseOff
RestLoop:       mov     dx,temp
                CalcOffset dh,dl
                mov     cx,WinWidth
                rep     movsw
                add     temp,100h       ;next line...
                mov     ax,temp
                mov     bx,LRC
                cmp     ah,bh
                jle     RestLoop

                MouseOn
                pop     bx
                pop     si
                sub     bx,si
                inc     bx
                mov     ax,0
                mov     cx,bx
fl:             mov     [si],al
                inc     si
                loop    fl
                add     wsp,FrameSize*2
noPopdown:
    		EndProc
PopDown   	endp



;--------------------------------------------------------------------
;Scrolling Windows:
;
;  Use:
;
;  ScrollUp   or   ScrollDown
;
;  to scroll the contents of the top window up or down one line.
;  Remember that the top or bottom line will have to be replaced
;  as soon as possible.
;
;--------------------------------------------------------------------
ScrollDown  	Proc
    		StartProc
                NewSeg
                Mov     bx,wsp
                cmp     bx,WStackEnd
                je      noWindows1
                mov     cx,[bx]
                mov     dx,2[bx]
                add     cx,101h
                sub     dx,101h
                mov     ax,4[bx]
                mov     bh,al
                jmp     short ScrollDownDone
noWindows1:     mov     cx,0
                mov     dx,24*256+79
                mov     bh,7
ScrollDownDone:
		MouseOff
                mov     ax,0701h
		int	10h
		MouseOn
    		EndProc
ScrollDown      endp

ScrollUp  	Proc
    		StartProc
                NewSeg
                Mov     bx,wsp
                cmp     bx,WStackEnd
                je      noWindows2
                mov     cx,[bx]
                mov     dx,2[bx]
                add     cx,101h
                sub     dx,101h
                mov     ax,4[bx]
                mov     bh,al
                jmp     short ScrollUpDone
noWindows2:     mov     cx,0
                mov     dx,24*256+79
                mov     bh,7
ScrollUpDone:	MouseOff
		mov	ax,0601h
		int	10h
		MouseOn
    		EndProc
ScrollUp        endp



;--------------------------------------------------------------------
;Changing Colors: 
;
; To Unconditionally change attributes of a section of text,
;
; ChAttR Line%,Column%,Characters%,Attribute%  (not implemented)
; ChAtt  Line%,Column%,Characters%,Attribute%
;
; ChattR uses relative window coordinates
;
;--------------------------------------------------------------------
ChAttR    	Proc  l:ptr word,c:ptr word, num:ptr word, att:ptr word
    		StartProc

    		EndProc
ChAttR          endp

ChAtt   	Proc  l:ptr word,c:ptr word, num:ptr word, att:ptr word
    		StartProc
                mov     ax,WinData
                mov     es,ax
    		mov bx,att
                mov     ax,[bx]
                mov     es:Attribute,al
    		mov bx,l
                mov     ax,[bx]         ;row
    		mov bx,c
                mov     cx,[bx]         ;column
                mov     dh,al
                mov     dl,cl
                dec     dh              ;Bump pointers to screen co-ords
                dec     dl
                CalcOffset dh,dl        ;di=screen offset
    		mov bx,num
                mov     cx,[bx]         ;# bytes
                NewSeg
                mov     es,VideoSegment
                MouseOff
                inc     di              ;Point to attribute
                mov     al,Attribute
ChAtt1:         stosb                   ;store attribute
                inc     di              ;Skip next Character
                loop    ChAtt1          ;Do it Again
                MouseOn
    		EndProc
ChAtt           endp


;--------------------------------------------------------------------
;Printing Strings:
;
;   Print your strings the fast way. Instead of PRINT,
;   use these statements:
;
;   RPRINT "Text",Line%,Column%,Attribute%
;
;   This function uses the current default window's upper left corner
;   as a 0,0 reference point in calculating position.
;
;   FPRINT "Text",Line%,Column%,Attribute%
;
;   This function uses screen literal coordinates
;
;--------------------------------------------------------------------
RPrint    	Proc  text:ptr word,l:ptr word,c:ptr word,att:ptr word
                StartProc
                mov     ax,WinData
                mov     es,ax
                assume  es:WinData
    		mov bx,att
                mov     ax,[bx]         ;attribute
                mov     es:Attribute,al
    		mov bx,text
                mov     cx,[bx]         ;string length
                jcxz    NoRPrint        ;Null length, no print
                mov     si,[bx+2]       ;String Offset in DGroup
     
    		mov bx,l
                mov     ax,[bx]
                mov     dh,al
    		mov bx,c
                mov     ax,[bx]
                mov     dl,al

                push    cx
                mov     bx,es:wsp
                mov     cx,es:[bx]
                add     dx,cx
                CalcOffset dh,dl
                pop     cx

                ;All parameters now parsed. Print string:
                ;ds=dgroup,si=string offset,cx=string length
                ;es=screen,di=screen offset
                NewSeg
                MouseOff
                OldSeg
                mov     ah,es:Attribute
                push    ax
                mov     ax,es:VideoSegment
                mov     es,ax
                assume  es:nothing
                pop     ax
                cld
RPrintLoop:     movsb
                mov     es:[di],ah
                inc     di
                loop    RPrintLoop
                NewSeg
                MouseOn
NoRPrint:
    		EndProc
RPrint          endp

FPrint    	Proc  text:ptr word,l:ptr word, c:ptr word, att:ptr word
                StartProc
                OldSeg
                mov     ax,WinData
                mov     es,ax
                assume  es:WinData
                mov     bx,[bp+parma]
                mov     ax,[bx]         ;attribute
                mov     es:Attribute,al
                mov     bx,[bp+parmd]
                mov     cx,[bx]         ;string length
                jcxz    NoFPrint        ;Null length, no print
                mov     si,[bx+2]       ;String Offset in DGroup
                mov     bx,[bp+parmc]
                mov     ax,[bx]
                dec     ax
                mov     bx,[bp+parmb]
                mov     di,[bx]
                dec     di
                mov     bx,80
                mul     bx
                add     di,ax
                shl     di,1            ;*2

                ;All parameters now parsed. Print string:
                ;ds=dgroup,si=string offset,cx=string length
                ;es=screen,di=screen offset
                NewSeg
                MouseOff
                OldSeg
                mov     ah,es:Attribute
                push    ax
                mov     ax,es:VideoSegment
                mov     es,ax
                assume  es:nothing
                pop     ax
                cld
FPrintLoop:     movsb
                mov     es:[di],ah
                inc     di
                loop    FPrintLoop
                NewSeg
                MouseOn
NoFPrint:
    		EndProc
FPrint          endp


;--------------------------------------------------------------------
;Mouse Support:
;
;    MouseLine           [1..25]
;    MouseCol            [1..80]
;    MousePixelX         [0..maxX]     Changes dependent
;    MousePixelY         [0..maxY]     on Video Mode.
;
;  Return Line and Column information from the mouse.
;
;    MouseLeft           [0|-1]
;    MouseRight          [0|-1]
;
;  Return True/False Button Press information from the mouse.
;
;    MouseShow
;
;  Turns mouse cursor on
;
;    MouseHide
;
;  Turns mouse cursor off
;
;--------------------------------------------------------------------

MouseLine       proc
                StartProc
                NewSeg
                mov     dx,0
                MouseRead
                mov     ax,dx
                shr     ax,1
                shr     ax,1
                shr     ax,1
                inc     ax
                EndProc
MouseLine       endp

MouseCol        proc
                StartProc
                NewSeg
                mov     cx,0
                MouseRead
                mov     ax,cx
                shr     ax,1
                shr     ax,1
                shr     ax,1
                inc     ax
                EndProc
MouseCol        endp

MousePixelX     proc
                StartProc
                NewSeg
                mov     cx,0
                MouseRead
                mov     ax,cx
                EndProc
MousePixelX     endp

MousePixelY     proc
                StartProc
                NewSeg
                mov     dx,0
                MouseRead
                mov     ax,dx
                EndProc
MousePixelY     endp

MouseLeft       proc
                StartProc
                NewSeg
                mov     bx,0
                MouseRead
                and     bx,1
                cmp     bx,1
                jne     NoMouseLeft
                mov     ax,LogicalTrue
                EndProc
NoMouseLeft:    mov     ax,LogicalFalse
                EndProc
MouseLeft       endp

MouseRight      proc
                StartProc
                NewSeg
                mov     bx,0
                MouseRead
                and     bx,2
                cmp     bx,2
                jne     NoMouseRight
                mov     ax,LogicalTrue
                EndProc
NoMouseRight:   mov     ax,LogicalFalse
                EndProc
MouseRight      endp

MouseShow       proc
                StartProc
                NewSeg
                MouseOn
                EndProc
MouseShow       endp

MouseHide       proc
                StartProc
                NewSeg
                MouseOff
                EndProc
MouseHide       endp

;--------------------------------------------------------------------
;Others:
;
;  BOX ULR,ULC,LRR,LRC,Style,Att
;
;  Style: bits 0, 1 and 2 determine type,
;         bit 3 determines whether to clear (1=clear)
;
;
;  EXIST filename$+chr$(0)
;
;  Function returns true if the file exists.
;
;--------------------------------------------------------------------

Box   		proc  y1:ptr word,x1:ptr word, y2:ptr word,x2:ptr word,style:ptr word, att:ptr word
                StartProc
                mov     ax,WinData
                mov     es,ax
                assume  es:WinData
    		mov bx,style  ;style
                mov     ax,[bx]
                and     ax,01111b       ;just last 4 bits
                push    ax
                shr     al,1
                shr     al,1
                shr     al,1
                cmp     al,1
                jne     Box1
                mov     es:BoxClear,1
                jmp     short Box2
Box1:           mov     es:BoxClear,0
Box2:           pop     ax
                and     al,0111b        ;just last 3 bits
                mov     es:BoxStyle,al
    		mov bx,att
                mov     ax,[bx]
                mov     es:Attribute,al
    		mov bx,x2
                mov     ax,[bx]
                dec     al
                mov     dl,al
    		mov bx,y2
                mov     ax,[bx]
                dec     al
                mov     dh,al
    		mov bx,x1
                mov     ax,[bx]
                dec     al
                mov     cl,al
    		mov bx,y1
                mov     ax,[bx]
                dec     al
                mov     ch,al
                mov     bh,es:Attribute
                mov     al,es:BoxStyle
                Push    ax
                NewSeg
                MouseOff
                OldSeg
                Pop     ax
                cmp     es:BoxClear,0
                jne     Box3
                call    DrawBox
                jmp     short Box4
Box3:           call    DrawBoxC
Box4:           NewSeg
                MouseOn
    		EndProc
Box             endp


Exist   	proc  filenam:ptr word
                StartProc
    		mov bx,filenam
                mov     cx,[bx]
                mov     dx,[bx+2]       ;ds:dx points to string
                mov     al,10000000b    ;select read mode
                mov     ah,3dh          ;select OPEN function
                int     21h
                jc      nofile
                mov     bx,ax           ;the file exists.
                mov     ah,3eh
                int     21h             ;so close it again
                mov     ax,LogicalTrue  ;set status to true
                jmp     short exist_done
nofile:         mov     ax,LogicalFalse ;no housekeeping to do
exist_done:
    		EndProc
Exist           endp

;--------------------------------------------------------------------
; Reading special keys from the Keyboard:
;
; Functions: (Return true [-1] or false [0])
;
;   InsertKey
;   AltKey
;   CtrlKey
;   LeftShiftKey
;   RightShiftKey
;   NumLockKey
;   CapsLockKey
;   ScrollLockKey
;
;--------------------------------------------------------------------
InsertKey 	proc
    		mov ah,2
    		int 16h
    		and al,80h
    		cmp al,80h
    		jne NoInsertKey
                mov     ax,LogicalTrue
    		ret
NoInsertKey:    mov     ax,LogicalFalse
    		ret
InsertKey 	endp

CapsLockKey 	proc
        	mov     ah,2
        	int     16h
        	and     al,40h
        	cmp     al,40h
        	jne     NoCapsLockKey
        	mov     ax,LogicalTrue
        	ret
NoCapsLockKey:
        	mov     ax,LogicalFalse
        	ret
CapsLockKey 	endp

NumLockKey 	proc
        	mov     ah,2
        	int     16h
        	and     al,20h
        	cmp     al,20h
        	jne     NoNumLockKey
        	mov     ax,LogicalTrue
        	ret
NoNumLockKey:
        	mov     ax,LogicalFalse
        	ret
NumLockKey 	endp

AltKey  	proc
        	mov     ah,2
        	int     16h
        	and     al,08h
        	cmp     al,08h
        	jne     NoAltKey
        	mov     ax,LogicalTrue
        	ret
NoAltKey:
        	mov     ax,LogicalFalse
        	ret
AltKey  	endp

CtrlKey 	proc
        	mov     ah,2
        	int     16h
        	and     al,04h
        	cmp     al,04h
        	jne     NoCtrlKey
        	mov     ax,LogicalTrue
        	ret
NoCtrlKey:
        	mov     ax,LogicalFalse
        	ret
CtrlKey 	endp

LeftShiftKey  	proc
        	mov     ah,2
        	int     16h
        	and     al,02h
        	cmp     al,02h
        	jne     NoLeftKey
        	mov     ax,LogicalTrue
        	ret
NoLeftKey:
        	mov     ax,LogicalFalse
        	ret
LeftShiftKey 	endp

RightShiftKey 	proc
        	mov     ah,2
        	int     16h
        	and     al,01h
        	cmp     al,01h
        	jne     NoRightKey
        	mov     ax,LogicalTrue
        	ret
NoRightKey:
        	mov     ax,LogicalFalse
        	ret
RightShiftKey 	endp

ScrollLockKey 	proc
        	mov     ah,2
        	int     16h
        	and     al,10h
        	cmp     al,10h
        	jne     NoScrKey
        	mov     ax,LogicalTrue
        	ret
NoScrKey:
        	mov     ax,LogicalFalse
        	ret
ScrollLockKey 	endp

;This work is protected by Canadian and International Copyright Laws.
;
;All distribution rights reserved by Geoff Allan
;Duplication or publication of source code without written
;permission from Geoff Allan is expressly prohibited.

        	end
