      COMMENT + This is a very simple assembly language program
		intended to show the power of interrupts.
		This program is a .COM file and has no psp.
		It must remain in one segment(no problem).
		Use the insert key and type your message
		inside the line box. When finished save file
		and use your assembler(I.E. MASM PRINTXT.ASM)
		Then use the linker (I.E. LINK PRINTXT.OBJ)
		You will get an error from the linker(no stack segment)
		but don't worry about it.At last use the EXE2BIN file
		included with DOS(I.E. EXE2BIN PRINTXT.EXE PRINTXT.COM).
		You now have created a command file that can run from the
		prompt. This is better than the TYPE method because
		the user doesn't have to know how to TYPE this to
		the screen. This also clears the screen before and
		after running the program. The program itself requires
		less than fifty bytes. This could be easily be adapted
		to a multi-page program.
		By Steve Goodman
		+


		TITLE print text

_TEXT           SEGMENT;set all segments the same for .com file
		ASSUME CS:_TEXT,DS:_TEXT,SS:_TEXT
		ORG 100h    ;load above PSP
start:          JMP overdata ; jump over text screen data

string1    DB   "Ŀ",13,10
	   DB   "                    FOR ASSEMBLY LANGUAGE BEGINNERS                         ",13,10
	   DB   "                                                                            ",13,10
	   DB   "  This file is in .COM format because it is small and also in using this    ",13,10
	   DB   "  format we save 256 Bytes of space. The Program Segment Prefix(PSP) is     ",13,10
	   DB   "  put at the first of an .EXE file so DOS can pass,get information about    ",13,10
	   DB   "  the program. The .COM file is rigid in many ways (stack,loading,data)     ",13,10
	   DB   "  but in some cases it is not a problem. The .COM file is easier to read    ",13,10
	   DB   "  when using Debug- because just your program is loaded. If you look at     ",13,10
	   DB   "  the file size and subtract (80 rows X 25 col =) 2000 characters you       ",13,10
	   DB   "  will see that the program is around fifty bytes.  This program uses       ",13,10
	   DB   "  two interrupts(INT 10, INT 16 in Hex). The first interrupt handles        ",13,10
	   DB   "  most of the screen functions and the second handles the keyboard input    ",13,10
	   DB   "  . Loading the AH reg. with a different value calls a different video      ",13,10
	   DB   "  program(print character, set video mode). Most books on programming       ",13,10
	   DB   "  list the functions supported by the BIOS interrupts. Some functions       ",13,10
	   DB   "  require that you give it more information in other registers before       ",13,10
	   DB   "  calling an interrupt. After those conditions have been met you call       ",13,10
	   DB   "  the interrupt. If the function needs to give you some information         ",13,10
	   DB   "  (I.E. what video mode, which key was pressed) it will be returned in      ",13,10
	   DB   "  a register(s). This should run on any video card and you do need an       ",13,10
	   DB   "  assembler of some kind. This was assembled with the MS Macro Assembler.   ",13,10
	   DB   "  If you have one, put your message in this box and assemble,link and       ",13,10
	   DB   "  convert .EXE to .COM then run.                                            ",13,10
	   DB   ""
videomode  DB  00

overdata:       MOV AH,0fh ;this value returns current video state in AL
		INT 10h    ;call Video interrupt
		MOV AH,0   ;this value sets video mode (value in AL)
		INT 10h    ;call video interrupt
		MOV SI,OFFSET string1 ;load address of text into source index
		MOV AH,0eh ;this value prints to the current screen
more:           MOV AL,[SI] ;load character to print in AL
		INT 10h     ; call Video interrupt
		INC SI      ; move pointer up one,get next character
		CMP AL,217  ;check to see if character is last one (  )
		JNE more    ;if not print again
		MOV AH,0    ; this value gets character from keyboard
		INT 16h     ; call Keyboard interrupt(wait for key press)
		MOV AH,0fh  ;check current video stste
		INT 10h     ;call Video interrupt
		MOV AH,0    ;Clear screen
		INT 10h     ;with this Video interrupt
		MOV AX,4c00H ; The recommended way to exit a program
		INT 21H      ; Call DOS Exit Interrupt
_TEXT           ENDS
		END start




