;created 08-08-91
;updated 12-02-91

;======================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
;RM92TS8,16,24,32,40,48

DOSSEG
.MODEL MEDIUM, BASIC
.CODE

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

;contains PROPER, UPPER, LOWER, NULEN, NUASC
;contains KILLSTRING

Comment |*
  IF FIRST CHARACTER OR ASC(Char$) is < 34 THEN SET CAPITALIZE FLAG
		ELSE CLEAR CAPITALIZE FLAG
  IF 97 TO 122 IF CAPITALIZE FLAG SET MAKE UPPER CASE, ELSE NOTHING
  IF 65 TO 90 MAKE LOWER CASE UNLESS CAPITALIZE FLAG SET
  DEFAULT IS DO NOTHING AND CLEAR CAPITALIZE FLAG

	To make lower case = OR 20h
	To make upper case = AND 0DFh
	|*

;======================================================================
;DECLARE SUB PROPER (Text$)
;Purpose:
;       Converts Text$ to a proper string. Changes the input string.
; The first letter is capitalized, the first letter after a space is
; capitalized.  Other letters are made lower case.
;======================================================================

EVEN
PROPER PROC FAR BASIC, String:WORD
	;---------------------Register list
	; DS = segment of string (assumed)
	; DX = not used
	; CX = length of string in characters
	; BX = pointer to source string
	; AH = flag for upper case, 0 = lower case, <> 0 = upper case
	; AL = scratch, temporary storage
	Mov     BX,String       ; get address of string descriptor
	Mov     CX,[BX]         ; get length into CX
	JCXZ    Quit            ; if a null string, quit
	Mov     BX,[BX+2]       ; get address of string
	Xor     AH,AH           ; clear upper case flag
	Mov     AL,[BX]      	; get first character
; test for control characters as they cause upper case flag to be set
	Cmp     AL,34           ; see if ' " ' or other control character
	JA	Test_First	; not a control, do other tests
	Inc     AH              ; else set upper case flag
	Jmp	Short Start	; and start loop
Test_First: ; for first character, make lower case character an upper case
	Cmp	AL,'a'		; is it < 'a'
	JB	Start		; yes, start next loop
	Cmp	AL,'z'		; is it > 'z'
	JA	Start		; yes, start next loop
	And     AL,0DFh         ; else, capitalize letter
	Mov     [BX],AL      	; and store value
Start:                          ; main loop starts here
	Dec	CX		; reduce count of string remaining
	JZ      Quit            ; if remaining count is 0, then quit
	Inc     BX              ; increment character counter
	Mov     AL,[BX]      	; get next character in AL (DS:BX)
Test_Control:	; test control, if yes, then set upper case flag & restart
	Cmp     AL,34           ; see if a ' " ' or other control character
	JA	Test_Upper	; not a control, do other tests
	Inc     AH              ; else set upper case flag
	Jmp	Short Start	; and restart loop
Test_Upper:     ; test if upper case letter that must be made lower case
	Cmp	AL,'A'		; is it upper case
	JB      Redo            ; nope, less than 'A' so restart loop
	Cmp	AL,'Z'		; is it a possible lower case
	JA      Test_Lower      ; yes, so test it
	Or      AH,AH           ; test upper case flag
	JZ	Make_Lower	; if upper case clear jmp ahead
	Xor     AH,AH           ; else clear upper case flag
	Jmp     Short Start     ; and start the loop again
Make_Lower:
	OR      AL,20h          ; make character lower case
	Mov     [BX],AL      	; and store value
	Xor     AH,AH           ; clear upper case flag
	Jmp	Short Start	; start the loop again
Test_Lower:	; test if lower case must be made upper case
	Cmp	AL,'a'		; is it < 'a'
	Jb      Redo            ; yes, so move to next letter
	Cmp	AL,'z'		; is it > 'z'
	Ja      Redo            ; yes, so move to next letter
	Or      AH,AH           ; is upper case flag clear?
	Jz      Redo            ; yes, so redo loop
Make_Upper:
	AND     AL,0DFh         ; else make character upper case
	Mov     [BX],AL      	; and store value
Redo:
	Xor     AH,AH           ; clear upper case flag
	Jmp 	Short Start	; start loop again
Quit:
	Ret
PROPER ENDP

;===========================================================================
; DECLARE SUB UPPER (Text$)
; Purpose:
;     Operates on source string and operates much faster than UCASE$
; approx 13% faster for a typical string on a 286 10 Mhz machine
; Counts from end of string to front because that is faster
;===========================================================================

EVEN
UPPER PROC FAR BASIC USES SI, STRING:WORD
	Mov     SI,STRING       ; get string descriptor in SI
	Mov     BX,[SI]         ; get length into BX
	Or      BX,BX           ; see if string has a 0 length
	Jz      Quit            ; if yes, then quit
	Mov     SI,[SI+2]       ; get address of string in SI
	; preload registers for faster comparison
	Mov     DX,'za'
	; must use BX because [SI+CX] as an index is not supported by
	; chip, while [SI+BX] is supported
EVEN                            ; speed loop on 286 machine
Redo:
	Dec     BX              ; reduce counter by 1
	Js      Quit            ; if hit less than zero then quit
	Mov     AL,[SI+BX]      ; load character into AL
	Cmp     AL,DL           ; is it < 'a'
	Jb      Redo            ; yes, so move to next letter
	Cmp     AL,DH           ; is it > 'z'
	Ja      Redo            ; yes, so move to next letter
	AND     AL,0DFh         ; else make character upper case
	Mov     [SI+BX],AL      ; store revised value
	Jmp     Short Redo      ; reloop
Quit:
	Ret
UPPER ENDP

;===========================================================================
; DECLARE SUB LOWER (Text$)
; Purpose:
;     Operates on source string and operates much faster than LCASE$
; approx 13% faster for a typical string on a 286 10 Mhz machine
; Counts from end of string to front because that is faster
;===========================================================================

EVEN
LOWER PROC FAR BASIC USES SI, STRING:WORD
	Mov     SI,STRING       ; get string descriptor in SI
	Mov     BX,[SI]         ; get length into BX
	Or      BX,BX           ; see if string has a 0 length
	Jz      Quit            ; if yes, then quit
	Mov     SI,[SI+2]       ; get address of string in SI
	; preload registers for faster comparison
	Mov     DX,'ZA'
EVEN                            ; speed loop on 286 machine
Redo:
	Dec     BX              ; reduce counter by 1
	Js      Quit            ; if hit less than zero then quit
	Mov     AL,[SI+BX]      ; load character into AL
	Cmp     AL,DL           ; is it < 'A'
	Jb      Redo            ; yes, so move to next letter
	Cmp     AL,DH           ; is it > 'Z'
	Ja      Redo            ; yes, so move to next letter
	OR      AL,20h          ; make character lower case
	Mov     [SI+BX],AL      ; store revised value
	Jmp     Short Redo      ; reloop
Quit:
	Ret
LOWER ENDP

;===========================================================================
; DECLARE FUNCTION NULEN% (Text$)
; Purpose:
;     Operates on source string and operates faster than LEN
; approx 50% faster for a typical string on a 286 10 Mhz machine
; Only works with strings, not TYPEs
;===========================================================================

EVEN
NULEN PROC FAR  BASIC, String:WORD
	Mov     BX,String       ; get address of string descriptor
	Mov     AX,[BX]         ; get length into AX
	Ret
NULEN ENDP

;============================================================================
; DECLARE FUNCTION NUASC% (String$)
;       It won't crash if you feed it a null
;       string.  If LEN(String$) = 0 then returns 0.
;       Else it returns the ASC value.
;============================================================================

EVEN
NUASC PROC FAR BASIC String:WORD
	Xor	AX,AX           ; assume zero length string
	Mov     BX,String
	Mov     CX,[BX]         ; move len of String to CX
	Jcxz    Quit            ; if LEN = 0 then quit (18 clocks on 8088)
	Mov     BX,[BX+2]       ; get address to BX
	Mov     AL,[BX]         ; get value of 1st char to AL
	Xor     AH,AH           ; clear high byte
Quit:
	Ret                     ; MASM cleans up stack
NUASC ENDP

;============================================================================
; DECLARE SUB KILLSTRING (Text$)
; Fast routine that makes input string a null string
;============================================================================
EXTRN BASIC B$STDL:FAR          ; QBASIC's STRINGRELEASE program

EVEN
KILLSTRING PROC FAR BASIC, String:WORD
	;Mov     AX,String       ; (14 clocks on 8088, 5 on 286)
	;Push    AX              ; push descriptor (15 on 8088, 5 on 286)
	Push    String          ; (30 on 8088, 5 on 80286)
	CALL    B$STDL          ; call BASIC to delete string
	Ret
KILLSTRING ENDP
END

