/* quick sort an array of ints using an algorithm from N. Wirth's book
 * 'Algorithms + Data Structures = Programs'
 * this is a non-recursive version to improve speed
 * written for Microsoft 'C' 28-FEB-87 by Ron Andrews
 *
 * 'n' is the number of items to sort (2 - 32767 only)
 * 'what' is a pointer to the array to be sorted
 */

qisort(n,what)
int n,*what;
	{
	register i,j;
	static int s,t,holder,l,r,stackl[20],stackr[20];
	if (n <= 1)
		return;
	s = 0;
	stackl[0] = 0;
	stackr[0] = n - 1;
	while (s >= 0)
		{
		l = stackl[s];
		r = stackr[s];
		--s;
		while (l < r)
			{
			i = l;
			j = r;
			holder = what[((unsigned) i + (unsigned) j) >> 1];
			while (i <= j)
				{
				while (holder > what[i])
					++i;
				while (holder < what[j])
					--j;
				if (i <= j)
					{
					if (i < j)
						{
						t = what[i];
						what[i] = what[j];
						what[j] = t;
						}
					++i;
					--j;
					}
				}
			if ((j - l) < (r - i))
				{
				if (i < r)
					{
					++s;
					stackl[s] = i;
					stackr[s] = r;
					}
				r = j;
				}
			else
				{
				if (l < j)
					{
					++s;
					stackl[s] = l;
					stackr[s] = j;
					}
				l = i;
				}
			}
		}
	}
