REM
REM +----------------------------------------------------------------------+
REM |             RENAME.BAS distributed as a portion of Mr_OBJ            |
REM |             supplied as an example of usage of Mr_OBJ routines       |
REM |      Copyright (c) 1989 Scott M. Russell all rights reserved         |
REM +----------------------------------------------------------------------+
REM
REM
REM  This basic module is used from within Mr_OBJ to control the primitive,
REM  RenameFile.  Since the primitive RenameFile contains no code for param
REM  checking this module will do any needed parameter checking.
REM  This module uses the following routines:
REM                           ResolvePath
REM                           Extract
REM                           FindFirstNext
REM                           RenameFile


'              $INCLUDE: 'Mr_OBJ.BI'


FUNCTION Rename% (FromFile$, ToFile$) STATIC

'
'              DRIVE or FROM-ROOT NOT SPECIFIED?, ADD ".\" FOR CURRENT DIRECTORY
'
   IF MID$(FromFile$,2,1) <> ":" AND MID$(FromFile$,1,1) <> "\" THEN
     FromFile$ = ".\" + FromFile$
   END IF
'
'              NULL SECOND?, ASSUME CURRENT DIRECTORY
'
   IF ToFile$ = "" THEN ToFile$ = "."
'
'              NOT CURRENT OR DRIVE SPECIFIED?, ADD ".\" FOR CURRENT DIRECTORY
'
   IF LEN(ToFile$) > 2 AND MID$(ToFile$,2,1) <> ":" THEN
     ToFile$   = ".\" + ToFile$
   END IF


'
'              RESOLVE "FROM" FILE PATH
'
   Temp$ = ResolvePath(FromFile$, RC%)
   FromFile$ = Temp$

'
'              RESOLVE "TO" FILE PATH
'
   Temp$ = ResolvePath(ToFile$, RC%)
   ToFile$ = Temp$

'
'              DON'T ALLOW A RENAME OVER ITSELF
'
   IF FromFile$ = ToFile$ THEN
     RC% = 13
     GOTO ExitOut
   END IF

'
'              DON'T ALLOW A CHANGE IN DRIVES
'
   IF MID$(FromFile$,1,1) <> MID$(ToFile$,1,1) THEN
     RC% = 15
     GOTO ExitOut
   END IF
'
'              SEE HOW THEY WANT THE RENAME (create mask)
'
   ToPath$ = ToFile$
   ToName$ = Extract(ToPath$)
'              DO NAME PORTION
   Flag% = FALSE
   NameIndexEnd% = 0
   FOR x% = 1 to LEN(ToName$)
      ThisChar$ = MID$(ToName$,x%,1)
      IF ThisChar$ = "." THEN EXIT FOR
      IF Flag% = FALSE AND ThisChar$ = "?" THEN
        Flag% = TRUE
        NameIndexStart% = x%
      ENDIF
      IF Flag% = TRUE AND ThisChar$ <> "?" THEN
        NameIndexEnd% = x%
        EXIT FOR
      ENDIF
   NEXT x%
   IF NameIndexEnd% = 0 THEN NameIndexEnd% = x%
   NameIndexLen% = NameIndexEnd% - NameIndexStart%
'              DO EXTENSION PORTION
   Flag% = FALSE
   ExtIndexEnd% = 0
   StartExt% = x%
   FOR x% = x% to LEN(ToName$)
      ThisChar$ = MID$(ToName$,x%,1)
      IF Flag% = FALSE AND ThisChar$ = "?" THEN
        Flag% = TRUE
        ExtIndexStart% = x%
      ENDIF
      IF Flag% = TRUE AND ThisChar$ <> "?" THEN
        ExtIndexStart% = x%
        EXIT FOR
      ENDIF
   NEXT x%
   IF ExtIndexEnd% = 0 THEN ExtIndexEnd% = x%
   ExtIndexLen% = ExtIndexEnd% - ExtIndexStart%
   ExtIndexStart% = ExtIndexStart% - StartExt%
'
'              GET READY FOR FIRST "FindFirstNext" AND PRIME LOOP
'
   RC% = TRUE                                  'use value start option of FFN
   Attrib$ = CHR$(NORMAL)                      'we only want normal files
   FromName$ = Extract(FromFile$)              'extract filename from path
   FromPath$ = FromFile$
   FromFile$ = FromPath$ + FromName$           'rebuild filespec
   FromName$ = FindFirstNext(Attrib$, FromFile$, RC%)
'
'              LOOP THROUGH CALLING FIND NEXT AT END
'
   DO WHILE RC% = 0
      NewFromSpec$ = FromPath$ + FromName$ + CHR$(0)
      NewToName$ = ToName$
      FOR FromIndexLen% = 1 to LEN(FromName$)
         IF MID$(FromName$, FromIndexLen%, 1) = "." THEN EXIT FOR
      NEXT FromIndexLen%
      FromIndexLen% = FromIndexLen% - 1
      For OffSet% = 1 to LEN(FromName$)
         IF MID$(FromName$, OffSet%, 1) = "." THEN EXIT FOR
      Next OffSet%
      IF NameIndexStart% <> 0 THEN
        IF NameIndexLen% < FromIndexLen% THEN
          UseLen% = NameIndexLen%
        ELSE
          UseLen% = FromIndexLen%
        END IF
        OverlayName$ = MID$(FromName$, NameIndexStart%, UseLen%)
        MID$(NewToName$, NameIndexStart%, UseLen%) = OverlayName$
      END IF
      IF ExtIndexStart% <> 0 THEN
        For x% = 1 to LEN(FromName$)
           IF MID$(FromName$, x%, 1) = "." THEN EXIT FOR
        Next x%
        For y% = 1 to LEN(NewToName$)
           IF MID$(NewToName$, y%, 1) = "." THEN EXIT FOR
        Next y%
        OverlayExt$ = MID$(FromName$, ExtIndexStart% + x%, ExtIndexLen%)
        MID$(NewToName$, ExtIndexStart% + y%, ExtIndexLen%) = OverlayExt$
      END IF
      Flag% = FALSE
      NewLen% = LEN(NewToName$)
      OffSet% = NewLen%
      PerCnt% = 0
      FOR x% = 1 to OffSet%
         ThisChar$ = MID$(NewToName$,x%,1)
         IF ThisChar$ = "." THEN PerCnt% = PerCnt% + 1
         IF ThisChar$ = "?" THEN
           Overlay$ = MID$(NewToName$, x% + 1, OffSet% - x%)
           MID$(NewToName$, x%, OffSet% - x%) = Overlay$
           MID$(NewToName$, NewLen%, 1) = " "
           NewLen% = NewLen% - 1
           IF MID$(NewToName$,x%,1) = "?" THEN x% = x% - 1
         END IF
      NEXT x%
      NewToName$ = RTRIM$(NewToName$)
      NewToSpec$ = ToPath$ + NewToName$ + CHR$(0)
      RC% = RenameFile(NewFromSpec$, NewToSpec$)
      FromName$ = FindFirstNext(Attrib$, FromFile$, RC%)
    LOOP

ExitOut:
   RENAME% = RC%                               'pass return code back

END FUNCTION
