         .XLIST
         PAGE  78,120
         PAGE
         TITLE  SNAP_D - MEMORY SNAP DUMP INTERRUPT PROGRAM
         .LIST
         SUBTTL INTERRUPT ROUTINE TO DUMP MEMORY TO THE PRINTER
         .186                     ; ENABLE 80186 INSTRUCTION SET
         COMMENT *

         SNAP_D VERSION 1.00

         Copyright (c) 1985 Don Gentry

         A limited license is granted to all users of this program,
         to make copies of this program, and distribute them to
         other users, on the following conditions:

         1. The notice on this page is not to be removed or altered

         2. No fee is to be charged for copying or distributing
            the program.

         3. No warranty of any kind is offered. This program is offered
            on an "AS IS" basis. Each user should verify that it meets
            his needs and verify correct operation.

         FOR HELP OR SUGGESTIONS WRITE:

         DON GENTRY
         183 BELLEGROVE CIRCLE
         BRANDON, MS  39042

         OR CALL (601) 992-0577


         INTERRUPT ROUTINE SNAP_D

         PURPOSE:
               DUMP A RANGE OF STORAGE TO THE PRINTER

         PARAMETERS:
               ES - SEGMENT CONTAINING THE AREA TO DUMP
               BX - THE OFFSET OF THE AREA TO DUMP
               CX - THE NUMBER OF BYTES TO DUMP

         OUTPUT:
               A DUMP OF THE STORAGE ON THE PRINTER
                                                                   *
         PAGE
REQ_HDR        SEGMENT AT 0      ; REQUEST HEADER STRUCTURE DEFINITION
;  --------------------------------------------------------------------
; |                                                                    |
; |            DOS DEVICE DRIVER REQUEST HEADER                        |
; |                                                           06/01/02 |
;  --------------------------------------------------------------------
;
RH_LEN         DB      ?         ; LENGTH OF RH + ANY DATA
RH_UNIT        DB      ?         ; UNIT CODE
RH_COMMAND     DB      ?         ; COMMAND CODE
;
; ----------   COMMAND CODE EQUATES
;
CMD_INIT       EQU     0         ; INITIALIZATION ENTRY
CMD_MCHK       EQU     1         ; MEDIA CHECK
CMD_BPB        EQU     2         ; BUILD BPB
CMD_IOCTLI     EQU     3         ; IO CONTROL INPUT
CMD_READ       EQU     4         ; INPUT DATA (READ FROM DEVICE)
CMD_NDI        EQU     5         ; NON DESTRUCTIVE INPUT NO WAIT]
CMD_STAT       EQU     6         ; INPUT STATUS
CMD_FLUSH      EQU     7         ; INPUT FLUSH
CMD_WRITE      EQU     8         ; OUTPUT DATA (WRITE TO DEVICE)
CMD_WRITEV     EQU     9         ; WRITE WITH VERIFY
CMD_STATOUT    EQU     10        ; OUTPUT STATUS
CMD_OFLUSH     EQU     11        ; OUTPUT FLUSH
CMD_IOCTLO     EQU     12        ; IO CONTROL OUTPUT
;
RH_STATUS      DB      ?         ; STATUS WORD
               ORG     RH_STATUS ; REDEFINE STATUS WORD
RH_STAT_HI     DB      ?         ; STATUS BYTE HIGH
STAT_ERR       EQU     10000000B ; ERROR STATUS RETURNED
STAT_BUSY      EQU     00000010B ; DEVICE BUSY
STAT_DONE      EQU     00000001B ; OPERATION COMPLETE
RH_STAT_LO     DB      ?         ; STATUS BYTE LOW
ERR_WPV        EQU     00H       ; WRITE PROTECT VIOLATION
ERR_UNIT       EQU     01H       ; UNKNOWN UNIT NUMBER
ERR_DNR        EQU     02H       ; DEVICE NOT READY
ERR_CMD        EQU     03H       ; UNKNOWN COMMAND
ERR_CRC        EQU     04H       ; CRC ERROR DETECTED
ERR_DRSL       EQU     05H       ; BAD DRIVE REQUEST STRUCTURE LENGTH
ERR_SEEK       EQU     06H       ; SEEK ERROR
ERR_MEDIA      EQU     07H       ; UNKNOWN MEDIA
ERR_SECTOR     EQU     08H       ; SECTOR NOT FOUND
ERR_PAPER      EQU     09H       ; PRINTER OUT OF PAPER
ERR_WRITE      EQU     0AH       ; WRITE FAULT
ERR_GEN        EQU     0BH       ; GENERAL FAILURE
;
; ----------   STATUS WORD EQUATES
;
               DD      ?         ; RESERVED FOR DOS
               DD      ?         ; RESERVED FOR DOS
RH_DATA        EQU     $         ; START OF OPERATION DATA
;
; ----------   FUNCTION CALL PARAMETER LISTS
;
; ----------   INITIALIZATION CALL (CMD CODE 0)
;
               ORG     RH_DATA     ; SET LOCATION COUNTER
IN_UNITS       DB      ?           ; NUMBER OF UNITS
IN_PGMEND      DD      ?           ; ENDING ADDRESS
               ORG     IN_PGMEND   ; REDEFINE ENDING ADDRESS
IN_PGMOFF      DW      ?           ; OFFSET OF ENDING ADDRESS
IN_PGMSEG      DW      ?           ; SEGMENT OF ENDING ADDRESS
IN_BPBPTR      DD      ?           ; POINTER TO BPB ARRAY
               ORG     IN_BPBPTR   ; REDEFINE BPB POINTER
IN_BPBOFF      DW      ?           ; OFFSET TO BPB ARRAY
IN_BPBSEG      DW      ?           ; SEGMENT OF BPB ARRAY
;
; ----------   MEDIA CHECK CALL (CMD CODE 1)
;
               ORG     RH_DATA     ; SET LOCATION COUNTER
M_DES          DB      ?           ; MEDIA DESCRIPTOR BYTE FROM DOS
;
M_ONES         EQU     11111000B   ; MUST BE ONES
M_DEMOUNT      EQU     00000100B   ; REMOVABLE MEDIA
M_8SECTOR      EQU     00000010B   ; 8 SECTOR
M_2SIDE        EQU     00000001B   ; DOUBLE SIDED
;
M_STAT         DB      ?           ; RETURNED STATUS
M_CHG          EQU     -1          ; MEDIA HAS GHANGED
M_UNK          EQU     0           ; DON'T KNOW IF CHANGED
M_SAME         EQU     1           ; MEDIA HAS NOT GHANGED
;
; ----------   BUILD BPB CALL (CMD CODE 2)
;
               ORG     RH_DATA     ; SET LOCATION COUNTER
BPB_DES        DB      ?           ; MEDIA DESCRIPTOR FROM DOS
BPB_DTA        DD      ?           ; DATA XFER ADDRESS
               ORG     BPB_DTA     ; REDEFINE DTA ADDRESS
BPB_DTAOFF     DW      ?           ; DTA OFFSET
BPB_DTASEG     DW      ?           ; DTA SEGMENT
BPB_BPB        DD      ?           ; BPB ARRAY TABLE ADDRESS
               ORG     BPB_BPB     ; REDEFINE BPB ADDRESS
BPB_BPBOFF     DW      ?           ; BPB OFFSET
BPB_BPBSEG     DW      ?           ; BPB SEGMENT
;
; ----------   INPUT OR OUTPUT (CMD CODE 3,4,8,9,12)
;
               ORG     RH_DATA     ; SET LOCATION COUNTER
IO_DES         DB      ?           ; MEDIA DESCRIPTOR BYTE FROM DOS
IO_DTA         DD      ?           ; DATA XFER ADDRESS (BUFFER)
               ORG     IO_DTA      ; REDEFINE DTA ADDRESS
IO_DTAOFF      DW      ?           ; DTA OFFSET
IO_DTASEG      DW      ?           ; DTA SEGMENT
IO_CNT         DW      ?           ; BYTE/SECTOR COUNT
IO_SECTOR      DW      ?           ; STARTING SECTOR NUMBER
;
; ----------   NON DESTRUCTIVE INPUT NO WAIT (CMD CODE 5)
;
               ORG     RH_DATA     ; SET LOCATION COUNTER
NDI_BYTE       DB      ?           ; BYTE READ FROM DEVICE
REQ_HDR        ENDS                ; END OF STRUCTURE
               PAGE
;**********************************************************************
;* * *     EQUATES FOR EASE OF CODING & CONDITIONAL ASSEMBLY      * * *
;**********************************************************************
;
LF       EQU   0AH                ; LINE FEED
CR       EQU   0DH                ; CARRIAGE RETURN
EOM      EQU   '$'                ; END OF MESSAGE
;
;  --------------------------------------------------------------------
; |                                                                    |
; |             INTERRUPT NUMBER ASSIGNMENT                            |
; |                                                                    |
; |      YOU SHOULD EQUATE THE SYMBOL SNAP_IRN TO AN UNUSED            |
; |      INTERRUPT NUMBER. ACCORDING TO THE IBM TECHNICAL              |
; |      REFERENCE MANUAL, INTERRUPTS F1-FF ARE UNUSED. I'M            |
; |      USING INTERRUPT F1 (241). YOU SHOULD VERIFY THAT IT'S         |
; |      NOT CURRENTLY USED IN YOUR SYSTEM. IF IT IS, CHANGE           |
; |      THE INTERRUPT NUMBER IN THE FOLLOWING EQUATE.                 |
; |                                                                    |
;  --------------------------------------------------------------------
;
SNAP_IRN EQU    0F1H              ; USER INTERRUPT NUMBER
;
;  --------------------------------------------------------------------
; |             ASSIGN THE CPU IDENTIFIER                              |
; |                                                                    |
; |      YOU SHOULD EQUATE THE SYMBOL SNAP_CPU TO IDENTIFY             |
; |      THE TYPE OF CPU USED FOR EXECUTION. IF RUNNING ON             |
; |      AN 80186, OR NEC V20 USE 186 AND THE EXTENDED INSTRUCTIONS    |
; |      WILL BE USED.                                                 |
; |                                                                    |
; |       186  FOR NEC V20, 80186, OR 8088                             |
; |       86   FOR 8088 OR 8086                                        |
; |                                                                    |
;  --------------------------------------------------------------------
;
SNAP_CPU EQU    86                ; DEFAULT IS 8086 (WILL RUN ON 186)
;***********************************************************************
;* * *   INCLUDE MACROS FOR EASE OF CODING & CLARITY               * * *
;***********************************************************************
;
         IFE   SNAP_CPU-186
SHIFT    MACRO DIR,DEST,NUM
         SH&DIR    DEST,&NUM         ; SHIFT
         ENDM
PUSHR    MACRO                    ; SAVE REGISTERS
         PUSHA                    ; SAVE REGS
         ENDM
POPR     MACRO                    ; RESTORE REGISTERS
         POPA                     ; RESTORE REGS
         ENDM
         ENDIF
;
         IFE   SNAP_CPU-86
SHIFT    MACRO DIR,DEST,NUM
         REPT  NUM
         SH&DIR    DEST,1            ; SHIFT
         ENDM
         ENDM
;
PUSHR    MACRO                    ; SAVE REGISTERS
         PUSH  AX                 ; SAVE AX
         PUSH  CX                 ; SAVE CX
         PUSH  DX                 ; SAVE DX
         PUSH  BX                 ; SAVE BX
         PUSH  SP                 ; SAVE SP
         PUSH  BP                 ; SAVE BP
         PUSH  SI                 ; SAVE SI
         PUSH  DI                 ; SAVE DI
         ENDM
;
POPR     MACRO                    ; RESTORE REGISTERS
         POP   DI                 ; RESTORE DI
         POP   SI                 ; RESTORE SI
         POP   BP                 ; RESTORE BP
         POP   BX                 ; DISCARD SP [LIKE POPA ON 80186/V20] 0
         POP   BX                 ; RESTORE BX
         POP   DX                 ; RESTORE DX
         POP   CX                 ; RESTORE CX
         POP   AX                 ; RESTORE AX
         ENDM                     ; END OF MACRO DEFINITION
         ENDIF
;
         PAGE
;**********************************************************************
;* * *        BEGIN THE CODE SEGMENT OF PROGRAM                   * * *
;**********************************************************************
;
CSEG     SEGMENT PARA PUBLIC 'CODE' ; IDENTIFY CODE SEGMENT
         ASSUME CS:CSEG           ; INITIAL ASSUMPTION
;  --------------------------------------------------------------------
; |                                                                    |
; |            DOS DEVICE DRIVER DEVICE HEADER                         |
; |                                                                    |
;  --------------------------------------------------------------------
;
DH_NEXT  DD    -1                 ; DEVICE DRIVER CHAIN FIELD
DH_ATTR  DW    1010000000000000B  ; DEVICE ATTRIBUTE FIELD
;              | |
;              | `----------------->  NON-IBM FORMAT
;              `------------------->  CHARACTER DEVICE
;
DH_STRAT DW    D_STRAT            ; OFFSET OF STRATEGY ENTRY POINT
DH_RUPT  DW    D_RUPT             ; OFFSET OF INTERRUPT ENTRY POINT
DH_NAME  DB    'SNAP_D'           ; DEVICE DRIVER NAME
         DB    'V1M00'            ; VERSION & LEVEL
;
INIT_MSG:
         DB    LF,LF,CR
         DB    'SNAP_D   Copyright (c) 1985 Don Gentry'
         DB    LF,CR
         IFE   SNAP_CPU-186
         DB    'SNAP_D   Version 1.00 now resident (SNAP_CPU IS 186)'
         ENDIF
         IFE   SNAP_CPU-86
         DB    'SNAP_D   Version 1.00 now resident (SNAP_CPU IS 86)'
         ENDIF
         DB    LF,LF,CR,EOM
;
DOS_SP   DW    0                  ; DOS' STACK POINTER
DOS_SS   DW    0                  ; DOS' STACK SEGMENT
;  --------------------------------------------------------------------
; |                                                                    |
; |            DOS DEVICE DRIVER STRATEGY ENTRY POINT                  |
; |                                                                    |
;  --------------------------------------------------------------------
;
;        Since we aren't really a device driver (we just want to
;        be loaded early in the IPL ) our STRATEGY entry really
;        does nothing. We'll just return to the caller
;
D_STRAT  PROC  FAR                ; STRATEGY ENTRY POINT
         RET                      ; JUST RETURN
D_STRAT  ENDP                     ; END OF PROCEDURE
;
RUPT_RTN PROC  NEAR               ; INTERRUPT HANDLER ROUTINE
SAVE_SP  DW     0                 ; CALLER'S STACK POINTER
SAVE_SS  DW     0                 ; CALLER'S STACK SEGMENT
OUT_LINE:
         DB     0AH,0DH           ; LF/CR
OUT_SEG  DB     'SSSS'
         DB     ':'
OUT_OFF  DB     'OOOO'
         DB     '  '
OUT_DATA:
         DB     'XX XX XX XX XX XX XX XX-XX XX XX XX XX XX XX XX'
         DB     '  *'
OUT_ASC  DB     'XXXXXXXXXXXXXXXX*'
         DB     0DH,00H
AT_TABLE:
;                0123456789ABCDEF
;
         DB     '                ' ; 0
         DB     '                ' ; 1
         DB     ' !"#$%& () +    ' ; 2
         DB     '0123456789      ' ; 3         TRANSLATE
         DB     ' ABCDEFGHIJKLMNO' ; 4           TABLE
         DB     'PQRSTUVWXYZ     ' ; 5
         DB     ' abcdefghijklmno' ; 6
         DB     'pqrstuvwxyz     ' ; 7
         DB     '                ' ; 8
         DB     '                ' ; 9
         DB     '                ' ; A
         DB     '                ' ; B
         DB     '                ' ; C
         DB     '                ' ; D
         DB     '                ' ; E
         DB     '                ' ; F
;
RUPT_GO:                          ; INTERRUPT ENTRY POINT
         CLI                      ; RUPTS OFF
         MOV    SAVE_SP,SP        ; SAVE CALLER'S SP
         MOV    SAVE_SS,SS        ; SAVE CALLER'S SS
         LEA    SP,DRIVSTAK       ; ADDRESS OF OUR STACK
         PUSH   CS                ; GET @ CODE SEG
         POP    SS                ; PUT IN STACK SEG
         STI                      ; RUPTS ON
         PUSHR                    ; SAVE REGS
         PUSH   DS                ; SAVE DS
         PUSH   CS                ; CS TO STACK
         POP    DS                ; DS OFF STACK
         ASSUME DS:CSEG           ; INFORM ASSEMBLER
         MOV    SI,CX             ; SAVE NUMBER OF BYTES
         MOV    DX,0              ; USE LPT1:
         MOV    AX,000AH          ; SEND LINE FEED
         INT    17H               ; BIOS PRINT CHAR
         MOV    AX,000AH          ; SEND LINE FEED
         INT    17H               ; BIOS PRINT CHAR
         MOV    AX,000DH          ; SEND CHAR RET
         INT    17H               ; BIOS PRINT CHAR
;
;
; -----  FORMAT SEGMENT REGISTER
;
SNAP_01:
         LEA    DI,OUT_SEG        ; GET @OUTPUT AREA
         MOV    AX,ES             ; GET SEG REG IN AX
         MOV    AL,AH             ; DUP AH IN AL
         SHIFT  R,AL,4            ; GET HIGH NIBBLE IN LOW
         CALL   XLATE             ; CONVERT TO ASCII
         MOV    [DI],AL           ; CHAR TO PRINT LINE
         INC    DI                ; BUMP TO NEXT CHAR
         SHIFT  R,AX,8            ; NEXT NIBBLE DOWN
         CALL   XLATE             ; MAKE ASCII
         MOV    [DI],AL           ; TO PRINT LINE
         INC    DI                ; BUMP LINE INDEX
         MOV    AX,ES             ; GET ES AGAIN
         MOV    AH,AL             ; USE AH THIS TIME
         SHIFT  R,AL,4            ; GET HIGH NIBBLE IN LOW
         CALL   XLATE             ; CONVERT TO ASCII
         MOV    [DI],AL           ; CHAR TO PRINT LINE
         INC    DI                ; BUMP TO NEXT CHAR
         SHIFT  R,AX,8            ; NEXT NIBBLE DOWN
         CALL   XLATE             ; MAKE ASCII
         MOV    [DI],AL           ; TO PRINT LINE
         INC    DI                ; BUMP LINE INDEX
;
; -----  FORMAT OFFSET VALUE
;
SNAP_02:
         LEA    DI,OUT_OFF        ; GET @OUTPUT AREA
         MOV    AX,BX             ; GET OFFSET IN AX
         MOV    AL,AH             ; DUP AH IN AL
         SHIFT  R,AL,4            ; GET HIGH NIBBLE IN LOW
         CALL   XLATE             ; CONVERT TO ASCII
         MOV    [DI],AL           ; CHAR TO PRINT LINE
         INC    DI                ; BUMP TO NEXT CHAR
         SHIFT  R,AX,8            ; NEXT NIBBLE DOWN
         CALL   XLATE             ; MAKE ASCII
         MOV    [DI],AL           ; TO PRINT LINE
         INC    DI                ; BUMP LINE INDEX
         MOV    AX,BX             ; GET OFFSET AGAIN
         MOV    AH,AL             ; USE AH THIS TIME
         SHIFT R, AL,4            ; GET HIGH NIBBLE IN LOW
         CALL   XLATE             ; CONVERT TO ASCII
         MOV    [DI],AL           ; CHAR TO PRINT LINE
         INC    DI                ; BUMP TO NEXT CHAR
         SHIFT  R,AX,8            ; NEXT NIBBLE DOWN
         CALL   XLATE             ; MAKE ASCII
         MOV    [DI],AL           ; TO PRINT LINE
         INC    DI                ; BUMP LINE INDEX
;
; -----  FORMAT DATA BYTES
;
         MOV    CX,16             ; GE BYTES/LINE
         LEA    DI,OUT_DATA       ; GET @OUTPUT AREA
SNAP_02A:
         MOV    AL,ES:[BX]        ; GET BYTE IN AL
         MOV    AH,AL             ; DUP AH IN AL
         SHIFT  R,AL,4            ; GET HIGH NIBBLE IN LOW
         CALL   XLATE             ; CONVERT TO ASCII
         MOV    [DI],AL           ; CHAR TO PRINT LINE
         INC    DI                ; BUMP TO NEXT CHAR
         SHIFT  R,AX,8            ; NEXT NIBBLE DOWN
         CALL   XLATE             ; MAKE ASCII
         MOV    [DI],AL           ; TO PRINT LINE
         ADD    DI,02             ; BUMP LINE INDEX
         INC    BX                ; BUMP INPUT INDEX
         LOOP   SNAP_02A          ; DO 16 BYTES/LINE
;
; -----  PRINT THE ASCII VERSION
;
         MOV    CX,16
         SUB    BX,16             ; BACK BX UP
         LEA    DI,OUT_ASC        ; ADDR OF ASCII OUTPUT
SNAP_02C:
         MOV    AL,ES:[BX]        ; GET A CHARACTER
         PUSH   BX                ; SAVE BX
         LEA    BX,AT_TABLE       ; GET TABLE ADDRESS
         XLAT                     ; TRANSLATE OUT UNPRINTABLE
         POP    BX                ; RESTORE BX
         MOV    [DI],AL           ; TO PRINT LINE
         INC    DI                ; BUMP OUT INDEX
         INC    BX                ; BUMP IN INDEX
         LOOP   SNAP_02C          ; DO A LINE
;
; -----  PRINT A LINE
;
         MOV    DX,0              ; USE LPT0:
         LEA    DI,OUT_LINE       ; ADDRESS LTHE PRINT LINE
SNAP_03:
         MOV    AH,00             ; BIOS PRINT CHAR FUNCTION CODE
         MOV    AL,[DI]           ; GET A CHARACTER
         CMP    AL,00             ; END OF LINE ?
         JE     SNAP_04           ; ...YES EXIT PRINT RTN
         INT    17H               ; PRINT CHAR
         INC    DI                ; BUMP INDEX
         JMP    SNAP_03           ; DO ANOTHER CHARACTER
SNAP_04:
         SUB    SI,16             ; DECREMENT USER'S COUNT
         JS     SNAP_05           ; GONE NEG - QUIT
         JZ     SNAP_05           ; QUIT ON 0
         JMP    SNAP_01
SNAP_05:
         MOV    AX,000AH          ; SEND LINE FEED
         INT    17H               ; BIOS PRINT CHAR
         MOV    AX,000AH          ; SEND LINE FEED
         INT    17H               ; BIOS PRINT CHAR
         MOV    AX,000DH          ; SEND CHAR RET
         INT    17H               ; BIOS PRINT CHAR

;
; -----  EXIT TO CALLER
;
         POP    DS                ; RESTORE DS REG
         ASSUME DS:NOTHING        ; INFORM ASSEMBLER
         POPR                     ; RESTORE GPR'S
         CLI                      ; RUPTS OFF
         MOV    SP,SAVE_SP        ; RESTORE SP
         MOV    SS,SAVE_SS        ; RESTORE SS
         IRET                     ; RETURN TO CALLER
XLATE    PROC   NEAR
;
; -----  TRANSLATE A CHARACTER TO ASCII
;
         PUSH   BX                ; SAVE BX REG
         LEA    BX,TR_TABLE       ; GET XLATE TABLE ADDRESS
         AND    AL,0FH            ; CLEAR HIGH NIBBLE
         XLAT                     ; TRANSLATE
         POP    BX                ; RESTORE BX REG
         RET
TR_TABLE:
         DB     '0123456789ABCDEF'
XLATE    ENDP
;
         DW     40 DUP(00)
DRIVSTAK EQU    $                 ; ADDRESS OF OUR STACK
RUPT_RTN ENDP                     ; END OF PROCEDURE
D_RUPT   PROC  FAR                ; INTERRUPT ENTRY POINT
;  --------------------------------------------------------------------
; |                                                                    |
; |            DOS DEVICE DRIVER INTERRUPT ENTRY POINT                 |
; |                                                                    |
;  --------------------------------------------------------------------
;
;        Since we aren't really a device driver (we just want to
;        be loaded early in the IPL ) our INTERRUPT entry will
;        only execute code on the INITIALIZATION entry. Any other
;        time we are called we'll dummy some status and exit to the
;        caller without doing anything.
;
         ASSUME CS:CSEG           ; INFORM ASSEMBLER
         PUSH  AX                 ; SAVE AX REGISTER
         MOV   AL,ES:RH_COMMAND[BX] ; PICK UP COMMAND CODE
         CMP   AL,CMD_INIT        ; INIT ENTRY ??
         JE    INIT_CMD           ; ...YES - HANDLE INITILAZITION
;
;        IF NOT INITIALIZATION ENTRY, DUMMY STATUS & EXIT
;
         MOV   ES:RH_STAT_HI[BX],STAT_ERR+STAT_DONE ;STATUS
         MOV   ES:RH_STAT_LO[BX],ERR_GEN ; REPORT GENERAL FAILURE
         MOV   ES:IO_CNT[BX],00H  ; SET NUMBER OF BYTES XFER'D
         POP   AX                 ; RESTORE AX REGISTER
         RET                      ; RETURN TO CALLER
RES_CODE EQU   $+1                ; MARK END OF RESIDENT ROUTINE
INIT_CMD:                         ; COMMAND IS INITIALIZE
         CLI                      ; RUPTS OFF
         MOV   DOS_SP,SP          ; SAVE DOS SP
         MOV   DOS_SS,SS          ; SAVE DOS SS
         MOV   AX,CS              ; NEW STACK SEGMENT TO AX
         MOV   SS,AX              ; TO STAK SEG REG
         MOV   SP,OFFSET DRIVSTAK ; NEW STACK POINTER
         STI                      ; RUPTS BACK ON
         ASSUME SS:CSEG           ; INFORM ASSEMBLER
         PUSHR                    ; SAVE DOS' REGS
         PUSH  CS                 ; CS TO STACK
         POP   DS                 ; DS OFF STACK
         ASSUME DS:CSEG
;
; -----  SET PROGRAM ENDING ADDRESS IN REQ HEADER
;
         MOV   ES:IN_PGMOFF[BX],OFFSET RES_CODE ; GET OFFSET END OF PGM  AM
         MOV   ES:IN_PGMSEG[BX],CS ; GET PROGRAM SEGMENT
;
; -----  SET STATUS FOR DOS
;
         AND   ES:RH_STAT_HI[BX],0FFH-STAT_ERR ; TURN ERROR BIT OFF
         MOV   ES:RH_STAT_HI[BX],STAT_DONE ; INDICATE DONE
;
;**********************************************************************
;* * *        SET INT 0F1H ROUTINE TO OUR CODE                    * * *
;**********************************************************************
;
         MOV   AL,SNAP_IRN        ; GET INTERRUPT NUMBER
         LEA   DX,RUPT_GO         ; GET ADDRESS OF RUPT ROUTINE
;
; -----  NOTE: DS ALREADY POINTS TO THE SEGMENT
;
         MOV   AH,25H             ; SET INTERRUPT VECTOR
         INT   21H                ; INVOVE DOS FUNCTION
;
; -----  PRINT INITIALIZATION MESSAGE
;
         LEA   DX,INIT_MSG        ; GET ADDRESS OF MSG
         MOV   AX,0900H           ; DOS PRINT FUNCTION
         INT   21H                ; INVOKE DOS
;
; -----  RESTORE DOS REGS FROM OUR STACK
;
         POPR                     ; RESTORE REGS
         ASSUME DS:NOTHING,SS:NOTHING,ES:NOTHING ; INFORM ASSEMBLER
         CLI                      ; RUPTS OFF
         MOV   SP,DOS_SP          ; RESTORE DOS SP
         MOV   SS,DOS_SS          ; RESTORE DOS SS
         STI                      ; RUPTS BACK ON
         POP   AX                 ; RESTORE AX REG
         RET                      ; RETURN TO CALLER
D_RUPT   ENDP
CSEG     ENDS                     ; END OF CODE SEG
         END
