
/* njstack demo program
	(C) Copyright 1989 by Mike Blaszczak
	Version 1.00 of 31 March, 1989
*/

#include <stdio.h>

/* counter is a variable that will determine the number of times we
	will call recur().  recur() uses the stack for a return address
	as well as allocating 15-bytes of space for a local variable.
*/

int	counter =500;

/* here, we declare the highmark variable as external.  this lets
	our program reference it later.
*/

extern	size_t highmark;

/* recur() is a very simple recursive procedure.  It will call itself
	the number of times specified by counter, above.  each time it
	executes, it prints out the value of highmark for the users'
	reference.  (After all, this is a demo; we don't do anything
	useful.)
*/

recur()
{
	char wastelocal[15];

	/* decrement counter for future reference	*/
	counter--;

	/* print out the value of highmark	*/

	printf("%4.4X\n", highmark);


	/* decide wether to return to the callers, or to call
		ourselves again.
	*/

	if (counter == 0)
		return;
	else
		recur();
}

main()
{
	/* print out the highmark when we start	*/

	printf("%4.4X\n", highmark);

	/* call the recursive monster	*/

	recur();

	/* if we've come back, print out the final highmark	*/

	printf("%4.4X\n", highmark);

	return;
}
