;STEXT.INC - 17 May 1991 - Knight Software
;------------------------------------------------------
;Update internal text registers with system 8x8 font info
GetTextInfo PROC NEAR
	PUSH	ES
	PUSH	BP
	PUSH	CX
	PUSH	BX
	PUSH	AX
	MOV	AX,1130H
	MOV	BH,3	;get 8x8 font address
	INT	10H	;and size info
	MOV	[FontSeg],ES
	MOV	[FontOfs],BP
	MOV	[FontSizeX],8
	MOV	[FontSizeY],8
	MOV	[CharSizeX],8
	MOV	[CharSizeY],8
	MOV	[FontMultX],1
	MOV	[FontMultY],1
	POP	AX
	POP	BX
	POP	CX
	POP	BP
	POP	ES
	RET
GetTextInfo ENDP

;-----------------------------------------------------------
;Read a character from font table
;Enter:  AL = Char to read
;Return: Character map is in TempChar

ReadChar PROC NEAR
	PUSH	ES
	PUSH	SI
	PUSH	DI
	PUSH	DX
	PUSH	CX
	PUSH	BX
	PUSH	AX
	MOV	ES,[FontSeg] ;Get pointer to font table
	MOV	SI,[FontOfs]
	MOV	AH,0
	ADD	AX,AX      ;generate index into table
	ADD	AX,AX
	ADD	AX,AX
	ADD	SI,AX
	MOV	AX,ES:[SI]
	MOV	BX,ES:[SI+2]  ;get character from bios rom
	MOV	CX,ES:[SI+4]
	MOV	DX,ES:[SI+6]

	LEA	DI,TempChar	;point to temp char array
	CMP	[FontDir],1
	JZ	@Rotate1
	CMP	[FontDir],2
	JZ	@Rotate2
	CMP	[FontDir],3
	JZ	@Rotate3
	MOV	[DI],AX
	MOV	[DI+2],BX	;copy character to temp vars 
	MOV	[DI+4],CX	;as is since no rotate needed
	MOV	[DI+6],DX
	JMP	@RotateDone

@Rotate1:
	PUSH	BP	;rotate the character to the
	MOV	BP,8	;right 90 degrees
@Cloop1:
	SHL	DH,1	;if rotate required then rotate it
	RCL	SI,1	;as we stuff it to the local stack
	SHL	DL,1
	RCL	SI,1
	SHL	CH,1
	RCL	SI,1
	SHL	CL,1
	RCL	SI,1
	SHL	BH,1
	RCL	SI,1
	SHL	BL,1
	RCL	SI,1
	SHL	AH,1
	RCL	SI,1
	SHL	AL,1
	RCL	SI,1
	MOV	[DI],SI	;copy char to temp vars
	INC	DI
	DEC	BP
	JNZ	@Cloop1
	POP	BP
	JMP	@RotateDone

@Rotate2:
	PUSH	BP	;rotate the character to the 
	MOV	BP,8	;left 90 degrees
@Cloop2:
	SHR 	AL,1	;if rotate required then rotate it
	RCL 	SI,1    ;as we stuff it to the local stack
	SHR 	AH,1
	RCL 	SI,1
	SHR 	BL,1
	RCL 	SI,1
	SHR 	BH,1
	RCL 	SI,1
	SHR 	CL,1
	RCL 	SI,1	;rotate in the other direction
	SHR 	CH,1	;@@@ this probably does not work,  @@@
	RCL 	SI,1	;@@@ I haven't checked it yet      @@@
	SHR 	DL,1
	RCL 	SI,1
	SHR 	DH,1
	RCL 	SI,1
	MOV 	[DI],SI	;copy char to local stack
	INC 	DI
	DEC 	BP
	JNZ 	@Cloop2
	POP 	BP
	JMP	@RotateDone

@Rotate3:
	XCHG	DH,AL	;flip the character upside down
	XCHG	DL,AH
	XCHG	CH,BL
	XCHG	CL,BH
	MOV	[DI],AX
	MOV	[DI+2],BX	;copy character 
	MOV	[DI+4],CX	;to local stack array
	MOV	[DI+6],DX
	JMP	@RotateDone

@RotateDone:
	POP	AX
	POP	BX
	POP	CX
	POP	DX
	POP	DI
	POP	SI
	POP	ES
	RET
ReadChar ENDP

;----------------------------------------------------------
;Draw a character on the screen at given location
;Entry:  AL = Character to draw
;        BX = X location
;        DX = Y location
;Return: N/A

DrawChar PROC NEAR
	PUSH	ES
	PUSH	SI
	PUSH	DI
	PUSH	DX
	PUSH	CX
	PUSH	BX
	PUSH	AX
	MOV	[PixelX1],BX	;store temp x location
	MOV	[PixelY1],DX	;store temp y location
	CALL	ReadChar	;Read the character map 
	MOV	ES,[VideoSegment] ;point ES at video segment
	MOV	DH,0
	LEA	SI,TempChar
@CharLp:
	MOV	DL,[FontMultY]
@YmultLp:
	MOV	AX,[PixelX1]
	MOV	[PixelX],AX
	MOV	AL,DH
	MUL	BYTE PTR [FontMultY]
	ADD	AL,DL
	ADC	AH,0
	ADD	AX,[PixelY1]
	MOV	[PixelY],AX
	CALL	GetPixelAddress
	MOV	DI,[PixelAddress]
	MOV	CH,[CharSizeX]
	MOV	BH,[SI]
	MOV	AL,[DrawForeColor]
	MOV	AH,[DrawBackColor]
@PixLoop:
	MOV	CL,[FontMultX]
@Nxtpix:
	TEST	BH,80H
	CALL	WORD PTR [TextPixelProc]
	INC	WORD PTR [PixelX]
	INC	DI
	JNZ	@AdrOK
	CALL	GetPixelAddress
	MOV	DI,[PixelAddress]
@AdrOK:
	DEC	CL
	JNZ	@Nxtpix
	SHL	BH,1
	DEC	CH
	JNZ	@PixLoop

	DEC	DL
	JNZ	@YmultLp
	INC	SI
	INC	DH
	CMP	DH,[CharSizeY]
	JNZ	@CharLp

	POP	AX
	POP	BX
	POP	CX
	POP	DX
	POP	DI
	POP	SI
	POP	ES
	RET
DrawChar ENDP

;-----------------------------------------------------------
;Draw text on the screen
;Entry:  ES:BX = Pointer to string to draw
;           CX = String size in charcters
;Return: N/A 

DrawText PROC NEAR
	PUSH	DI
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	MOV	DI,BX	
	MOV	BX,[CPX]    ;get current pointer
	MOV	DX,[CPY]
@DrawTextLp:
	MOV	AL,ES:[DI]  ;Get a char to draw
	CALL	DrawChar    ;Draw the character
	INC	DI	    ;Point to next char in string

	MOV	AH,0	    ;Preset AH to zero
	CMP	[FontDir],1 ;Adjust CP based on 
	JZ	@DrawText1  ;Text Direction selected
	CMP	[FontDir],2
	JZ	@DrawText2
	CMP	[FontDir],3
	JZ	@DrawText3
	JMP	@DrawText0

@DrawText0:
	MOV	AL,[FontSizeX] ;PixelX+FontSize - 0 degrees
	ADD	BX,AX
	JMP	@DrawTextDone

@DrawText1:
	MOV	AL,[FontSizeY] ;PixelY+FontSize - 90 degrees
	ADD	DX,AX
	JMP	@DrawTextDone

@DrawText2:
	MOV	AL,[FontSizeY] ;PixelY+FontSize - 180 degrees
	ADD	DX,AX
	JMP	@DrawTextDone

@DrawText3:
	MOV	AL,[FontSizeX] ;PixelX+FontSize - 270 degrees
	ADD	BX,AX
	JMP	@DrawTextDone

@DrawTextDone:
        LOOP	@DrawTextLp ;loop til done
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	POP	DI
	RET
DrawText ENDP

