/*** 
*string.h - definitions/declarations for string manipulation routines
*
*
*Purpose:
*   This file contains the function declarations for the string
*   manipulation functions.
*   [ANSI/System V]
*
*******************************************************************************/


#ifndef _SIZE_T_DEFINED
typedef unsigned int size_t;
#define _SIZE_T_DEFINED
#endif

/* function declarations for those who want strong type checking
 * on arguments to library function calls
 */

#ifdef LINT_ARGS    /* argument checking enabled */

#ifndef NO_EXT_KEYS /* extended keywords are enabled */
char * cdecl memccpy(char *, char *, int, unsigned int);
void * cdecl memchr(const void *, int, size_t);
int cdecl memcmp(const void *, const void *, size_t);
int cdecl memicmp(char *, char *, unsigned int);
void * cdecl memcpy(void *, const void *, size_t);
void * cdecl memset(void *, int, size_t);
void cdecl movedata(unsigned int, unsigned int, unsigned int, unsigned int, unsigned int);
char * cdecl strcat(char *, const char *);
char * cdecl strchr(const char *, int);
int cdecl strcmp(const char *, const char *);
int cdecl strcmpi(char *, char *);
int cdecl stricmp(char *, char *);
char * cdecl strcpy(char *, const char *);
size_t cdecl strcspn(const char *, const char *);
char * cdecl strdup(char *);
char * cdecl strerror(char *);
size_t cdecl strlen(const char *);
char * cdecl strlwr(char *);
char * cdecl strncat(char *, const char *, size_t);
int cdecl strncmp(const char *, const char *, size_t);
int cdecl strnicmp(char *, char *, unsigned int);
char * cdecl strncpy(char *, const char *, size_t);
char * cdecl strnset(char *, int, unsigned int);
char * cdecl strpbrk(const char *, const char *);
char * cdecl strrchr(const char *, int);
char * cdecl strrev(char *);
char * cdecl strset(char *, int);
size_t cdecl strspn(const char *, const char *);
char * cdecl strstr(const char *, const char *);
char * cdecl strtok(char *, const char *);
char * cdecl strupr(char *);
#else           /* extended keywords not enabled */
char *memccpy(char *, char *, int, unsigned int);
void *memchr(const void *, int, size_t);
int memcmp(const void *, const void *, size_t);
int memicmp(char *, char *, unsigned int);
void *memcpy(void *, const void *, size_t);
void *memset(void *, int, size_t);
void movedata(unsigned int, unsigned int, unsigned int, unsigned int, unsigned int);
char *strcat(char *, const char *);
char *strchr(const char *, int);
int strcmp(const char *, const char *);
int strcmpi(char *, char *);
int stricmp(char *, char *);
char *strcpy(char *, const char *);
size_t strcspn(const char *, const char *);
char *strdup(char *);
char *strerror(char *);
size_t strlen(const char *);
char *strlwr(char *);
char *strncat(char *, const char *, size_t);
int strncmp(const char *, const char *, size_t);
int strnicmp(char *, char *, size_t);
char *strncpy(char *, const char *, size_t);
char *strnset(char *, int, unsigned int);
char *strpbrk(const char *, const char *);
char *strrchr(const char *, int);
char *strrev(char *);
char *strset(char *, int);
size_t strspn(const char *, const char *);
char *strstr(const char *, const char *);
char *strtok(char *, const char *);
char *strupr(char *);
#endif  /* NO_EXT_KEYS */

#else           /* argument checking not enabled */

#ifndef NO_EXT_KEYS /* extended keywords are enabled */
char * cdecl memccpy();
void * cdecl memchr();
int cdecl memcmp();
int cdecl memicmp();
void * cdecl memcpy();
void * cdecl memset();
void cdecl movedata();
char * cdecl strcat();
char * cdecl strchr();
int cdecl strcmp();
int cdecl strcmpi();
int cdecl stricmp();
char * cdecl strcpy();
size_t cdecl strcspn();
char * cdecl strdup();
char * cdecl strerror();
size_t cdecl strlen();
char * cdecl strlwr();
char * cdecl strncat();
int cdecl strncmp();
int cdecl strnicmp();
char * cdecl strncpy();
char * cdecl strnset();
char * cdecl strpbrk();
char * cdecl strrchr();
char * cdecl strrev();
char * cdecl strset();
size_t cdecl strspn();
char * cdecl strstr();
char * cdecl strtok();
char * cdecl strupr();
#else           /* extended keywords not enabled */
char *memccpy();
void *memchr();
void *memcpy();
void *memset();
void movedata();
char *strcat();
char *strchr();
char *strcpy();
char *strdup();
char *strerror();
char *strlwr();
char *strncat();
char *strncpy();
char *strnset();
char *strpbrk();
char *strrchr();
char *strrev();
char *strset();
char *strstr();
char *strtok();
char *strupr();
#endif  /* NO_EXT_KEYS */

#endif  /* LINT_ARGS */
