          TITLE  "SAVE/RESTORE THE CURRENT SCREEN BUFFER IN VIDEO I/O"
          PAGE   60,132
  ;
  ;   WRITTEN BY LYLE E. SMITH 9/10/86
  ;    PLACED IN THE PUBLIC DOMAIN
  ;
   PAGE   60,132
DATA      SEGMENT   WORD   PUBLIC   'DATA'
;
;   THE FOLLOWING SCREEN BUFFER WILL CAPTURE THE LOWER 4K OF
;   EITHER THE MONO OR COLOR VIDEO RAM.  THIS SHOULD ALLOW FOR
;   MOST PROGRAMS.  HOWEVER IF YOUR PROGRAM USES THE HIGHER ADDRESSES
;   YOU MAY NEED TO INCREASE THIS BUFFER.  I'M NOT SURE HOW MUCH DATA
;   SPACE THAT THE QB COMPILER WILL LET ME USE (NO DOC IN QB REF).
;   YOU WILL ALSO NEED TO INCREASE THE BYTE COUNT LOADED INTO THE
;   CX REGISTERS BEFORE THE REP MOVSB INSTRUCTION.
;
SCREEN    DB     4096 DUP(?)
SERVICE   DW     ?
MODE      DB     ?
CURSTR    DB     ?
CURSTP    DB     ?
CURCOL    DB     ?
CURROW    DB     ?
CURRPAGE  DB     ?
DATA      ENDS
  ;
DGROUP    GROUP     DATA

          PAGE
CODE      SEGMENT   BYTE   PUBLIC   'CODE'
          ASSUME    CS:CODE,DS:DGROUP
          PUBLIC    SVSCR
;
;  SVSCR PROGRAM CALLING METHOD IS
;     CALL SVSCR(X)   WHERE X IS AN INTEGER VALUE (VARIABLE OR CONSTANT)
;                     THE VALUE SHOULD BE EITHER 0 OR 1.
;     A 0 INDICATES TO SAVE THE CURRENT SCREEN/MODE TO THE INTERNAL
;     BUFFERS.
;     A 1 INDICATES TO RESTORE THE SCREEN/MODE FROM THE INTERNAL
;     BUFFERS.
;
SVSCR     PROC      FAR
          PUSH   BP
          MOV    BP,SP
          MOV    BX,6[BP]              ;GET ADDR OF PARM 0
          MOV    AX,[BX]               ;GET PARM TO AX
          MOV    SERVICE,AX            ;SAVE SERVICE PARM
          MOV    AX,SERVICE            ; GET SERVICE PARM
          DEC    AX                    ; CHECK FOR WHICH FUNCTION
          JZ     RESTORE               ;  WAS A 1 (NOW 0) RESTORE SCREEN
          PAGE
SAVE:
          MOV    AH,0FH                ; BIOS GET VIDEO MODE FUNC
          INT    10H                   ; GO BIOS
          MOV    MODE,AL               ; SAVE VIDEO MODE
          MOV    CURRPAGE,BH           ; SAVE CURRENT PAGE
          MOV    AH,03H                ; BIOS GET CURSOR INFO FUNC
          MOV    BH,CURRPAGE           ;  FOR CURRENT PAGE
          INT    10H                   ; GO BIOS
          MOV    CURSTR,CH             ;  SAVE CURSOR START SCAN LINE
          MOV    CURSTP,CL             ;  SAVE CURSOR STOP SCAN LINE
          MOV    CURROW,DH             ;  SAVE CURSOR POS ROW
          MOV    CURCOL,DL             ;  SAVE CURSOR POS COL
          MOV    CX,0B800H             ; DEFAULT VIDEO IS COLOR
          MOV    AL,MODE               ;  GET VIDEO MODE
          CMP    AL,07H                ; IS IT MODE 7 (MONO)
          JNE    CONT1                 ; NO IT'S COLOR CONTINUE
          MOV    CX,0B000H             ; SET VIDEO ADDR TO MONO
CONT1:
          PUSH   DS                    ; SAVE CURRENT DATA SEGMENT
          PUSH   CX                    ;  PUT VIDEO BASE ADDR ON STACK
          POP    DS                    ; PUT IN SOURCE SEGMENT REG
          POP    ES                    ; PUT DS IN ES FOR DEST
          XOR    DI,DI                 ; SHOW WHERE BUFFER STARTS
          XOR    SI,SI                 ; SOURCE IS AT START OF SCREEN
          MOV    CX,4096               ; SAVE 4K BYTES - BUFFER SIZE
          CLD                          ; CLEAR DIRECTION FLAG
   REP    MOVSB                        ; MOVE 4K BYTES
          PUSH   ES                    ; PUT DS TO STACK
          POP    DS                    ; RESTORE IT
          JMP    EXIT                  ;GO EXIT OUT
          PAGE
RESTORE:
          PUSH   DS                    ;SAVE DS
          XOR    AX,AX                 ; SET AX TO 0
          MOV    DS,AX                 ; SET DATA SEG TO 0
          MOV    AL,01H                ; VIDEO OFF
          MOV    DX,03D8H              ;SET VIDEO REG ADDR
          OUT    DX,AL                 ;TURN OFF VIDEO RAM
          POP    DS                    ; RESTORE DS
          MOV    AH,00H                ; BIOS SET VIDEO MODE FUNC
          MOV    AL,MODE               ;  SAVED MODE
          INT    10H                   ; GO BIOS
          MOV    AH,01H                ; BIOS SET CURSOR SIZE FUNC
          MOV    CH,CURSTR             ;  SAVED CURSOR START LINE
          MOV    CL,CURSTP             ;  SAVED CURSOR STOP LINE
          INT    10H                   ; GO BIOS
          MOV    AH,02H                ; BIOS SET CURSOR POSITION FUNC
          MOV    DH,CURROW             ;  SAVED CURSOR POS ROW
          MOV    DL,CURCOL             ;  SAVED CURSOR POS COL
          MOV    BH,CURRPAGE           ;  SAVED DISPLAY PAGE
          INT    10H                   ; GO BIOS
          MOV    CX,0B800H             ; DEFAULT VIDEO ADDR IS COLOR
          MOV    AL,MODE               ; GET SAVED MODE
          CMP    AL,07H                ; IS IT MONO?
          JNE    CONT2                 ; NO - COLOR - CONTINUE
          MOV    CX,0B000H             ; IT'S MONO SET VIDEO ADDR
CONT2:
          PUSH   CX                    ; SAVE ADDR OF VIDEO TO STACK
          POP    ES                    ; PUT IN DEST SEGMENT REG
          XOR    SI,SI                 ; SHOW ADDRESS OF BUFFER
          XOR    DI,DI                 ; SHOW START OF VIDEO SCREEN
          MOV    CX,4096               ; RESTORE 4K BYTES - BUFFER SIZE
          CLD                          ; CLEAR DIRECTION FLAG
   REP    MOVSB                        ; MOVE 4K BYTES
          PAGE
EXIT:     XOR    AX,AX                 ;ZAP AX TO ZERO
          PUSH   DS                    ; SAVE DS
          MOV    DS,AX                 ;SHOW ZERO SEGMENT AREA
          MOV    AL,29H                ;BYTE TO INDICATE VIDEO ON
          MOV    DX,03D8H              ;ADDRESS OF VIDEO REG
          OUT    DX,AL                 ;TURN VIDEO BACK ON
          POP    DS                    ;RESTORE THE REGS
          POP    BP                    ; RESTORE THE BP
          RET    2                     ;GO BACK - POP ONE ARG
SVSCR     ENDP
CODE      ENDS
          END
