
GDT_Fword  label Fword  ;this stuff goes into the GTDR register
    dw EndGDT-GDT       ;GDT size
b0  dw GDT,0            ;gets converted to linear address by InitBases

IDT_Fword  label Fword  ;this stuff goes into the ITDR register
    dw  EndIDT-IDT      ;IDT size
b1  dw  IDT,0           ;gets converted to linear address by InitBases

;-------------Global Descriptor Table
GDT  label byte
     dq  0     ;first is null descriptor

;MainTSS
     dw     EndMainTSS-MainTSS      ;limit bits (0..15)  limit of segment
b4   dw     MainTSS          ;base (0..15)  ;linear address start of segment
     db     0                ;base (16..23)
     db     89h              ;access        ;task, present DPL0
     db     0                ;granularity   ;byte
     db     0                ;base (24..31)
;TmpTSS
     dw     EndTmpTSS-TmpTSS ;limit bits (0..15)
b5   dw     TmpTSS           ;base (0..15)
     db     0                ;base (16..23)
     db     89h              ;access        ;task, present DPL0
     db     0                ;granularity
     db     0                ;base (24..31)
;flat_des                     this one can address all possible memory
     dw     0FFFFh           ;limit bits (0..15)
     dw     0                ;base (0..15)   starts at 0
     db     0                ;base (16..23)
     db     92h              ;access         present, DPL0, read/write
     db     0CFh             ;granularity    page granular
     db     0                ;base (24..31)
;real mode data descriptor    will look right when terminating protected mode
     dw     0FFFFh           ;limit bits (0..15)
     dw     0                ;base (0..15)   (don't care)
     db     0                ;base (16..23)
     db     92h              ;access         present, DPL0, read/write
     db     0                ;granularity    byte granular
     db     0                ;base (24..31)
;code  segment      (CODE_SEL)
     dw     CodeEnd          ;limit bits (0..15)
bmc0 dw     0                ;base (0..15)    starts at offset 0
     db     0                ;base (16..23)
     db     9Ah              ;access     readable code segment
     db     0                ;granularity  a **16** bit code segment
     db     0                ;base (24..31)
;data segment       (DATA_SEL)
     dw     DataEnd          ;limit bits (0..15)
bmd1 dw     0                ;base (0..15)
     db     0                ;base (16..23)
     db     92h              ;access   writeable data segment
     db     0                ;granularity
     db     0                ;base (24..31)
;FULL_TEXT_SEL     Same as CODE_SEL but with 64k limit
     dw     0FFFFh           ;limit bits (0..15)
FT1  dw     0                ;base (0..15)    starts at offset 0
     db     0                ;base (16..23)
     db     9Ah              ;access     readable code segment
     db     0                ;granularity  a **16** bit code segment
     db     0                ;base (24..31)
EndGDT  label byte

;-----------Interrupt Descriptor Table
IDT      label byte
     dq    256 dup(?)       ;filled in with interrupt gates by InitIDT

EndIDT   label byte

;-----------Tasks
;Define a structure for TSS's
TSSstruc struc
  BackLink dd 0    ;0
  ESP0 dd 0
  SS0  dd 0
  misc dd 0,0,0,0
  CR3x dd 0
  EIPx dd 0        ;5
  EFLx dd 0        ;6
  EAXx dd 0
  ECXx dd 0
  EDXx dd 0
  EBXx dd 0
  ESPx dd 0        ;11
  EBPx dd 0
  ESIx dd 0
  EDIx dd 0
  ESx dd 0
  CSx dd 0         ;16
  SSx dd 0
  DSx dd 0
  FSx dd 0
  GSx dd 0
  LDTx dd 0
  DebugTrap dw 0
  MapBase dw 0     ;23
TSSstruc EndS

MainTSS TSSstruc <, offset SupIntTos, DATA_SEL,,,offset BeginSupervisory,IOPLFL,,,,,Offset SupTos,,,,,CODE_SEL,DATA_SEL,,,,,,$+2-MainTSS>
     db     10000h/8 dup(0)  ;bitmap, all bytes 0--any i/o permitted in
                             ; virtual mode
     db     0ffh             ;byte for overread
EndMainTSS  label byte

TmpTSS TSSstruc <, , ,,,,,,,,,,,,,,,,,,,,,offset EndTmpTSS+2>
        ;point beyond this tss for no bitmap
     db     0ffh
EndTmpTSS  label byte

BaseCount label word     ;# items in table
     dw   (EndBaseTable -BaseTable) / 4
BaseTable   label word ;contains items to be converted to linear addresses
                       ;see InitBases
     dw   b0        ;b0 contains an offset
     dw   DGROUP    ;the real mode segment for b0
     dw   b1        ;etc.
     dw   DGROUP
     dw   b4
     dw   DGROUP
     dw   b5
     dw   DGROUP
     dw   bmc0
     dw   _TEXT
     dw   bmd1
     dw   DGROUP
     dw   Ft1
     dw   _TEXT
EndBaseTable  label word
