{ MPI - Multiple Precision Positive Integer Arithmetic Package   }
{ Copyright 1989, KSU Research Foundation, Manhattan KS  66506   }
{ License granted to copy, but not for sale or profit   }
 {test program in Turbo Pascal to interface to multiple precision positive}
 {integer arithmetic package}
 {$L mpiface}
 program turbtest;
    type
      register = array[0..31] of word;
      ctrlptr = ^ctrl;
      regptrtyp = ^register;
      ctrl = record
        operation: packed array[1..4] of char;  {4 character routine abbrev.}
        ptr1,ptr2: regptrtyp;  {arguments}
        ln1,ln2: word;  {arguments}
      end;
    var
      argsdescr,holddescr : ctrl;
      argsptr,holdptr : ctrlptr;
      onesreg,prodcopy : register;
      ones : packed array[1..10] of char;
      product : packed array[1..40] of char;
      regptr : regptrtyp;
      pc : char;
      i : byte;
    function mpiface(a: ctrlptr): ctrlptr;  external;
    function pptface(a: ctrlptr): char; external;
    begin
        ones := '111111111 ';
        argsptr := addr(argsdescr);
        holdptr := addr(holddescr);
          with argsptr^ do begin
{first, converting a blank-delimited string of ones to internal notation }
{the assembler routine expects everybody relative to the CS segment register,
  but PASCAL thinks its' stuff is relative to the DS segment register}
            ptr1 := addr(onesreg);
            ptr2 := addr(ones);
            operation := 'COND'
          end;
        argsptr := mpiface(argsptr);
          with argsptr^ do begin
{descriptor of internal representation of ones in ptr1 and ln1 of argsdescr now}
            ptr2 := ptr1;   {ones will be squared when it is used as }
            ln2 := ln1;   {both operands in a multiply operation }
            operation := 'MULT'
          end;
        argsptr := mpiface(argsptr);
 {we have to make a copy of this product to chain multiply it}
        regptr := argsptr^.ptr1;
        for i := 0 to argsptr^.ln1 do
        prodcopy[31-argsptr^.ln1+i] := regptr^[i];
          with argsptr^ do begin
            ptr1 := addr(prodcopy[31-argsptr^.ln1]);
            ptr2 := ptr1;   {ones will be raised to 4th power}
            ln2 := ln1;   {when this has been done }
            operation := 'MULT'
          end;
        argsptr := mpiface(argsptr);
 {we have to make a copy of this product to do probablistic primality test}
     {because the random number generator at start of probp.8s spoils MPIPR}
        regptr := argsptr^.ptr1;
        for i := 0 to argsptr^.ln1 do
        prodcopy[31-argsptr^.ln1+i] := regptr^[i];
 { but now that we have a copy in a safe place, .. }
 { since primality test doesn't destroy its argument, do that first}
          with argsptr^ do begin
            ptr1 := addr(prodcopy[31-argsptr^.ln1]);
            operation := 'PROB'        {define new operation}
          end;
        holddescr := argsdescr;
        pc := pptface(argsptr);              {pc holds 'P' or 'C' now}
          with holdptr^ do begin
            operation := 'CONB';
 {ptr1 and ln1 already contain descriptor of ones**4}
 { the value in the prodcopy register is still the same, so just reusing
 the descriptors will suffice }
            ptr2 := ptr1;
            ln2 := ln1;
            ptr1 := addr(product[40])
          end;
        product := '                                        ';
        argsptr := mpiface(holdptr);       {that established decimal string in product}
        writeln('111111111 ** 4 is: ',pc,' Value is: ',product)
    end.
