/****************************************************************************/
/* Prototype File                                Fri Oct 04 21:59:43 1991   */
/****************************************************************************/
#ifndef __T_PROTO_H
#define __T_PROTO_H

/*------------------------- Prototypes for T_BASE.C ------------------------*/
int base_at_cr( TUI *tuip, int inx, int col, int row);
void free_base( TUI *tuip, int inx );
void realloc_base( TUI *tuip, int n_alloc );
int add_base( TUI *tuip, int inx );
int del_base( TUI *tuip, int inx );
int free_tui( TUI *tuip );

/*------------------------- Prototypes for T_DLG.C  ------------------------*/
void clear_area( WINDOW *wnp, int x, int y, int width, int height );
void draw_shadow( WINDOW *wnp, TUI_BASE *basep );
void draw_box( WINDOW *wnp, TUI_BASE *basep );
int draw_square_text( WINDOW *wnp, TUI_BASE *basep, int len, uchar *text, int f_att, int f_pos );
void draw_button( WINDOW *wnp, TUI_BASE *basep );
void draw_check( WINDOW *wnp, TUI_BASE *basep );
void draw_input( WINDOW *wnp, TUI_BASE *basep );
void draw_slider( WINDOW *wnp, TUI_BASE *basep );
void draw_icon( WINDOW *wnp, TUI_BASE *basep );
void draw_base( WINDOW *wnp, TUI_BASE *basep );
int draw_item( TUI *tuip, int inx );
void refresh_base( WINDOW *wnp, TUI_BASE *basep );
void refresh_dialog( TUI *tuip, int inx );
int draw_dialog( TUI *tuip, int inx );
int erase_dialog( TUI *tuip, int inx );
void center_dialog( TUI *tuip, int inx );
void position_dialog( TUI *tuip, int inx, int col, int row );
void desel_radios( WINDOW *wnp, TUI_BASE *cmpp, TUI_BASE *basep, int cnt );
int process_input( WINDOW *wnp, TUI_BASE *basep, int mode, int *proc_mouse, int *proc_key );
void validate_slider( TUI_SLIDER *sldrp );
int process_slider( WINDOW *wnp, TUI_BASE *basep );
int process_btnchk( TUI_BASE *basep, WINDOW *wnp, TUI_BASE *dlgp, int num_in_dlg);
void wait_for_release( void );
int advance_tabs(TUI *tuip, int inx, WINDOW *wnp, int num_in_dlg, int num_with_tab,
						 int key, int *tab_inx);
int do_dialog( TUI *tuip, int inx, int mode );

/*------------------------- Prototypes for T_FSEL.C ------------------------*/
int getdisk( void );
int setdisk(int drive);
long datetol( TUI_FILE_DATE *date );
void get_curr_path( char *path );
int remove_lastdir(char *d);
int cmp_dir_name( const void *p1, const void *p2 );
int cmp_dir_ext( const void *p1, const void *p2 );
int cmp_dir_size( const void *p1, const void *p2 );
int cmp_dir_datetime( const void *p1, const void *p2 );
void sort_directory(TUI_DIR *dir_array, int num, int sort_type);
void split_fn_ext( char *n, char *f, char *s);
void merge_fn_ext( char *n, char *f, char *s);
int directory_read(char *path, char *wildcard, TUI_DIR *dir_array, int *num );
void make_path_plus( char *dest, char *path, char *name );
void split_path( char *path_plus, char *path, char *wildcard );
void make_filesel_strs( int num, TUI_DIR *dir_array, char *str_buffer );
int file_selected( char *wildcard, char *path, char *filename, char *fullname );
void validate_offset( int csr, int h, int *offset );
int ffirst( char *p, TUI_FBLK *fblk, int mode );
int fnext( TUI_FBLK *fblk );

/*------------------------- Prototypes for T_UTIL.C ------------------------*/
int file_exists( char *fname );
void set_slider( TUI *tuip, int inx, long position, long page_amt, long total );
void set_base_btn_text( TUI_BASE *basep, char *new_text );
void set_base_check_text( TUI_BASE *basep, char *new_text );
void set_base_input_strs( TUI_BASE *basep, char *text, char *mask, char *tplt );

/*------------------------- Prototypes for T_HELP.C ------------------------*/
int tui_help( int sx, int sy, int ex, int ey, char *fname, char *search_str, int mode );
int browse( TUI_HELP *help );
void cleanup( TUI_HELP *help );
void remove_commands(char *s, char *d);
char *itoa4( int val );
int get_line(int fid, uchar *d, int max_len);
int find_color(char *s);
char *get_token( char *s, char *d, char delim, int mode );
int find_word( char *word, int curr_col, int *col, char *lines[], int num_lines, int dir, int mode );
int fast_find( char *word, char *lines[], int num_lines, int skip_line );
char *mystrstr( char *s, char *w, int mode, int skip );
void mystrupr( char *s, char *d );
int cvt_tabs_to_spaces( char *s, int *text_len, int tab_size );
int get_font( char *fname, int block );
int auto_repeat(ulong tm);

/*------------------------- Prototypes for T_INIT.C ------------------------*/
void default_font( int block );
int init_tui_fonts( TUI *tuip );
int init_tui( TUI *tuip );
void end_tui( TUI *tuip );

/*------------------------- Prototypes for T_ADD.C  ------------------------*/
void set_base_parms( TUI_BASE *basep, int type, int hot_key, uint flags,
		 int transfer, int x_off, int y_off, int width, int height, int style );
int add_dialog( TUI *tuip, uint flags, int x_off, int y_off, int width, int height,
						int att, int bdr_att, int style );
int add_box( TUI *tuip, int hot_key, uint flags, int transfer, int x_off,
				 int y_off, int width, int height, int att, int style );
int add_button( TUI *tuip, int hot_key, uint flags, int transfer, int x_off,
						int y_off, int width, int height, int style, int norm_att,
						int norm_f_att, int sel_att, int sel_f_att, int tab_color,
						int first_pos, char *text );
int add_check( TUI *tuip, int hot_key, uint flags, int transfer, int x_off,
					 int y_off, int width, int height, int style, int norm_att,
					 int norm_f_att, int tab_color, int mark_pos, uchar mark_char,
					 int first_pos, char *text );
int add_input( TUI *tuip, int hot_key, uint flags, int transfer, int x_off,
					 int y_off, int width, int height, int style, int norm_att,
					 int tab_color, uint input_flags, char *text, char *mask, char *tplt );
int add_slider( TUI *tuip, uint flags, int transfer, int x_off, int y_off,
						int width, int height, int style, int arrow_att, int track_att,
						int grab_att, uchar *slider_chars );
int add_icon( TUI *tuip, int hot_key, uint flags, int transfer, int x_off,
					int y_off, int width, int height, int style, int norm_att,
					int sel_att, int tab_color, uchar *images );
void set_tui_parenting( TUI *tuip );
int set_base_parent( TUI *tuip, int inx );

/*------------------------- Prototypes for T_SAVE.C ------------------------*/
int save_tui( TUI *tuip, char *fname );

/*------------------------- Prototypes for T_LOAD.C ------------------------*/
int load_tui( TUI *tuip, char *fname );
int load_tui_ll( TUI *tuip, char *fname );

/*------------------------- Prototypes for T_FSELT.C -----------------------*/
int register_fsel_tui( TUI *tuip );
void register_fsel_dlg0( TUI *tuip );

/*------------------------- Prototypes for T_HELPT.C -----------------------*/
int  register_help_tui( TUI *tuip );
void register_help_dlg0( TUI *tuip );
void register_help_dlg1( TUI *tuip );

/*-------------------------- Prototypes for T_DBG.C ------------------------*/
#if ( defined(ENQ_DEBUG) || defined(SOURCE_TRACE) )
int tui_vld( char *s, int mode, int i, TUI *tp );
int tui_base_vld( char *s, int mode, TUI_BASE *tbp );
WINDOW *get_dlg_wnp(TUI *tp, int i);
int get_item_type(TUI *tp, int i);
int get_item_x(TUI *tp, int i);
int get_item_y(TUI *tp, int i);
int get_item_w(TUI *tp, int i);
int get_item_h(TUI *tp, int i);
int get_box_att(TUI *tp, int i);
long get_sldr_pos(TUI *tp, int i);
char *get_str_text(TUI *tp, int i);
char *get_btn_text(TUI *tp, int i);
int get_btn_att(TUI *tp, int i);
int get_btn_sel_att(TUI *tp,int i);
char *get_check_text(TUI *tp, int i);
char *get_inp_text(TUI *tp, int i);
char *get_inp_mask(TUI *tp, int i);
char *get_inp_tplt(TUI *tp, int i);
void set_item_x(TUI *tp, int i, int x);
void set_item_y(TUI *tp, int i, int y);
void set_item_w(TUI *tp, int i, int w);
void set_item_h(TUI *tp, int i, int h);
void set_box_att(TUI *tp, int i, int att);
void set_btn_att(TUI *tp, int i, int att);
void set_btn_sel_att(TUI *tp, int i, int att);
void set_sldr_pos(TUI *tp, int i, long sval);
void set_btn_text(TUI *tp, int i, char *s);
void set_str_text(TUI *tp, int i, char *s);
void set_inp_strs(TUI *tp, int i, char *t, char *m, char *p);
int is_valid_inx(TUI *tp, int i);
int is_selected(TUI *tp, int i);
int is_tabbed(TUI *tp, int i);
int is_enabled(TUI *tp, int i);
void select(TUI *tp, int i);
void deselect(TUI *tp, int i);
void tab(TUI *tp, int i);
void detab(TUI *tp, int i);
void enable_item(TUI *tp, int i);
void disable_item(TUI *tp, int i);
#endif

#endif /* __T_PROTO_H */

/**** END OF FILE ****/
