'=======================================================================
' Copyright Copr. (C) 1991, Sidney J. Kelly, All rights reserved
' This makes Horizontal Menus that use a Keyboard, Quick letters & Mouse
'
' The LEFT click of the Mouse selects the item.
' The right Button% drag is equivalent to moving arrow keys.
' Right Click outside menu window = ESC
' HOME, END, PAGEUP, PAGEDOWN = a quick selection of Top & Bottom item
'
' Invalid extended keys "chirp" to report an error
'
' Updated 10/22/91
'=======================================================================
DEFINT A-Z
REM $INCLUDE: 'VERTM.INC'

'Does Horizontal Menus
DECLARE SUB HorizMenu (Init%, HorizMenuChange%, RetValue%)
'Initialize the Array of Messages
DECLARE SUB InitHArray (Msg%, HorMenu() AS HorizMType)
'Prints the Menu
DECLARE SUB PrintHArray (HorMenu() AS HorizMType)
'This checks to determine if Mouse in is a box
DECLARE SUB HMouseCK (Col%, MenuSelect%, ErrVal%, MenuItems%, HorMenu() AS HorizMType)
'Displays a help menu
DECLARE SUB HelpMenu (Msg%, Init%, HorizMenuChange%)

'============================================================================
'Chooses the actual menu and allows for gaps in number and allow some
'overshooting too.
'Input:
'    Col% = current column number of mouse
'       MenuItems% = number of items in the Menu, prevents Subsript Out of Range
'                   ERR = 9 errors
'       HorMenu() = Array of HorizMType
'Returns:
'       ErrVal% = Mouse out of range of a menu item
'       MenuSelect% = Value of menu item selected
'
' This is a generic rouine for Horizontal menus
'============================================================================
SUB HMouseCK (Col%, MenuSelect%, ErrVal%, MenuItems%, HorMenu() AS HorizMType) STATIC
	
	'reset value
	ErrVal% = 0                  'used w/ left click to see if out of range

	SELECT CASE MenuItems%
		CASE ELSE
		SELECT CASE Col%
			CASE (HorMenu(1).LCol - 1) TO (HorMenu(1).LCol + HorizMenLen%)
					MenuSelect% = 1
			CASE (HorMenu(2).LCol - 1) TO (HorMenu(2).LCol + HorizMenLen%)
					MenuSelect% = 2
			CASE (HorMenu(3).LCol - 1) TO (HorMenu(3).LCol + HorizMenLen%)
					MenuSelect% = 3
			CASE (HorMenu(4).LCol - 1) TO (HorMenu(4).LCol + HorizMenLen%)
					MenuSelect% = 4
			CASE (HorMenu(5).LCol - 1) TO (HorMenu(5).LCol + HorizMenLen%)
					MenuSelect% = 5
			CASE (HorMenu(6).LCol - 1) TO (HorMenu(6).LCol + HorizMenLen%)
					MenuSelect% = 6
			CASE ELSE
					ErrVal% = -1    'report back left click got nothing
		END SELECT
	'add rest of list here if add more menus

	END SELECT

END SUB

'============================================================================
' This makes Horizontal Menus
' This is the Main Menu
' Input:
'      Init% = 0 if want to reinitialize menu
' Returns:
'      RetValue% = 0 if ESC,
'
'In this routine
'                  a LEFT Button% press selects
'                 a RIGHT Button% press =  an arrow key if inside menu
'                         area
'                 a RIGHT Button% release outside menu area = ESC key
'                 a RIGHT Button% drag = moving arrow key
'Mouse presses are tested before keystrokes.
'Use MMPRESSLOCATE because it acts as a buffer and holds most recent
'mouse presses.  If we just check for a Button% down, it may happen and
'be finished before we can check for it in the loop.
'This is a generic routine
' Updated 1/25/91
'============================================================================
SUB HorizMenu (Init%, HorizMenuChange%, RetValue%) STATIC

'Menu information
STATIC ULR%, ULC%, LRR%, LRC%, MenuItems%
'Mouse variables
STATIC Row, Col%, Times, Button%, Hidden%
'selecting variables
STATIC OldValue, ChoiceLetter$, MenuSelect%, BeginCol%, KeyPressed
STATIC Inits%, MWidth%


 'Can only dimension the arrays one time
 IF Inits% = 0 THEN
	
	REM $DYNAMIC
	DIM HorMenu(1 TO HMenuEntries) AS HorizMType
	REM $STATIC

	'Set Horizontal Windows Variables Menus
	WINDOWS(5).ULR = 1
	WINDOWS(5).ULC = 1
	WINDOWS(5).LRR = WINDOWS(5).ULR
	WINDOWS(5).LRC = 80
	WINDOWS(5).MaxMenNum = 6
 END IF
	Inits% = -1

 IF Init% = 0 THEN
	'Initialize the Menu
	CALL InitHArray(Msg%, HorMenu())

	'Get the basic dimensions of the outside box
	ULR% = WINDOWS(5).ULR
	ULC% = WINDOWS(5).ULC
	LRR% = WINDOWS(5).LRR
	LRC% = WINDOWS(5).LRC
	MenuItems% = WINDOWS(5).MaxMenNum
	MWidth% = HorizMenLen% + 1 'width of box cursor

	'Make the choice letter string
	ChoiceLetter$ = SPACE$(MenuItems%)
	FOR x = 1 TO MenuItems%
		MID$(ChoiceLetter$, x) = HorMenu(x).KeyLet
	NEXT

	'Make sure we have a beginning location
	MenuSelect% = 1
	'Print the array
	CALL PrintHArray(HorMenu())
	GOSUB InitCursor     'if first time through

 ELSE
	
	'This allows Vertical Menu to affect Horizontal Menu
	'but only if Init% <> 0
	IF HorizMenuChange% < 0 THEN
		SELECT CASE HorizMenuChange%
			CASE -1
				MenuSelect% = MenuSelect% - 1
			CASE -2
				MenuSelect% = MenuSelect% + 1
			CASE -3
				 CALL MMLOCATE(Row%, Col%)
				 IF (Row = ULR%) THEN
					'This figures out which box was selected
					CALL HMouseCK(Col%, MenuSelect%, ErrVal%, MenuItems%, HorMenu())
					GOSUB ReDoCursor     'display box cursor
					IF ErrVal% GOTO ReStartHoriz
					RetValue% = MenuSelect%
					GOTO Ender
				 END IF
			CASE ELSE
		END SELECT
		GOSUB PositionChk  'keep w/in range
		GOSUB ReDoCursor   'hilight KeyPressed
		RetValue% = MenuSelect%
		GOTO Ender
	END IF
 END IF
 Init% = True
 
 'keep w/in range
 GOSUB PositionChk    'keep cursor w/in range
 GOSUB ReDoCursor     'if moved, display box cursor

 'Resets mode if ESC had been last selection
 IF Hidden THEN
	GOSUB InitCursor      'turn box back on
	Hidden = 0            'clear Hidden Variable
 END IF


 'Clears keyboard and mouse for testing
  CALL CLRMOUSEKEY

DO
	DO 'keep reading keystrokes

ReStartHoriz:
		'Read a key from the buffer.  Normal key is positive,
		'extended key is negative, no key = -256
		'Function reads normal and extended keyboards
		KeyPressed% = WAITFORKEY
	
		'skip the following if no mouse, for speed reasons
		IF NoMouse% GOTO SkipMouseSection


		Button% = 0 'Check for LEFT Button% Press
		CALL MMPRESSLOCATE(Button%, Times%, Row%, Col%)
		IF Times THEN  'Got a LEFT Button% press
			IF Row = WINDOWS(7).ULR THEN
				SELECT CASE Col% 'Puts up a help routine
					CASE WINDOWS(7).ULC TO WINDOWS(7).LRC
						SELECT CASE MenuSelect%
							CASE 6     'put up full help menu
								Msg2% = 6
							CASE ELSE  'get the normal horizontal help menu
								Msg2% = 10
						END SELECT
						Init2 = 0:
						CALL HelpMenu(Msg2%, Init2%, HorizMenuChange%)
					CASE ELSE
				END SELECT
			END IF
			'Check if Mouse is within range
			IF (Row = ULR%) THEN
					'This figures out which box was selected
					CALL HMouseCK(Col%, MenuSelect%, ErrVal%, MenuItems%, HorMenu())
					GOSUB ReDoCursor     'display box cursor
					IF ErrVal% GOTO ReStartHoriz
					RetValue% = MenuSelect%
					GOTO Ender
			END IF
		END IF

		Button% = 1 'Check for RIGHT Button% press
		CALL MMPRESSLOCATE(Button%, Times%, Row%, Col%)
		IF Times THEN   'Got a RIGHT Button% press
		'Check if Mouse is within range
			IF (Row = ULR%) THEN
					'This figures out which box was selected
					CALL HMouseCK(Col%, MenuSelect%, ErrVal%, MenuItems%, HorMenu())
					GOSUB ReDoCursor
					GOTO ReStartHoriz  'restart loop
			END IF
		END IF

		'Test if RIGHT Button% being dragged directly over a menu item
		'if yes, then cycle left or right on menu
		'Can't test for LEFT Button% down, as MMPRESSLOCATE gets it
		IF MMRIGHTBUT% THEN   'see if Button% is down
			CALL MMLOCATE(Row%, Col%)
		'Check if Mouse is within range (allow a little overshooting)
			IF Row = ULR% THEN
					'This figures out which box was selected
					CALL HMouseCK(Col%, MenuSelect%, ErrVal%, MenuItems%, HorMenu())
					GOSUB ReDoCursor
					GOTO ReStartHoriz
			END IF
		END IF

	   'Test if RIGHT Button% released outside menu area
	   'if yes, then exit as if ESC key were pressed
	   Button% = 1 'Check for RIGHT Button% release
	   CALL MMRELEASELOCATE(Button%, Times%, Row%, Col%)
	   IF Times THEN
		   'Check if Mouse is outside range
		   IF (Row > ULR% + 1) OR (Row < ULR% - 1) THEN
				MenuSelect% = 1
				GOSUB ReDoCursor
				RetValue% = 0     'return ESC
				HorizMenuChange% = 0
				Hidden = 1
				GOSUB InitCursor
				GOTO Ender         'quit
		   END IF
	   END IF

SkipMouseSection:                 'we get here if no mouse found

	'we do not check for actual key until finished checking mouse
	'keep looping until something happens
	LOOP UNTIL KeyPressed% <> -256

	SELECT CASE KeyPressed%     'Act on keystrokes
		CASE -&H4B, -&HF  'Cursor Left, Shift Tab
			MenuSelect% = MenuSelect% - 1
			GOSUB PositionChk
		CASE -&H4D, 9     'Cursor Right, Tab
			MenuSelect% = MenuSelect% + 1
			GOSUB PositionChk
		CASE 27 'Escape key only
			MenuSelect% = 1
			GOSUB ReDoCursor
			RetValue% = 0     'return ESC
			HorizMenuChange% = 0
			Hidden = 1
			GOSUB InitCursor
			GOTO Ender         'quit
		'Return key, Down Arrow, Page Down, End
		CASE 13, -&H50, -&H4F, -&H51
			GOSUB ReDoCursor   'hilight KeyPressed
			RetValue% = MenuSelect%
			GOTO Ender
		CASE 65 TO 90, 97 TO 122 'only look for alpha keys
			'capitalize lower case and make it a string
			MID$(Choice$, 1) = CHR$(KeyPressed% AND &HDF)
			Temp% = INSTR(ChoiceLetter$, Choice$)
			IF Temp% THEN
				MenuSelect% = Temp%
				GOSUB ReDoCursor  'hilight KeyPressed
				RetValue% = Temp%
				GOTO Ender
			END IF
		CASE -&H3B    'F-1 key pressed
			'Puts up a help routine
			SELECT CASE MenuSelect%
				CASE 6     'put up full help menu
					Msg2% = 6
				CASE ELSE  'get the normal horizontal help menu
					Msg2% = 10
			END SELECT
			Init2 = 0:
			CALL HelpMenu(Msg2%, Init2%, HorizMenuChange%)
		CASE ELSE   'Some other key
			'make a chirp sound w/o using floating point numbers
			 CALL BEEPER10
			 CALL BEEPER20

			'Ignore key repeat & clear keyboard buffer
			'let the users lean on the keyboard if they desire
			CALL CLRKBD
	END SELECT

	'highlight cursor again for next time through loop
	GOSUB ReDoCursor
 LOOP  'end of primary loop

Ender:             'Common Exit Section

EXIT SUB

'-------------------GOSUB area

ReDoCursor:
	'we exit if no change in vertical position
	'this speeds up display on a CGA
	IF OldValue = MenuSelect% THEN RETURN

	'restore old item
	BeginCol% = HorMenu(OldValue).LCol - 1
	CALL REVVID(ULR%, BeginCol%, MWidth% + 1)

InitCursor:           'Entry point first time through
	'do new item
	BeginCol% = HorMenu(MenuSelect%).LCol - 1
	CALL REVVID(ULR%, BeginCol%, MWidth% + 1)
	OldValue = MenuSelect%
	RETURN

'Keep Cursor within range of menu
PositionChk:
	SELECT CASE MenuSelect%
		CASE IS > MenuItems%
			MenuSelect% = 1
		CASE IS <= 0
			MenuSelect% = MenuItems%
		CASE ELSE
	END SELECT
	RETURN


END SUB

'============================================================================
'This selects the Main Data array
'Input:
'      Msg% = Selection of Messages you desire
'============================================================================
SUB InitHArray (Msg%, HorMenu() AS HorizMType)

SELECT CASE Msg%
	'Put other menus here

	'All positions are relative to initial coordinates
	CASE ELSE
	HorMenu(1).Menu = "File "
	HorMenu(1).LCol = 5
	HorMenu(1).KeyLet = "F"

	HorMenu(2).Menu = "Edit "
	HorMenu(2).LCol = HorMenu(1).LCol + HorizMenLen% + 2
	HorMenu(2).KeyLet = "E"

	HorMenu(3).Menu = "View"
	HorMenu(3).LCol = HorMenu(2).LCol + HorizMenLen% + 2
	HorMenu(3).KeyLet = "V"

	HorMenu(4).Menu = "Search"
	HorMenu(4).LCol = HorMenu(3).LCol + HorizMenLen% + 2
	HorMenu(4).KeyLet = "S"

	HorMenu(5).Menu = "Run"
	HorMenu(5).LCol = HorMenu(4).LCol + HorizMenLen% + 2
	HorMenu(5).KeyLet = "R"

	HorMenu(6).Menu = "Help"
	HorMenu(6).LCol = 72         'This shows an example of skip
	HorMenu(6).KeyLet = "H"
END SELECT

END SUB

'==========================================================================
'This prints a Horizontal Menu
'Routine assumes that Menu will take up whole 80 Col% Row
'==========================================================================
SUB PrintHArray (HorMenu() AS HorizMType)

STATIC ULR%, ULC%, MenuItems%, HiLite%, x%

	'Get the basic demensions of the outside box
	ULR% = WINDOWS(5).ULR
	ULC% = WINDOWS(5).ULC
	LRR% = WINDOWS(5).LRR
	LRC% = WINDOWS(5).LRC
	MenuItems% = WINDOWS(5).MaxMenNum

	'Turn mouse cursor off, because BACKFILL does not
	CALL MMCURSOFF
	'clear to Black characters on White background
	'this works best for all types of CRT's
	CALL BACKFILL(ULR%, ULC%, LRR%, LRC%, &H70, 32)

	CALL MMCURSON
	'have to have black background if want to use intense w/ LCD display
	IF ColorMode% THEN
		HiLite% = &HC    'black background w/ intense red foreground
	ELSE
		HiLite% = &HF    'black background w/ intense white foreground
	END IF

	'this prints the menu and hilites the character
	FOR x = 1 TO MenuItems%
		CALL QPRT(ULR%, HorMenu(x).LCol, HorMenu(x).Menu)
		CALL QPRINT(ULR%, HorMenu(x).LCol, HorMenu(x).KeyLet, HiLite%)
	NEXT

END SUB

