'=======================================================================
' Copyright Copr. (C) 1991, Sidney J. Kelly, All rights reserved
' This makes Dialog Boxes that use a Keyboard, Quick letters & Mouse
'
' The LEFT click of the Mouse selects the item.
' The right Button% drag is equivalent to moving arrow keys.
' Right Click outside menu window = ESC
' HOME, END, PAGEUP, PAGEDOWN = a quick selection of Top & Bottom item
'
' F1- key = Local Help, somewhat context sensitive
'
' Updated 10/22/91
'=======================================================================
DEFINT A-Z
REM $INCLUDE: 'VERTM.INC'

'Initialize the Array of Messages
DECLARE SUB InitDArray (Msg%, DMenu() AS DialogType)

'-----------From other modules
'Selects the Border% Elements based on KeyPressed of Border%
'Listed by Border% Number
     'No Border                                       =Border  0
     'Double Line Border% (the default for CASE else) =Border% 1
     'Single Line Border%                             =Border% 2
     'Double Horizontal Single Vertical Border%       =Border% 3
     'Double Vertical Single Horizontal Border%       =Border% 4
     'Solid Border%                                   =Border% 5
     'Double Line Border for Dialog Box               =Border% 6
'add OR 256 if want a background shadow
DECLARE SUB NormalWindow (ULR%, ULC%, LRR%, LRC%, Attr%, Border%, Label$)

'Prints help menu
DECLARE SUB HelpMenu (Msg%, Init%, HorizMenuChange%)

'======================================================================
'Draws a Dialog Window
'This Dialog box currently designed to handle only 2 Dialog choice boxes
'
' Left click on the box causes an exit
' Right click in a box selects the box
' Right click outside the menu area = ESC and exit routine
'
'Input:
'     Msg% = Number of Message
'     Init% = If 0 then reinitialize ChoiceLetter$
'     Attr% = Color
'
'Output:
'     RetValue% = Return value
'
'This is a specialized routine for 2 box Dialog boxes
'======================================================================
SUB DialogMenu (Msg%, Init%, Attr%, RetValue%) STATIC

STATIC SelColr, UnSelColr, OldValue, ChoiceLetter$
STATIC ULR, ULC, LRR, LRC, MenuItems%
STATIC LColr, RColr

'Mouse variables
STATIC Row, Col%, Times, Button%, Inits%
STATIC MMTRow, MMBRow, Box1L, Box2L, Box1R, Box2R

'Can only dimension the arrays one time
'Inits% is used to make sure we do this only once in entire program
IF Inits% = False THEN
     REM $DYNAMIC
     DIM DMenu(1 TO DialogEntries%) AS DialogType
     REM $STATIC
    
     'Set Dialog Box Variables DMenu
     WINDOWS(4).ULR = 10
     WINDOWS(4).ULC = 31
     WINDOWS(4).LRR = WINDOWS(4).ULR + 5    'DialogStrg%
     WINDOWS(4).LRC = WINDOWS(4).ULC + (DialogStrg% * 2) + 10
     WINDOWS(4).MaxMenNum = DialogEntries%
END IF
     Inits% = True

IF Init% = False THEN
     CALL InitDArray(Msg%, DMenu())
     ChoiceLetter$ = SPACE$(WINDOWS(4).MaxMenNum)
     MID$(ChoiceLetter$, 1) = DMenu(1).LKey
     MID$(ChoiceLetter$, 2) = DMenu(1).RKey
END IF
     Init% = True

     'Get the basic demensions of the outside box
     ULR = WINDOWS(4).ULR
     ULC = WINDOWS(4).ULC
     LRR = WINDOWS(4).LRR
     LRC = WINDOWS(4).LRC
     MenuItems% = WINDOWS(4).MaxMenNum
    
     'Save background area
     x% = (LRR - ULR + 2) * (LRC - ULC + 3)
     DIM Scrn3%(x%)
    
     'Save the background -- while allowing for the shadow
     CALL WINDSAVE(ULR%, ULC%, LRR% + 1, LRC% + 2, VARSEG(Scrn3%(0)), VARPTR(Scrn3%(0)))

     'Select Colors, given the unhighlighted color
     SelColr = (Attr% \ 16) + 8:  UnSelColr = Attr%
    
     'Draw Main Box
     Border% = 1 OR 256
     CALL KILLSTRING(Label$)  'delete Temp% string
     CALL NormalWindow(ULR%, ULC%, LRR%, LRC%, UnSelColr, Border%, Label$)

     'Draw Top Msg%
     CALL QPRT(DMenu(1).TRow, DMenu(1).TCol, DMenu(1).TMenu)
     'Draw Left  Msg%
     CALL QPRT(DMenu(1).LRow, DMenu(1).LCol, DMenu(1).LMenu)
     'Draw Right Msg%
     CALL QPRT(DMenu(1).RRow, DMenu(1).RCol, DMenu(1).RMenu)

     'Temporary variables outside the loop for speed purposes
     MMTRow = DMenu(1).LRow - 1    'Top of box
     MMBRow = DMenu(1).LRow + 1    'Bottom of Box
     Box1L = DMenu(1).LCol         'Left margin of Left Box
     Box2L = DMenu(1).RCol         'Left margin of Right Box
     Box1R = Box1L + DialogStrg%   'Right margin of Left Box
     Box2R = Box2L + DialogStrg%   'Right margin of Right Box

     OldValue = 0
     MenuSelect% = 1
     GOSUB ReDoBox

'Clears keyboard and mouse for testing
'keeps stale keystrokes and mouse presses from prematurely affecting
'the loop
 CALL CLRMOUSEKEY

'--------------Start of Main Loop-----------------------------------
DO     'Main loop keep adjusting box cursor until leave routine
     DO 'keep reading keystrokes
   
ReStart1:
          'Function reads normal and extended keyboards
          'Read a key from the buffer: normal key is positive
          'extended key is negative, & no key = -256
          KeyPressed% = WAITFORKEY
        
          'skip the following if no mouse, for speed reasons
          IF NoMouse% GOTO SkipMouseSection1

          IF MMLEFTBUT% THEN   'see if left Button% is down
               CALL MMLOCATE(Row%, Col%)
               IF Row = WINDOWS(7).ULR THEN
                    SELECT CASE Col%       'Puts up a help routine
                         CASE WINDOWS(7).ULC TO WINDOWS(7).LRC
                              Init2 = 0: Msg2% = 9
                              CALL HelpMenu(Msg2%, Init2%, HorizMenuChange%)
                          CASE ELSE
                    END SELECT
               END IF
               IF (Row >= MMTRow) AND (Row <= MMBRow) THEN
                    SELECT CASE Col%
                         CASE Box1L TO Box1R
                              MenuSelect% = 1
                              GOSUB ReDoBox
                              GOTO Ender
                         CASE Box2L TO Box2R
                              MenuSelect% = 2
                              GOSUB ReDoBox
                              GOTO Ender
                         CASE ELSE
                              'do nothing, not in range
                    END SELECT
               END IF
          END IF

          IF MMRIGHTBUT% THEN   'see if right Button% is down
               CALL MMLOCATE(Row%, Col%)
               IF (Row >= MMTRow) AND (Row <= MMBRow) THEN
                    SELECT CASE Col%
                         CASE Box1L TO Box1R
                              MenuSelect% = 1
                              GOSUB ReDoBox
                         CASE Box2L TO Box2R
                              MenuSelect% = 2
                              GOSUB ReDoBox
                         CASE ELSE
                              'do nothing, not in range
                    END SELECT
               END IF
          END IF

       
        'Test if RIGHT Button% released outside menu area
        'if yes, then exit as if ESC key were pressed
        Button% = 1 'Check for RIGHT Button% release
        CALL MMRELEASELOCATE(Button%, Times%, Row%, Col%)
        IF Times THEN
               IF (Row < ULR) OR (Row > LRR) THEN
                    MenuSelect% = 0
                    GOTO Ender
               END IF
               IF (Col% < ULC) OR (Col% > LRC) THEN
                    MenuSelect% = 0
                    GOTO Ender
               END IF
        END IF

SkipMouseSection1:                 'we get here if no mouse found
 
     'we do not check for actual key until finished checking mouse
     'keep looping until something happens
     LOOP UNTIL KeyPressed% <> -256

     'Reset the reverse video cursor
     'in case we are shifting left or right on menu item
     GOSUB ReDoBox

     SELECT CASE KeyPressed%     'Act on keystrokes
          CASE -&H4B, -15   'Cursor Left, Shift Tab
               MenuSelect% = MenuSelect% - 1
               GOSUB PositionChk
          CASE -&H4D, 9     'Cursor Right, Tab
               MenuSelect% = MenuSelect% + 1
               GOSUB PositionChk
          CASE 27 'Escape key only
               MenuSelect% = 0
               GOTO Ender
          CASE 13 'Return key
               GOSUB ReDoBox  'hilight KeyPressed
               GOTO Ender
          CASE 65 TO 90, 97 TO 122 'only look for alpha keys
               'capitalize lower case and make it a string
               MID$(Choice$, 1) = CHR$(KeyPressed% AND &HDF)
               Temp% = INSTR(ChoiceLetter$, Choice$)
               IF Temp% THEN
                    MenuSelect% = Temp%
                    GOSUB ReDoBox  'hilight KeyPressed
                    GOTO Ender
               END IF
          CASE -&H3B    'F-1 key pressed
               'Puts up a help routine
               Init2 = 0: Msg2% = 9
               CALL HelpMenu(Msg2%, Init2%, HorizMenuChange%)
          CASE ELSE   'Some other key
               'do nothing
     END SELECT

     'highlight cursor again for next time through loop
     GOSUB ReDoBox
 LOOP  'end of primary loop

Ender:             'Common Exit Section
     RetValue% = MenuSelect%
   
     'restore the window
     CALL WINDREST(ULR%, ULC%, LRR% + 1, LRC% + 2, VARSEG(Scrn3%(0)), VARPTR(Scrn3%(0)))
     'erase the window so can redimension it again
     ERASE Scrn3%
EXIT SUB

'---------------------------GOSUB Routines-------------------------
'This highlites a box "cursor" by flipping display
ReDoBox:
     Border% = 6        'ReDraw Left Prompt & Right Prompt
     CALL KILLSTRING(Label$)   'delete Temp% string

     IF OldValue = MenuSelect% THEN RETURN

     SELECT CASE MenuSelect%
          CASE 1
               LColr = SelColr%
               RColr = UnSelColr%
          CASE 2
               LColr = UnSelColr%
               RColr = SelColr%
     END SELECT
     'Draw the boxes
     CALL NormalWindow(DMenu(1).LRow - 1, DMenu(1).LCol - 1, DMenu(1).LRow + 1, DMenu(1).LCol + LEN(DMenu(1).LMenu) + 1, LColr, Border%, Label$)
     CALL NormalWindow(DMenu(1).RRow - 1, DMenu(1).RCol - 1, DMenu(1).RRow + 1, DMenu(1).RCol + LEN(DMenu(1).RMenu) + 1, RColr, Border%, Label$)
     OldValue = MenuSelect%
 RETURN

'Keep Cursor within range of menu
PositionChk:
     SELECT CASE MenuSelect%
          CASE IS > MenuItems%
               MenuSelect% = 1
          CASE IS <= 0
               MenuSelect% = MenuItems%
          CASE ELSE
     END SELECT
RETURN

END SUB

'=======================================================================
' This initialize the dialog box menus
' Only purpose is to make program modular and allow several different
' Arrays of Dialog boxes to be kept around
'=======================================================================
SUB InitDArray (Msg%, DMenu() AS DialogType)

SELECT CASE Msg%
     'Dialog Box Entries
    
     'All positions are relative to initial coordinates
     CASE 1
          'Normal Version
          DMenu(1).TMenu = "Are you Sure?"
          DMenu(1).TRow = WINDOWS(4).ULR + 1
          DMenu(1).TCol = WINDOWS(4).ULC + 5
          DMenu(1).LMenu = "   No"
          DMenu(1).LKey = "N"
          DMenu(1).LRow = WINDOWS(4).ULR + 3
          DMenu(1).LCol = WINDOWS(4).ULC + 3
          DMenu(1).RMenu = "  Yes"
          DMenu(1).RKey = "Y"
          DMenu(1).RRow = WINDOWS(4).ULR + 3
          DMenu(1).RCol = DMenu(1).LCol + DialogStrg% + 4

     CASE 2
          'Valley-Speak
          DMenu(1).TMenu = "  For Sure?"
          DMenu(1).TRow = WINDOWS(4).ULR + 1
          DMenu(1).TCol = WINDOWS(4).ULC + 5
          DMenu(1).LMenu = "No way"
          DMenu(1).LKey = "N"
          DMenu(1).LRow = WINDOWS(4).ULR + 3
          DMenu(1).LCol = WINDOWS(4).ULC + 3
          DMenu(1).RMenu = "Really"
          DMenu(1).RKey = "R"
          DMenu(1).RRow = WINDOWS(4).ULR + 3
          DMenu(1).RCol = DMenu(1).LCol + DialogStrg% + 4
END SELECT

END SUB

