; Created 03/11/91
; Updated 12/10/91

;contains SETBLINK, VGACONTROL, VGABORDER

;=======================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
;RM82TS8,16,24,32,40,48,56,64

;============================================================================
; DECLARE SUB SETBLINK (BYVAL Status%)
; CALL SETBLINK (Status%)
;
; Purpose:
;       Toggles background blinking/intensity for MONO, CGA, EGA, VGA
;       allows use of background colors that would otherwise flash
; Parameters:
;       =  0 turn off blinking, enable intensity
;       <> 0 to turn it on again
; Returns:
;       nothing
;============================================================================
DOSSEG
.MODEL MEDIUM, BASIC
.CODE

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

EVEN
SETBLINK PROC FAR BASIC, STATUS:WORD
	Xor             AX,AX
	Mov             ES,AX              ; set ES to BIOS RAM
	Assume          ES:NOTHING         ; tell MASM
VGATest:                                   ; tests only for active display
	Mov     	AX,1A00h
	Mov     	BX,10h             ; Test for VGA adapter
	Push		BP		   ; save BP in case CRT is CGA/MONO
	Int     	10h
	Pop		BP
	Cmp     	AL,1Ah             ; If VGA exists, it returns AL=1Ah
	Jne     	EGATest            ; VGA doesn't exist test for EGA
	Cmp     	BL,8               ; Else VGA exists, primary dsp info
	Je		EGA_Adjust	   ; BL = 8 if have VGA color
	Cmp		BL,7
	Je		EGA_Adjust         ; BL = 7 if have VGA mono as primary
	Cmp     	BL,5               ; 
	Je      	EGA_Mono           ; BL = 5 if have EGA mono as primary
	Cmp		BL,9
	JA		CGA_Adjust	   ; MCGA, treat as a CGA
;else test for EGA
EGATest:
	Mov             AX,1200h           ; read EGA/VGA config
	Mov             BX,10h
	Push		BP		   ; save BP in case have CGA/MONO
	Int             10h
	Pop		BP
	Cmp             BL,10h             ; EGA changes BL from 10h
	Je              CGA_Adjust         ; no change in BL so have CGA/MDA
	Cmp		CL,9		   ; if EGA mono active must
	JA		EGA_Mono           ; go directly to register manip.
	Cmp             CL,5               ; determine primary monitor type
					   ; EGA/VGA is primary monitor
					   ; if CL is greater than 5
	JA              EGA_Adjust         ; EGA active
CGA_Adjust:                                ; not a VGA/EGA or inactive
					   ; so treat as a CGA/Mono
	Mov             BX,STATUS          ; read input number (note BYVAL)
	Mov             DX,ES:[0463h]      ; read base port address for CRT
	ADD             DL,04h             ; CGA/Mono independent code
	Mov             AL,ES:[0465h]      ; read current setting of CRT mode
					   ; register
	OR              BX,BX              ; see if user input is 0
	JZ              SETB1              ; if zero
	OR              AL,20h             ; set bit
	Jmp             Short SETB2
SETB1:
	And             AL,0DFh            ; clear bits
SETB2:
	Out             DX,AL              ; send to CRT corrected settings
	Mov             ES:[0465h],AL      ; write back current CRT mode
	Ret                                ; quit, MASM cleans up stack
EVEN
EGA_Adjust:
	Mov             BX,STATUS          ; read input number (note BYVAL)
	OR              BX,BX              ; see if user input is 0
	JZ              SETB3              ; if 0 then jump forward
	Mov             BL,01              ; set bit for blinking
SETB3:
	Mov             AX,1003h           ; do it to EGA/VGA
					   ; if BL = 1 then blinking enabled
					   ; if BL = 0 then intensity enabled
; this function does not appear to work well with EGA clones
; that emulate HERC display so alt function is used below
	Int             10h
SETB_END:                                  ; quit
	Ret                                ; MASM cleans up stack
EGA_Mono:
;-----------------------------------------------------------------------
; normal BIOS function does not appear to work well with an EGA mono and 
; EGA's that emulate HERC display.  Solution is overkill:
; 1) use rom BIOS
; 2) register manipulation for EGA 
; 3) register manipulation for Herc display
;-----------------------------------------------------------------------
;Bios method - this is very safe
	Mov             BX,STATUS          ; read input number
	OR              BX,BX              ; see if user input is 0
	JZ              @f                 ; if 0 then jump forward
	Mov             BL,01              ; set bit for blinking
@@:
	Mov             AX,1003h           ; do it to EGA/VGA
					   ; if BL = 1 then blinking enabled
					   ; if BL = 0 then intensity enabled
	Int             10h
; EGA register manipulation, EGA's in MONO emulation mode do not appear
; to respect this
	Mov             BX,STATUS	   ; read input value (note BYVAL)
	Mov             CX,0110b           ; assume default no blink mode
	Or              BX,BX
	JZ              @f
	Mov             CX,1110b           ; else use blink mode
@@:
	CLI                                ; must clear interrupts
	Mov     	DX,03BAh           ; reset attrib controller flip-flop
	In      	AL,DX              ; by reading toggle port
	Mov     	DX,03C0h           ; attribute controller address
	Mov     	AL,30h             ; set address of Mode Control w/o
				           ; turning off display
	Out     	DX,AL              ; write address
	Mov     	AL,CL              ; get input value
	Out     	DX,AL              ; send it out
	STI                                ; turn on interrupts
; Herc register manipulation, since this port does not exist
; on a EGA, this shouldn't cause any problems
	Mov             BX,STATUS          ; read input number
	Mov		DX,03B8h	   ; get HERC CRT Mode Port
	Mov             AL,ES:[0465h]      ; read current setting of CRT mode
					   ; register
	OR              BX,BX              ; see if user input is 0
	JZ              SETB5              ; if zero
	OR              AL,20h             ; set bit
	Jmp             Short SETB6
SETB5:
	And             AL,0DFh            ; clear bits
SETB6:
	Out             DX,AL              ; send to CRT corrected settings
	Mov             ES:[0465h],AL      ; write back current CRT mode
	Ret                                ; MASM cleans up stack
SETBLINK        ENDP

;======================================================================
; DECLARE SUB VGACONTROL
; CALL VGACONTROL
; Purpose:
;       Resets Color VGA to normal defaults w/o clearing screen
; Then turns on intensity, turns off blinking, turns off gray scale
; selects the VGA better print screen routine, selects 400 line mode, 
; sets number of rows to 25, columns to 80, resets default color palette
; turns off the cursor, and selects video page 0.  If the Color VGA
; is in mode 7 when the program begins, it will stay in that mode
;
; Input:
;       Nothing
; Returns:
;       Nothing
;======================================================================

EVEN
VGACONTROL PROC FAR BASIC
	Mov     AX,1A00h
	Mov     BX,10h          ; Test for VGA adapter
	Push    BP              ; save BP to be safe until ... 
	Int     10h		; (early CGA/MONO's did not preserve BP)
	Pop     BP              ; we know that we have VGA
	Cmp     AL,1Ah          ; If VGA exists, it returns AL=1Ah
	Jne     Quit            ; else VGA doesn't exist so quit
	Cmp     BL,8            ; test for VGA color, if no then quit
	Jne     Quit            ; BL = 8 if have VGA color
	Mov     AX,1200h        ; enable default palette loading
	Mov     BL,31h
	Int     10h
	Mov     AH,12h          ; select better PRT SCRN
	Mov     BL,20h          ; designed for VGA
	Int     10h
	Mov     AX,1200h        ; enable BIOS cursor emulation
	Mov     BL,34h
	Int     10h
	Mov     AX,1202h        ; select 400 line mode for text
	Mov     BL,30h
	Int     10h
	Mov     AX,1201h        ; disable gray scale summing
	Mov     BL,33h
	Int     10h
	Mov     AH,0Fh          ; get current video mode
	Int     10h
	Xor     AH,AH
	Or      AL,10000000b    ; set high bit
	Cmp     AL,87h          ; in normal mono mode?
	Je      @f              ; yes, skip ahead
	Mov     AL,83h          ; reset display to color default
@@:
	Xor     BX,BX           ; bug fix for AST/AMI 386 bios
	Int     10h             ; without clearing display  (bit 7 set)
	Mov     AX,1003h        ; turn on intensity/disable blinking
	Xor     BL,BL
	Int     10h
	Xor     AX,AX           ; set AX = 0
	Mov     ES,AX           ; set ES to BIOS ram (0)
	Mov     AL,ES:[0449h]   ; reset CRT_MODE to correct value
				; to undo what we did to reset display mode
				; must clear bit 7
	And     AL,1111111b     ; clear bit 7 too, so VGA will forget
	Mov     ES:[0449h],AL   ; so correct MODE returned by BIOS
	Mov	AL,ES:[0487h]	; get VGA_Mode control register into AL
	And	AL,1111111b	; clear bit 7 too, so VGA will forget
	Mov	ES:[0487h],AL	; write corrected value back
				; Turn off cursor
	Mov     AX,300H		; read current cursor values
	Xor     BX,BX		; for page 0
	Int     10h		; (a work around for a VGA clone problem)
	Or      CH,20h		; turn off cursor (set bit five of CH)
	; fix bug to AST 386 machine and AMI 386 BIOS
	; they want AL to contain current video mode
	Mov     AH,0Fh
	Int     10h
	Xor     BX,BX		; make sure its page 0
				; this is the normal routine
	Mov     AH,01		; set cursor size
	; CX contains new cursor information
	Int     10h		; call video routine
Quit:
	Ret
VGACONTROL ENDP

;======================================================================
; DECLARE SUB VGABORDER (BYVAL BORDER%)
; CALL VGABORDER (BORDER%
; Purpose:
;       Selects border color on a VGA color display.  Does nothing if
;	not a color VGA.
; Input:
;       Border color
; Returns:
;       Nothing
;======================================================================

EVEN
VGABORDER PROC FAR BASIC, BORDER:WORD
	Mov     AX,1A00h
	Mov     BX,10h          ; Test for VGA adapter
	Push    BP              ; save BP to be safe until ... 
	Int     10h		; (early CGA/MONO's did not preserve BP)
	Pop     BP              ; we know that we have VGA
	Cmp     AL,1Ah          ; If VGA exists, it returns AL=1Ah
	Jne     Quit            ; else VGA doesn't exist so quit
	Cmp     BL,8            ; test for VGA color, if no then quit
	Jne     Quit            ; BL = 8 if have VGA color
	Mov     BX,BORDER       ; read border (note BYVAL)
	Cmp	BX,15		; is value out of range? (above 15?)
	Ja	Quit		; yes, so quit
	Mov     BH,BL           ; put value in BH
	Mov     AX,1001h
	Int     10h             ; set border to color selected
Quit:
	Ret
VGABORDER ENDP
END

