; Last Updated 6/14/91
; Updated 10/17/91

;=======================================================================
;   Copyright (C) Copr. 1990, 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
;RM82TS8,16,24,32,40,48,56,64

DOSSEG
.MODEL MEDIUM, BASIC

.DATA
	;external data so all video routines can access
	INCLUDE VDATA.INC
.CODE

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1990, 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

EXTRN   Get_Adapter:FAR              ; inside VDATA

EVEN                                 ; speed up 80286/80386 access
COMPAQ          DB      'COMPAQ'     ; BIOS ID string in COMPAQ CGA
COMPAQ_LEN      Equ     $-COMPAQ     ; length of string
EVEN                                 ; speed up 80286/80386 access
ZDS		DB	'ZDS CORP'   ; BIOS ID string for Zenith CGA
ZDS_LEN		Equ	$-ZDS        ; length of string

;===========================================================================
; DECLARE SUB SNOWCHECK ()
; CALL SNOWCHECK
; Purpose:
;        Clears the snowcheck variable if find a CGA display by
;        OLIVETTI (AT&T), COMPAQ, or ZENITH
;
; Returns:
;	 Nothing Above Data Area Filed
;===========================================================================

EVEN
SNOWCHECK PROC  FAR BASIC USES DI SI
	Assume  DS:@data        ; tell MASM
	Cmp     B$DVIDEOINSTL,1 ; have we done this before?
	JE      Didit           ; yep, so skip ahead
	Call    Get_Adapter     ; determine the display type
Didit:
	Cmp     B$DVIDEOPORT,0  ; snowcheck is already set to off
	JE      All_Done        ; so skip ahead
	;------------------------------------------------
	;Look for CGA's that do not need snowcheck
	;------------------------------------------------
ATT_test:
	Mov     AX,0F000h       ; Get ROM ID segment
	Mov     ES,AX           ; Store segment in ES
	Assume  ES:NOTHING      ; tell MASM
	CLD                     ; clear the direction flag for safety
	Mov     AX,CS
	Mov     DS,AX           ; set DS = to CS
	Assume  DS:NOTHING      ; tell MASM
				; faster version
				; Source:  XMS.SYS version 2.06 MASM source
	Cmp     ES:[0C05h],'LO' ; look for byte reversed 'OL' at FC00:0050h
				; in memory letters are reversed
	Je      NO_SNOW_found   ; AT&T found so quit

Compaq_test:
     	; Purpose of this test is to allow other routines to know if
     	; "snow" testing is necessary.
	Mov     DI,0FFEAh        ; Get ID offset & store in DI
     	Mov     SI,OFFSET COMPAQ ; DS:SI points to  "COMPAQ".
	Mov     CX,COMPAQ_LEN    ; CX has length of "COMPAQ".
	REP     CMPSB            ; ES:DI destination, DS:SI source
	JE      NO_SNOW_found    ; COMPAQ found so quit

Test_ZDS:
	Mov     DI, 800Ch       ; load location of ZDS string
	Mov     SI, OFFSET ZDS  ; DS:SI points to "ZDS CORP"
	Mov     CX, ZDS_LEN     ; put length of string in CX
	Rep	CMPSB
	Je      NO_SNOW_found   ; report ZDS found
				; else, clean up & quit
All_Done:
	Mov     AX,SS           ; for safety make sure DS=DGROUP
	Mov     DS,AX           ; point DS to DGROUP
	Assume  DS:@data        ; tell MASM
	Ret                     ; quit, MASM adjusts stack

EVEN                            ; speed up 80286/80386 access
NO_SNOW_found:
	; report that a non-snowy CGA found
	Mov     AX,SS
	Mov     DS,AX           ; point DS to DGROUP
	Assume  DS:@data        ; tell MASM
	Xor     AX,AX           ; set AX = 0
	Mov     B$DVIDEOPORT,AX ; clear retrace port
	Ret                     ; quit, MASM adjusts stack
SNOWCHECK ENDP

;===========================================================================
; DECLARE SUB TOGGLESNOW (BYVAL Mode%)
; CALL TOGGLESNOW(Mode%)
;Input: If Mode% =  0, clears SNOWCHECK
;       If Mode% <> 0, leaves SNOWCHECK set
;Purpose:
;        Clears the snowcheck variable if find a CGA display
;        Also reinitializes Video Data Area to page 0
;
;Returns:  Nothing
;	   Video Data Area Filed
;===========================================================================

EVEN
TOGGLESNOW PROC FAR BASIC MODE:WORD
	Call  	Get_Adapter       ;determine the display type
				  ;reinitialize each time
	Cmp   	B$DVIDEOPORT,0    ;snowcheck is already set to off
				  ;don't want to tinker with this
				  ;if have a MONO, EGA or VGA display
	JE      Finis             ;so skip ahead
	Mov     BX,MODE           ;get value of MODE toggle (BYVAL)
	Or      BX,BX             ;is it zero?, then
	JNZ	Finis		  ;nothing to do so skip ahead
	Xor     AX,AX             ;set AX = to 0
	Mov     B$DVIDEOPORT,AX   ;else, clear snowcheck variable & quit
Finis:
	Ret                       ;MASM cleans up stack
TOGGLESNOW	ENDP
END

