; Created  10/15/90
; Updated  12/10/91

;======================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;======================================================================
;RM83TS8,16,24,32,40,48

DOSSEG
.MODEL MEDIUM, BASIC
.DATA
	;external data so all video routines can access
	INCLUDE VDATA.INC
.CODE

INCLUDE  NOWAIT.INC
EXTRN	Get_Adapter:FAR

COMMENT         |
Calc_DI_Offset_Addr  macro
	;; standard routine
	;; Output in DI
	;; Note destroys AX, BX, CL
	;;               ;8086  ;80286
	Mov   AX,CurrRow   ;14     ;5
	Dec   AX           ;3      ;2   ;;change from 1-25 to 0-24
	Mov   CL,160       ;4      ;2
	Mul   CL           ;77     ;13  ;;multiply CurrRow by 160
	Mov   BX,BegCol    ;14     ;5   ;;get starting column
	Dec   BX           ;3      ;2   ;;change from 1-80 to 0-79
	Shl   BX,1         ;2      ;2   ;;multiply (CurrRow-1) by 2
	Add   AX,BX        ;3      ;2   ;;get offset
	Mov   DI,AX        ;3      ;2   ;;move to source index
	endm               ;---------
			   ;123    ;35  ;;clocks
		|

Calc_DI_Offset_Addr    macro
	;; This is slightly slower in the abstract
	;; sense on a 80286.  Cannot observe the difference
	;; on a 8088 with a CGA because of delay waiting for retrace.
	;; Though if have an 8088 with MONO or VGA/EGA it is faster
	;;
	;; Input:     Nothing
	;; Output:    DI = Memory Offset
	;; Destroys:  CX,AX
	;; Macro is used because inline code speeds routine
	;;               ;8088 ;80286
	Xor     CL, CL     ;3    ;2   ;; Clear CL
	Mov     AX,CurrRow ;14   ;5   ;; get starting Row
	Dec     AX         ;3    ;2   ;; change from 1-25 to 0-24
	Mov     CH, AL     ;2    ;2   ;; CX = Row * 256
	Shr     CX, 1      ;2    ;2   ;; CX = Row * 128
	Mov     DI, CX     ;2    ;2   ;; Store in DI
	Shr     DI, 1      ;2    ;2   ;; DI = Row * 64
	Shr     DI, 1      ;2    ;2   ;; DI = Row * 32
	Add     DI, CX     ;3    ;2   ;; DI = (Row * 128)+(Row * 32)={Row*160}
	Xor     CH, CH     ;3    ;2   ;; Clear CH register
	Mov     AX,BegCol  ;14   ;5   ;; get starting Column
	Dec     AX         ;3    ;2   ;; change from 1-80 to 0-79
	Mov     CL, AL     ;2    ;2   ;; CX = Columns
	Shl     CX, 1      ;2    ;2   ;; Account for attribute
	Add     DI, CX     ;3    ;2   ;; DI = (Row * 160) + (Col * 2)
			  ;--------
      endm                ;60    ;36  ;; clocks

.CODE
; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1990, 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

;==================Some data variables==================================
;         Stored in Code segment to save space in DGROUP

EVEN
	CurrRow        DW    0           ;current CurrRow
	BegCol         DW    0           ;Starting Column
	Num_Cols       DW    0           ;words to copy per line
	EndingRow      DW    0           ;Ending Row
	BkgndColor     DW    0           ;store shadow color for MAKEBOXES
	Color          DB    0           ;Store color attribute

;=======================================================================
; DECLARE SUB
; CLEARAREA (BYVAL ULR%, BYVAL ULC%, BYVAL LRR%, BYVAL LRC%, BYVAL ATTRIB%)
; CALL CLEARAREA (ULR%, ULC%, LRR%, LRC%, ATTRIB%)
; Changes the attribute of an area on the screen in text mode
;
; Note user must toggle mouse cursor, not done automatically
;=======================================================================

comment |
	Register usage when all done:
	AH = Color attribute to change line to
	AL = loading point for STOB, scratch.
	CX = Number of characters to change on a line.
	DX = Port for CGA video retrace check, if necessary.
		0 means display is not a not a CGA display
	DI = Offset of Screen for current character
	ES = Segment of Video display, 0xB000 or 0xB800
	BX = is used as a scratch variable register
	DS & SI are not changed
     |
EVEN
Doit:				;save a jump in normal case
	Call  Get_Adapter       ;determine display type
	Jmp   Short Main	;back to main loop
EVEN
CLEARAREA Proc FAR BASIC USES DI, \
ULR:Word, ULC:Word, LRR:Word, LRC:Word, ATTRIB:Word
	Cmp   B$DVIDEOINSTL,1	;have we installed before?
	JNE   Doit		;install and return
Main:
	;Mov   ES,B$DVIDEOSEG   ;store Video Segment in ES
	;Mov   DX,B$DVIDEOPORT  ;Get B$VDIDEOPORT
	LES   DX,DWORD PTR B$DVIDEOPORT  ;faster than above
	Mov   AX,ULC           ;get first column (BYVAL)
	Mov   BegCol,AX
	Mov   AX,LRC           ;get last column (BYVAL)
	Mov   BX,80            ;assume out of range
	Cmp   AX,80            ;is right column out of range
	JA    @f               ;assumed correctly
	Mov   BX,AX            ;else, store LRC in BX
			       ; so no wrap around on left margin
@@:
	Sub   BX,BegCol        ;subtract last column from first column
	Inc   BX               ;add 1 to get number of columns to print
	Mov   Num_Cols,BX      ;BX equals number of words to copy per line
	Mov   AX,LRR           ;get last line (BYVAL)
	Mov   EndingRow,AX
	Mov   AX,ULR           ;get first line (BYVAL)
	Mov   CurrRow,AX       ;set current row to first line
	Calc_DI_Offset_Addr    ;calculate DI offset for line (MACRO)
	Mov   CX,Num_Cols      ;load counter with words to copy
	JCXZ  Exit2            ;if CX is zero it's a zero length line
			       ;so exit now
	Mov   AX,ATTRIB        ;get the color ATTRIBUTE% (BYVAL)
	Mov   Color,AL	       ;save value in Color
	Cld                    ;clear the direction flag to move data forward
	Or    DL,DL            ;are we on a mono or EGA system?
	JNZ   CGA1             ;NO, do the retrace stuff
EVEN                           ;AL contains Color attribute
Mono2:
	Inc   DI               ;the increment before store allows one
			       ;to change just the color attribute
	Stosb                  ;store the attribute
	Loop  Mono2            ;loop until CX is zero
;Next Line
	Mov   AX,EndingRow
	Cmp   AX,CurrRow       ;Are we done restoring window?
	Je    Exit2            ;exit if complete
	INC   CurrRow          ;next line
	Calc_DI_Offset_Addr    ;compute new offset address MACRO
	Mov   CX,Num_Cols      ;set counter to # of words to copy
	Mov   AL,Color         ;get attribute & put it in AL
	JMP Short Mono2        ;jump to print next line
Exit2:
	Ret                    ;return skipping the passed parameters

CGA1:
	Mov   AH,Color         ;get attribute & put it in AH
	;AL is going to be trashed by Wait_CGA_Retrace Macro
EVEN
CGA2:
	Inc   DI               ;skip to ATTRIB byte
	CLI                    ;prevent hardware interrupts
	Wait_CGA_Retrace       ;wait for retrace on CGA MACRO (destroys AL)
	Mov   AL,AH            ;get ATTRIB from AH & put it in AL
	Stosb                  ;store the attribute from AL
	STI                    ;allow interrupts again
	Loop  CGA2             ;loop until CX is zero
;Next_Line
	Mov   AX,EndingRow
	Cmp   AX,CurrRow       ;Are we done restoring window?
	Je    Exit2            ;exit if complete
	INC   CurrRow          ;next line
	Calc_DI_Offset_Addr    ;compute new offset address MACRO
	Mov   CX,Num_Cols      ;set counter to # of words to copy
	JMP Short CGA1         ;jump to print next line
CLEARAREA   Endp

;===========================================================================
; DECLARE SUB BACKFILL
;(BYVAL ULR%, BYVAL ULC%, BYVAL LRR%, BYVAL LRC%, BYVAL ATTRIB%, BYVAL TEXTCHAR%)
; CALL BACKFILL(ULR%, ULC%, LRR%, LRC%, ATTRIB%, TEXTCHAR%)
; Fills the display area with a character and a fixed text attribute
; Note user must toggle Mouse cursor, not done automatically
;===========================================================================

comment |
	Register usage when all done:
	AH = Color attribute to change line to
	AL = loading point for text character.
	CX = Number of characters to change on a line.
	DX = Port for CGA video retrace check, if necessary.
	     0 means display is not a not a CGA display
	DI = Offset of Screen for current character
	ES = Segment of Video display, 0xB000 or 0xB800
	BX = is used as a scratch variable register
	SI = holds the text & character attribute
	DS  is not changed
     |

EVEN
Doit1:				; save a jump in mormal case
	Call Get_Adapter        ; determine display type
	Jmp  Short Main1	; back to main loop
EVEN
BACKFILL Proc FAR BASIC USES DI SI, \
ULR:Word, ULC:Word, LRR:Word, LRC:Word, ATTRIB:Word, TEXTCHAR:Word
	Cmp   B$DVIDEOINSTL,1	;have we installed?
	JNE   Doit1		;no, so doit
Main1:
	;Mov   ES,B$DVIDEOSEG   ;store Video Segment in ES
	;Mov   DX,B$DVIDEOPORT  ;Get B$VDIDEOPORT
	LES   DX,DWORD PTR B$DVIDEOPORT  ;faster than above
	Mov   AX,ULC           ;get first column (BYVAL)
	Mov   BegCol,AX
	Mov   AX,LRC           ;get last column (BYVAL)
	Mov   BX,80            ;assume out of range
	Cmp   AX,80            ; make sure right margin not > 80
	JA    @f               ; so no wrap around on left margin
	Mov   BX,AX            ;w/in range so store in BX
@@:
	Sub   BX,BegCol        ;subtract first column from last column
	Inc   BX               ;add 1 to get number of columns to print
	Mov   Num_Cols,BX      ;BX equals number of words to copy per line
	Mov   AX,LRR           ;get last line (BYVAL)
	Mov   EndingRow,AX     ;store in EndingRow
	Mov   AX,ULR           ;get first line (BYVAL)
	Mov   CurrRow,AX       ;store in CurrRow
	Calc_DI_Offset_Addr    ;calculate offset for line MACRO
	Mov   CX,Num_Cols      ;load counter with words to copy
	JCXZ  Exit3            ;if CX is zero it's a zero length line
			       ;so exit now
	Mov   AX,ATTRIB        ;get the color ATTRIBUTE% (BYVAL)
	Mov   AH,AL            ;store color ATTRIBUTE% in AH too
	Mov   Color,AL         ;store AL temporarily in Color
	Mov   BX,TEXTCHAR      ;get text string character# (BYVAL)
	Or    BX,BX            ;see if string character is &H00
	JZ    Exit3            ;it is zero so exit
	Mov   AL,BL            ;store character number in AL
	Mov   SI,AX            ;store text (AL) & attribute (AH) in SI
	Cld                    ;clear the direction flag to move data forward
	Or    DL,DL            ;are we on a mono or EGA system (is DL = 0)?
	JNZ   CGA4             ;NO, do retrace stuff
EVEN
Mono3:
	Mov   AX,SI            ;get attribute & text chr# & put it in AX
	Rep Stosw              ;store the attribute & text$
;Next_Line
	Mov   AX,EndingRow
	Cmp   AX,CurrRow       ;Are we done restoring window?
	Je    Exit3            ;exit if complete
	INC   CurrRow          ;next line
	Calc_DI_Offset_Addr    ;compute new offset address MACRO
	Mov   CX,Num_Cols      ;set counter to # of words to copy
	JMP Short Mono3        ;jump to print next line
Exit3:
	Ret                    ;return skipping the passed parameters
EVEN
CGA4:
	CLI                    ;prevent hardware interrupts
	Wait_CGA_Retrace       ;wait for CGA retrace MACRO
	Mov  AX,SI             ;reload Attribute & Text$ in AX
	Stosw                  ;increments DI automatically
	STI                    ;allow interrupts again
	Loop  CGA4             ;loop until CX is zero
;Next_Line
	Mov   AX,EndingRow
	Cmp   AX,CurrRow       ;Are we done restoring window?
	Je    Exit3            ;exit if complete
	INC   CurrRow          ;next line
	Calc_DI_Offset_Addr    ;compute new offset address MACRO
	Mov   CX,Num_Cols      ;set counter to # of words to copy
	JMP Short CGA4         ;jump to print next line
BACKFILL   Endp

;============================================================================
;DECLARE SUB MAKEBOXES _
;  (BYVAL ULR%, BYVAL ULC%, BYVAL LRR%, BYVAL LRC%, BYVAL HASNO%, BYVAL BORDER%,_
;    BYVAL ATTRIB%)
; CALL MAKEBOXES(ULR,ULC,LRR,LRC,HASHNO,BORDER,ATTRIB)
;
; Somewhat shorter and 1.0076 times faster than using the primitives
; in this .OBJ file to do the same thing
; Automatically toggles Mouse cursor before draws boxes
;============================================================================
EVEN
BOXD		LABEL	WORD
		DB	'ͺɻȼ'
BOXS		LABEL	WORD
		DB	'ĳڿ'
BOXSVDH		LABEL	WORD
		DB	'ͳոԾ'
BOXSHDV		LABEL	WORD
		DB	'ĺַӽ'
BOXSOLID	LABEL	WORD
		DB      ''     ;heavy line on bottom, medium on top

EVEN
MAKEBOXES Proc FAR BASIC USES SI, \
ULR:Word, ULC:Word, LRR:Word, LRC:Word, HASHNO:Word, BORDER:Word, ATTRIB:Word
	Turn_Off_Mouse                  ; shut off mouse if on MACRO
	Mov     BX,HASHNO
	Or      BX,BX
	JZ      No_Background           ; no back fill so skip ahead
Fill_In_Background:
	Mov     AX,BX                   ; store HASHNO in AX
	Push    ULR                     ; push values on the stack
	Push    ULC                     ; Push ULC
	Push    LRR                     ; Push LRR
	Push    LRC                     ; Push LRC
	Push    ATTRIB                  ; push ATTRIB
	Push    AX                      ; push HASHNO
	Push	CS                      ; fast far call w/in same segment
	CALL    Near Ptr BACKFILL
No_Background:                          ; Draw Main Outline
	Mov	BX,BORDER               ; see if we have a Border choice
	Or	BL,BL                   ; if border not zero, do BORDER
	JNZ     DrawBorder
	JMP	DrawShadow              ; plain border
DrawBorder:
	;Must lie about DS so the OFFSET is calculated correctly
	;relative to CSEG not DGROUP
	Assume  DS:NOTHING
	Cmp     BL,2
	JNE	@f
	Mov	SI,OFFSET BOXS		; single sided
	Jmp	Short	StartBorder
@@:
	Cmp	BL,3
	JNE	@f
	Mov	SI,OFFSET BOXSVDH       ; single vertical, double horizontal
	Jmp	Short	StartBorder
@@:
	Cmp	BL,4
	JNE	@f
	Mov	SI,OFFSET BOXSHDV       ; double vertical, single horizontal
        Jmp	Short	StartBorder
@@:
	Cmp	BL,5
	JNE	@f
	Mov	SI,OFFSET BOXSOLID      ; solid box
        Jmp	Short	StartBorder
@@:
	Mov     SI,OFFSET BOXD          ; default format, double sided
EVEN
StartBorder:
	Assume  DS:@data
	;Draw Left Side
	Mov     BX,ULC
	Mov     AX,ULR
	Inc     AX                      ; shorten side, draw corner later
	Push    AX
	Push    BX
	Mov     AX,LRR
	Dec     AX                      ; shorten side, draw corner later
	Push    AX
	Push    BX
	;Push    ULR
	;Push    ULC
	;Push    LRR
	;Push    ULC
	Push    ATTRIB
	Mov     AL,CS:[SI+1]
	Push    AX                      ; Push Bottom Row Character
	Push    CS                      ; fast far call w/in same segment
	CALL    Near Ptr BACKFILL
	;Draw Right Side
	Mov     BX,LRC
	Mov     AX,ULR
	Inc     AX                      ; shorten side, draw corner later
	Push    AX
	Push    BX
	Mov     AX,LRR
	Dec     AX                      ; shorten side, draw corner later
	Push    AX
	Push    BX
	;Push    ULR
	;Push    LRC
	;Push    LRR
	;Push    LRC
	Push    ATTRIB
	Mov     AL,CS:[SI+1]
	Push    AX                      ; Push Right Side Character
	Push    CS                      ; fast far call w/in same segment
	CALL    Near Ptr BACKFILL
	;Draw Top Row
	Push    ULR                     ; Push ULR
	Push    ULC                     ; Push ULC
	Push    ULR                     ; Push ULR
	Push    LRC                     ; Push LRC
	Push    ATTRIB                  ; push ATTRIB
	Mov     AL,CS:[SI]
	Push    AX                      ; Push Top Row Character
	Push	CS                      ; fast far call w/in same segment
	CALL    Near Ptr BACKFILL
	;Draw Bottom Row
	Push    LRR
	Push    ULC
	Push    LRR
	Push    LRC
	Push    ATTRIB
	Mov     AL,CS:[SI]
	Push    AX
	Push	CS                      ; fast far call w/in same segment
	CALL    Near Ptr BACKFILL
;Draw Border Edges
	;Draw Upper Left
	Push    ULR
	Push    ULC
	Push    ULR
	Push    ULC
	Push    ATTRIB
	Mov     AL,CS:[SI+2]
	Push    AX
	Push	CS                      ; fast far call w/in same segment
	CALL    Near Ptr BACKFILL
	;Draw Upper Right
	Push    ULR
	Push    LRC
	Push    ULR
	Push    LRC
	Push    ATTRIB
	Mov     AL,CS:[SI+3]
	Push    AX
	Push	CS                      ; fast far call w/in same segment
	CALL    Near Ptr BACKFILL
	;Draw Lower Right
	Push    LRR
	Push    LRC
	Push    LRR
	Push    LRC
	Push    ATTRIB
	Mov     AX,CS:[SI+5]
	Push    AX
	Push	CS                      ; fast far call w/in same segment
	CALL    Near Ptr BACKFILL
	;Draw Lower Left
	Push    LRR
	Push    ULC
	Push    LRR
	Push    ULC
	Push    ATTRIB
	Mov     AL,CS:[SI+4]            ; draw bottom left
	Push    AX
	Push	CS                      ; fast far call w/in same segment
	CALL    Near Ptr BACKFILL
DrawShadow:
;Select shadow color depending on MONO or COLOR display mode
	Mov     BX,BORDER     ; get BORDER
	Or      BH,BH         ; see if we must draw a Shadow
	JZ      Quit          ; nope, so quit
	Xor     BX,BX         ; set ES to Ram BIOS area
	Mov     ES,BX
	Mov     BX,ES:[0463h] ; look a port info stored in RAM bios
			      ; at 0000:0463h
	Cmp     BL,0B4h       ; is this a MONO port?
	JNE     Color_Def     ; nope, so skip ahead
	Mov     AX,17h        ; Assume mono or Herc display
	Test    Byte Ptr ES:[0487h],01000b ; is EGA inactive ?
	JNZ     Use_it        ; nope
Color_Def:
	Mov     AX,7          ; else use color/EGA mono default
Use_it:
	Mov     BkgndColor,AX ; store shadow color
	Mov     BX,LRC
	Mov     CX,BX
	Cmp     BX,77         ; can't draw a shadow if LRC > 77
	JBE     @f
	Jmp     Short  Quit
@@:
	Mov     BX,LRR
	Mov     ES,BX         ; store temporarily in ES
	Cmp     BX,24         ; can't draw a shadow if LRR >24
	JBE     @f
	Jmp     Short  Quit
@@:
	;Draws bottom right shadow
	Mov     BX,ULR
	Inc     BX
	Push    BX            ; push ULR+1
	Inc     CX
	Push    CX            ; push LRC+1
	Mov     BX,ES
	Inc     BX
	Push    BX            ; push LRR+1
	Inc     CX
	Push    CX            ; push LRC+2
	Mov     BX,BkgndColor
	Push    BX
	Push	CS            ; fast far call w/in same segment
	CALL    Near Ptr CLEARAREA
	;Draws bottom left shadow
	Mov     BX,LRR
	Inc     BX
	Mov     CX,BX
	Push    BX            ; push LRR+1
	Mov     BX,ULC
	Add     BX,2
	Push    BX            ; push ULC+2
	Push    CX            ; push LRR+1
	Mov     BX,LRC
	Inc     BX
	Push    BX            ; push LRC+1
	Mov     BX,BkgndColor
	Push    BX            ; push shadow color
	Push	CS	      ; fast far call w/in same segment
	CALL    Near Ptr CLEARAREA
Quit:
	Turn_On_Mouse          ; turn Mouse cursor on if on MACRO
	Ret
MAKEBOXES     ENDP
END

