; Created 04/17/91
; Updated 12/15/91

;=======================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
;RM120TS8,16,24,32,40,48,56,64

DOSSEG
.MODEL MEDIUM, BASIC
.DATA
	;external data so all video routines can access
	INCLUDE VDATA.INC
.CODE
;Copyright       DB    13,10,'Copyright Copr. (C) 1991 Sidney J. Kelly',13,10
;Copyright1      DB    'All Rights Reserved',13,10,26

;=======================================================================
; DECLARE SUB CHANGEPAGE ()
; CALL CHANGEPAGE
;Purpose:
;        Adjust the current VIDEOSEG to reflect current active page,
;        reinitializes Video Data Area, and moves mouse cursor
;        to the new page if mouse is currently installed.
;
;Limit:
;        This will permit 25, 43, & 50 line displays
;        Note on many HERC's the page size is fixed at 16kb even though
;        it really is 4kb in Text Mode.  Note that some old EGA's (ITT EGA) 
;        do not properly calculate page size if using 43 line mode.
;
; Proper values for Screen 0 are:
;	80 x 25 = 4,096 bytes: 	80 x 43 = 7,136 bytes
;	80 x 50 = 8,256 bytes
;	40 x 25 = 2,048	bytes:  40 x 43 = 3,696 bytes
;	40 x 50 = 4,256 bytes
;Returns:
;	 Nothing Video Data Area Filed
;=======================================================================

EVEN
CHANGEPAGE PROC FAR
	Xor     AX,AX             ;zero out AX
	Mov	ES,AX             ;put zero in ES, to look at low memory
	Assume  ES:NOTHING        ;tell MASM of change
	Mov	BX,0B000h         ;assume the Mono screen segment
	Mov	AL,ES:[463h]      ;get CRT controller port address 0000:0463h
	Cmp	AL,0B4h           ;is it mono?
	JZ 	Have_Mono         ;yes, don't add 800h to video segment
	Mov	BH,0B8h           ;adjust BX for a color monitor
	Cmp     B$DVIDEOINSTL,1   ;Is that video port status accurate?
	JE	Buffer_Set        ;yes, so skip ahead
				  ;test if color VGA/EGA or a CGA
	Push	BX                ;save BX because the EGA test destroys BX
	Mov     AH,12h            ;specify EGA BIOS special function service
	Mov	BL,10h            ;request EGA info
	Push    BP                ;save BP in case video bios destroys it
        Int	10h               ;call the BIOS
	Pop     BP
        Cmp	BL,10h            ;if BL is still 10h, there's no EGA
	JNE     Color_EGA         ;it is a V/EGA, skip ahead
Snowy_CGA:                        ;its a CGA,  set video retrace port
	Mov     B$DVIDEOPORT,3DAh ;and store in data area
Color_EGA:
	Pop	BX            	  ;get the video segment again
Have_Mono:
	Mov	B$DVIDEOINSTL,1   ;note that it is now installed
Buffer_Set:
        ;BX contains Page 0 Segment Address
	XOR     CH,CH             ;clear the high byte
	Mov	CL,Byte Ptr ES:[0462h] ;get current page number
				  ;adjust mouse cursor to current page
	Cmp     B$MOUSEON,0       ;is there a mouse?
	Jz      MouseOff          ;if 0 then no so skip ahead
	Push    BX                ;save BX (because it contains Segment Addr)
	Mov     BX,CX             ;store page number in BX
	Mov     AX,29             ;change CRT using Mouse routines
	Int     33h
	Pop     BX                ;restore BX
MouseOff:
	JCXZ    Finis             ;if it is page 0, then quit
	Mov     DX,CX             ;store CX temporarily in DX
	Mov     AX,ES:[044Ch]     ;get current page size
	Mov     CL,4
	Shr     AX,CL             ;divide page size by 16
	Mov     CX,DX             ;get page number back into CX
Adj_Page:       ;allows for 25, 43 & 50 line pages in text mode
	Add     BX,AX             ;adjust one page ahead
	Loop	Adj_Page          ;loop until page (CX) = 0
Finis:
        Mov     B$DVIDEOSEG,BX    ;store current segment address
	Ret
CHANGEPAGE	ENDP
END

