; created 09/10/90
; Updated 11/04/91

;======================================================================
;   Copyright (C) Copr. 1990, 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;======================================================================
;======================================================================
; Important information for my set of video routines
;======================================================================

;RM82TS8,16,24,32,40,48,56,64

DOSSEG
.MODEL MEDIUM, BASIC

BIOSRAM SEGMENT  AT 0         ; make ASSUME's more descriptive
BIOSRAM ENDS

;contains  Get_Adapter

PUBLIC B$DVIDEOPORT, B$DVIDEOSEG, B$DVIDEODI, B$DVIDEOINSTL
PUBLIC B$HAVEMOUSE, B$MOUSEON, B$MOUSETOGL

.DATA
	EVEN
	; DON'T CHANGE THE ORDER, it is used so one can use les/lds to load
	; ES:DX or DS:DX pair of registers
	B$DVIDEOPORT	DW	0	;retrace port if CGA, 0 if not CGA
	B$DVIDEOSEG     DW      0       ;current video segment
	; no magic to  following order
	B$DVIDEODI      DW      0       ;current offset inside video segment
	B$DVIDEOINSTL   DB      0       ;records if Get_Adapter run
	B$HAVEMOUSE     DB      0       ;record have mouse
	B$MOUSEON       DB      0       ;record mouse visible if >0
	B$MOUSETOGL     DB      0       ;mouse was on, so turn back on

.CODE


INCLUDE NOWAIT.INC

Copyright       DB    13,10,'Copyright Copr. (C) 1990, 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

;===========================================================================
;Purpose:
;	   Called as a subroutine to find display adapter attached
;          sets the above information segment to reflect that information
;Destroys: ES, ES= BIOSRAM, other registers preserved, direction unchanged
;Assumes:  DS=DGROUP (i.e. DS=SS)
;Returns:  Nothing
;	   Above Data Area Filed
; Routine assumes that if you have an EGA or VGA, it is active.
;  This could produce snow if EGA were a secondary display acting as
;  a mono monitor, with CGA active. Not tested because routine would become
;  bloated to handle very unusual case.
;===========================================================================

EVEN
Get_Adapter PROC FAR BASIC USES AX BX CX DX
	Assume DS:@data
	Xor     AX,AX         ; zero out AX (assume no retrace port needed)
	Mov     ES,AX         ; put the zero in ES, to look at low memory
	Assume ES:BIOSRAM     ; tell MASM of change
	Mov     DX,0B000h     ; assume the Mono screen segment
	Cmp     Byte Ptr ES:[0463h],0B4h ; is video controller port mono?
	JE      All_Done      ; yes, skip over adding 800h to video segment
	Mov     DH,0B8h       ; no, adjust DX for a color monitor
	Mov     AH,12h        ; specify EGA BIOS EGA special function service
	Mov     BL,10h        ; request EGA info  (works on VGA too)
	Push    BP            ; protect against bad video bios
	Int     10h           ; call the BIOS
	Pop     BP
	Mov     AX,3DAh       ; assume CGA color, use Mov to preserve flags
			      ; load AX with address for retrace port
	Cmp     BL,10h        ; if BL is still 10h, there's no EGA/VGA
	JE      All_Done      ; it is an CGA, so skip ahead
	Xor     AX,AX         ; else its an EGA/VGA, clear retrace port number
All_Done:
	Mov     B$DVIDEOSEG,DX   ; Store the information we found
	Mov     B$DVIDEOPORT,AX
	Mov     B$DVIDEOINSTL,1  ; Note that routine is installed
	Ret
Get_Adapter ENDP
END

