; Created 05/03/91
; Updated 12/10/91

;=======================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
;RM82TS8,16,24,32,40,48,56,64

DOSSEG
.MODEL MEDIUM, BASIC
.DATA
	;external data so all video routines can access
	INCLUDE VDATA.INC
.CODE
INCLUDE NOWAIT.INC
EXTRN	Get_Adapter:FAR

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1990, 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

;============================================================================
; VPRINT.ASM - performs Vertical Printing in the QuickBASIC
; DECLARE SUB VPRINT (BYVAL ROW%, BYVAL COL%, Text$, BYVAL ATTRIBUTE%)
; Works in TextMode only, ignores all special characters
; Sensitive to all video modes (i.e. no snow on CGA's)
; If no attribute is selected, the default attribute is &H07 (normal)
; Assumes: Display width is 80 columns
; DOES NOT CHECK ROW, COL INPUT TO DETERMINE IF W/IN RANGE
;============================================================================

comment |
     Register usage when all done:
     AH = Color attribute for printing entire string.
     AL = temporarily holds the character to print.
     CX = Length of Text string.
     DX = Port for CGA video retrace check, if necessary.
          0 means display is not a not a CGA display
     DI = Offset of Screen for current character
     ES = Segment of Video display, 0xB000 or 0xB800
     SI = Offset of Text$ String
     DS = Assumed to point to segment containing Text string.
          Program does not set this, so string is assumed to
          be a near string in DGROUP, the default in QB 4.5
     BX = is used as a scratch variable register
     |

EVEN
Doit:
	Call  Get_Adapter  ;call routine to find display type
	Jmp	Short Didit
EVEN
VPRINT Proc FAR BASIC USES SI DI, ROW:Ptr, COLL:Ptr, TEXTSTRG:Ptr, ATTRIB:Ptr
	Turn_Off_Mouse     ; shut off mouse if on MACRO
	Cmp   B$DVIDEOINSTL,1 ;See if we have done this before
	JNE    Doit        ;no, install
Didit:
	Mov   CX,ROW       ;read value of Row
	Dec   CX           ;convert to BIOS format
	Mov   DH,CL        ;store ROW (CL) in DH
	Mov   CX,COLL      ;read value of COLL
	Dec   CX           ;convert to BIOS format
	Mov   DL,CL        ;store COLL (CL) in DL
	CALL Near Ptr SET_DI  ;call routine to find video seg offset in DI
      	;Mov   ES,B$DVIDEOSEG  ;restore the initialized values
	;Mov   DX,B$DVIDEOPORT ;puts 0 in DX if not CGA
	LES   DX,DWORD PTR B$DVIDEOPORT  ;faster than above
	Mov   BX,ATTRIB    ;get the color ATTRIBUTE% (BYVAL) in BL
	; and make sure not &H00
	Mov   BH,07        ;Assume black background, white letters
	Or    BL,BL        ;is attribute 0?
	JZ    @f           ;yes, so jump ahead (note jump only if unlikely)
	Mov   BH,BL        ;no, so load in BH
@@:
	Mov   AH,BH        ;put it in AH
	Mov   SI,TEXTSTRG  ;put descriptor to TEXT$ into SI
	Mov   CX,[SI]      ;put Len(TEXT$) into CX for loop counter
	JCXZ  Exit         ;if CX is zero it's a null string, exit now
	Mov   SI,[SI+02]   ;put address of first character in X$ into SI
	Cld                ;clear the direction flag to move data forward
	Or    DX,DX        ;are we on a mono or EGA system (is DX = 0)?
	JNZ   CGA          ;NO, use the retrace stuff
EVEN
Mono:
	Lodsb              ;get the character from TEXT$ and increment SI
	Stosw              ;store both the character and attribute
	Add   DI,158       ;skipping down each row (Stosw already
			   ;increments one character)
	Loop  Mono         ;loop until CX is zero
Exit:
	Turn_On_Mouse      ; turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
EVEN
CGA:
	CLI                ;prevent interrupts to speed routine
	Wait_CGA_Retrace   ;wait for CGA retrace MACRO
	Lodsb              ;get the character from TEXT$ and increment SI
	Stosw              ;store both the character and attribute
	STI                ;allow interrupts again
	Add   DI,158       ;skipping down each row (Stosw already
			   ;increments one character)
	Loop  CGA          ;loop until CX is zero
	Turn_On_Mouse      ; turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
VPRINT  Endp

;============================================================================
; VPRT.ASM - performs Vertical Printing in the QuickBASIC
; DECLARE SUB VPRT (BYVAL ROW%, BYVAL COL%, TEXT$)
; Works in TextMode only, ignores all special characters
; Sensitive to all video modes (i.e. no snow on CGA's)
; Does not change the attribute, uses whatever was there.
; Assumes: Display width is 80 columns
; DOES NOT CHECK ROW, COL INPUT TO DETERMINE IF W/IN RANGE
;============================================================================

EVEN
Doit1:
	Call  Get_Adapter  ;call routine to find display type
	Jmp	Short Didit1
EVEN
VPRT Proc FAR BASIC USES SI DI, ROW:Ptr, COLL:Ptr, TEXTSTRG:Ptr,
	Turn_Off_Mouse     ; shut off mouse if on MACRO
	Cmp   B$DVIDEOINSTL,1 ;See if we have done this before
	JNE   Doit1        ;no, so install
Didit1:
	Mov   CX,ROW       ;read value of ROW
	Dec   CX           ;convert to BIOS format, 0 wd become &HFFFF
	Mov   DH,CL        ;store CL in DH
	Mov   CX,COLL      ;read value of COLL
	Dec   CX           ;convert to BIOS format, a 0 wd become &HFFFF
	Mov   DL,CL        ;store CL in DL
	CALL Near Ptr SET_DI  ;call routine to find video seg offset in DI
	;Mov   ES,B$DVIDEOSEG  ;restore the initialized values
	;Mov   DX,B$DVIDEOPORT ;DX = 0 if not CGA, else CGA retrace port
	LES   DX, DWORD PTR B$DVIDEOPORT  ;faster than above
	Mov   SI,TEXTSTRG  ;put descriptor to TEXT$ into SI
	Mov   CX,[SI]      ;put Len(TEXT$) into CX for loop counter
	JCXZ  Exit1        ;if CX is zero it's a null string, exit now
	Mov   SI,[SI+02]   ;put address of first character in X$ into SI
	Cld                ;clear the direction flag to move data forward
	OR    DX,DX        ;are we on a mono or EGA system (is DX = 0)?
	JNZ   CGA1         ;NO, use the retrace stuff
EVEN                       ; speeds loop
Mono1:
	Lodsb              ;get the character from TEXT$ and increment SI
	Stosb              ;store just the character but not the attribute
	Add    DI,159      ;skipping down each row
	Loop   Mono1       ;loop until CX is zero
Exit1:
	Turn_On_Mouse      ; turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
EVEN			   ; speeds loop on AT+
CGA1:
	CLI                ;prevent interrupts to speed routine
	Wait_CGA_Retrace   ;wait for CGA retrace MACRO
	Lodsb              ;get the character from TEXT$ and increment SI
	Stosb              ;store just the character but not the attribute
	STI                ;allow interrupts again
	Add   DI,159       ;skipping down each row
	Loop  CGA1         ;loop until CX is zero
	Turn_On_Mouse      ; turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
VPRT    Endp

;=============================================================================
;Call SET_DI
; A local subroutine that fixes DI 
; Setup for 80 column display because that is all QBASIC supports
;
; Input:     DH = Row :  DL = Column
; Output:    DI = Memory Offset
; Destroys:  CX
; A local routine is used so that the name will not become public and 
; and take up space in the .OBJ file
;=============================================================================
EVEN
SET_DI Label Near
	Set_DI_Offset      ; call MACRO to find video seg offset in DI
	Retn		   ; make a near return
END

