DEFINT A-Z
'=======================================================================
' VertM Include
' Updated as of 9/9/91
' Copyright Copr. (C) 1991 by Sidney J. Kelly, All Rights Reserved
'=======================================================================

'Menuing Constants
CONST MaxWinNum% = 7       'Maximum number of Windows
CONST MenStrLen% = 20      'Each string is 20 characters long Max
CONST DialogStrg% = 6      'Length of dialog message
CONST MainMEntries% = 8    'Number of Entries in Main Menu
CONST SecdMEntries% = 6    'Number of Entries in Secondary Menu
CONST DialogEntries% = 2   'Number of entries for Dialog Window
CONST HorizMenLen% = 6     'Width of Horizontal Menus
CONST HMenuEntries% = 6    'Number of Horizontal Menu Entries
CONST InvalidValue% = -256 'Return fact that secondary menu not valid

'Help Menu sizes
CONST HelpMsgLen% = 44     'Width of Help window
CONST HelpEntries% = 120   'Size of array
CONST LenDirName% = 12     'Length of DirArray entry

'Storage array for keeping current window dimensions
'This will be in far memory to save space in DGROUP
TYPE WindowType
     ULR AS INTEGER           'holds dimensions of box
     ULC AS INTEGER
     LRR AS INTEGER
     LRC AS INTEGER
     MaxMenNum AS INTEGER     'for use with MenuType, number of menus
END TYPE


'Storage array for variables necessary for vert menu
'This will be in far memory to save space in DGROUP
TYPE MenuType
     Menu AS STRING * MenStrLen 'length set by constant
     KeyLet AS STRING * 1       'hold the key letter
     KeyLetLoc AS INTEGER       'hold row offset of KeyLetter, if 0 no need to initialize
     BotLine AS STRING * 36     'hold message at bottom
     RowNum AS INTEGER          'Hold Row Number
END TYPE
                        
TYPE DialogType                 'One line prompt line w/ 2 option boxes
     TMenu AS STRING * 14
     TRow AS INTEGER
     TCol AS INTEGER
     LMenu AS STRING * DialogStrg
     LKey AS STRING * 1
     LRow AS INTEGER
     LCol AS INTEGER
     RMenu AS STRING * DialogStrg
     RKey AS STRING * 1
     RRow AS INTEGER
     RCol AS INTEGER
END TYPE

TYPE HorizMType                      'Horizontal Menus
     Menu AS STRING * HorizMenLen
     LCol AS INTEGER
     KeyLet AS STRING * 1
END TYPE

TYPE HelpType                        'HelpMenus
     MESSAGE AS STRING * HelpMsgLen  'holds individual help lines
END TYPE

TYPE DType                           'Holds DirArray
     FNAME AS STRING * LenDirName
END TYPE

                      'GLOBAL VARIABLES
'So all modules can access        -        Shared variables
COMMON SHARED WINDOWS() AS WindowType
COMMON SHARED SizeOFZero%       'Size of main window
COMMON SHARED VideoType%        'Type of adapter & CRT
COMMON SHARED ColorMode%        ' = -1 if CRT can use color
COMMON SHARED NoMouse%          ' = -1 if no MS Mouse found
'COMMON SHARED Fudge&            ' = FudgeFactor& \ 4
COMMON SHARED KeepMain%         ' report that secondary menu active
COMMON SHARED Choice$           ' holds CHR$(of a keystroke)

'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

'Video Routines:

' Fills in a rectangle of your choice with a character and attribute
DECLARE SUB BACKFILL (BYVAL ULR%, BYVAL ULC%, BYVAL LRR%, BYVAL LRC%, BYVAL Attr%, BYVAL TextChar%)

 ' Input:
 '        0 = turn cursor off
 '        1 = turn cursor on in attactive mode
 '        2 = set cursor to half-block size
 '        3 = set cursor to full block size
DECLARE SUB CURSET (BYVAL Mode%)

 ' The following routine selects an EGA palette comparable to HERC colors
DECLARE SUB EGAMONO (BYVAL Mode%)

 ' Prints Far Arrays of Strings, Very fast
 'because it does not create temporary strings in DGROUP
 'Does change attribute, better for first printing of an array
DECLARE SUB FPRINT (BYVAL Row%, BYVAL Col%, BYVAL SEGS%, BYVAL OFFS%, BYVAL LENGTH%, BYVAL SKIPNUM, BYVAL Attr%)

 ' Prints Far Arrays of Strings, Very fast
 'because it does not create temporary strings in DGROUP
 'does not change attribute
DECLARE SUB FPRT (BYVAL Row%, BYVAL Col%, BYVAL SEGS%, BYVAL OFFS%, BYVAL LENGTH%, BYVAL SKIPNUM)

' Makes a box of a specified dimension
DECLARE SUB MAKEBOXES (BYVAL ULR%, BYVAL ULC%, BYVAL LRR%, BYVAL LRC%, BYVAL HASNO%, BYVAL Border%, BYVAL ATTRIB%)

' Very fast screen printer, NO snow on CGA
DECLARE SUB QPRINT (BYVAL Row%, BYVAL Col%, Text$, BYVAL Attr%)

 ' Screen printer using the current attribute under the string w/o change
DECLARE SUB QPRT (BYVAL Row%, BYVAL Col%, Text$)

 ' Reverse foreground and background colors, blink should be off
 ' if intense colors are used
DECLARE SUB REVVID (BYVAL Row%, BYVAL Col%, BYVAL NumChar%)

 ' Sets blink mode if BMode% <> 0
 ' Sets intensity mode if BMode% = 0
 ' Necessary for use w/ REVVID and intense foreground
DECLARE SUB SETBLINK (BYVAL BMode%)

 ' Tests for CGA displays by AT&T (Olivetti), COMPAQ and Zenith
 ' disables snowchecking for those CGA displays
DECLARE SUB SNOWCHECK ()

'  CALL TOGGLESNOW(Mode%)
' Input: If Mode% =  0, clears SNOWCHECK
'        If Mode% <> 0, leaves SNOWCHECK set
' Purpose:
'         Clears the snowcheck variable (B$DVIDEOPORT) if find a CGA display
'         Also reinitializes Video Data Area
DECLARE SUB TOGGLESNOW (BYVAL Mode%)


 ' Returns the videostatus of the machine using SCREEN style numbers
 ' However the MCGA returns Screen 11, rather than 13 so you can test for
 ' VGA too.   Return parameters
 ' Mono         =   0
 ' CGA          =   2
 ' PGA          =   2   (Untested, assume PGA would be treated as CGA)
 ' COMPAQ - CGA =  -2   to tell that user may have a single color display
 ' HERC         =   3   if have HERC and MSHERC.COM
 ' HERC         =  -3   if have HERC but w/o MSHERC.COM
 ' AT&T         =   4,  but only if have just CGA display, not EGA or VGA
 ' EGA64        =   8   Because resolution limited for 64k EGA
 ' EGA64 w/CGA  =  -8   Because resolution limited to CGA modes
 ' EGA          =   9   Have minimum of 128kb of video ram
 ' EGA w/CGA    =  -9   Since resolution limited to CGA modes
 ' EGA Mono     =  10   If have EGA with mono display
 ' MCGA w/EGA   = -12   If have an EGA ECD digital color display, since
 '                      resolution of this display is limited to EGA modes
 ' MCGA Mono    = -11   If have MCGA with a mono display
 ' MCGA         =  11   If have an analog color display
 ' VGA Mono     = -10   To distinguish between EGA mono
 ' VGA          =  13   Normal VGA color display
 ' VGA          = -13   Monochrome monitor really appears to be color
DECLARE FUNCTION VIDEOSTAT% ()

 ' Vertical Printing, assumes width of 80
DECLARE SUB VPRT (BYVAL Row%, BYVAL Col%, Text$)

 ' These do the same as above, but only save a portion of the array
 ' DIM ARRAY%(2000). Performs no range checking!
 ' CALL WINDSAVE(ULR%, ULC%, LRR%, LRC%, VARSEG(Array%(0)), VARPTR(Array%(0)))
DECLARE SUB WINDSAVE (BYVAL ULR%, BYVAL ULC%, BYVAL LRR%, BYVAL LRC%, BYVAL SEGADD%, BYVAL OFFADR%)

 ' These do the same as above, but only restore save a portion from the array
 ' DIM ARRAY%(2000).  Performs no range checking
 ' CALL WINDREST(ULR%, ULC%, LRR%, LRC%, VARSEG(Array%(0)), VARPTR(Array%(0)))
DECLARE SUB WINDREST (BYVAL ULR%, BYVAL ULC%, BYVAL LRR%, BYVAL LRC%, BYVAL SEGADD%, BYVAL OFFADR%)

 ' Flips colors w/o changing text attributes
 ' Does not touch the color if the intensity bit is set
DECLARE SUB XORCRT (BYVAL Row%, BYVAL Col%, BYVAL NumChar%)

 ' Select VGA border color
DECLARE SUB VGABORDER (BYVAL Border%)

 ' Resets color VGA to defaults
DECLARE SUB VGACONTROL 

'Keyboard:

 ' Clears the Keyboard of all pending keys
 ' by resetting the tail of the buffer to the head w/o reading any keys
 ' may crash the system if KeyBoard Macro program is in use.
DECLARE SUB CLRKBD ()

 ' Returns -256 if no key pressed
 ' Returns ASC(key) for normal keys
 ' Returns Scan code for extended keys as a negative number
 ' respects 101 key keyboards
DECLARE FUNCTION WAITFORKEY% ()

'Mouse:

 ' Returns number of buttons if Mouse Exists, 0 if Mouse does not Exist
 ' You MUST call it or FASTMOUSE before calling any other mouse function!!!!!!!
 ' Because of changes to the mouse driver over time, this has become very slow
DECLARE FUNCTION MMEXIST% ()

 ' A faster routine.  Assumes have 2 button mouse if returns TRUE
 ' Does not reset hardware.
DECLARE FUNCTION FASTMOUSE% ()

 ' Resets Keyboard & mouse motion counters
DECLARE SUB CLRMOUSEKEY ()

' Turns MOUSE cursor on
DECLARE SUB MMCURSON ()

 ' Turns MOUSE cursor off
DECLARE SUB MMCURSOFF ()

 ' -The following routine is designed for text screen use only
 ' Find location of Mouse
DECLARE SUB MMLOCATE (Row%, Col%)

 ' See if left button is down
DECLARE FUNCTION MMLEFTBUT% ()

 ' Test if either a normal key or mouse press has occured
DECLARE FUNCTION MMORKEY% ()

 ' Find information about last button press
 ' Button = 0 for left, 1 for right button
DECLARE SUB MMPRESSLOCATE (Button%, Times%, Row%, Col%)

 ' Find information about last button release
 ' Button = 0 for left, 1 for right button
DECLARE SUB MMRELEASELOCATE (Button%, Times%, Row%, Col%)

' Test if Right Button currently Pushed
DECLARE FUNCTION MMRIGHTBUT% ()

 ' Moves mouse cursor to a fixed location
DECLARE SUB MMSETLOCATION (BYVAL Row%, BYVAL Col%)

 'Allows a linear speed change of mouse from 0 to 3
DECLARE SUB MMSPEED (BYVAL Value%)

 ' Changes character used by text cursor (character is allways intense white)
DECLARE SUB MMTCURSOR (BYVAL Char%)

'Other:

 ' Parses tabs and spaces to determine number of words in string
DECLARE FUNCTION COUNTARGS% (Text$)

 ' Delay timer routine
 ' Run the first function just one time and assign to Fudge&
'DECLARE FUNCTION FudgeFactor& ()

 ' Machine independent delay
'DECLARE SUB DELAY (MiliSec%, Fudge&)
 
  ' Fast routine to delete a normal string
DECLARE SUB KILLSTRING (A$)

 ' Fast substitute for LEN on variable length strings
DECLARE FUNCTION NULEN% (A$)

 ' Smaller than SOUND routine, Needs FudgeFactor&
 ' Does not use floating point
'DECLARE SUB NUSOUND (Freq%, Duration%, Fudge&)

'Dir Array Routines
DECLARE FUNCTION FILEARRAY% (FileName$, BYVAL ATTRIB, BYVAL ArraySize, DirArray() AS DType)
'NumItems is the number of items of the array, returned by FILEARRAY
DECLARE SUB DIRSORT (BYVAL DirSeg%, BYVAL DirOff%, BYVAL NumItems%)

 ' Adjust speed of AT keyboard to normal = 1
 ' fast = 0, any other number = s...l....o.....w
DECLARE SUB ATKEYDELAY (BYVAL Speed%)

 ' Alt sound routines
DECLARE SUB BEEPER10
DECLARE SUB BEEPER20

  ' Alt delay routine uses the CRT for a delay
  ' somewhat machine independent delay
DECLARE SUB KILLTIME (BYVAL DelayFact%)

