'=======================================================================
' Copyright Copr. (C) 1991, Sidney J. Kelly, All rights reserved
' This makes Vertical Menus that use a Keyboard, Quick letters & Mouse
'
' The LEFT click of the Mouse selects the item.
' For the Horizontal Menu it takes a double click
' The right Button% drag is equivalent to moving arrow keys.
' Right Click outside menu window = ESC
' HOME, END, PAGEUP, PAGEDOWN = a quick selection of Top & Bottom item
'
' Invalid extended keys "chirp" to report an error
'
' Updated 12/22/91
'=======================================================================
DEFINT A-Z
REM $INCLUDE: 'VERTM.INC'

'Save some space for common message strings
CONST Text$ = "    Press key or button to continue.      "
CONST CopyRight$ = "Copyright (C) 1991, Sidney J. Kelly, All rights reserved"
CONST EscMsg$ = " You pressed the ESCAPE key, and selected Nothing.  "
CONST NotImp$ = "   Sorry, not implemented in here."

'Declare SUBS----------------------------------------------------------
'Selects the Border% Elements based on KeyPressed of Border%
'Listed by Border% Number
	'No Border                                       =Border  0
	'Double Line Border% (the default for CASE else) =Border% 1
	'Single Line Border%                             =Border% 2
	'Double Horizontal Single Vertical Border%       =Border% 3
	'Double Vertical Single Horizontal Border%       =Border% 4
	'Solid Border%                                   =Border% 5
	'Double Line Border for Dialog Box               =Border% 6
'add OR 256 if want a background shadow
DECLARE SUB NormalWindow (ULR%, ULC%, LRR%, LRC%, Attr%, Border%, Label$)
'Make my logo
DECLARE SUB MakeMyLogo ()
 'Choose the Main Menu
DECLARE SUB ChooseMainMenu (Msg%, WinNumber%, RetValue%, MMessage$)
 'Choose the Secondary Menu
DECLARE SUB ChooseSecdMenu (Msg%, WinNumber%, RetValue%, SMessage$)
 'The heart of the PROGRAM
DECLARE SUB DoButtonTest (Msg%, WinNumber%, ChoiceLetter$, RetValue%, T() AS MenuType)
 'Prints the Menus
DECLARE SUB PrintMenu (WinNumber%, Attr%, Init%, ChoiceLetter$, Label$, T() AS MenuType)
 'Checks mouse location
DECLARE SUB MouseMenuSelect (NUMBERMENUS%, Temp%, ErrVal%, MenuSelect%, T() AS MenuType)

'Does Dialog Boxes
DECLARE SUB DialogMenu (Msg%, Init%, Attr%, RetValue%)

'Does Horizontal Menus
DECLARE SUB HorizMenu (Init%, HorizMenuChange%, RetValue%)

'Saves bottom two message lines of Main Window
DECLARE SUB SaveBottom ()
'Restores bottom two message lines of Main Window
DECLARE SUB RestoreBottom ()

'Initialize the Vertical Menus
DECLARE SUB InitMMenuArray (Msg%, MainMenu() AS MenuType)
DECLARE SUB InitSMenuArray (Msg%, SecMenu() AS MenuType)

'Size the arrays
DECLARE SUB SetMainSize (Msg%)
DECLARE SUB SetSecSize (Msg%)

'Prints Help Windows
'The Msg% feature not fully implemented
'You would have to assign each menu action a unique code
DECLARE SUB HelpMenu (Msg%, Init%, HorizMenuChange%)

 ' Select nice defaults for mouse
DECLARE SUB MouseAdj ()

 ' Shell to DOS routine
DECLARE SUB DOSSHELL (MaxCRTLen%)
 ' Adjusts display if user wants hirez text
DECLARE SUB AdjustDspLen (VideoType%, LRR%, SizeOFZero%, MaxCRTLen%)

'Useful near constants
Chr34$ = CHR$(34)              'make some routines run faster
Choice$ = SPACE$(1)            'this holds the CHR$ equiv of a keystroke
Cmd$ = COMMAND$                'save space call COMMAND$ once

'if have an AT keyboard, speed it up to max
CALL ATKEYDELAY(0)

 ' Determine various screen/adapter types
VideoType% = VIDEOSTAT%   'Store in a shared variable

'--------COMMAND$ - Command Line switches ------------------------------
  'Default video parameters
  CALL VGACONTROL   ' reset VGA to defaults
  WIDTH 80, 25
  SizeOFZero% = 2002
  LRR% = 25

  'delay routines need a graphics adapter to work
  IF VideoType = 0 THEN
	Text1$ = "Sorry, you need a graphics adapter for this to work!"
	CLS
	CALL QPRT(4, 1, Text1$)
	END
  END IF


IF NULEN%(Cmd$) THEN    'if anything on COMMAND line test it
	' Note if have LCD display, user will want to use a command line option
	' to select Mono mode.  It appears that LCD/PLASMA displays
	' only have two attributes on and off, and no intensity
	' We will treat this display as a COMPAQ CGA display
	IF INSTR(Cmd$, "/B") THEN VideoType = -2

	'If user uses the /F switch give fast CGA display w/o snow checking
	IF INSTR(Cmd$, "/F") THEN CALL TOGGLESNOW(0)

	'Adjust display to max length if /H switch
	'If user uses the /H switch give him maximum resolution
	'and tiny txt but do it only in color mode because
	'too hard to see in mono mode, except on a VGA
	IF INSTR(Cmd$, "/H") THEN
		CALL AdjustDspLen(VideoType%, LRR%, SizeOFZero%, MaxCRTLen%)
	END IF

	'Allow a COMPAQ user with a real color display to use it
	IF INSTR(Cmd$, "/C") THEN VideoType = 2

	IF INSTR(Cmd$, "/?") THEN
		CLS
		Text1$ = "Command Line Switches:"
		CALL QPRT(4, 1, Text1$)
		Text1$ = " /B is select Mono mode."
		CALL QPRT(5, 1, Text1$)
		Text1$ = " /F is select FAST CGA mode, may make certain CGA's snow."
		CALL QPRT(6, 1, Text1$)
		Text1$ = " /H is select HiRez mode, select high rez display mode."
		CALL QPRT(7, 1, Text1$)
		Text1$ = " /C is select color mode for a COMPAQ CGA display."
		CALL QPRT(8, 1, Text1$):
		Text1$ = " /?, print this HELP display."
		CALL QPRT(9, 1, Text1$):
		END
	END IF
END IF

'-Color Selection Section based on CRT type
SELECT CASE VideoType%    'test for display that can show color well
	CASE -3, -2, 0, 3, 4, 10, -10, -12
		'for Herc, COMPAQ, AT&T/OLIVETTI, EGA mono, VGA mono display
		Attr4% = &H70   'Background color = 7: Foreground color = 0
		ColorMode% = 0  'report have a mono display
	CASE ELSE
		Attr4% = &H20   'Background color = 2: Foreground color = 0
		ColorMode% = -1 'report have a color display
END SELECT

 ' Make sure COMPAQ, ZENITH and AT&T CGA displays go as fast as possible
 '  whether or not a command line entry was used
CALL SNOWCHECK

REM $DYNAMIC
'This array allows us to control current window
' 7 windows:
'   1) Base, 2) Main Vertical Menu, 3) Secondary Vertical Menu
'   4) Dialog, 5) Horizontal Menu, 6) Help Menu
'   7) Help - Mouse hot key area
DIM WINDOWS(1 TO MaxWinNum%)  AS WindowType
 ' Add more screens here if you need them
REM $STATIC

'Save bottom two lines of display
DIM Bot2Line%(162) 'create an array to hold information

'Set base window variables
WINDOWS(1).ULR = 2: WINDOWS(1).ULC = 1
WINDOWS(1).LRR = LRR%: WINDOWS(1).LRC = 80


'**********This is where the program really begins**********************
	CLS : LOCATE , , 0  'Clear screen & turn off cursor
	CALL SETBLINK(0)    ' Turn blinking off, so can have background intensity
	'select blue border on a VGA color display if have color display
	IF ColorMode% THEN CALL VGABORDER(VBorderC%)
	
	'Get variables necessary to draw the background window
	ULR% = WINDOWS(1).ULR: ULC% = WINDOWS(1).ULC
	LRR% = WINDOWS(1).LRR: LRC% = WINDOWS(1).LRC
	MenuItems% = WINDOWS(1).MaxMenNum

	CALL KILLSTRING(Label$)
	Border% = 3
	CALL NormalWindow(ULR%, ULC%, LRR%, LRC%, Attr4%, Border%, Label$)
	
	CALL MouseAdj 'select nice defaults for mouse

	'This makes the hot spot for local help for use by the Mouse
	Label$ = "[ F1 = Local Help ]"
	WINDOWS(7).MaxMenNum = NULEN%(Label$)
	WINDOWS(7).ULR = WINDOWS(1).ULR
	WINDOWS(7).LRC = 79
	WINDOWS(7).ULC = WINDOWS(7).LRC - WINDOWS(7).MaxMenNum + 1
	WINDOWS(7).LRR = WINDOWS(1).ULR
	CALL QPRINT(WINDOWS(7).ULR, WINDOWS(7).ULC, Label$, &HF)
	CALL KILLSTRING(Label$)

	WinNumber% = 1
	'Save the bottom two lines of display
	'This allows easy restore of lines independent of color choosen
	CALL SaveBottom

'-----------------Make my LOGO ----------------------------

	CALL MakeMyLogo
	
'---------------End of Logo--------------------------------------

	HMenuInit% = 0
	HorizMenuChange% = 0

StartAgain:
	'clears the bottom two lines of the display
	CALL RestoreBottom

	'Show the horizontal menu
	CALL HorizMenu(HMenuInit%, HorizMenuChange%, RetValue%)
	HMenuInit% = -1

		'The best way to do this is to use the RetValue% to select the
		'Msg% value used for the popdown menu
		SELECT CASE RetValue%
			CASE 0       'ESC key pressed
				CALL QPRINT(WINDOWS(1).LRR - 1, 22, EscMsg$, &H70)
				CALL CLRMOUSEKEY     'clear mouse & keyboard
				DO
				LOOP UNTIL MMORKEY   'wait for an event
				GOTO StartAgain
			CASE 6       'help key pressed
				Msg% = 6
				CALL HelpMenu(Msg%, Init%, HorizMenuChange%)
				HMenuInit% = -1
				GOTO StartAgain
			CASE ELSE    'any other key pressed
				Msg% = RetValue%
		END SELECT


DO  '******************** Begin Primary Loop************************


	'Draw the 1st popdown Menu
	'This wont return until it gets a value
	WinNumber% = 2
	CALL ChooseMainMenu(Msg%, WinNumber%, RetValue%, MMessage$)


 IF RetValue% = 6 THEN     'Select secondary Menu if got a 6
	'clears the bottom two lines of the display
	CALL RestoreBottom

 DO     '********************Begin Secondary Loop*****************

	WinNumber% = 3
	CALL ChooseSecdMenu(Msg%, WinNumber%, RetValue%, SMessage$)

	'**********************************************************
	'Programmer Secondary hook area, Hang everything on the Menutree
	'based on the RetValue%
	'**********************************************************
	SELECT CASE RetValue%
	
	  CASE WINDOWS(3).MaxMenNum%
		Text1$ = " Your choice was <<EXIT>>, so I will."
		CALL QPRINT(WINDOWS(1).LRR, 22, Text1$, &H70)
		CALL KILLSTRING(Text1$)
		RetValue% = 6   'make return value = value that got us here
		CALL ATKEYOFF
		CALL KILLTIME(4000) 'delay so can see message
		'clears the bottom two lines of the display
		CALL ATKEYON
		CALL RestoreBottom
		EXIT DO
	
	  CASE 2 TO (WINDOWS(3).MaxMenNum% - 1)
		CALL RestoreBottom
		Text1$ = "Selection: " + Chr34$ + SMessage$ + Chr34$
		CALL QPRINT(WINDOWS(1).LRR, 22, Text1$, &H70)
		CALL KILLSTRING(Text1$)
	  CASE 1
		CALL RestoreBottom
		CALL QPRINT(WINDOWS(1).LRR - 1, 12, CopyRight$, &H70)
	
	  CASE 0
		CALL RestoreBottom
		CALL QPRINT(WINDOWS(1).LRR, 22, EscMsg$, &H70)
		RetValue% = 6   'make return value = value that got us here
		EXIT DO
	
	  CASE InvalidValue%  'We tried to access a secondary menu
		'and could not because it would extend past right column of
		'screen
		CALL RestoreBottom
		RetValue% = 6   'make return value = value that got us here
		EXIT DO
	END SELECT

	CALL CLRMOUSEKEY          'clear mouse and keyboard buffer
	CALL ATKEYOFF
	CALL KILLTIME(3000)       'allow time to see screen update
	CALL ATKEYON
    
  LOOP    '********************End of Secondary Loop**************

 END IF

	 '**********************************************************
	'Programmer Main hook area, Hang everything on the Menutree
	'based on the RetValue%
	'**********************************************************

	SELECT CASE RetValue%
	  CASE WINDOWS(2).MaxMenNum%
		Text1$ = "   You selected <<QUIT>>, so I will."
		CALL QPRINT(WINDOWS(1).LRR, 22, Text1$, &H70)
		CALL KILLSTRING(Text1$)
		EXIT DO
	
	  CASE 5       'Shell to DOS
		CALL DOSSHELL(MaxCRTLen%)
		GOTO Skipper     'skip over pause for keystroke
		
	  CASE 3
		CALL QPRINT(WINDOWS(1).LRR - 1, 12, CopyRight$, &H70)
	
	  CASE 1 TO (WINDOWS(2).MaxMenNum% - 1)
		'clears the bottom two lines of the display
		CALL RestoreBottom
		Text1$ = "You selected " + Chr34$ + RTRIM$(MMessage$) + Chr34$
		CALL QPRINT(WINDOWS(1).LRR, 24, Text1$, &H70)
		CALL KILLSTRING(Text1$)
	
	  CASE 0    'ESC key pressed
		'CLEAR the Vertical Menu
		HMenuInit% = -1    'keep top box cursor
		HorizMenuChange% = 0  'don't change it
		GOTO StartAgain
	
	  CASE -1, -2, -3
		EXIT DO
	END SELECT

	HorizMenuChange% = 0
	CALL CLRMOUSEKEY      'clear mouse and keyboard buffer
	CALL ATKEYOFF
	CALL KILLTIME(3000)   'allow time to see screen update
	CALL ATKEYON
	CALL RestoreBottom

Skipper:

LOOP    '********************End of Primary Loop*******************

	  'Break out of Vertical Menu by Click on Top Row
	  'or an arrow key then restart
	  SELECT CASE RetValue%
		CASE -1, -2
			HMenuInit% = -1
			HorizMenuChange% = RetValue%
			CALL CLRMOUSEKEY
			GOTO StartAgain
		CASE -3
			HMenuInit% = -1
			HorizMenuChange% = RetValue%
			GOTO StartAgain
		CASE ELSE  'do nothing
	  END SELECT


	SELECT CASE Msg1%  'This toggles the dialog message box "language"
		CASE 2
			Msg1% = 1  'Normal Version
		CASE ELSE
			Msg1% = 2  'Valley Speak version
	END SELECT

	IF ColorMode THEN   'handle multiple display types
		Attr% = &H40    'color, red on black
	ELSE
		Attr% = &H70    'mono, white on black
	END IF

	Init% = False
	CALL DialogMenu(Msg1%, Init%, Attr%, RetValue%)

	SELECT CASE RetValue%  'Exit only if hit yes
		CASE 2
		CASE 1, 0   'No BOX selected or ESC key pressed
			CALL QPRINT(WINDOWS(1).LRR, 21, Text$, &H70)
			'make sure position on horizontal menu doesn't change
			HorizMenuChange% = 0
			GOTO StartAgain
	END SELECT

'********************Cleanup & Quit************************************
	WIDTH 80, 25     'reset to default width
	CALL MMCURSOFF   'if mouse cursor on, then turn it off
	COLOR 7, 0       'restore normal DOS default
	'clear screen
	CLS : LOCATE , , 1
	CALL QPRT(10, 10, CopyRight$)
	' Turn blinking back on
	CALL SETBLINK(1)
END

'======================================================================
' Adjust all systems defaults if user want hirez text mode
'======================================================================
SUB AdjustDspLen (VideoType%, LRR%, SizeOFZero%, MaxCRTLen%) STATIC
	SELECT CASE VideoType%
		CASE 9
		'reset normal mode so SHELL works if user program changes display width
			WIDTH 80, 25
			LRR% = 43       'EGA color
			WIDTH 80, LRR%
			SizeOFZero% = 3442
			MaxCRTLen% = -1
		CASE 13, -13, -10
		'reset normal mode so SHELL works if user program changes display width
			WIDTH 80, 25
			LRR% = 50       'VGA color
			WIDTH 80, LRR%
			SizeOFZero% = 4002: MaxCRTLen% = -1
		CASE ELSE            'reset all modes to 80 x 25
			WIDTH 80, 25    'everything else
			SizeOFZero% = 2002
			LRR% = 25: MaxCRTLen% = 0
	END SELECT
END SUB

'=======================================================================
'Choose the Primary Menu
'Parameters:
'        Msg% = Allows selection of multiple windows based on Msg% number
'        WinNumber% = window number of popdown menu
'
'Returns:
'        RetValue% 0, if escape key selected
'        MMessage$ = The string used to descibe the Menu item
'
'This is a specialized routine only for Main Menu
'=======================================================================
SUB ChooseMainMenu (Msg%, WinNumber%, RetValue%, MMessage$) STATIC

	STATIC Inits%, Temp%

	'This sizes the Main window based on Msg% number
	CALL SetMainSize(Msg%)
	
	IF Inits% = False THEN
		'Save everything
		ULR% = WINDOWS(WinNumber%).ULR
		ULC% = WINDOWS(WinNumber%).ULC
		LRR% = WINDOWS(WinNumber%).LRR
		LRC% = WINDOWS(WinNumber%).LRC
		MenuItems% = WINDOWS(WinNumber%).MaxMenNum
	
		REM $DYNAMIC
		'Dimension MainMenu array
		DIM MainMenu(1 TO MenuItems%)  AS MenuType
	
		'Initialize data for primary Menu, again based on Msg% number
		CALL InitMMenuArray(Msg%, MainMenu())
	
		'Determine size of window assuming have shadow & topbox
		Temp% = (LRR% - ULR% + 3) * (LRC% - ULC% + 3)
		
		DIM SCRN1%(Temp%)
		REM $STATIC
		' Save screen 0 behind menu, assume have shadow
		CALL WINDSAVE(ULR% - 1, ULC%, LRR% + 1, LRC% + 2, VARSEG(SCRN1%(0)), VARPTR(SCRN1%(0)))
	END IF
	Inits% = True

	Attr% = &H70    'Make it Black letters on White background
	Init% = False      'This initializes ChoiceLetter$
	Label$ = "Main Menu"
	CALL PrintMenu(WinNumber%, Attr%, Init%, ChoiceLetter$, Label$, MainMenu())
	CALL DoButtonTest(Msg%, WinNumber%, ChoiceLetter$, RetValue%, MainMenu())

	'If the RetValue% inidicates still in Secondary Menu, don't erase
	IF RetValue% = KeepMain THEN
		'do nothing
		MMessage$ = MainMenu(RetValue%).Menu
	ELSE
		'Restore window
		ULR% = WINDOWS(WinNumber%).ULR
		ULC% = WINDOWS(WinNumber%).ULC
		LRR% = WINDOWS(WinNumber%).LRR
		LRC% = WINDOWS(WinNumber%).LRC
		MenuItems% = WINDOWS(WinNumber%).MaxMenNum
	
		CALL WINDREST(ULR% - 1, ULC%, LRR% + 1, LRC% + 2, VARSEG(SCRN1%(0)), VARPTR(SCRN1%(0)))
		IF RetValue% > 0 THEN
			MMessage$ = MainMenu(RetValue%).Menu
		ELSE
			MMessage$ = " "
		END IF
		ERASE SCRN1%
		ERASE MainMenu
		Inits% = False
	
		'erase temporary string
		CALL KILLSTRING(Label$)

	END IF

END SUB

'=======================================================================
'Choose Secondary Menu
'Parameters:
'        Msg% = Allows selection of multiple windows based on Msg% number
'               Msg% comes from the horizontal menu
'        WinNumber% = window number of popdown menu
'
'Returns:
'        RetValue% 0, if escape key selected
'        SMessage$ = The string used to descibe the Menu item
'
'This is a specialized routine only for Secondary Menu
'=======================================================================
SUB ChooseSecdMenu (Msg%, WinNumber%, RetValue%, SMessage$) STATIC

  STATIC Inits%, Temp%

	'This sizes the Main window based on Msg% number
	CALL SetSecSize(Msg%)

 IF Inits% = False THEN
	
	 ULR% = WINDOWS(WinNumber%).ULR
	 ULC% = WINDOWS(WinNumber%).ULC
	 LRR% = WINDOWS(WinNumber%).LRR
	 LRC% = WINDOWS(WinNumber%).LRC
	 MenuItems% = WINDOWS(WinNumber%).MaxMenNum

	'If a Secondary Menu not possible, then ignore
	IF (ULR% = 0) OR (LRC% > WINDOWS(1).LRC) THEN
		SMessage$ = " "
		RetValue% = InvalidValue%
	EXIT SUB
	END IF

	REM $DYNAMIC
	DIM SecMenu(1 TO MenuItems%) AS MenuType

	'Initialize data for secondary Menu
	CALL InitSMenuArray(Msg%, SecMenu())
	'Assume a shadow
	Temp% = (LRR% - ULR% + 2) * (LRC% - ULC% + 3)
	
	DIM SCRN3%(Temp%)
	REM $STATIC

	' Save screen 0 behind menu, assume have a shadow
	CALL WINDSAVE(ULR%, ULC%, LRR% + 1, LRC% + 2, VARSEG(SCRN3%(0)), VARPTR(SCRN3%(0)))
 END IF

  Inits% = True

  IF ColorMode% THEN
	'Attr% = &H71    'Blue letters on White background
	'Attr% = &H1E    'Yellow letters on Blue background
	'Attr% = &H13    'Cyan letters on Blue background
	Attr% = &H31     'Blue letters on Cyan background
  ELSE
	Attr% = &H70    'Make it Black letters on White background
  END IF

	Init% = False      'This initializes ChoiceLetter$
	Label$ = "Secondary Menu"

DO
	CALL PrintMenu(WinNumber%, Attr%, Init%, ChoiceLetter$, Label$, SecMenu())
	CALL DoButtonTest(Msg%, WinNumber%, ChoiceLetter$, RetValue%, SecMenu())
	'Don't allow Left Arrow, or Right Arrow to exit
	IF RetValue% >= 0 THEN
		EXIT DO
	ELSE
		Init% = True
	END IF
LOOP

	'Restore window
	ULR% = WINDOWS(WinNumber%).ULR
	ULC% = WINDOWS(WinNumber%).ULC
	LRR% = WINDOWS(WinNumber%).LRR
	LRC% = WINDOWS(WinNumber%).LRC
	MenuItems% = WINDOWS(WinNumber%).MaxMenNum

	CALL WINDREST(ULR%, ULC%, LRR% + 1, LRC% + 2, VARSEG(SCRN3%(0)), VARPTR(SCRN3%(0)))
	Inits% = False

	IF RetValue% > 0 THEN
		SMessage$ = SecMenu(RetValue%).Menu
	ELSE
		SMessage$ = " "
	END IF

	ERASE SCRN3%
	ERASE SecMenu
	'erase temporary string
	CALL KILLSTRING(Label$)

END SUB

'=======================================================================
'This is the main Routine
'Parameters:
'    WinNumber% = Current number of menu window
'    ChoiceLetter$= ChoiceLetter$ from print menu
'    T as MenuType = MenuType array (generally MainMenu or SecMenu)
'Output:
'    RetValue% = integer return value
'Assumes:
'    That a window menu already has been drawn, and ChoiceLetter$ filed in
'
'In this routine
'                  a LEFT Button% press selects
'                 a RIGHT Button% press =  an arrow key if inside menu
'                         area
'                 a RIGHT Button% release outside menu area = ESC key
'                 a RIGHT Button% drag = moving arrow key
'                 a Double Click of Left Button% selects another Vert Menu
'
'Mouse presses are tested before keystrokes.
'Use MMPRESSLOCATE because it acts as a buffer and holds most recent
'mouse presses.  If we just check for a Button% down, it may happen and
'be finished before we can check for it in the loop.
'
'This is a generic routine
'=======================================================================
SUB DoButtonTest (Msg%, WinNumber%, ChoiceLetter$, RetValue%, T() AS MenuType) STATIC

 'To keep this routine independent make STATIC
 STATIC KeyPressed%, Choice$

 'Mouse variables
 STATIC Row, Times, Button%
 STATIC BeginRow%, BeginCol%, StopRow%, StopCol%, NUMBERMENUS%
 STATIC ULR1, ULC1, LRR1, LRC1, Row1, RowOld, Inits%, BottomLine, OldValue
 STATIC MWidth%

 IF Inits% = False THEN BottomLine = WINDOWS(1).LRR
 Inits% = True       'Make sure do above only one time per session

 'These formulas allow Menu to be of any size and number
 'we do these computations outside the loop
 ULR1 = WINDOWS(WinNumber%).ULR
 ULC1 = WINDOWS(WinNumber%).ULC
 LRR1 = WINDOWS(WinNumber%).LRR
 LRC1 = WINDOWS(WinNumber%).LRC
 NUMBERMENUS = WINDOWS(WinNumber%).MaxMenNum

 BeginRow% = ULR1 + 2
 BeginCol% = ULC1 + 2
 StopRow = BeginRow% + T(NUMBERMENUS).RowNum
 StopCol = BeginCol% + MenStrLen%
 MWidth% = MenStrLen% + 1

 'Draw the initial cursor on the screen
 MenuSelect% = 1
 'Start cursor with first one on the list
 GOSUB InitCursor
 'Clears keyboard and mouse for testing
 CALL CLRMOUSEKEY

'------------Start of Main Loop----------------------------------
DO  'Main loop keep adjusting box cursor until leave routine

	DO 'keep reading keystrokes
	
ReStart:
		'Read a key from the buffer.  Normal key is positive,
		'extended key is negative, no key = -256
		'Function reads normal and extended keyboards
		KeyPressed% = WAITFORKEY
	
		'skip the following if no mouse, for speed reasons
		IF NoMouse% GOTO SkipMouseSection

		Button% = 0 'Check for LEFT Button% Press
		CALL MMPRESSLOCATE(Button%, Times%, Row%, Col%)
		IF Times THEN  'Got a LEFT Button% press
			IF Row = WINDOWS(7).ULR THEN
				SELECT CASE Col% 'Puts up a help routine
					CASE WINDOWS(7).ULC TO WINDOWS(7).LRC
					 Init2 = 0
					 CALL HelpMenu(Msg%, Init2%, HorizMenuChange%)
					CASE ELSE
				END SELECT
			END IF
			'Go back to Horizontal Menu selection
			'if click on top row
			IF Row = WINDOWS(5).ULR THEN
				RetValue% = -3
				GOSUB ReDoCursor
				EXIT SUB
			END IF
			'Check if Mouse is within range
			IF (Row >= BeginRow%) AND (Row <= StopRow) THEN
				IF (Col% >= BeginCol%) AND (Col% <= StopCol) THEN
					GOSUB MouserCheck
					IF ErrVal% GOTO ReStart    'restart loop
					GOSUB ReDoCursor     'display box cursor
					RetValue% = MenuSelect%
					EXIT SUB
				END IF
			END IF
		END IF
	
		Button% = 1 'Check for RIGHT Button% press
		CALL MMPRESSLOCATE(Button%, Times%, Row%, Col%)
		IF Times THEN   'Got a RIGHT Button% press
		'Check if Mouse is within range
			IF (Row >= BeginRow%) AND (Row <= StopRow) THEN
				IF (Col% >= BeginCol%) AND (Col% <= StopCol) THEN
					GOSUB MouserCheck
					IF ErrVal% GOTO ReStart   'restart loop
					GOSUB ReDoCursor
					GOTO ReStart  'restart loop
				END IF
			END IF
		END IF

		'Test if RIGHT Button% being dragged directly over a menu item
		'if yes, then cycle up or down menu
		'Can't test for LEFT Button% down, as MMPRESSLOCATE gets it
		IF MMRIGHTBUT% THEN   'see if Button% is down
			CALL MMLOCATE(Row%, Col%)
		'Check if Mouse is within range (allow a little overshooting)
			IF (Row >= BeginRow% - 2) AND (Row <= StopRow + 2) THEN
				IF (Col% >= BeginCol%) AND (Col% <= StopCol) THEN
					GOSUB MouserCheck
					IF ErrVal% GOTO ReStart  'restart loop
					GOSUB ReDoCursor
					GOTO ReStart  'restart loop
				END IF
			END IF
		END IF


	   'Test if RIGHT Button% released outside menu area
	   'if yes, then exit as if ESC key were pressed
	   Button% = 1 'Check for RIGHT Button% release
	   CALL MMRELEASELOCATE(Button%, Times%, Row%, Col%)
	   IF Times THEN
		   'Check if Mouse is outside range
		   IF (Row < ULR1) OR (Row > LRR1) THEN
			   RetValue% = 0
			   GOSUB ReDoCursor
			   EXIT SUB
		   END IF
		   IF (Col% < ULC1) OR (Col% > LRC1) THEN
			   RetValue% = 0
			   GOSUB ReDoCursor
			   EXIT SUB
		   END IF
	   END IF

SkipMouseSection:                 'we get here if no mouse found

	'we do not check for actual key until finished checking mouse
	'keep looping until something happens
	LOOP UNTIL KeyPressed% <> -256

	SELECT CASE KeyPressed%     'Act on keystrokes
		CASE -&H48        'Cursor Up
			MenuSelect% = MenuSelect% - 1
			GOSUB PositionCheck
		CASE -&H50        'Cursor Down
			MenuSelect% = MenuSelect% + 1
			GOSUB PositionCheck
		CASE 27           'Escape key only
			RetValue% = 0
			GOSUB ReDoCursor  'hilight KeyPressed
			EXIT SUB
		CASE 13 'Return key
			RetValue% = MenuSelect%
			GOSUB ReDoCursor  'highlight KeyPressed
			EXIT SUB
		CASE 65 TO 90, 97 TO 122 'only look for alpha keys
			'capitalize lower case and make it a string
			Choice$ = CHR$(KeyPressed% AND &HDF)
			RetValue% = INSTR(ChoiceLetter$, Choice$)
			'speed up garbage collection
			CALL KILLSTRING(Choice$)
		
			IF RetValue% THEN    'if got other than 0
				MenuSelect% = RetValue%
				GOSUB ReDoCursor  'highlight KeyPressed
				EXIT SUB
			END IF
		CASE -&H47, -&H49 'Home Key, Pageup
			MenuSelect% = 1
		CASE -&H4F, -&H51 'End key, Page down
			MenuSelect% = NUMBERMENUS
		CASE -&H4D, 9     'Right Arrow, Tab
			GOSUB ReDoCursor  'hilight KeyPressed
			RetValue% = -2
			EXIT SUB
		CASE -&H4B, -&HF  'Left Arrow, Shift Tab
			GOSUB ReDoCursor  'hilight KeyPressed
			RetValue% = -1
			EXIT SUB
		CASE -&H3B    'F-1 key pressed
			'Puts up a help routine
			Init2 = 0
			CALL HelpMenu(Msg%, Init2%, HorizMenuChange%)
		CASE ELSE   'Some other key
			'Ignore key repeat & clear keyboard buffer
			'let the user really lean on the keyboard if he desires
			CALL CLRKBD
			'make a chirp sound w/o using floating point numbers
			CALL BEEPER10: CALL BEEPER20
			'Ignore key repeat & clear keyboard buffer
			'let the user really lean on the keyboard if he desires
			CALL CLRKBD
	END SELECT

	'highlight cursor again for next time through loop
	GOSUB ReDoCursor
 LOOP  'end of primary loop

'--------------------------------GOSUBS--------------------------
'GOSUBS should offer a speed advantage over
'SUBS or FUNCTIONS because the parameters do not have to be
'passed.  GOSUBS are treated as near calls, rather than far calls.

'This highlites a box "cursor" by flipping display
'Disadvantage, works best only with Black Text on White Background
'where the keyletter is shown using intense characters.
'
ReDoCursor:
	'we exit if no change in vertical position
	'this speeds up display on a CGA
	IF OldValue = T(MenuSelect%).RowNum THEN RETURN

	'restore old box to background colors
	Row1 = BeginRow% + OldValue
	CALL REVVID(Row1, BeginCol%, MWidth%)

InitCursor:           'Entry point first time through
	'do new item
	Row1 = BeginRow% + T(MenuSelect%).RowNum
	CALL REVVID(Row1, BeginCol%, MWidth%)
	OldValue = T(MenuSelect%).RowNum

	'Draw phrase on bottom line of display
	'1st erase old message
	CALL BACKFILL(BottomLine, 22, BottomLine, 57, &H70, 32)
	'2nd draw new message
	CALL QPRT(BottomLine, 22, T(MenuSelect%).BotLine)
	RETURN

'Keep Cursor within range of menu
PositionCheck:
	SELECT CASE MenuSelect%
		CASE IS > NUMBERMENUS
			MenuSelect% = 1
		CASE IS <= 0
			MenuSelect% = NUMBERMENUS
		CASE ELSE
	END SELECT
	RETURN

MouserCheck:   'returns a menu select value if mouse is w/in range of table
			'entries
	Temp% = Row - BeginRow%
	CALL MouseMenuSelect(NUMBERMENUS, Temp%, ErrVal%, MenuSelect%, T())
	RETURN

END SUB

'=====================================================================
' This sets up QBASIC for shelling to DOS & returning w/o errors
'=====================================================================
SUB DOSSHELL (MaxCRTLen%) STATIC
	   
		'Display storage area for main background screen
		'reserve enough memory
		'REDIM makes it a dynamic array
		REM $DYNAMIC
		REDIM SCRN0%(SizeOFZero%)
		REM $STATIC

		CALL MMCURSOFF   'turn off mouse
		'Save underlying screen first
		WinNumber% = 1
		ULR% = WINDOWS(1).ULR: ULC% = WINDOWS(1).ULC
		LRR% = WINDOWS(1).LRR: LRC% = WINDOWS(1).LRC
		MenuItems% = WINDOWS(1).MaxMenNum
		CALL WINDSAVE(ULR% - 1, ULC%, LRR%, LRC%, VARSEG(SCRN0%(0)), VARPTR(SCRN0%(0)))
	    
		COLOR 7, 0      'restore normal DOS default
		'clear screen using BASIC routines
		CLS : LOCATE , , 1
		Text1$ = "Type EXIT to return to VERTMEN"
		'print then erase string
		CALL QPRT(1, 1, Text1$): CALL KILLSTRING(Text1$)
    
		T& = FRE(-1)         'prevent out of memory error
		IF T& < 70000 THEN
			Text1$ = "Sorry, insufficient memory to go to DOS, press any key to continue."
			CALL QPRT(4, 1, Text1$):
			CALL CLRKBD             'wait for a key press
			DO
				X% = WAITFORKEY%
			LOOP UNTIL X% <> -256
			CALL KILLSTRING(Text1$)
		ELSE
			SHELL
		END IF
    
		CALL VGACONTROL   ' reset VGA to defaults
		'restore original display size if user entered /H switch
	    
		IF MaxCRTLen% THEN
			CALL AdjustDspLen(VideoType%, LRR%, SizeOFZero%, MaxCRTLen%)
		END IF

		WinNumber% = 1
		ULR% = WINDOWS(1).ULR
		ULC% = WINDOWS(1).ULC
		LRR% = WINDOWS(1).LRR
		LRC% = WINDOWS(1).LRC
		MenuItems% = WINDOWS(1).MaxMenNum
    
		CALL WINDREST(ULR% - 1, ULC%, LRR%, LRC%, VARSEG(SCRN0%(0)), VARPTR(SCRN0%(0)))
		'Restore window upon return
		CALL MouseAdj    'turn mouse cursor back on
		LOCATE , , 0     'turn off normal video cursor
		CALL SETBLINK(0) 'turn blinking off, so can have background intensity
		'select border on a VGA color display
		IF ColorMode% THEN CALL VGABORDER(VBorderC%)
	    
		'give up memory used to save screen
		ERASE SCRN0%
END SUB

'=======================================================================
' Justs set up the array, does nothing else
' Simply here to make the code modular
' Sets up MainMenu
' Input:
'    Msg% = Which set of MainMenu arrays to select
' Output:
'    Just an initialized array
'
' Time saver, if the Offset of the KeyLet from Left Column will be
' 0, do not bother to initialize the variable MainMenu(x).KeyLetLoc = 0
'=======================================================================
SUB InitMMenuArray (Msg%, MainMenu() AS MenuType)

	SELECT CASE Msg%
		'Put other main menu choices here
		CASE 5      'The Run Menu
'***************This is the only return value for which we keep the main
'***************window.  Out of range so not kept
			KeepMain = 99

			MainMenu(1).Menu = "Start - Start Pgm"
			MainMenu(1).KeyLet = "S"       'Keyletter to highlight
			'MainMenu(1).KeyLetLoc = 0     'if no offset, don't bother
			MainMenu(1).BotLine = NotImp$  'Bottom row message
			MainMenu(1).RowNum = 0         'Offset from top of menu
		
			MainMenu(2).Menu = "Exit - Exit Pgm"
			MainMenu(2).KeyLet = "X"
			MainMenu(2).KeyLetLoc = 1
			MainMenu(2).BotLine = NotImp$  'Bottom row message
			MainMenu(2).RowNum = 2
	
			MainMenu(3).Menu = "Quit this DEMO!"
			MainMenu(3).KeyLet = "Q"
			'MainMenu(3).KeyLetLoc = 0
			MainMenu(3).BotLine = "     This will exit the Demo!"
			MainMenu(3).RowNum = 4

		CASE ELSE
						
'***************This is the only return value for which we keep the main
'***************window.  Set so that Secondary Menu is item # 6
			KeepMain = 6
						
							'Length of Text of Menu
							'12345678901234567890  , 20 characters
			MainMenu(1).Menu = "File - Select Files"
			MainMenu(1).KeyLet = "F"       'Keyletter to highlight
			'MainMenu(1).KeyLetLoc = 0      'Offset form left side
			MainMenu(1).BotLine = NotImp$  'Bottom row message
			MainMenu(1).RowNum = 0         'Offset from top of menu

			MainMenu(2).Menu = "Edit - Edit Files"
			MainMenu(2).KeyLet = "E"
			'MainMenu(2).KeyLetLoc = 0
			MainMenu(2).BotLine = NotImp$
			MainMenu(2).RowNum = 1
		
			MainMenu(3).Menu = "About - Author"
			MainMenu(3).KeyLet = "A"
			MainMenu(3).KeyLetLoc = 8
			MainMenu(3).BotLine = "  Updated by S. J. Kelly, 11/14/91"
			MainMenu(3).RowNum = 3
		
			MainMenu(4).Menu = "List - List Files"
			MainMenu(4).KeyLet = "L"
			'MainMenu(4).KeyLetLoc = 0
			MainMenu(4).BotLine = NotImp$
			MainMenu(4).RowNum = 4
		
			MainMenu(5).Menu = "Shell to DOS"
			MainMenu(5).KeyLet = "D"
			MainMenu(5).KeyLetLoc = 9
			MainMenu(5).BotLine = "  Shell to Dos   (This does work!)"
			MainMenu(5).RowNum = 5
		
			MainMenu(6).Menu = "Other - Menu     -"
			MainMenu(6).KeyLet = "O"
			'MainMenu(6).KeyLetLoc = 0
			MainMenu(6).BotLine = " -   Select Secondary Menu. -"
			MainMenu(6).RowNum = 7
		
			MainMenu(7).Menu = "Test - Of Routine"
			MainMenu(7).KeyLet = "T"
			'MainMenu(7).KeyLetLoc = 0
			MainMenu(7).BotLine = NotImp$
			MainMenu(7).RowNum = 8
		
			MainMenu(8).Menu = "Quit this DEMO!"
			MainMenu(8).KeyLet = "Q"
			'MainMenu(8).KeyLetLoc = 0
			MainMenu(8).BotLine = "     This will exit the Demo!"
			MainMenu(8).RowNum = 10
		
	END SELECT

END SUB

'=======================================================================
'Justs set up the array, does nothing else
'Simply here to make the code modular
'
'Sets up SecondaryMenu
'Input:
'    Msg% = Which set of SecMenu arrays to select
'
' Time saver, if the Offset of the KeyLet from Left Column will be
' 0, do not bother to initialize the variable MainMenu(x).KeyLetLoc = 0
'=======================================================================
SUB InitSMenuArray (Msg%, SecMenu() AS MenuType)

	SELECT CASE Msg%
		'Put other secondary menu choices here
		CASE ELSE
			SecMenu(1).Menu = "About - Author"
			SecMenu(1).KeyLet = "A"
			SecMenu(1).KeyLetLoc = 8
			SecMenu(1).BotLine = "   Yes, I realy did write this."
			SecMenu(1).RowNum = 0       'offset from top row

			SecMenu(2).Menu = "Backup - Files"
			SecMenu(2).KeyLet = "B"
			'SecMenu(2).KeyLetLoc = 0
			SecMenu(2).BotLine = NotImp$
			SecMenu(2).RowNum = 1

			SecMenu(3).Menu = "Compare - Files"
			SecMenu(3).KeyLet = "C"
			'SecMenu(3).KeyLetLoc = 0
			SecMenu(3).BotLine = NotImp$
			SecMenu(3).RowNum = 2
		
			SecMenu(4).Menu = "Macro - Record"
			SecMenu(4).KeyLet = "M"
			'SecMenu(4).KeyLetLoc = 0
			SecMenu(4).BotLine = NotImp$
			SecMenu(4).RowNum = 3
		
			SecMenu(5).Menu = "Start - Program"
			SecMenu(5).KeyLet = "S"
			'SecMenu(5).KeyLetLoc = 0
			SecMenu(5).BotLine = NotImp$
			SecMenu(5).RowNum = 4

			SecMenu(6).Menu = "Return to Main  -"
			SecMenu(6).KeyLet = "R"
			'SecMenu(6).KeyLetLoc = 0
			SecMenu(6).BotLine = " - Return to Primary Menu. -"
			SecMenu(6).RowNum = 5
		
	END SELECT
END SUB

'=======================================================================
' Draw a classy border with highlights
' This routine requires a border of 0, it works best without shadows
'
' For Demo purposes only, does nothing useful!
'
' Works well on color and EGA/VGA mono displays
' Works o.k. on Herc & Monochrome displayas
'
' Updated 7/31/91
'=======================================================================
SUB MakeMyLogo

CONST BoltShape$ = "" 'This makes the screws at edge of plaque
CONST Text1$ = "(c) S J Kelly 1991"
CONST NullString$ = ""

STATIC Attr1%, Attr2%, Attr3%

	Border% = 0  'no border, no shadow
	ULC% = 31: LRC% = ULC% + 23
	ULR% = 9: LRR% = ULR% + 7:
	
	IF ColorMode% THEN
		Attr% = &H3F          'Back = 3: Fore = 15
	ELSE
		Attr% = &H70          'Black on white background
	END IF
	CALL NormalWindow(ULR%, ULC%, LRR%, LRC%, Attr%, Border%, NullString$)

	CALL QPRINT(ULR% + 3, ULC% + 3, Text1$, Attr%)

	CALL MMCURSOFF  'BACKFILL doesn't automatically toggle mouse cursor
				 'before making screen writes

	Attr1% = Attr% \ 16            'get background color
	Attr2% = (Attr1% * 16) OR 15  'old background + bright fground
	Attr3% = (Attr1% * 16) OR 8   'old background + gray fground

		'draw top side
	CALL BACKFILL(ULR%, ULC%, ULR%, LRC% - 1, Attr2%, 223)
		'draw left side
	CALL BACKFILL(ULR%, ULC%, LRR% - 1, ULC%, Attr2%, 219)
		'draw right side
	CALL BACKFILL(ULR%, LRC%, LRR%, LRC%, Attr3%, 219)
		'draw bottom
	CALL BACKFILL(LRR%, ULC%, LRR%, LRC% - 1, Attr3%, 220)

		'draw upper right corner
	CALL BACKFILL(ULR%, LRC%, ULR%, LRC%, Attr3%, 220)
		'draw lower left corner
	CALL BACKFILL(LRR%, ULC%, LRR%, ULC%, Attr2%, 223)

	'add the "bolts" to the rectangle
	CALL QPRT(ULR% + 1, ULC% + 2, BoltShape$)
	CALL QPRT(ULR% + 1, LRC% - 2, BoltShape$)
	CALL QPRT(LRR% - 1, ULC% + 2, BoltShape$)
	CALL QPRT(LRR% - 1, LRC% - 2, BoltShape$)

	CALL MMCURSON     'turn mouse cursor back on

END SUB

'======================================================================
' Sets mouse to nice defaults
'======================================================================
SUB MouseAdj STATIC

	IF FASTMOUSE% THEN            'Mouse setup
		CALL MMTCURSOR(30)        'select an attractive cursor
		CALL MMSETLOCATION(1, 1)  'move mouse near upper left corner
		NoMouse% = False          'report have a mouse
		CALL MMSPEED(2)           'make mouse fast
		'turn mouse on after adjust screen size
		CALL MMCURSON
	ELSE
		NoMouse% = True           'tell menu program to skip mouse test
	END IF

END SUB

'=======================================================================
' Chooses the actual menu and allows for gaps in number and allow some
' overshooting too (as that leads to smooth scrolling).
'
' Input:
'    NUMBERMENUS = Selects the depth of checker routine, avoids
'                 ERR = 9, subscript out-of-range error
'    Temp% = Current Row - Beginning Row of vertical menu
'    T() = a MenuType array
'
' Returns:
'    ErrVal% = -1 if out of range
'    MenuSelect% = Return value (range is 1 to NUMBERMENUS)
'
'This is a generic routine
'=======================================================================
SUB MouseMenuSelect (NUMBERMENUS, Temp%, ErrVal%, MenuSelect%, T() AS MenuType) STATIC

	ErrVal% = False

  SELECT CASE NUMBERMENUS
	CASE 2
		SELECT CASE Temp%
			CASE IS <= T(1).RowNum
				MenuSelect% = 1
			CASE IS >= T(2).RowNum
				MenuSelect% = 2
			CASE ELSE
				ErrVal% = True    'report back  got nothing
		END SELECT
		EXIT SUB
	CASE 3
		SELECT CASE Temp%
			CASE IS <= T(1).RowNum
				MenuSelect% = 1
			CASE T(2).RowNum
				MenuSelect% = 2
			CASE IS >= T(3).RowNum
				MenuSelect% = 3
			CASE ELSE
				ErrVal% = True    'report back  got nothing
		END SELECT
		EXIT SUB
	CASE 4
		SELECT CASE Temp%
			CASE IS <= T(1).RowNum
				MenuSelect% = 1
			CASE T(2).RowNum
				MenuSelect% = 2
			CASE T(3).RowNum
				MenuSelect% = 3
			CASE IS >= T(4).RowNum
				MenuSelect% = 4
			CASE ELSE
				ErrVal% = True    'report back  got nothing
		END SELECT
		EXIT SUB
	CASE 5
		SELECT CASE Temp%
			CASE IS <= T(1).RowNum
				MenuSelect% = 1
			CASE T(2).RowNum
				MenuSelect% = 2
			CASE T(3).RowNum
				MenuSelect% = 3
			CASE T(4).RowNum
				MenuSelect% = 4
			CASE IS >= T(5).RowNum
				MenuSelect% = 5
			CASE ELSE
				ErrVal% = True    'report back  got nothing
		END SELECT
		EXIT SUB
	CASE 6
		SELECT CASE Temp%
			CASE IS <= T(1).RowNum
				MenuSelect% = 1
			CASE T(2).RowNum
				MenuSelect% = 2
			CASE T(3).RowNum
				MenuSelect% = 3
			CASE T(4).RowNum
				MenuSelect% = 4
			CASE T(5).RowNum
				MenuSelect% = 5
			CASE IS >= T(6).RowNum
				MenuSelect% = 6
			CASE ELSE
				ErrVal% = True    'report back  got nothing
		END SELECT
		EXIT SUB
	CASE 7
		SELECT CASE Temp%
			CASE IS <= T(1).RowNum
				MenuSelect% = 1
			CASE T(2).RowNum
				MenuSelect% = 2
			CASE T(3).RowNum
				MenuSelect% = 3
			CASE T(4).RowNum
				MenuSelect% = 4
			CASE T(5).RowNum
				MenuSelect% = 5
			CASE T(6).RowNum
				MenuSelect% = 6
			CASE IS >= T(7).RowNum
				MenuSelect% = 7
			CASE ELSE
				ErrVal% = True    'report back  got nothing
		END SELECT
		EXIT SUB
	CASE 8
		SELECT CASE Temp%
			CASE IS <= T(1).RowNum
				MenuSelect% = 1
			CASE T(2).RowNum
				MenuSelect% = 2
			CASE T(3).RowNum
				MenuSelect% = 3
			CASE T(4).RowNum
				MenuSelect% = 4
			CASE T(5).RowNum
				MenuSelect% = 5
			CASE T(6).RowNum
				MenuSelect% = 6
			CASE T(7).RowNum
				MenuSelect% = 7
			CASE IS >= T(8).RowNum
				MenuSelect% = 8
			CASE ELSE
				ErrVal% = True    'report back  got nothing
		END SELECT
		EXIT SUB
	CASE 1
		SELECT CASE Temp%
			CASE T(1).RowNum - 1 TO T(1).RowNum + 1
				MenuSelect% = 1
			CASE ELSE
				ErrVal% = True    'report back  got nothing
		END SELECT
		EXIT SUB
	CASE ELSE
		'not implemented
		ErrVal% = True    'report back  got nothing
  END SELECT

END SUB

'=======================================================================
' NormalWindow Program, typical popup w/o drops or exploding
' (Exploding is not recommended on a CGA because snow prevention cause
' box to open too slowly)
'
' HASHNO% = is the ASC number of a character used to fill the main
' window, e.g. 32 fills window with spaces, 176 uses a cross hatch pattern
' 0 is a special case that says merely draw the box, but don't erase the
' window contents.
'
' This routine is designed to be generic
'=======================================================================
SUB NormalWindow (ULR%, ULC%, LRR%, LRC%, Attr%, Border%, Label$) STATIC

	STATIC HASHNO%, X%
	CONST LBracket$ = "[", RBracket$ = "]"

	SELECT CASE Border%
		CASE 6              'Dialog boxes
			HASHNO% = 0
		CASE IS > 5         'Have a shadow
			HASHNO% = 32
		CASE 3              'used here as main window
			IF ColorMode% THEN HASHNO% = 32 ELSE HASHNO% = 176
		CASE 0              'No shadow, no border
			HASHNO% = 32
		CASE ELSE           'Border of 1-2,4 w/o Shadow
			HASHNO% = 176
	END SELECT

	CALL MAKEBOXES(ULR%, ULC%, LRR%, LRC%, HASHNO%, Border%, Attr%)
	SELECT CASE X%   'Draws a message label
		CASE 1 TO ((LRC% - ULC%) - 5)
			'T$ = "[" + lABEL$ + "]"
			CALL QPRINT(ULR%, ULC% + 3, LBracket$, Attr%)
			CALL QPRINT(ULR%, ULC% + 4, Label$, Attr%)
			X% = NULEN%(Label$)
			CALL QPRINT(ULR%, ULC% + 4 + X%, RBracket$, Attr%)
		CASE ELSE
	END SELECT
	'speed up garbage collection
	'LSET T$ = ""

END SUB

'=====================================================================
'Prints a Menu given its WinNumber% and the Color
'
'Parameters:
'    WinNumber% = Window number of the menu array
'    Attr% = Color to print main text
'    Init% = If 0 then reinitialize KeyString list
'    T() = An Array of type MenuType
'
' Returns:
'    ChoiceLetter$, the list of the shortcut keys for the Menu
'=====================================================================
SUB PrintMenu (WinNumber%, Attr%, Init%, ChoiceLetter$, Label$, T() AS MenuType) STATIC

	STATIC Z%, X%, HiLite%
	STATIC ULR%, ULC%, LRR%, LRC%, MenuItems%, Liner$
	CONST LineMark$ = "  "

	ULR% = WINDOWS(WinNumber%).ULR
	ULC% = WINDOWS(WinNumber%).ULC
	LRR% = WINDOWS(WinNumber%).LRR
	LRC% = WINDOWS(WinNumber%).LRC
	MenuItems% = WINDOWS(WinNumber%).MaxMenNum

 IF Init% = False THEN  'This makes the ChoiceLetter$ string
	ChoiceLetter$ = SPACE$(MenuItems%)
	FOR Z = 1 TO MenuItems%
		MID$(ChoiceLetter$, Z) = T(Z).KeyLet
	NEXT

	'This fills in empty rows with an attractive
	'single line
	LengthLiner = LRC% - ULC% + 1
	Liner$ = STRING$(LengthLiner, 196)
	MID$(Liner$, 1) = ""
	MID$(Liner$, LengthLiner) = ""
 END IF

 'Report that we have initialized the ChoiceLetter$
 'and the Liner$
 Init% = True

 Border% = 1 OR 256   'add shadows
 CALL NormalWindow(ULR%, ULC%, LRR%, LRC%, Attr%, Border%, Label$)

 BeginRow% = WINDOWS(WinNumber%).ULR + 2
 BeginCol% = WINDOWS(WinNumber%).ULC + 3
 'StopLimit% = BeginRow% + MenuItems% - 1

 IF ColorMode% THEN
	HiLite% = &HC  'black background w/ bright red foreground
 ELSE
	HiLite% = &HF   'black background w/ intense white foreground
 END IF

 OldVal = 0
 FOR X = 1 TO MenuItems%   'This prints the items
   'this draws a line if no Menu entry
	IF T(X).RowNum = OldVal + 2 THEN
		CALL QPRT(BeginRow% + OldVal + 1, BeginCol% - 3, Liner$)
	END IF
	OldVal = T(X).RowNum

	'this draws the Menu entry
	CALL QPRT(BeginRow% + T(X).RowNum, BeginCol%, T(X).Menu)
	CALL QPRINT(BeginRow% + T(X).RowNum, BeginCol% + T(X).KeyLetLoc, T(X).KeyLet, HiLite%)
  NEXT

 'This adds a "Top Hat" to MainMenus
 IF WinNumber% = 2 THEN CALL QPRINT(ULR% - 1, ULC%, LineMark$, &H7)

END SUB

'======================================================================
'This restores the bottom two lines of the display in an array
'When first Saved, this allow very quick erasure of bottom 2 lines
'======================================================================
SUB RestoreBottom STATIC

 STATIC ULR%, ULC%, LRR%, LRC%
 SHARED Bot2Line%()

 ULR% = WINDOWS(1).ULR
 ULC% = WINDOWS(1).ULC
 LRR% = WINDOWS(1).LRR
 LRC% = WINDOWS(1).LRC
 CALL WINDREST(LRR% - 1, ULC%, LRR%, LRC%, VARSEG(Bot2Line%(0)), VARPTR(Bot2Line%(0)))

END SUB

'===========================================================================
'This saves the bottom two lines of the display in an array
'When Restored, this allow very quick erasure of bottom 2 lines
'===========================================================================
SUB SaveBottom STATIC

 STATIC ULR%, ULC%, LRR%, LRC%
 SHARED Bot2Line%()

 ULR% = WINDOWS(1).ULR
 ULC% = WINDOWS(1).ULC
 LRR% = WINDOWS(1).LRR
 LRC% = WINDOWS(1).LRC
 CALL WINDSAVE(LRR% - 1, ULC%, LRR%, LRC%, VARSEG(Bot2Line%(0)), VARPTR(Bot2Line%(0)))

END SUB

'======================================================================
'This dimensions the Window based on the Msg% number
'======================================================================
SUB SetMainSize (Msg%)
	SELECT CASE Msg%
	
		CASE 2
			'Set Menu Box Variables  MainMenu
			WINDOWS(2).ULR = WINDOWS(1).ULR + 1
			WINDOWS(2).ULC = WINDOWS(1).ULC + 3 + ((Msg% - 1) * (HorizMenLen% + 2))
			WINDOWS(2).MaxMenNum = MainMEntries%
			WINDOWS(2).LRR = WINDOWS(2).ULR + WINDOWS(2).MaxMenNum% + 6
			WINDOWS(2).LRC = WINDOWS(2).ULC + MenStrLen% + 4
		CASE 3
			'Set Menu Box Variables  MainMenu
			WINDOWS(2).ULR = WINDOWS(1).ULR + 1
			WINDOWS(2).ULC = WINDOWS(1).ULC + 3 + ((Msg% - 1) * (HorizMenLen% + 2))
			WINDOWS(2).MaxMenNum = MainMEntries%
			WINDOWS(2).LRR = WINDOWS(2).ULR + WINDOWS(2).MaxMenNum% + 6
			WINDOWS(2).LRC = WINDOWS(2).ULC + MenStrLen% + 4
	
		CASE 4
			'Set Menu Box Variables  MainMenu
			WINDOWS(2).ULR = WINDOWS(1).ULR + 1
			WINDOWS(2).ULC = WINDOWS(1).ULC + 3 + ((Msg% - 1) * (HorizMenLen% + 2))
			WINDOWS(2).MaxMenNum = MainMEntries%
			WINDOWS(2).LRR = WINDOWS(2).ULR + WINDOWS(2).MaxMenNum% + 6
			WINDOWS(2).LRC = WINDOWS(2).ULC + MenStrLen% + 4
	
		CASE 5
			'Set Menu Box Variables  MainMenu  for "RUN"
			WINDOWS(2).ULR = WINDOWS(1).ULR + 1
			WINDOWS(2).ULC = WINDOWS(1).ULC + 3 + ((Msg% - 1) * (HorizMenLen% + 2))
			WINDOWS(2).MaxMenNum = 3
			WINDOWS(2).LRR = WINDOWS(2).ULR + WINDOWS(2).MaxMenNum% + 5
			WINDOWS(2).LRC = WINDOWS(2).ULC + MenStrLen% + 4
	
		CASE ELSE
			'Set Menu Box Variables  MainMenu
			WINDOWS(2).ULR = WINDOWS(1).ULR + 1
			WINDOWS(2).ULC = WINDOWS(1).ULC + 3
			WINDOWS(2).MaxMenNum = MainMEntries%
			WINDOWS(2).LRR = WINDOWS(2).ULR + WINDOWS(2).MaxMenNum% + 6
			WINDOWS(2).LRC = WINDOWS(2).ULC + MenStrLen% + 4
	END SELECT
END SUB

'======================================================================
'This dimensions the window based on the Msg% number
'======================================================================
SUB SetSecSize (Msg%)

	SELECT CASE Msg%
		'Invalid entries
		CASE 4 TO 999
			WINDOWS(3).ULR = 0
			WINDOWS(3).ULC = 0
			WINDOWS(3).MaxMenNum = SecdMEntries%
			WINDOWS(3).LRR = 0
			WINDOWS(3).LRC = 0
	
		CASE ELSE
			'Set Secondary Box Variables  SecMenu
			WINDOWS(3).ULR = WINDOWS(2).ULR + 5
			WINDOWS(3).ULC = WINDOWS(2).ULC + 25
			WINDOWS(3).MaxMenNum = SecdMEntries%
			WINDOWS(3).LRR = WINDOWS(3).ULR + WINDOWS(3).MaxMenNum% + 3
			WINDOWS(3).LRC = WINDOWS(3).ULC + MenStrLen% + 4
	END SELECT

END SUB

