; Last Updated 6/15/91
; Updated 12/10/91

;=======================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
;RM82TS8,16,24,32,40

DOSSEG
.MODEL MEDIUM, BASIC
.DATA
	;external data so all video routines can access
	INCLUDE VDATA.INC
.CODE
INCLUDE NOWAIT.INC
EXTRN	Get_Adapter:FAR

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

;============================================================================
; FPRINT.ASM - performs Quick Printing in the QuickBASIC
; DECLARE SUB FPRINT (BYVAL ROW%, BYVAL COL%, BYVAL SEGS%, BYVAL OFFS%, BYVAL LNGTH%, BYVAL SKIPPER%, BYVAL ATTRIBUTE%)
;
; Prints Fixed strings in Far Arrays
;
; Works in TextMode only, ignores all special characters
; Sensitive to all video modes (i.e. no snow on CGA's)
; If no attribute is selected, the default attribute is &H07 (normal)
; Assumes: Display width is 80 columns, Rows are 25, 43, or 50
;
; DOES NOT CHECK ROW, COL INPUT TO DETERMINE IF W/IN RANGE
;============================================================================

comment |
     Register usage when all done:
     AH = Color attribute for printing entire string.
     AL = temporarily holds the character to print.
     CX = Length of Text string.
     DX = Port for CGA video retrace check, if necessary.
          0 means display is not a not a CGA display
     DI = Offset of Screen for current character
     ES = Segment of Video display, 0xB000 or 0xB800
     SI = Offset of Text String
     DS = Points to segment containing Text string.
     BX = is used as a scratch variable register
     |

EVEN
Doit:                      ;save a jump
	Call  Get_Adapter  ;call routine to find display type
	Jmp   Short Didit
EVEN
FPRINT Proc FAR BASIC USES SI DI, \
ROW:Ptr, COLL:Ptr, BUFADD:DWORD, LNGTH:Ptr, SKIPPER:Ptr, ATTRIB:Ptr
	Assume  DS:@data
	Turn_Off_Mouse     ; shut off mouse if on MACRO
	Cmp   B$DVIDEOINSTL,1 ; See if we have done this before
	JNE   Doit         ; do install
Didit:
	Mov   DX,COLL      ;read value of COLL
	Dec   DX           ;convert to BIOS format
	Mov   CX,ROW       ;read value of Row (COLL in DL)
			   ;   allow EGA 43 line/ VGA 50 line
	Dec   CX           ;convert to BIOS format
	Mov   DH,CL        ;store ROW (CL) in DH
	CALL Near Ptr SET_DI ;call routin to find video seg offset in DI
	Mov   BX,ATTRIB    ;get the color ATTRIBUTE% that was passed (BYVAL)
	Mov   BH,07        ;Assume Default of black background, white letters
	Or    BL,BL        ;& make sure attribute is not &H00
	Jz    @f           ;Assumed correctly, it was &H00
	Mov   BH,BL        ;else put ATTRIBUTE value in BH
@@:
	Mov   AH,BL        ;now put it into AH for screen writing below
	Mov   CX,LNGTH     ;put Len(TEXT$) into CX for loop counter
	JCXZ  Exit         ;if CX is zero it's a null string, exit now
	Mov   BX,SKIPPER   ;get element number w/in array
	;Mov   ES,B$DVIDEOSEG  ;restore the initialized values
	;Mov   DX,B$DVIDEOPORT ;DX = 0 if not CGA, else CGA retrace port
	LES   DX,DWORD PTR B$DVIDEOPORT ;faster than above
	;Mov   SI,OFFS      ;put address of first character of TEXT$ into SI
	;Mov   DS,SEGS      ;put Segment address of TEXT$ into DS
	LDS   SI,BUFADD    ;faster than above
	Assume DS:NOTHING
	ADD   SI,BX        ;add offset of element to array's base offset
	Cld                ;clear the direction flag to move data forward
	Or    DX,DX        ;are we on a mono or EGA system (is DX = 0)?
	JNZ   CGA          ;NO, do the retrace stuff
EVEN
Mono:
	Lodsb              ;get the character from TEXT$ in AL, increment SI
	Stosw              ;store both the character (AL) and attribute (AH)
	Loop  Mono         ;loop until CX is zero
Exit:
	Mov   AX,SS        ;in QBASIC SS = @data = DGROUP
	Mov   DS,AX
	Assume DS:@data
	Mov   B$DVIDEODI,DI ;save current DI
	Turn_On_Mouse      ;turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
EVEN
CGA:
	CLI                ;prevent interrupts to speed routine
	Wait_CGA_Retrace   ;wait for CGA retrace MACRO
	Lodsb              ;get the character from TEXT$ and increment SI
	Stosw              ;store both the character and attribute
	STI                ;allow interrupts again
	Loop  CGA          ;loop until CX is zero
	Mov   AX,SS        ;in QBASIC SS = @data = DGROUP
	Mov   DS,AX
	Assume DS:@data
	Mov   B$DVIDEODI,DI ;save current DI
	Turn_On_Mouse      ;turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
FPRINT  Endp

;============================================================================
; FPRT.ASM - performs Quick Printing in the QuickBASIC
; DECLARE SUB FPRT (BYVAL ROW%, BYVAL COL%, BYVAL SEGS%, BYVAL OFFS%, BYVAL LNGTH%, BYVAL SKIPPER%)
;
; Prints Fixed strings in Far Arrays
;
; Works in TextMode only, ignores all special characters
; Sensitive to all video modes (i.e. no snow on CGA's)
; Does not change the attribute, uses whatever was there.
;
; Assumes: Display width is 80 columns, Max Rows are 25, 43, or 50
;
; DOES NOT CHECK ROW, COL INPUT TO DETERMINE IF W/IN RANGE
;============================================================================

EVEN
Doit1:                     ;save a jump
	Call  Get_Adapter  ;call routine to find display type
	Jmp   Short Didit1
EVEN
FPRT Proc FAR BASIC USES SI DI, \
ROW:Ptr, COLL:Ptr, BUFFADD:DWORD, LNGTH:Ptr, SKIPPER:PTR
	Assume  DS:@data
	Turn_Off_Mouse     ; shut off mouse if on MACRO
	Cmp   B$DVIDEOINSTL,1 ;See if we have done this before
	JE    Doit1        ;no, so install
Didit1:
	Mov   DX,COLL      ;read value of COLL (Note BYVAL)
	Dec   DX           ;convert to BIOS format
	Mov   CX,ROW       ;read value of ROW   (COL in DL) (Note BYVAL)
	Dec   CX           ;convert to BIOS format, 0 wd become &HFFFF
	Mov   DH,CL        ;store CL in DH
	CALL Near Ptr SET_DI  ;call routine to find video seg offset in DI
	Mov   CX,LNGTH    ;put Len(TEXT$) into CX for loop counter
	JCXZ  Exit1        ;if CX is zero it's a null string, exit now
	;Mov   ES,B$DVIDEOSEG  ;restore the initialized values
	;Mov   DX,B$DVIDEOPORT ;DX = 0 if not CGA, else CGA retrace port
	LES   DX,DWORD PTR B$DVIDEOPORT  ;faster than above
	Mov   BX,SKIPPER   ;get element number w/in array
	;Mov   SI,OFFS      ;put address of first character of TEXT$ into SI
	;Mov   DS,SEGS      ;put Segment address of TEXT$ into DS
	LDS   SI,BUFFADD   ;faster than above
	Assume DS:NOTHING
	ADD   SI,BX        ;add offset of element number to array's base offset
	Cld                ;clear the direction flag to move data forward
	OR    DX,DX        ;are we on a mono or EGA system (is DX = 0)?
	JNZ   CGA1         ;NO, do the retrace stuff
EVEN                       ; speeds loop
Mono1:
	Lodsb              ;get character from TEXT$ (AL), increment SI
	Stosb              ;store just character (AL) but not the attribute
	Inc    DI          ;skip to next cell
	Loop   Mono1       ;loop until CX is zero
Exit1:
	Mov   AX,SS
	Mov   DS,AX        ;make DS = DGROUP
	Assume DS:@data
	Mov  B$DVIDEODI,DI ;save current DI
	Turn_On_Mouse      ;turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
EVEN                       ; speeds loop
CGA1:
	CLI                ;prevent interrupts to speed routine
	Wait_CGA_Retrace   ;wait for CGA retrace MACRO
	Lodsb              ;get the character from TEXT$ and increment SI
	Stosb              ;store just the character but not the attribute
	STI                ;allow interrupts again
	Inc    DI          ;skip to next cell
	Loop   CGA1        ;loop until CX is zero
	Mov    AX,SS
	Mov    DS,AX        ;make DS = DGROUP
	Assume DS:@data
	Mov    B$DVIDEODI,DI ;save current DI
	Turn_On_Mouse      ;turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
FPRT    Endp

;=============================================================================
;Call SET_DI
; A local subroutine that fixes DI 
; Setup for 80 column display because that is all QBASIC supports
;
; Input:     DH = Row :  DL = Column
; Output:    DI = Memory Offset
; Destroys:  CX
; A local routine is used so that the name will not become public and 
; and take up space in the .OBJ file
;=============================================================================
EVEN
SET_DI Label Near
	Set_DI_Offset      ; call MACRO to find video seg offset in DI
	Retn		   ; make a near return
END
