; Created 09/01/90
; Updated 12/10/91

;======================================================================
;   Copyright (C) Copr. 1990, 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;======================================================================
;RM82TS8,16,24,32,40,48,56,64

DOSSEG
.MODEL MEDIUM, BASIC
.DATA
	;external data so all video routines can access
	INCLUDE VDATA.INC
.CODE

INCLUDE NOWAIT.INC
EXTRN	Get_Adapter:FAR

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1990, 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

;============================================================================
; QPRINT.ASM - performs Quick Printing in the QuickBASIC
; DECLARE SUB QPRINT (BYVAL ROW%, BYVAL COL%, Text$, BYVAL ATTRIBUTE%)
; Works in TextMode only, ignores all special characters
; Sensitive to all video modes (i.e. no snow on CGA's)
; If no attribute is selected, the default attribute is &h07 (normal)
; Assumes: Display width is 80 columns, Rows are 25, 43, or 50
;
; DOES NOT CHECK ROW, COL INPUT TO DETERMINE IF W/IN RANGE
;============================================================================

comment |
     Register usage when all done:
     AH = Color attribute for printing entire string.
     AL = temporarily holds the character to print.
     CX = Length of Text string.
     DX = Port for CGA video retrace check, if necessary.
          0 means display is not a not a CGA display
     DI = Offset of Screen for current character
     ES = Segment of Video display, 0xB000 or 0xB800
     SI = Offset of Text String
     DS = Assumed to point to segment containing Text string.
          Program does not set this, so string is assumed to
          be a near string in DGROUP, the default in QB 4.5
     BX = is used as a scratch variable register
     |

EVEN
Doit:	; save a jump in normal scenario
	Call  Get_Adapter  ;call routine to find display type
	Jmp	Short Main
EVEN
QPRINT Proc FAR BASIC USES SI DI, \
ROW:Ptr, COLL:Ptr, TEXTSTRG:Ptr, ATTRIB:Ptr
	Assume  DS:@data
	Turn_Off_Mouse  ; shut off mouse if on MACRO
	Cmp   B$DVIDEOINSTL,1	;See if we have done this before
	JNE   Doit	;no, so determine type of display
Main:
	Mov   DX,COLL  	;read value of COLL (BYVAL)
	Dec   DX       	;convert to BIOS format
	Mov   CX,ROW   	;read value of Row (COLL in DL) (BYVAL)
	Dec   CX       	;convert to BIOS format
	Mov   DH,CL        	;store ROW (CL) in DH
	CALL Near Ptr SET_DI  	;call routine to find video seg offset in DI
      	;Mov   ES,B$DVIDEOSEG  	;restore the initialized values
	;Mov   DX,B$DVIDEOPORT 	;puts 0 in DX if not CGA
	LES   DX,DWORD PTR B$DVIDEOPORT ; faster than above
	Mov   BX,ATTRIB		;get the color ATTRIBUTE% (BYVAL)
	Mov   BH,07        ;asume no entry, use black backgnd, white letters
	Or    BL,BL        ;Is attribute > &H00?
	Jz    @f           ;no, so use default & so jump ahead
	Mov   BH,BL        ;yes, so store in BH
@@:
	Mov   AH,BH        ;then store attribute in AH
	Mov   SI,TEXTSTRG  ;put descriptor to TEXT$ into SI
	Mov   CX,[SI]      ;put Len(TEXT$) into CX for loop counter
	JCXZ  Exit         ;if CX is zero it's a null string, exit now
	Mov   SI,[SI+02]   ;put address of first character in X$ into SI
	Cld                ;clear the direction flag to move data forward
	Or    DX,DX        ;are we on a mono or EGA system (is DX = 0)?
	JNZ   CGA          ;no, use CGA w/ retrace stuff
EVEN
Mono:
	Lodsb              ;get the character from TEXT$ and increment SI
	Stosw              ;store both the character and attribute
	Loop  Mono         ;loop until CX is zero
Exit:
	Mov   B$DVIDEODI,DI ;save current DI
	Turn_On_Mouse      ;turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
EVEN
CGA:
	CLI                ;prevent interrupts to speed routine
	Wait_CGA_Retrace   ;wait for CGA retrace MACRO
	Lodsb              ;get the character from TEXT$ and increment SI
	Stosw              ;store both the character and attribute
	STI                ;allow interrupts again
	Loop  CGA          ;loop until CX is zero
	Mov   B$DVIDEODI,DI ;save current DI
	Turn_On_Mouse      ;turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
QPRINT  Endp

;============================================================================
; QPRT.ASM - performs Quick Printing in the QuickBASIC
; DECLARE SUB QPRT (BYVAL ROW%, BYVAL COL%, TEXT$)
; Works in TextMode only, ignores all special characters
; Sensitive to all video modes (i.e. no snow on CGA's)
; Does not change the attribute, uses whatever was there.
; Much faster than LOCATE X,Y : PRINT T$;
; Routine is about 10.5 times faster than PRINT on a color EGA on an AT
;            about 6.2  times faster than PRINT on a color VGA on a AT-SX
;            about 7    times faster than PRINT on a mono EGA on an AT
;            about 1.8  times faster than PRINT on a CGA on an IBM PC
;            about 6.7  times faster than PRINT on a HERC on an AT
;            about 6    times faster than PRINT on a COMPAQ Portable
;
; Assumes: Display width is 80 columns, Max Rows are 25, 43, or 50
;
; DOES NOT CHECK ROW, COL INPUT TO DETERMINE IF W/IN RANGE
;============================================================================
EVEN
Doit1:                     ; save a jump in normal case
	Call  Get_Adapter  ;call routine to find display type
	Jmp   Short Main1
EVEN
QPRT Proc FAR BASIC USES SI DI, \
ROW:Ptr, COLL:Ptr, TEXTSTRG:Ptr,
	Turn_Off_Mouse        ; shut off mouse if on MACRO
	Cmp   B$DVIDEOINSTL,1 ;See if we have done this before
	JNE   Doit1           ;no, so calc variables and return
Main1:
	Mov   DX,COLL      ;read value of COLL (BYVAL)
	Dec   DX           ;convert to BIOS format, a 0 wd become &HFFFF
	Mov   CX,ROW       ;read value of ROW   (COL in DL) (BYVAL)
	Dec   CX           ;convert to BIOS format, 0 wd become &HFFFF
	Mov   DH,CL        ;store CL in DH
	CALL Near Ptr SET_DI  ;call routine to find video seg offset in DI
	;Mov   ES,B$DVIDEOSEG  ;restore the initialized values
	;Mov   DX,B$DVIDEOPORT ;DX = 0 if not CGA, else CGA retrace port
	LES   DX,DWORD PTR B$DVIDEOPORT ; faster than above
	Mov   SI,TEXTSTRG  ;put descriptor to TEXT$ into SI
	Mov   CX,[SI]      ;put Len(TEXT$) into CX for loop counter
	JCXZ  Exit1        ;if CX is zero it's a null string, exit now
	Mov   SI,[SI+02]   ;put address of first character in X$ into SI
	Cld                ;clear the direction flag to move data forward
	OR    DX,DX        ;are we on a mono or EGA system (is DX = 0)?
	JNZ   CGA1         ;No, use retrace stuff
EVEN                       ; speeds loop
Mono1:
	Lodsb              ;get the character from TEXT$ and increment SI
	Stosb              ;store just the character but not the attribute
	Inc    DI          ;skip to next cell
	Loop   Mono1       ;loop until CX is zero
Exit1:
	Mov  B$DVIDEODI,DI ;save current DI
	Turn_On_Mouse      ;turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
EVEN                       ; speeds loop
CGA1:
	CLI                ;prevent interrupts to speed routine
	Wait_CGA_Retrace   ;wait for CGA retrace MACRO
	Lodsb              ;get the character from TEXT$ and increment SI
	Stosb              ;store just the character but not the attribute
	STI                ;allow interrupts again
	Inc    DI          ;skip to next cell
	Loop   CGA1        ;loop until CX is zero
	Mov  B$DVIDEODI,DI ;save current DI
	Turn_On_Mouse      ;turn Mouse cursor on if on MACRO
	Ret                ;return skipping the passed parameters
QPRT    Endp

;============================================================================
; DECLARE SUB QATTRIB (BYVAL ROW%, BYVAL COL%, BYVAL NUMCHAR%, BYVAL ATTRIB%)
; CALL QATTRIB(ROW%, COL%, NUMCHAR%, ATTRIB%)
; Row, Column is the starting location. attribute is the color
; and Numchar is the number of characters to change.
; Changes the attribute of characters on the screen in text mode
; Assumes: Display width is 80 columns, Rows are 25, 43, or 50
;
; DOES NOT CHECK ROW, COL INPUT TO DETERMINE IF W/IN RANGE
;============================================================================

comment |
     Register usage when all done:
     AH = Color attribute to change NUMCHAR to
     AL = loading point for STOB, scratch.
     CX = Number of characters to change.
     DX = Port for CGA video retrace check, if necessary.
          0 means display is not a not a CGA display
     DI = Offset of Screen for current character
     ES = Segment of Video display, 0xB000 or 0xB800
     DS = Assumed to point to segment containing Text string
          Program does not set this, so string is assumed to
	  be a near string in DGROUP
     SI = is used as a scratch variable register
     BX = is used as a scratch variable register
     |
EVEN
Doit2:				;save a jump in normal case
	Call  Get_Adapter      	;call routine to find display type
	Jmp  Short Main2
EVEN
QATTRIB Proc FAR BASIC USES SI DI, \
ROW:Ptr, COLL:Ptr, NUMCHAR:Ptr, ATTRIB:Ptr
	Assume  DS:@data
	Turn_Off_Mouse         ; shut off mouse if on MACRO
	Cmp   B$DVIDEOINSTL,1  ;See if we have done this before
	JNE    Doit2           ;no, so doit now
Main2:
	Mov   DX,COLL          ;read value of COLL (BYVAL)
	Dec   DX               ;convert to BIOS format
	Mov   CX,ROW           ;read value of ROW (COL in DL) (BYVAL)
	Dec   CX               ;convert to BIOS format
	Mov   DH,CL            ;store CL in DH
	CALL  Near Ptr SET_DI   ;call routine to find video seg offset in DI
	;Mov   ES,B$DVIDEOSEG    ;restore the initialized values
	;Mov   DX,B$DVIDEOPORT
	LES   DX,DWORD PTR B$DVIDEOPORT  ;faster than above
	Mov   AX,ATTRIB        ;color ATTRIBUTE% (BYVAL)
	Mov   AH,AL            ;put it into AH for screen writing below
	Mov   CX,NUMCHAR       ;put number into CX for loop counter (BYVAL)
	JCXZ  Exit2            ;if CX is zero, quit
	Cld                    ;clear the direction flag to move data forward
	Mov   AL,AH            ;get attribute & put it in AL
	OR    DX,DX            ;are we on a mono or EGA system (is DX =0)?
	JNZ   CGA2             ;NO, use retrace stuff
EVEN
Mono2:
	Inc   DI
	Stosb                  ;store just the attribute
	Loop  Mono2            ;loop until CX is zero
Exit2:
	Mov   B$DVIDEODI,DI    ;save current DI
	Turn_On_Mouse          ;turn Mouse cursor on if on MACRO
	Ret                    ;return skipping the passed parameters
EVEN
CGA2:
	CLI                    ;prevent interrupts to speed display
	Wait_CGA_Retrace       ;wait for CGA retrace MACRO
	Mov   AL,AH            ;get attribute & put it in AL
	Stosb                  ;store just the attribute
	STI                    ;allow interrupts again
	Inc   DI               ;skip to next attribute
	Loop  CGA2             ;loop until CX is zero
	Mov   B$DVIDEODI,DI    ;save current DI
	Turn_On_Mouse          ;turn Mouse cursor on if on MACRO
	Ret                    ;return skipping the passed parameters
QATTRIB  Endp

;=============================================================================
;Call SET_DI
; A local subroutine that fixes DI 
; Setup for 80 column display because that is all QBASIC supports
;
; Input:     DH = Row :  DL = Column
; Output:    DI = Memory Offset
; Destroys:  CX
; A local routine is used so that the name will not become public and 
; and take up space in the .OBJ file
;=============================================================================
EVEN
SET_DI Label Near
	Set_DI_Offset      ; call MACRO to find video seg offset in DI
	Retn		   ; make a near return
END

