; Created 07/23/91
; Updated 12/10/91

;=======================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
;RM82TS8,16,24,32,40,48,56,64

DOSSEG
.MODEL MEDIUM, BASIC
.DATA
	;external data so all video routines can access
	INCLUDE VDATA.INC
.CODE

INCLUDE  NOWAIT.INC
EXTRN   Get_Adapter:FAR

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

;============================================================================
; DECLARE SUB REVVID (BYVAL ROW%, BYVAL COLUMN%, BYVAL NUMCHARS%)
; CALL REVVID(ROW%, COLUMN%, NUMCHARS%)
; Purpose: Clever visual effect, reverses foreground and background colors
; w/o adjusting text
;
; Works in TextMode only.  Sensitive to all video modes (no snow on CGA's)
; Assumes: Display width is 80 * 25, 80 * 43 or 80 * 50, but does not test for
; this
;============================================================================

EVEN
Doit:                              ; save a jump
	Call    Get_Adapter        ; call routine to find display type
	Jmp     Short Didit
EVEN
REVVID Proc FAR BASIC USES SI, ROW:WORD, COLL:WORD, NUMCHARS:WORD
	Turn_Off_Mouse             ; shut off mouse if on MACRO
	Cmp     B$DVIDEOINSTL,1    ; See if we have done this before
	JNE     Doit               ; no, so install
Didit:
	Mov     DX,COLL            ; read value of COLL (in DL) (BYVAL)
	Dec     DX                 ; convert to BIOS format
	Mov     CX,ROW             ; read value of Row  (BYVAL)
	Dec     CX                 ; convert to BIOS format
	Mov     DH,CL              ; store ROW (CL) in DH
	Set_SI_Offset              ; MACRO to find video seg offset in SI
	Inc     SI                 ; make it point to attribute
	Mov     BX,NUMCHARS        ; number of characters, (note BYVAL)
	Or	BX,BX		   ; see if BX = 0
	JZ	Finis              ; exit if no characters, BX = 0
	CLD                        ; clear direction flag
	;Mov     DX,B$DVIDEOPORT    ; get retrace port info
				   ; DX = 0 if MONO or EGA/VGA, else = CGA
				   ; retrace port
	;Mov     DS,B$DVIDEOSEG     ; get default video segment
	LDS     DX,DWORD PTR B$DVIDEOPORT    ; faster than above
	Assume  DS:NOTHING         ; WARNING DS <> DGROUP!
	; register status
	; DX holds 0 if not CGA, else CGA port number
	; CX = 4 the shift register
	; BX = Number of characters
	; AX scratch register, holds attribute 
	; DS = video segment
	; SI = pointer into video segment, points to attribute

	Mov     CX,4               ; shift right counter
	OR      DL,DL              ; is this a snowy CGA?
	JNZ     CGA                ; DL <> 0, so it must be
EVEN
Mono:
	Ror     byte ptr [SI],CL   ; reverse forground w/ background color
	Add    	SI,2		   ; skip to next attribute
 	Dec 	BX
	Jnz	Short Mono         ; do loop again until all bytes changed
Finis:
	Mov     AX,SS              ; point DS to DGROUP
	Mov     DS,AX
	Assume  DS:@data
	Turn_On_Mouse              ; turn Mouse cursor on if on MACRO
	Ret
EVEN                               ; speed 8086/80286 access
CGA:
	; AH is used for temporary storage, AL is trashed
	; by Wait_CGA_Retrace Macro
	Cli
	Wait_CGA_Retrace           ; wait for CGA retrace MACRO
	Mov	AH,[SI]		   ; read attribute into AH
	Sti			   ; allow interrupts again
	Ror     AH,CL              ; reverse forground w/ background color
; two wait for retraces are necessary because slow video memory access on CGA
; would otherwise cause minor snow using just ROR access.
	Cli
	Wait_CGA_Retrace           ; wait for CGA retrace MACRO
	Mov	[SI],AH            ; store back in memory
	Sti                        ; allow interrupts for a second
	Add    	SI,2		   ; skip to next attribute
	Dec 	BX
	Jnz	Short CGA          ; do loop again until all bytes changed
	Mov     AX,SS              ; point DS to DGROUP
	Mov     DS,AX
	Assume  DS:@data
	Turn_On_Mouse              ; turn Mouse cursor on if on MACRO
	Ret
REVVID  Endp
END
