; Last Updated 6/14/91
; Updated 12/10/91

;=======================================================================
;   Copyright (C) Copr. 1990, 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
;RM120TS8,16,24,32,40

DOSSEG
.MODEL MEDIUM, BASIC
.DATA
	;external data so all video routines can access
	INCLUDE VDATA.INC
.CODE

INCLUDE NOWAIT.INC
EXTRN	Get_Adapter:FAR

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1990, 1991 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

comment         |
CalcOffSet_Save  macro
                              ;;destroys AX,CX & BX
                              ;;modifies SI
            Mov   AX,CurrRow
	    Dec   AX          ;;change from 1-25 to 0-24
	    Mov   CL,160
	    Mul   CL          ;;multiply CurrRow by 160
            Mov   BX,BegCol   ;;get starting column
	    Dec   BX          ;;change from 1-80 to 0-79
	    Shl   BX,1        ;;multiply (CurrRow-1) by 2
            Add   AX,BX       ;;get offset
            Mov   SI,AX       ;;move to source index
         endm
		|

CalcOffSet_Save    macro
	;; This is slightly slower in the abstract
	;; sense on a 80286.  Cannot observe the difference
	;; on a 8088 with a CGA because of delay waiting for retrace.
	;; Though if have an 8088 with MONO or VGA/EGA it is faster
	;;
	;; Input:     Nothing
	;; Output:    SI = Memory Offset
	;; Destroys:  CX,AX
	;; Macro is used because inline code speeds routine
	;;               ;8088 ;80286
	Xor     CL, CL     ;3    ;2   ;; Clear CL
	Mov     AX,CurrRow ;14   ;5   ;; get starting Row
	Dec     AX         ;3    ;2   ;; change from 1-25 to 0-24
	Mov     CH, AL     ;2    ;2   ;; CX = Row * 256
	Shr     CX, 1      ;2    ;2   ;; CX = Row * 128
	Mov     SI, CX     ;2    ;2   ;; Store in SI
	Shr     SI, 1      ;2    ;2   ;; SI = Row * 64
	Shr     SI, 1      ;2    ;2   ;; SI = Row * 32
	Add     SI, CX     ;3    ;2   ;; SI = (Row * 128)+(Row * 32)={Row*160}
	Xor     CH, CH     ;3    ;2   ;; Clear CH register
	Mov     AX,BegCol  ;14   ;5   ;; get starting Column
	Dec     AX         ;3    ;2   ;; change from 1-80 to 0-79
	Mov     CL, AL     ;2    ;2   ;; CX = Columns
	Shl     CX, 1      ;2    ;2   ;; Account for attribute
	Add     SI, CX     ;3    ;2   ;; SI = (Row * 160) + (Col * 2)
			   ;--------
	endm               ;60    ;36  ;; clocks


comment         |
CalcOffSet_Rest  macro
                              ;;destroys AX,CX & BX
                              ;;modifies DI
            Mov   AX,CurrRow
	    Dec   AX          ;;change from 1-25 to 0-24
	    Mov   CL,160
	    Mul   CL          ;;multiply CurrRow by 160
            Mov   BX,BegCol   ;;get starting column
	    Dec   BX          ;;change from 1-80 to 0-79
	    Shl   BX,1        ;;multiply (CurrRow-1) by 2
            add   AX,BX       ;;get offset
            Mov   DI,AX       ;;move to source index
         endm
		|

CalcOffSet_Rest    macro
	;; This is slightly slower in the abstract
	;; sense on a 80286.  Cannot observe the difference
	;; on a 8088 with a CGA because of delay waiting for retrace.
	;; Though if have an 8088 with MONO or VGA/EGA it is faster
	;;
	;; Input:     Nothing
	;; Output:    DI = Memory Offset
	;; Destroys:  CX,AX
	;; Macro is used because inline code speeds routine
	;;               ;8088 ;80286
	Xor     CL, CL     ;3    ;2   ;; Clear CL
	Mov     AX,CurrRow ;14   ;5   ;; get starting Row
	Dec     AX         ;3    ;2   ;; change from 1-25 to 0-24
	Mov     CH, AL     ;2    ;2   ;; CX = Row * 256
	Shr     CX, 1      ;2    ;2   ;; CX = Row * 128
	Mov     DI, CX     ;2    ;2   ;; Store in DI
	Shr     DI, 1      ;2    ;2   ;; DI = Row * 64
	Shr     DI, 1      ;2    ;2   ;; DI = Row * 32
	Add     DI, CX     ;3    ;2   ;; DI = (Row * 128)+(Row * 32)={Row*160}
	Xor     CH, CH     ;3    ;2   ;; Clear CH register
	Mov     AX,BegCol  ;14   ;5   ;; get starting Column
	Dec     AX         ;3    ;2   ;; change from 1-80 to 0-79
	Mov     CL, AL     ;2    ;2   ;; CX = Columns
	Shl     CX, 1      ;2    ;2   ;; Account for attribute
	Add     DI, CX     ;3    ;2   ;; DI = (Row * 160) + (Col * 2)
			   ;--------
	endm               ;60    ;36  ;; clocks


COMMENT |
===============================================================================
    WINDSAVE.ASM - saves a portion of the text screen in QuickBASIC
 call from Quickbasic:
 DECLARE SUB WINDSAVE(BYVAL ULR%, BYVAL ULC%, BYVAL LRR%, BYVAL LRC%,BYVAL SEGADD%, BYVAL OFFADR% )
 CALL  WINDSAVE(ULR%,ULC%,LRR%,LRC%,VARSEG(STORAGE(0)),VARPTR(STORAGE(0)))
 Description of parameters:
    Because a rectangle can be described by two points, we us the following
    data points:
       ULR = Upper left row
       UCL = Upper left column
       LRR = Lower right row
       LRC = Lower right column
    Dimension storage array to handle size of display in bytes
    E.g. 80*20 display would require an integer array of 1600
===============================================================================
          |

.CODE
EVEN
CurrRow        DW    0           ;current CurrRow
BegCol         DW    0           ;Starting Column
Num_Cols       DW    0           ;words to copy per line
EndingRow      DW    0           ;Ending Row

EVEN
Doit:                              ; saves a jump
	    Call  Get_Adapter      ;find information about display
	    Jmp   Short didit      ;jump back to main loop
EVEN
WINDSAVE PROC FAR BASIC USES DI SI, \
ULR:PTR, ULC:PTR, LRR:PTR, LRC:PTR, BUFFADD:DWORD
	    Assume      DS:@data
	    Turn_Off_Mouse         ;shut off mouse if on MACRO
	    Cmp   B$DVIDEOINSTL,1  ;are we installed?
	    JNE   Doit             ;no, so install
didit:
		  ;save the screen segment for later
	    ;Mov   DI,OFFADD        ;get offset of storage array in DI
	    ;Mov   ES,SEGADD        ;get segment in ES
	    LES   DI,BUFFADD       ;faster than above
            Mov   AX,ULC           ;get first column (BYVAL)
            Mov   BegCol,AX
            Mov   AX,LRC           ;get last column (BYVAL)
            SUB   AX,BegCol        ;subtract first column from first column
	    Inc   AX               ;Add 1 to get number of columns to print
            Mov   Num_Cols,AX      ;AX=# of words to copy per line
            Mov   AX,LRR           ;get last line (BYVAL)
            Mov   EndingRow,AX
            Mov   AX,ULR           ;get first line (BYVAL)
            Mov   CurrRow,AX
            CalcOffSet_Save        ;calculate offset for line
            Mov   CX,Num_Cols      ;load counter with words to copy
	    ;Mov   DX,B$DVIDEOPORT
	    ;Mov   DS,B$DVIDEOSEG   ;set DS to Video segment
	    LDS   DX,DWORD PTR B$DVIDEOPORT  ;faster than above
	    ; have to set DS last because when we do
	    ; we lose access to DGROUP and the stack
	    Assume DS:NOTHING      ;tell MASM
	    Cld                    ;all data moves below will be forward
	    OR    DL,DL            ;monochrome or EGA (is DL = 0)?
	    JNZ   CGA              ;NO, do the retrace stuff
EVEN
Mono:
	    Rep   Movsw            ;move the data in one operation
				   ;to start next line
	    Mov   AX,EndingRow
	    CMP   AX,CurrRow       ;Are we done restoring window?
	    JE    Finis            ;Finis if complete
	    Inc   CurrRow          ;next line
	    CalcOffSet_Save        ;compute new offset address
	    Mov   CX,Num_Cols      ;set counter to number of words to copy
	    Jmp   Short Mono       ;jump to print next line
EVEN
CGA:
	    CLI                    ;prevent interrupts
	    Wait_CGA_Retrace       ;wait for CGA retrace MACRO
	    Movsw                  ;now get the word from the screen
				   ;and put it in array
	    STI                    ;allow interrupts again
	    Loop  CGA              ;loop until done
NextLine:
            Mov   AX,EndingRow
	    CMP   AX,CurrRow       ;Are we done restoring window?
	    JE    Finis            ;Finis if complete
	    Inc   CurrRow          ;next line
            CalcOffSet_Save        ;compute new offset address
            Mov   CX,Num_Cols      ;set counter to number of words to copy
	    Jmp   Short CGA        ;jump to print next line
Finis:
	    Mov   AX,SS            ; point DS to DGROUP
	    Mov   DS,AX
	    Assume   DS:@data      ; tell MASM
	    Turn_On_Mouse          ;turn Mouse cursor on if on MACRO
	    Ret                    ;return skipping the passed parameters
WINDSAVE    Endp

comment     |
===============================================================================
    WINDREST.ASM - restores a portion of the text screen in QuickBASIC

 DECLARE SUB WINDREST(BYVAL ULR%, BYVAL ULC%, BYVAL LRR%, BYVAL LRC%,BYVAL SEGADD%, BYVAL OFFADR% )
 CALL  WINDREST(ULR%,ULC%,LRR%,LRC%,VARSEG(STORAGE(0)),VARPTR(STORAGE(0)))
 Description of parameters:
    Because a rectangle can be described by two points, we us the following
    data points:
       ULR = Upper left row
       UCL = Upper left column
       LRR = Lower right row
       LRC = Lower right column
    Dimension storage array to handle size of display in bytes
    E.g. 80*20 display would require an integer array of 1600
===============================================================================
          |

EVEN
Doit1:                            ;saves a byte
	   Call  Get_Adapter      ;find information about display
	   Jmp  Short didit1
EVEN
WINDREST PROC FAR BASIC USES DI SI, \
ULR:PTR, ULC:PTR, LRR:PTR, LRC:PTR, BUFADD:DWORD
	    Assume      DS:@data
	    Turn_Off_Mouse         ;shut off mouse if on MACRO
	    Cmp   B$DVIDEOINSTL,1  ;are we installed?
	    Jne   Doit1            ;no, so install
didit1:
	    ;Mov   DX,B$DVIDEOPORT
	    ;Mov   ES,B$DVIDEOSEG   ;save the screen segment in ES
	    LES   DX,DWORD PTR B$DVIDEOPORT  ;faster than above
	    Mov   AX,ULC           ;get first column (BYVAL)
            Mov   BegCol,AX
            Mov   AX,LRC           ;get last column (BYVAL)
            Sub   AX,BegCol        ;subtract first column from first column
	    Inc   AX               ;add 1 to get number of columns to print
            Mov   Num_Cols,AX      ;AX=# of words to copy per line
            Mov   AX,LRR           ;get last line (BYVAL)
            Mov   EndingRow,AX
            Mov   AX,ULR           ;get first line (BYVAL)
            Mov   CurrRow,AX	   ;set current row to first line
            CalcOffSet_Rest        ;calculate offset for line
            Mov   CX,Num_Cols      ;load counter with words to copy
            ;Mov   SI,OFFADD        ;get the address of the first array element
	    ;Mov   DS,SEGADD        ;get segment of storage array in DS
	    LDS   SI,BUFADD        ;faster than above
            Assume DS:NOTHING      ;tell MASM
            Cld                    ;all data moves below will be forward
EVEN
ShowNext1:
	    OR    DL,DL            ;monochrome or EGA (is DL = 0)?
	    JNZ   CGA1             ;NO, do the retrace stuff
EVEN
Mono1:
	    Rep   Movsw            ;move the data in one operation
;do the NextLine:
	    Mov   AX,EndingRow
	    CMP   AX,CurrRow        ;Are we done restoring window?
	    JE    Finis1            ;Finis if complete
	    Inc   CurrRow           ;next line
	    CalcOffSet_Rest         ;compute new offset address
	    Mov   CX,Num_Cols       ;set counter to # of words to copy
	    Jmp   Short Mono1       ;jump to print next line
EVEN
CGA1:
	    CLI                    ;prevent interrupts
	    Wait_CGA_Retrace       ;wait for CGA retrace MACRO
	    Movsw                  ;now get the word from the screen
				   ;and put it into the array
	    STI                    ;allow interrupts again
	    Loop  CGA1             ;loop until done
NextLine1:
            Mov   AX,EndingRow
	    CMP   AX,CurrRow       ; Are we done restoring window?
	    JE    Finis1           ; Finis if complete
	    Inc   CurrRow          ; next line
	    CalcOffSet_Rest        ; compute new offset address
	    Mov   CX,Num_Cols      ; set counter to # of words to copy
	    Jmp   Short CGA1       ; jump to print next line
Finis1:
	    Mov   AX,SS            ; point DS to DGROUP
	    Mov   DS,AX
	    Assume   DS:@data      ; tell MASM
	    Turn_On_Mouse          ; turn Mouse cursor on if on MACRO
	    Ret                    ; return skipping the passed parameters
WINDREST Endp
END

