// XFileDlg.cpp : implementation file
//

#include "stdafx.h"
////////////////////////////////////////////////////////////
//              dlgs.h and afxdlgs.h need to standard
//              control IDs used by the common dlgs.
#include "dlgs.h"
#include "afxdlgs.h"

#include "xfile.h"
#include "xfiledlg.h"
#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CXFileDlg dialog

CXFileDlg::CXFileDlg() : CFileDialog(TRUE)
{
    
}
                                
CXFileDlg::CXFileDlg(BOOL bOpenFileDialog,
        LPCSTR lpszDefExt,
        LPCSTR lpszFileName,
        DWORD dwFlags,
        LPCSTR lpszFilter,
        CWnd* pParentWnd) 
        : CFileDialog(bOpenFileDialog, lpszDefExt,
                        lpszFileName, dwFlags, lpszFilter, pParentWnd)
{  
    
    //{{AFX_DATA_INIT(CXFileDlg)
    m_xName = "";
    m_newdir = "";
    //}}AFX_DATA_INIT
}

void CXFileDlg::DoDataExchange(CDataExchange* pDX)
{
    CFileDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CXFileDlg)
    DDX_Control(pDX, IDC_NEWDIR, m_cnewdir);
    DDX_Control(pDX, edt1, m_cxName);
    DDX_Control(pDX, stc1, m_cCommDlgDir);
    DDX_Text(pDX, edt1, m_xName);
    DDX_Text(pDX, IDC_NEWDIR, m_newdir);
    //}}AFX_DATA_MAP
}

void CXFileDlg::OnOK()
{
                                /////////////////////////////////////////////////////
                                // This is the KEY routine.
                                // The "trick" is to first call CFileDialog::OnOK()
                                // to update the CFileDialog member variables.
                                // Then, retreive the values you need.
                                // Finally, if you don't intend to "re display" 
                                // the DLG after OK is pressed, (and a new directory
                                // name has been added, call the CDialog::OnOK()
                                // function to complete OK processing.
                                
    CString     filename;
    CFileDialog::OnOK();        // Used to update/set the dialog box 
                                  
        //////////////////////////////////////////////////////////////////
        // Get the file name. If *.*, then the user
        // has selected a file name the same as a subdirectory.
        // commdlg.DLL doens't like that, so it changes the listbox to
        // the subdirectory.
        // A suggestion to the SDK group would be to add an
        // attibute to the OPENFILENAME structure of OF_ALLOWFILECREATE
        // which would imply that the dialog box is being used for
        // file or directory creation.
        
    filename = CFileDialog::GetFileName();
    
    if (filename == "*.*" || filename.IsEmpty()) {
        
        //////////////////////////////////////////////////////////////////
        //  Update the File name windows so the user doesn't see "*.*"
        m_cxName.SetWindowText(m_saveFileName);

        //////////////////////////////////////////////////////////////////
        // If we're here, then we're done.
        // However, CFileDialog would try to re-display the DLG.
        // By calling CDialog::OnOK() we avoid this redisplay and
        // end the dialog... as it should be for file/directory creation
        
        CDialog::OnOK();
    }
}

BEGIN_MESSAGE_MAP(CXFileDlg, CFileDialog)
    //{{AFX_MSG_MAP(CXFileDlg)
    ON_BN_CLICKED(IDC_FEATURES, OnClickedFeatures)
    ON_EN_UPDATE(edt1, OnUpdateXFileDlg)
    ON_EN_SETFOCUS(IDC_NEWDIR, OnSetfocusNewdir)
    ON_EN_CHANGE(IDC_NEWDIR, OnChangeNewdir)
    ON_EN_KILLFOCUS(IDC_NEWDIR, OnKillfocusNewdir)
    ON_BN_CLICKED(IDC_CLASS, OnClickedClass)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXFileDlg message handlers

BOOL CXFileDlg::OnInitDialog()
{
    CFileDialog::OnInitDialog();
        
    //  Hide these windows so the user cannot tab to them.  Note that in
    //  the private template (in cddemo.dlg) the coordinates for these guys are
    //  *outside* the coordinates of the dlg window itself.  Without the following
    //  ShowWindow()'s you would not see them, but could still tab to them.

   GetDlgItem(stc2)->ShowWindow(SW_HIDE);
   GetDlgItem(lst1)->ShowWindow(SW_HIDE);
   GetDlgItem(cmb1)->ShowWindow(SW_HIDE);
   GetDlgItem(pshHelp)->ShowWindow(SW_HIDE);
   
   m_cxName.LimitText(8);       // The File Name Edit control
   m_cnewdir.LimitText(11);
   SetNewDirMDT(FALSE);                 // If the user changes the new directory
   SetNewDirFocus(FALSE);               // then avoid automatically updating it.
                                        // NOTE: MDT stands for Modified Data Tag
                                        //       (It comes from my AS/400 roots!)
   m_nAppSel = 0;

   return TRUE;  // return TRUE  unless you set the focus to a control
}

void CXFileDlg::OnLBSelChangedNotify( UINT nIDBox, UINT iCurSel, UINT nCode)
{
//  nIDBox    The ID of the list box or combo box in which the selection occurred.

//  iCurSel The index of the current selection.
//  nCode   The control notification code.
//          This parameter must have one of the following values, with the meaning as given:

//  CD_LBSELCHANGE      Specifies iCurSel is the selected item in a single-selection list box.
//  CD_LBSELSUB         Specifies that iCurSel is no longer selected in a multiselection list box.
//  CD_LBSELADD         Specifies that iCurSel was selected in a multiselection list box.
//  CD_LBSELNOITEMS     Specifies that no selection exists in a multiselection list box.
    
    if ( (nIDBox == lst2) && (nCode == CD_LBSELCHANGE) )    {
        m_cxName.GetWindowText(m_xName);
        if  (m_xName.CompareNoCase("*.*") > 0) {
            m_basedir.Empty();      // Empty the directory so OnUpdateApp will refresh it.   
            OnUpdateXFileDlg();
        }
    }

}

void CXFileDlg::OnClickedFeatures()
{
                             //////////////////////////////////////////////////////////
                             // This is were you would do your "I'm here" processing
                             // It is called when the "Features" button is pressed.
    AfxMessageBox("You clicked the FEATURES button!");
    
}


void CXFileDlg::OnUpdateXFileDlg()
{
    CString NewDir;
        
    m_cxName.GetWindowText(m_xName);
    
        /////////////////////////////////////////////////
        // If existing directory selected, then don't  //
        // update everything else with that *.* crap.  //
        /////////////////////////////////////////////////
        
    if  (m_xName.CompareNoCase("*.*")==0) return;

    if (!ChgDir())  m_cnewdir.SetWindowText(m_xName);
    m_cnewdir.GetWindowText(m_newdir);
    if (m_basedir.IsEmpty())
        m_cCommDlgDir.GetWindowText(m_basedir);    // Retrieve the directory from the static control that
                                                   // is maintained by the COMMDLG.    
    m_xName.MakeLower();
    m_newdir.MakeLower();          
    m_basedir.MakeLower();    

    if (!m_newdir.IsEmpty() ) {
        if (m_basedir.Right(1)!="\\") NewDir = "\\";
    }
    NewDir += m_newdir;
    
    if ( m_xName.IsEmpty() ) 
            m_cCommDlgDir.SetWindowText(m_basedir + " " + NewDir );
    else    m_cCommDlgDir.SetWindowText(m_basedir + " " + NewDir + "\\" + m_xName + "." + m_ofn.lpstrDefExt);
    
    m_saveFilePath  = m_basedir + NewDir;
    m_saveFileName  = m_xName;
    m_saveFileTitle = m_xName + "." + m_ofn.lpstrDefExt;
    m_saveFileExt   = m_ofn.lpstrDefExt;
}


                           
void CXFileDlg::OnChangeNewdir()
{
        // Do only when "NEWDIR" has the input focus

  if (NewDirGotFocus() )  OnUpdateXFileDlg();

}


void CXFileDlg::OnSetfocusNewdir()
{
        /////////////////////////////////////////////////
        //  If we ever get here, then stop the auto-change
        //  procedure from automatically updating the "New Dir"
        //  edit control.
        
    SetNewDirMDT(TRUE);
    SetNewDirFocus(TRUE);
}

void CXFileDlg::OnKillfocusNewdir()
{
    SetNewDirFocus(FALSE);
    
}
                   
void CXFileDlg::OnClickedClass()
{
        //////////////////////////////////////////////////////
        // Yet another silly message (YASM) to test my logic!    
        
    AfxMessageBox("You clicked the CLASS button!");
}      



